PRINT N'Quitando [dbo].[DF_Interaction_RawWords]...';


GO
ALTER TABLE [dbo].[AsyncInteraction] DROP CONSTRAINT [DF_Interaction_RawWords];


GO
PRINT N'Quitando [dbo].[DF_AsyncInteraction_ValidChar]...';


GO
ALTER TABLE [dbo].[AsyncInteraction] DROP CONSTRAINT [DF_AsyncInteraction_ValidChar];


GO
PRINT N'Quitando [dbo].[DF_AsyncInteraction_ValidWords]...';


GO
ALTER TABLE [dbo].[AsyncInteraction] DROP CONSTRAINT [DF_AsyncInteraction_ValidWords];


GO
PRINT N'Quitando [dbo].[DF_Interaction_ProcessedWords]...';


GO
ALTER TABLE [dbo].[AsyncInteraction] DROP CONSTRAINT [DF_Interaction_ProcessedWords];


GO
PRINT N'Quitando [dbo].[DF_Interaction_CreatedDate]...';


GO
ALTER TABLE [dbo].[AsyncInteraction] DROP CONSTRAINT [DF_Interaction_CreatedDate];


GO
PRINT N'Quitando [dbo].[DF_Audio_Channel]...';


GO
ALTER TABLE [dbo].[Audio] DROP CONSTRAINT [DF_Audio_Channel];


GO
PRINT N'Quitando [dbo].[DF_Audio_Char]...';


GO
ALTER TABLE [dbo].[Audio] DROP CONSTRAINT [DF_Audio_Char];


GO
PRINT N'Quitando [dbo].[DF_Audio_Words]...';


GO
ALTER TABLE [dbo].[Audio] DROP CONSTRAINT [DF_Audio_Words];


GO
PRINT N'Quitando [dbo].[DF_Audio_TotalPhrases]...';


GO
ALTER TABLE [dbo].[Audio] DROP CONSTRAINT [DF_Audio_TotalPhrases];


GO
PRINT N'Quitando [dbo].[DF_Audio_CharsPerPhrase]...';


GO
ALTER TABLE [dbo].[Audio] DROP CONSTRAINT [DF_Audio_CharsPerPhrase];


GO
PRINT N'Quitando [dbo].[DF_InteractionEvaluationPlan_InteractionDateEnd]...';


GO
ALTER TABLE [dbo].[InteractionEvaluationPlan] DROP CONSTRAINT [DF_InteractionEvaluationPlan_InteractionDateEnd];


GO
PRINT N'Quitando [dbo].[DF_InteractionEvaluationPlan_InteractionDuration]...';


GO
ALTER TABLE [dbo].[InteractionEvaluationPlan] DROP CONSTRAINT [DF_InteractionEvaluationPlan_InteractionDuration];


GO
PRINT N'Iniciando recompilación de la tabla [dbo].[AsyncInteraction]...';


GO
BEGIN TRANSACTION;

SET TRANSACTION ISOLATION LEVEL SERIALIZABLE;

SET XACT_ABORT ON;

CREATE TABLE [dbo].[tmp_ms_xx_AsyncInteraction] (
    [VCC]                  VARCHAR (50)  NOT NULL,
    [ID]                   VARCHAR (250) NOT NULL,
    [Folder]               VARCHAR (50)  NULL,
    [ExportedContent]      VARCHAR (250) NULL,
    [Channel]              VARCHAR (50)  NULL,
    [Campaign]             VARCHAR (50)  NULL,
    [StartDate]            DATETIME      NULL,
    [EndDate]              DATETIME      NOT NULL,
    [Account]              VARCHAR (250) NULL,
    [Initiative]           VARCHAR (50)  NULL,
    [ContactName]          VARCHAR (300) NULL,
    [FirstTakedAgent]      VARCHAR (50)  NULL,
    [FirstTakedAgentName]  VARCHAR (100) NULL,
    [LastTakedAgent]       VARCHAR (50)  NULL,
    [LastTakedAgentName]   VARCHAR (100) NULL,
    [IsTaken]              VARCHAR (10)  NULL,
    [TotalMessages]        INT           NULL,
    [DurationTime]         VARCHAR (50)  NULL,
    [AttentionTime]        VARCHAR (50)  NULL,
    [DispositionCode]      VARCHAR (150) NULL,
    [DispositionTreePath]  VARCHAR (250) NULL,
    [IsProcess]            BIT           NULL,
    [IsCancel]             BIT           NULL,
    [IsTranscribed]        BIT           NULL,
    [FileName]             VARCHAR (250) NULL,
    [ViewFileName]         VARCHAR (250) NULL,
    [ErrorMessage]         VARCHAR (MAX) NULL,
    [RawChar]              INT           CONSTRAINT [DF_Interaction_RawWords] DEFAULT ((0)) NULL,
    [ValidChar]            INT           CONSTRAINT [DF_AsyncInteraction_ValidChar] DEFAULT ((0)) NULL,
    [ValidWords]           INT           CONSTRAINT [DF_AsyncInteraction_ValidWords] DEFAULT ((0)) NULL,
    [TotalPhrases]         INT           CONSTRAINT [DF_Interaction_ProcessedWords] DEFAULT ((0)) NULL,
    [CharsPerPhrase]       INT           NULL,
    [CreatedDate]          DATETIME      CONSTRAINT [DF_Interaction_CreatedDate] DEFAULT (getdate()) NULL,
    [CreatedByUserId]      VARCHAR (50)  NULL,
    [LastModifiedDate]     DATETIME      NULL,
    [LastModifiedByUserId] VARCHAR (50)  NULL,
    [TimeStamp]            DATETIME      NULL,
    CONSTRAINT [tmp_ms_xx_constraint_PK_Interaction1] PRIMARY KEY CLUSTERED ([VCC] ASC, [ID] ASC, [EndDate] ASC)
);

IF EXISTS (SELECT TOP 1 1 
           FROM   [dbo].[AsyncInteraction])
    BEGIN
        INSERT INTO [dbo].[tmp_ms_xx_AsyncInteraction] ([VCC], [ID], [EndDate], [Folder], [ExportedContent], [Channel], [Campaign], [StartDate], [Account], [Initiative], [ContactName], [FirstTakedAgent], [LastTakedAgent], [IsTaken], [TotalMessages], [DurationTime], [AttentionTime], [DispositionCode], [DispositionTreePath], [IsProcess], [IsCancel], [IsTranscribed], [FileName], [ViewFileName], [ErrorMessage], [RawChar], [ValidChar], [ValidWords], [TotalPhrases], [CharsPerPhrase], [CreatedDate], [CreatedByUserId], [LastModifiedDate], [LastModifiedByUserId], [TimeStamp])
        SELECT   [VCC],
                 [ID],
                 [EndDate],
                 [Folder],
                 [ExportedContent],
                 [Channel],
                 [Campaign],
                 [StartDate],
                 [Account],
                 [Initiative],
                 [ContactName],
                 [FirstTakedAgent],
                 [LastTakedAgent],
                 [IsTaken],
                 [TotalMessages],
                 [DurationTime],
                 [AttentionTime],
                 [DispositionCode],
                 [DispositionTreePath],
                 [IsProcess],
                 [IsCancel],
                 [IsTranscribed],
                 [FileName],
                 [ViewFileName],
                 [ErrorMessage],
                 [RawChar],
                 [ValidChar],
                 [ValidWords],
                 [TotalPhrases],
                 [CharsPerPhrase],
                 [CreatedDate],
                 [CreatedByUserId],
                 [LastModifiedDate],
                 [LastModifiedByUserId],
                 [TimeStamp]
        FROM     [dbo].[AsyncInteraction]
        ORDER BY [VCC] ASC, [ID] ASC, [EndDate] ASC;
    END

DROP TABLE [dbo].[AsyncInteraction];

EXECUTE sp_rename N'[dbo].[tmp_ms_xx_AsyncInteraction]', N'AsyncInteraction';

EXECUTE sp_rename N'[dbo].[tmp_ms_xx_constraint_PK_Interaction1]', N'PK_Interaction', N'OBJECT';

COMMIT TRANSACTION;

SET TRANSACTION ISOLATION LEVEL READ COMMITTED;


GO
PRINT N'Iniciando recompilación de la tabla [dbo].[Audio]...';


GO
BEGIN TRANSACTION;

SET TRANSACTION ISOLATION LEVEL SERIALIZABLE;

SET XACT_ABORT ON;

CREATE TABLE [dbo].[tmp_ms_xx_Audio] (
    [VCC]                    VARCHAR (50)    NOT NULL,
    [ID]                     VARCHAR (100)   NOT NULL,
    [Section]                NUMERIC (5)     NOT NULL,
    [Part]                   NUMERIC (5)     NOT NULL,
    [Channel]                VARCHAR (50)    CONSTRAINT [DF_Audio_Channel] DEFAULT ('CALL') NULL,
    [Number]                 VARCHAR (50)    NULL,
    [Gender]                 VARCHAR (50)    NULL,
    [Format]                 VARCHAR (50)    NULL,
    [SilenceTime]            NUMERIC (12, 3) NULL,
    [DurationTime]           NUMERIC (12, 3) NULL,
    [MediaInfoTime]          NUMERIC (12, 3) NULL,
    [DurationLinguisticTime] NUMERIC (12, 3) NULL,
    [IsDiariced]             BIT             NULL,
    [ChannelsChanged]        BIT             NULL,
    [ValidChar]              INT             CONSTRAINT [DF_Audio_Char] DEFAULT ((0)) NULL,
    [ValidWords]             INT             CONSTRAINT [DF_Audio_Words] DEFAULT ((0)) NULL,
    [TotalPhrases]           INT             CONSTRAINT [DF_Audio_TotalPhrases] DEFAULT ((0)) NULL,
    [CharsPerPhrase]         INT             CONSTRAINT [DF_Audio_CharsPerPhrase] DEFAULT ((0)) NULL,
    [Category1]              VARCHAR (100)   NULL,
    [Category2]              VARCHAR (100)   NULL,
    [Category3]              VARCHAR (100)   NULL,
    [Description]            VARCHAR (100)   NULL,
    [Campaign]               VARCHAR (100)   NULL,
    [Agent]                  VARCHAR (50)    NULL,
    [AgentName]              VARCHAR (100)   NULL,
    [Type]                   VARCHAR (50)    NULL,
    [Init]                   VARCHAR (50)    NULL,
    [IsProcess]              BIT             NULL,
    [IsCancel]               BIT             NULL,
    [IsTranscribed]          INT             NULL,
    [StartDate]              DATETIME        NULL,
    [EndDate]                DATETIME        NULL,
    [DispositionCode]        VARCHAR (50)    NULL,
    [FileName]               VARCHAR (200)   NULL,
    [ErrorMessage]           VARCHAR (MAX)   NULL,
    [CreatedDate]            DATETIME        NULL,
    [CreatedByUserId]        VARCHAR (50)    NULL,
    [LastModifiedDate]       DATETIME        NULL,
    [LastModifiedByUserId]   VARCHAR (50)    NULL,
    [TimeStamp]              DATETIME        NULL,
    CONSTRAINT [tmp_ms_xx_constraint_PK_Audio_11] PRIMARY KEY CLUSTERED ([VCC] ASC, [ID] ASC, [Section] ASC, [Part] ASC)
);

IF EXISTS (SELECT TOP 1 1 
           FROM   [dbo].[Audio])
    BEGIN
        INSERT INTO [dbo].[tmp_ms_xx_Audio] ([VCC], [ID], [Section], [Part], [Channel], [Number], [Gender], [Format], [SilenceTime], [DurationTime], [MediaInfoTime], [DurationLinguisticTime], [IsDiariced], [ChannelsChanged], [ValidChar], [ValidWords], [TotalPhrases], [CharsPerPhrase], [Category1], [Category2], [Category3], [Description], [Campaign], [Agent], [Type], [Init], [IsProcess], [IsCancel], [IsTranscribed], [StartDate], [EndDate], [DispositionCode], [FileName], [ErrorMessage], [CreatedDate], [CreatedByUserId], [LastModifiedDate], [LastModifiedByUserId], [TimeStamp])
        SELECT   [VCC],
                 [ID],
                 [Section],
                 [Part],
                 [Channel],
                 [Number],
                 [Gender],
                 [Format],
                 [SilenceTime],
                 [DurationTime],
                 [MediaInfoTime],
                 [DurationLinguisticTime],
                 [IsDiariced],
                 [ChannelsChanged],
                 [ValidChar],
                 [ValidWords],
                 [TotalPhrases],
                 [CharsPerPhrase],
                 [Category1],
                 [Category2],
                 [Category3],
                 [Description],
                 [Campaign],
                 [Agent],
                 [Type],
                 [Init],
                 [IsProcess],
                 [IsCancel],
                 [IsTranscribed],
                 [StartDate],
                 [EndDate],
                 [DispositionCode],
                 [FileName],
                 [ErrorMessage],
                 [CreatedDate],
                 [CreatedByUserId],
                 [LastModifiedDate],
                 [LastModifiedByUserId],
                 [TimeStamp]
        FROM     [dbo].[Audio]
        ORDER BY [VCC] ASC, [ID] ASC, [Section] ASC, [Part] ASC;
    END

DROP TABLE [dbo].[Audio];

EXECUTE sp_rename N'[dbo].[tmp_ms_xx_Audio]', N'Audio';

EXECUTE sp_rename N'[dbo].[tmp_ms_xx_constraint_PK_Audio_11]', N'PK_Audio_1', N'OBJECT';

COMMIT TRANSACTION;

SET TRANSACTION ISOLATION LEVEL READ COMMITTED;


GO
PRINT N'Iniciando recompilación de la tabla [dbo].[InteractionEvaluationPlan]...';


GO
BEGIN TRANSACTION;

SET TRANSACTION ISOLATION LEVEL SERIALIZABLE;

SET XACT_ABORT ON;

CREATE TABLE [dbo].[tmp_ms_xx_InteractionEvaluationPlan] (
    [Instance]             VARCHAR (50)  NOT NULL,
    [IdEvaluationPlan]     VARCHAR (50)  NOT NULL,
    [InteractionType]      VARCHAR (50)  NOT NULL,
    [FormattedEndDate]     VARCHAR (50)  NULL,
    [IdCampaign]           VARCHAR (50)  NULL,
    [IdInteraction]        VARCHAR (250) NOT NULL,
    [InteractionSection]   NUMERIC (5)   NULL,
    [InteractionPart]      NUMERIC (5)   NULL,
    [IdAgent]              VARCHAR (50)  NULL,
    [AgentName]            VARCHAR (100) NULL,
    [InteractionMessages]  INT           NULL,
    [InteractionDateStart] DATETIME      NULL,
    [InteractionDateEnd]   DATETIME      CONSTRAINT [DF_InteractionEvaluationPlan_InteractionDateEnd] DEFAULT ((0)) NULL,
    [InteractionDuration]  NUMERIC (8)   CONSTRAINT [DF_InteractionEvaluationPlan_InteractionDuration] DEFAULT ((0)) NULL,
    [InteractionOrigin]    VARCHAR (50)  NULL,
    [InteractionFormat]    VARCHAR (50)  NULL,
    [ManagementResult]     VARCHAR (250) NULL,
    [ContactId]            VARCHAR (50)  NULL,
    [QueryPassed]          BIT           NULL,
    [CreatedByUserId]      VARCHAR (50)  NULL,
    [CreatedDate]          DATETIME      NULL,
    [LastModifiedByUserId] VARCHAR (50)  NULL,
    [LastModifiedDate]     DATETIME      NULL,
    [TimeStamp]            DATETIME      NULL
);

IF EXISTS (SELECT TOP 1 1 
           FROM   [dbo].[InteractionEvaluationPlan])
    BEGIN
        INSERT INTO [dbo].[tmp_ms_xx_InteractionEvaluationPlan] ([Instance], [IdEvaluationPlan], [InteractionType], [FormattedEndDate], [IdCampaign], [IdInteraction], [InteractionSection], [InteractionPart], [IdAgent], [InteractionMessages], [InteractionDateStart], [InteractionDateEnd], [InteractionDuration], [InteractionOrigin], [InteractionFormat], [ManagementResult], [ContactId], [QueryPassed], [CreatedByUserId], [CreatedDate], [LastModifiedByUserId], [LastModifiedDate], [TimeStamp])
        SELECT [Instance],
               [IdEvaluationPlan],
               [InteractionType],
               [FormattedEndDate],
               [IdCampaign],
               [IdInteraction],
               [InteractionSection],
               [InteractionPart],
               [IdAgent],
               [InteractionMessages],
               [InteractionDateStart],
               [InteractionDateEnd],
               [InteractionDuration],
               [InteractionOrigin],
               [InteractionFormat],
               [ManagementResult],
               [ContactId],
               [QueryPassed],
               [CreatedByUserId],
               [CreatedDate],
               [LastModifiedByUserId],
               [LastModifiedDate],
               [TimeStamp]
        FROM   [dbo].[InteractionEvaluationPlan];
    END

DROP TABLE [dbo].[InteractionEvaluationPlan];

EXECUTE sp_rename N'[dbo].[tmp_ms_xx_InteractionEvaluationPlan]', N'InteractionEvaluationPlan';

COMMIT TRANSACTION;

SET TRANSACTION ISOLATION LEVEL READ COMMITTED;


GO
PRINT N'Creando [dbo].[Agent]...';


GO
CREATE TABLE [dbo].[Agent] (
    [VCC]                  VARCHAR (50)  NOT NULL,
    [AgentId]              VARCHAR (50)  NOT NULL,
    [Name]                 VARCHAR (250) NOT NULL,
    [CreatedDate]          DATETIME      NULL,
    [CreatedByUserId]      VARCHAR (50)  NULL,
    [LastModifiedDate]     DATETIME      NULL,
    [LastModifiedByUserId] VARCHAR (50)  NULL,
    [TimeStamp]            DATETIME      NULL
);


GO
PRINT N'Modificando [dbo].[BulkAsyncInteraction]...';


GO
ALTER PROCEDURE [dbo].[BulkAsyncInteraction]
AS
BEGIN
	-- ESTE SP INSERTA REGISTROS UNICOS DE ASYNCINTERACTION PROVENIENTES DE LA BD EXTERNA EN LA TABLA ASYNCINTERACTION Y PROCESSASYNCINTERACTION

	--
	INSERT INTO [dbo].[AsyncInteraction] (
		[VCC], [ID], [Folder], [ExportedContent], [Channel]
		, [Campaign], [StartDate], [EndDate], [Account], [Initiative]
		, [ContactName], [FirstTakedAgent], [LastTakedAgent], [FirstTakedAgentName], [LastTakedAgentName]
		, [IsTaken], [TotalMessages], [DurationTime], [AttentionTime], [DispositionCode]
		, [DispositionTreePath], [RawChar], [CreatedDate], [CreatedByUserId], [LastModifiedDate]
		, [LastModifiedByUserId], [TimeStamp]
	)
		-- SELECCIONAMOS TODOS LOS REGISTROS DE LA TABLA TEMPORAL [#AsyncInteractionTemp] QUE NO EXISTEN EN [AsyncInteraction] POR LOS PK
		SELECT AIT.[VCC], AIT.[ID], AIT.[Folder], AIT.[ExportedContent], AIT.[Channel]
				, AIT.[Campaign], AIT.[StartDate], AIT.[EndDate], AIT.[Account], AIT.[Initiative]
				, AIT.[ContactName], AIT.[FirstTakedAgent], AIT.[LastTakedAgent], A1.[Name], A2.[Name]
				, AIT.[IsTaken], AIT.[TotalMessages], AIT.[DurationTime], AIT.[AttentionTime], AIT.[DispositionCode]
				, AIT.[DispositionTreePath], AIT.[RawChar], AIT.[CreatedDate], AIT.[CreatedByUserId], AIT.[LastModifiedDate]
				, AIT.[LastModifiedByUserId], GETUTCDATE()
			FROM [#AsyncInteractionTemp] AIT
			LEFT JOIN [dbo].[AsyncInteraction] AI (NOLOCK)
				ON AI.[VCC] = AIT.[VCC]
					AND AI.[ID] = AIT.[ID]
					AND CONVERT(VARCHAR, AI.[EndDate], 23) = AIT.[Folder]
			LEFT JOIN [dbo].[Agent] A1 (NOLOCK)
				ON A1.[VCC] = AIT.[VCC]
					AND A1.[AgentId] = AIT.[FirstTakedAgent]
			LEFT JOIN [dbo].[Agent] A2 (NOLOCK)
				ON A2.[VCC] = AIT.[VCC]
					AND A2.[AgentId] = AIT.[LastTakedAgent]
			WHERE AI.[ID] IS NULL

	--
	INSERT INTO [dbo].[ProcessAsyncInteraction] (
		[VCC], [ProcessId], [InteractionType], [Campaign], [InteractionId]
		, [EndDate], [FormattedEndDate], [CreatedDate], [CreatedByUserId], [LastModifiedDate]
		, [LastModifiedByUserId], [TimeStamp]
	)
		-- SELECCIONAMOS TODOS LOS REGISTROS DE LA TABLA TEMPORAL [#ProcessAsyncInteractionTemp] QUE NO EXISTEN EN [ProcessAsyncInteraction] POR LOS PK
		SELECT PAIT.[VCC], PAIT.[ProcessId], PAIT.[InteractionType], PAIT.[Campaign], PAIT.[InteractionId] 
				, PAIT.[EndDate], PAIT.[FormattedEndDate], PAIT.[CreatedDate], PAIT.[CreatedByUserId], PAIT.[LastModifiedDate]
				, PAIT.[LastModifiedByUserId], GETUTCDATE()
			FROM [#ProcessAsyncInteractionTemp] PAIT
			LEFT JOIN [dbo].[ProcessAsyncInteraction] PAI (NOLOCK)
				ON PAI.[VCC] = PAIT.[VCC]
					AND PAI.[ProcessId] = PAIT.[ProcessId]
					AND PAI.[InteractionType] = PAIT.[InteractionType]
					AND PAI.[InteractionId] = PAIT.[InteractionId]
					--AND PAI.[EndDate] = PAIT.[EndDate]
					AND PAI.[FormattedEndDate] = PAIT.[FormattedEndDate]
			WHERE PAI.[InteractionId] IS NULL
	
	-- ELIMINAMOS LAS TABLAS TEMPORALES
	DROP TABLE [#AsyncInteractionTemp]
	DROP TABLE [#ProcessAsyncInteractionTemp]
END
GO
PRINT N'Modificando [dbo].[GetAudiosProcess]...';


GO
-- [dbo].[GetAudiosProcess] 5, 1, 'allegro', 'proceso1', '', '2019-04-11 00:00:00.000', '2019-06-06 04:59:59.997', 22, 26, 23, 59, 'entrantes,PruebasJair,VideoCall', 'icagente', NULL, 'allegro', '', ''
ALTER PROCEDURE [dbo].[GetAudiosProcess]
(
	@PageSize				INT,
	@PageNumber				INT,
	@VCC					VARCHAR(50),
	@ProcessId				VARCHAR(50),
	@ID						VARCHAR(250),
	@StartDate				DATETIME = NULL,
	@EndDate				DATETIME = NULL,
	@StartHour				INT,
	@StartMinute			INT,
	@EndHour				INT,
	@EndMinute				INT,
	@Campaign				VARCHAR(MAX),
	@Agent					VARCHAR(MAX),
	@ResultCode				VARCHAR(MAX),
	@Type					VARCHAR(50),
	@IdathaResults			NVARCHAR(MAX),
	@TotalIdathaResults		INT,
	@InteractionType		VARCHAR(50),
	@InteractionIds         VARCHAR(MAX) = NULL,
	@Folder					VARCHAR(50)
)
AS
BEGIN
	SET NOCOUNT ON
	
	-- DEFINIMOS UNA TABLE TEMPORAL PARA DEPOSITAR LA TODOS LAS INTERACCIONES DEL PROCESS
	CREATE TABLE #PROCESS_INTERACTIONS(
		vcc VARCHAR(50),
		interactionType VARCHAR(100),
		id VARCHAR(250),
		section VARCHAR(100),
		part VARCHAR(100),
		processId VARCHAR(100),
		number VARCHAR(100),
		name VARCHAR(100),
		silenceTime INT,
		durationTime INT,
		durationLinguisticTime INT,
		category1 VARCHAR(100),
		category2 VARCHAR(100),
		category3 VARCHAR(100),
		agent VARCHAR(100),
		agentName VARCHAR(150),
		description VARCHAR(100),
		environment VARCHAR(100),
		isTranscribed VARCHAR(100),
		errorMessage VARCHAR(100),
		createdDate DATETIME,
		endDate DATETIME,
		campaign VARCHAR(50),
		dispositionCode VARCHAR(250),
		folder VARCHAR(50)
	)

	-- INSERTAMOS LOS REGISTROS CALL
	INSERT INTO #PROCESS_INTERACTIONS
		SELECT A.[VCC]						'vcc',
				'CALL'						'interactionType',
				A.[ID]						'id',
				A.[Section]					'section',
				A.[Part]					'part',
				PA.[ProcessId]				'processId',
				A.[Number]					'number',
				P.[Name]					'name',
				A.[SilenceTime]				'silenceTime',
				A.[DurationTime]			'durationTime',
				A.[DurationLinguisticTime]	'durationLinguisticTime',
				A.[Category1]				'category1',
				A.[Category2]				'category2',
				A.[Category3]				'category3',
				A.[Agent]					'agent',
				A.[AgentName]				'agentName',
				A.[Description]				'description',
				P.[Environment]				'environment',
				A.[IsTranscribed]			'isTranscribed',
				A.[ErrorMessage]			'errorMessage',
				A.[CreatedDate]				'createdDate',
				A.[EndDate]					'endDate',
				A.[Campaign]				'campaign',
				A.[DispositionCode]			'dispositionCode',
				NULL						'folder'
			FROM [dbo].[Audio] A (NOLOCK)
			INNER JOIN [dbo].[ProcessAudio] PA (NOLOCK) 
				ON A.ID = PA.AudioId 
					AND A.Section = PA.Section 
					AND A.Part = PA.Part
			INNER JOIN [dbo].[Process] P (NOLOCK) 
				ON PA.[ProcessId] = P.[Name]
			WHERE A.[VCC] = @VCC
				AND PA.[ProcessId] = @ProcessId
				AND P.[Type] = 'SPEECH'
				
	-- INSERTAMOS LOS REGISTROS DE INTERACCIONES DE OTROS CANALES
	INSERT INTO #PROCESS_INTERACTIONS
		SELECT AI.[VCC]																'vcc',
				AI.[Channel]														'interactionType',
				AI.[ID]																'id',
				NULL																'section',
				NULL																'part',
				PAI.[ProcessId]														'processId',
				AI.[ContactName]													'number',
				PAI.[ProcessId]														'name',
				NULL																'silenceTime',
				CASE WHEN TRY_CAST(AI.[DurationTime] AS INT) IS NULL THEN
					CAST(SUBSTRING(AI.[DurationTime], 1, CHARINDEX(':', AI.[DurationTime], 1) - 1) AS INT) * 3600
					+
					CAST(SUBSTRING(AI.[DurationTime], CHARINDEX(':', AI.[DurationTime], 1) + 1, 2) AS INT) * 60
					+
					CAST(SUBSTRING(AI.[DurationTime], CHARINDEX(':', AI.[DurationTime], CHARINDEX(':', AI.[DurationTime], 1) + 1) + 1, 2) AS INT)
				ELSE AI.[DurationTime]
				END																	'durationTime',
				NULL																'durationLinguisticTime',
				NULL																'category1',
				NULL																'category2',
				NULL																'category3',
				AI.[FirstTakedAgent]												'agent',
				ISNULL(AI.[LastTakedAgentName], AI.[LastTakedAgentName])			'agentName',
				AI.[DispositionCode]												'description',
				'I6'																'environment',
				AI.[IsTranscribed]													'isTranscribed',
				AI.[ErrorMessage]													'errorMessage',
				AI.[CreatedDate]													'createdDate',
				AI.[EndDate]														'endDate',
				AI.[Campaign]														'campaign',
				AI.[DispositionTreePath]											'dispositionCode',
				AI.[Folder]															'folder'
			FROM [dbo].[ProcessAsyncInteraction] PAI (NOLOCK)
			INNER JOIN [dbo].[AsyncInteraction] AI (NOLOCK)
				ON AI.[VCC] = PAI.[VCC]
					--AND AI.[Campaign] = PAI.[Campaign]
					AND AI.[Channel] = PAI.[InteractionType]
					AND AI.[ID] = PAI.[InteractionId]
					AND AI.[Folder] = PAI.[FormattedEndDate]
			INNER JOIN [dbo].[Process] P (NOLOCK) 
				ON P.[Name] = PAI.[ProcessId]
			WHERE PAI.[VCC] = @VCC
				AND PAI.[ProcessId] = @ProcessId
				AND P.[Type] = 'SPEECH'
		
	-- DECLARAMOS VARIABLE PARA LA CONSULTA ACUMULADA QUE LANZAREMOS
	DECLARE @SQL NVARCHAR(MAX) = ''
	DECLARE @SQL_WHERE_IDATHA NVARCHAR(MAX) = ''
    DECLARE @FILTERS_OPTIONAL_PART VARCHAR(MAX) = ''
	DECLARE @FILTERS_EXCLUDING_PART VARCHAR(MAX )= ''	
	
	SET @SQL_WHERE_IDATHA = ''

	-- HACEMOS EL PRIMER QUERY PARA SACAR EL NUMERO DE REGISTROS DEL PROCESS
	SET @SQL = ' SET NOCOUNT ON
	DECLARE @rows INT
	DECLARE @SYNC_INTERACTIONS INT
	DECLARE @ASYNC_INTERACTIONS INT
	DECLARE @maxDurationTime Numeric(12,3)

	SELECT @SYNC_INTERACTIONS = COUNT(*) FROM #PROCESS_INTERACTIONS PI WHERE PI.[interactionType] = ''CALL''
	SELECT @ASYNC_INTERACTIONS = COUNT(*) FROM #PROCESS_INTERACTIONS PI WHERE PI.[interactionType] <> ''CALL''
	SELECT @maxDurationTime = MAX([durationTime]) FROM #PROCESS_INTERACTIONS 
	'

	SET @SQL += '
		SET @rows = (
			SELECT COUNT(PI.[id])
				FROM #PROCESS_INTERACTIONS PI (NOLOCK)
				WHERE PI.[vcc] = ''' + @VCC + ''' 
					'
	IF (@ProcessId IS NOT NULL) 
			SET @SQL += 'AND PI.[ProcessId]= ''' + @ProcessId + ''' 
						'

	IF(@Type = 'query')
	BEGIN
		SET @SQL_WHERE_IDATHA += 'AND ((CONCAT(PI.[id], ''_'', PI.[section], ''_'', PI.[part]) IN (''' + @IdathaResults + '''))
						OR (PI.[id] IN (''' + @IdathaResults + ''')))
					'
	
		SET @SQL += @SQL_WHERE_IDATHA

	END
	ELSE IF(@Type = 'allegro' OR @Type = 'ftp' OR @Type = 'sftp' OR @Type = 'fileSystem')
	BEGIN
		IF (@ID IS NOT NULL) 
			SET @FILTERS_OPTIONAL_PART += 'AND ((CONCAT(PI.[id], ''_'', PI.[section], ''_'', PI.[part]) LIKE ''%' + @ID + '%'')
						OR (PI.[id] = ''' + @ID + '''))
					'
		
		IF (@Campaign IS NOT NULL AND LEN(@Campaign) > 0) 
			SET @FILTERS_OPTIONAL_PART += 'AND PI.[campaign] IN (''' + @Campaign + ''')
						'
		
		IF (@Agent IS NOT NULL AND LEN(@Agent) > 0) 
			SET @FILTERS_OPTIONAL_PART += 'AND (
									(PI.[agent] IN (''' + @Agent + '''))
									OR 
									(PI.[agent] IS NULL)
								)
						'
		
		--CORREGIR
		-- (CONCAT(PI.campaign, ''_'', ISNULL(CONVERT(VARCHAR(4), PI.[dispositionCode]), '''') IN (''' + @ResultCode + '''))
		IF (@ResultCode IS NOT NULL AND LEN(@ResultCode) > 0) 
			SET @FILTERS_OPTIONAL_PART += 'AND (
									(CONCAT(PI.campaign, ''_'', ISNULL(CONVERT(VARCHAR(4), PI.[dispositionCode]), ''X'')) IN (''' + @ResultCode + '''))
									OR 
									--(CONCAT(PI.campaign, ''_'', ISNULL(PI.[dispositionCode], ''X'')) IN (''' + @ResultCode + '''))
									(CONCAT(PI.campaign, ISNULL(REPLACE(PI.[dispositionCode], ''/'', ''_''), ''_'')) IN (''' + @ResultCode + '''))
									) '
		
		IF (@InteractionType IS NOT NULL AND LEN(@InteractionType) > 0) 
			SET @FILTERS_OPTIONAL_PART += 'AND PI.[interactionType] = ''' + @InteractionType + ''' 
						'

		IF (@Folder IS NOT NULL AND LEN(@Folder) > 0) 
			SET @FILTERS_OPTIONAL_PART += 'AND PI.[folder] = ''' + @Folder + ''' 
						'

		IF (@Folder IS NOT NULL AND LEN(@Folder) > 0) 

		IF (@StartDate IS NOT NULL AND @EndDate IS NOT NULL) 
			SET @FILTERS_OPTIONAL_PART += 'AND PI.[endDate] BETWEEN ''' + CONVERT(VARCHAR(10), @StartDate, 120) + ''' 
						AND ''' + CONVERT(VARCHAR(10), @EndDate, 120) + '''
						'
		
		IF (@StartHour IS NOT NULL AND @EndHour IS NOT NULL) 
			SET @FILTERS_OPTIONAL_PART += 'AND DATEPART(HOUR, PI.[endDate]) >= ' + CONVERT(VARCHAR, @StartHour) + ' 
						AND DATEPART(HOUR, PI.[endDate]) <= ' + CONVERT(VARCHAR, @EndHour) + '
						'
		
		IF (@StartMinute IS NOT NULL AND @EndMinute IS NOT NULL) 
			SET @FILTERS_OPTIONAL_PART += 'AND DATEPART(MINUTE, PI.[endDate]) >= ' + CONVERT(VARCHAR, @StartMinute) + ' 
						AND DATEPART(MINUTE, PI.[endDate]) <= ' + CONVERT(VARCHAR, @EndMinute) + '
						'

		IF (@InteractionIds IS NOT NULL AND @InteractionIds <> '')
        BEGIN
			SET @FILTERS_OPTIONAL_PART = ''
			SET @FILTERS_EXCLUDING_PART = ' AND PI.[id] IN (SELECT Value FROM [dbo].[split](''' + @InteractionIds + ''','','')) 
						'
	    END
		
	END

	SET @SQL += @FILTERS_OPTIONAL_PART + @FILTERS_EXCLUDING_PART
	SET @SQL += ') '
	SET @SQL += 'SELECT @rows AS total, 
						@maxDurationTime AS maxDurationTime,
						@ASYNC_INTERACTIONS AS asyncDetails, 
						@SYNC_INTERACTIONS AS audios '

	-- SECCION DE QUERY PARA RESUMEN DE CANALES
	SET @SQL += '
		SELECT PI.[interactionType]			''interactionType'',
				COUNT(*)					''interactions'' 
			FROM #PROCESS_INTERACTIONS PI 
			WHERE PI.[vcc] = ''' + @VCC + ''' 
	'

	IF(@ProcessId IS NOT NULL) 
		SET @SQL += '
				AND PI.[processId] = ''' + @ProcessId + ''' '
		
	SET @SQL += '
		GROUP BY  PI.[interactionType] '

	-- SECCION DE QUERY PARA RESUMEN DE CAMPANAS
	SET @SQL += '
		SELECT PI.[campaign]			''campaign''
			FROM #PROCESS_INTERACTIONS PI 
			WHERE PI.[vcc] = ''' + @VCC + ''' 
	'

	IF(@ProcessId IS NOT NULL) 
		SET @SQL += '
				AND PI.[processId] = ''' + @ProcessId + ''' '
		
	SET @SQL += '
		GROUP BY  PI.[campaign] '

	-- SECCION DE QUERY PARA LISTADO DE DETALLES(AUDIOS/TEXTOS)
	SET @SQL += '
		SELECT PI.[interactionType],
				PI.[id],
				PI.[section],
				PI.[part],
				PI.[processId],
				PI.[folder],
				PI.[campaign],
				PI.[number],
				PI.[name],
				PI.[silenceTime],
				PI.[durationTime],
				PI.[durationLinguisticTime],
				PI.[category1],
				PI.[category2],
				PI.[category3],
				PI.[agent],
				PI.[agentName],
				PI.[description],
				PI.[environment],
				PI.[isTranscribed],
				PI.[errorMessage],
				PI.[createdDate],
				PI.[endDate]
			FROM #PROCESS_INTERACTIONS PI
			WHERE PI.[vcc] = ''' + @VCC + ''' 
				'

	IF(@ProcessId IS NOT NULL) SET @SQL += 'AND PI.[processId] = ''' + @ProcessId + ''' '
			
	SET @SQL += ' '

	SET @SQL += @FILTERS_OPTIONAL_PART + @FILTERS_EXCLUDING_PART
	SET @SQL += @SQL_WHERE_IDATHA
	SET @SQL += 'ORDER BY PI.[ID], 
						PI.[ProcessId], 
						PI.[Agent], 
						PI.[AgentName], 
						PI.[Description], 
						PI.[Environment], 
						PI.[DurationTime], 
						PI.[CreatedDate]
			OFFSET ' + CONVERT(VARCHAR(50), @PageSize) + ' * (' + CONVERT(VARCHAR(50), @PageNumber) + ' - 1) ROWS
			FETCH NEXT ' + CONVERT(VARCHAR(50), @PageSize) + ' ROWS ONLY
			'

	SET @SQL += ' SET NOCOUNT OFF'
	--select @SQL
	EXEC(@SQL)
	
	DROP TABLE #PROCESS_INTERACTIONS
END
GO
PRINT N'Modificando [dbo].[GetProcessInteractionsTask]...';


GO
ALTER PROCEDURE [dbo].[GetProcessInteractionsTask]
(
	@VCC		VARCHAR(50),
	@ProcessId	VARCHAR(50)
)
AS
BEGIN
	SET NOCOUNT ON

	BEGIN
		-- ACTUALIZAMOS LOS REGISTROS DE INTERACCIONES SINCRONAS(CALL) Y RETORNAMOS LOS DETALLES DE LAS QUE SE VAN A TRANSCRIBIR

		-- Actualiza en el primer momento que se consulta a estos registros, con el valor 1 en el campo IsProcess. Indica que se encuentra utilizado por un proceso.
		UPDATE [dbo].[Audio] SET
			[dbo].[Audio].[IsProcess] = 1,	-- Indicar que se esta tomando como procesando para que ningun otro procesamiento en parelelo pueda utilizar el registro.
			[dbo].[Audio].[IsCancel] = null -- Limpiamos el campo isCancel para retomar los audios que fallaron en procesos pasados
		-- Retornamos todas las columnas a listar.
		OUTPUT INSERTED.[VCC]							'vcc',
				PA.[ProcessId]							'processId',
				'CALL'									'interactionType',
				INSERTED.[ID]							'id',
				INSERTED.[Section]						'section',
				INSERTED.[Part]							'part',
				INSERTED.[StartDate]					'startDate',
				INSERTED.[EndDate]						'endDate',
				INSERTED.[Campaign]						'campaign',
				INSERTED.[DispositionCode]				'dispositionCode',
				INSERTED.[Agent]						'agent',
				INSERTED.[Type]							'origin',
				P.[Language]							'language',
				E.[Name]								'name',
				E.[Type]								'environmentType',
				E.[Description]							'description',
				E.[FTPDirectory]						'ftpDirectory',
				E.[ApiHost]								'apiHost',
				E.[ApiPort]								'apiPort',
				E.[ApiUser]								'apiUser',
				E.[ApiPassword]							'apiPassword',
				E.[DbDisabled]							'dbDisabled',
				E.[DbServer]							'dbServer',
				E.[DbPort]								'dbPort',
				E.[DbUser]								'dbUser',
				E.[DbPassword]							'dbPassword',
				E.[PbxDisabled]							'pbxDisabled',
				E.[PbxServer]							'pbxServer',
				E.[PbxPort]								'pbxPort',
				E.[PbxUser]								'pbxUser',
				E.[PbxPassword]							'pbxPassword',
				INSERTED.[DurationTime]					'durationTime'
		FROM [dbo].[ProcessAudio] PA (NOLOCK)
		INNER JOIN [dbo].[Audio] A (NOLOCK) 
			ON A.[VCC] = PA.[VCC]
				AND CONCAT(A.[ID], '_', A.[Section], '_', A.[Part]) = CONCAT(PA.[AudioId], '_', PA.[Section], '_', PA.[Part])
		INNER JOIN [dbo].[Process] P (NOLOCK) 
			ON P.[VCC] = A.[VCC]
				AND PA.ProcessId = P.[Name]
		INNER JOIN [dbo].[Environment] E (NOLOCK) 
			ON E.[VCC] = PA.[VCC]
				AND P.[Environment] = E.[Name]
		WHERE A.[VCC] = @VCC
			AND PA.[ProcessId] = @ProcessId
			AND ((ISNULL(A.[IsProcess], 0) = 0				
					AND ISNULL(A.[IsTranscribed], 0) = 0)	-- RETORNAR SOLO LAS INTERACCIONES QUE NO HAYAN SIDO TOMADAS POR OTRO PROCESS
				OR (A.[IsProcess] = 1						
					AND A.[IsCancel] = 1))					-- RETORNAR SOLO LAS INTERACCIONES QUE HAYAN SIDO TOMADAS Y CANCELADAS POR OTRO PROCESS

		-- ACTUALIZAMOS LOS REGISTROS DE INTERACCIONES ASINCRONAS Y RETORNAMOS LOS DETALLES DE LAS QUE SE VAN A TRANSCRIBIR
		UPDATE [dbo].[AsyncInteraction] 
		SET [dbo].[AsyncInteraction].[IsProcess] = 1,
			[dbo].[AsyncInteraction].[IsCancel] = NULL
		OUTPUT INSERTED.[VCC]														'vcc',
				P.[Name]															'processId',
				INSERTED.[Channel]													'interactionType',
				INSERTED.[ID]														'id',
				INSERTED.[EndDate]													'endDate',
				INSERTED.[Folder]													'folder',
				INSERTED.[Campaign]													'campaign',
				INSERTED.[DispositionCode]											'dispositionCode',
				ISNULL(INSERTED.[LastTakedAgent], INSERTED.[FirstTakedAgent])		'agent',
				INSERTED.[Initiative]												'origin',
				INSERTED.[TotalMessages]											'totalMessages',
				INSERTED.[RawChar]													'rawChar',
				INSERTED.[ExportedContent]											'exportedContent',
				P.[Language]														'language',
				'allegro'															'environmentType'
		FROM [dbo].[ProcessAsyncInteraction] PAI (NOLOCK)
		INNER JOIN [dbo].[AsyncInteraction] AI (NOLOCK)
			ON AI.[ID] = PAI.[InteractionId]
				AND AI.[EndDate] = PAI.[EndDate]
		INNER JOIN [dbo].[Process] P (NOLOCK) 
			ON P.[Name] = PAI.[ProcessId] 
		WHERE AI.[VCC] = @VCC
			AND PAI.[ProcessId] = @ProcessId
			AND ((ISNULL(AI.[IsProcess], 0) = 0
					AND ISNULL(AI.[IsTranscribed], 0) = 0)	-- RETORNAR SOLO LAS INTERACCIONES QUE NO HAYAN SIDO TOMADAS POR OTRO PROCESS
				OR (AI.[IsProcess] = 1
					AND AI.[IsCancel] = 1))					-- RETORNAR SOLO LAS INTERACCIONES QUE HAYAN SIDO TOMADAS Y CANCELADAS POR OTRO PROCESS
	END

	SET NOCOUNT OFF
END
GO
PRINT N'Modificando [dbo].[BulkAudio]...';


GO
ALTER PROCEDURE [dbo].[BulkAudio]
AS
BEGIN
	-- EMULAMOS UNA NUEVA TABLA EN BASE A #AudioTemp DONDE SE REMOVERAN TODOS LOS REGISTROS DUPLICADOS PARA EL PK DE LA TABLA Audio
	WITH CTE AS (
		SELECT A.[VCC], A.[ID], A.[Section], A.[Part], A.[Number],
				A.[Gender], A.[SilenceTime], A.[DurationTime], A.[Category1], A.[Category2],
				A.[Category3], A.[Description], A.[Campaign], A.[Agent], AG.[Name] 'AgentName',
				A.[Type], A.[Init], A.[StartDate], A.[EndDate], A.[DispositionCode], 
				A.[CreatedDate], A.[CreatedByUserId], A.[LastModifiedDate], A.[LastModifiedByUserId], RN = ROW_NUMBER() OVER(PARTITION BY A.[VCC], A.[ID], A.[Section], A.[Part] ORDER BY A.[ID])
	    FROM #AudioTemp A (NOLOCK)
	    LEFT JOIN [dbo].[Agent] AG (NOLOCK)
			ON AG.[VCC] = A.[VCC]
				AND AG.[AgentId] = A.[Agent]
	)
	-- LA TABLA TEMPORAL #AudioTemp LLEGA CON ALGUNOS REGISTROS DUPLICADOS DEBIDO A LOS CRUCES AL APLICAR LOR FILTROS, POR ELLO DEBEMOS 
	-- IDENTIFICAR LOS REPETIDOS, RN = ROW_NUMBER() OVER(PARTITION BY ...) <- NUMERA CADA REGISTRO SEGUN EL(LOS) VALOR(ES) DE ...

	-- EL CTE SOLO PUEDE SER INVOCADO UNA VEZ POR ESO LO PONEMOS EN EL SELECT FINAL DONDE EL CONTADOR(RN) ES 1
	--DELETE FROM CTE WHERE RN > 1

	INSERT INTO dbo.Audio(
			[VCC]
			,[ID]
			,[Section]
			,[Part]
			,[Number]
			,[Gender]
			,[SilenceTime]
			,[DurationTime]
			,[Category1]
			,[Category2]
			,[Category3]
			,[Description]
			,[Campaign]
			,[Agent]
			,[AgentName]
			,[Type]
			,[Init]
			,[StartDate]
			,[EndDate]
			,[DispositionCode]
			,[CreatedDate]
			,[CreatedByUserId]
			,[LastModifiedDate]
			,[LastModifiedByUserId]
			,[TimeStamp]
			) 
		SELECT
			 A.[VCC]
			,A.[ID]
			,A.[Section]
			,A.[Part]
			,A.[Number]
			,A.[Gender]
			,A.[SilenceTime]
			,A.[DurationTime]
			,A.[Category1]
			,A.[Category2]
			,A.[Category3]
			,A.[Description]
			,A.[Campaign]
			,A.[Agent]
			,A.[AgentName]
			,A.[Type]
			,A.[Init]
			,A.[StartDate]
			,A.[EndDate]
			,A.[DispositionCode]
			,A.[CreatedDate]
			,A.[CreatedByUserId]
			,A.[LastModifiedDate]
			,A.[LastModifiedByUserId]
			,GETUTCDATE()
		FROM CTE A (NOLOCK)
		WHERE A.RN = 1
			AND NOT EXISTS (
			SELECT * FROM Audio B (NOLOCK)
			WHERE B.[VCC] = A.[VCC]
			AND B.[ID] = A.[ID]
			AND B.[Section] = A.[Section]
			AND B.[Part] = A.[Part]
		);

	-- EMULAMOS UNA NUEVA TABLA EN BASE A #AudioTemp DONDE SE REMOVERAN TODOS LOS REGISTROS DUPLICADOS PARA EL PK DE LA TABLA Audio
	WITH CTE_PAT AS (
	   SELECT PAT.[VCC], PAT.[ProcessId], PAT.[AudioId], PAT.[Section], PAT.[Part]
			,PAT.[CreatedDate], PAT.[CreatedByUserId], PAT.[LastModifiedDate], PAT.[LastModifiedByUserId], RN = ROW_NUMBER() OVER(PARTITION BY PAT.[VCC], PAT.[ProcessId], PAT.[AudioId], PAT.[Section], PAT.[Part] ORDER BY PAT.[AudioId])
	   FROM #ProcessAudioTemp PAT (NOLOCK)
	)
	-- EL CTE_PAT SOLO PUEDE SER INVOCADO UNA VEZ POR ESO LO PONEMOS EN EL SELECT FINAL DONDE EL CONTADOR(RN) ES 1
	--DELETE FROM CTE_PAT WHERE RN > 1
		
	-- Insertamos registros en la tabla ProcessAudio
	INSERT INTO dbo.ProcessAudio
			([VCC]
			,[ProcessId]
			,[AudioId]
			,[Section]
			,[Part]
			,[CreatedDate]
			,[CreatedByUserId]
			,[LastModifiedDate]
			,[LastModifiedByUserId]
			,[TimeStamp]
			) 
		SELECT
			 PAT.[VCC]
			,PAT.[ProcessId]
			,PAT.[AudioId]
			,PAT.[Section]
			,PAT.[Part]
			,PAT.[CreatedDate]
			,PAT.[CreatedByUserId]
			,PAT.[CreatedDate]
			,PAT.[CreatedByUserId]
			,GETUTCDATE()
		FROM CTE_PAT PAT (NOLOCK)
		WHERE PAT.RN = 1
			AND NOT EXISTS (
			SELECT * FROM ProcessAudio PA (NOLOCK)
			WHERE PA.[VCC] = PAT.[VCC]
			AND PA.[ProcessId] = PAT.[ProcessId]
			AND PA.[AudioId] = PAT.[AudioId]
			AND PA.[Section] = PAT.[Section]
			AND PA.[Part] = PAT.[Part]
		)
		GROUP BY 
			PAT.[VCC]
			,PAT.[ProcessId]
			,PAT.[AudioId]
			,PAT.[Section]
			,PAT.[Part]
			,PAT.[CreatedByUserId]
			,PAT.[CreatedDate]

		DROP TABLE #AudioTemp
		DROP TABLE #ProcessAudioTemp

END
GO
PRINT N'Modificando [dbo].[GetEvaluationPlanInteractionByTypeAndId]...';


GO
-- ESTE SP RETORN LAS TRANSCRIPCIONES DE UNA INTERACCION SEGUN SU VCC, INTERACTIONTYPE(CHANNEL), INTERACTIONID
ALTER PROCEDURE [dbo].[GetEvaluationPlanInteractionByTypeAndId] (
	@VCC VARCHAR(50) = NULL,
	@EvaluationPlanId VARCHAR(50) = NULL,
	@InteractionType VARCHAR(50) = NULL,
	@InteractionId VARCHAR(250) = NULL
)
AS
BEGIN
	SET NOCOUNT ON

	-- RECUPERAMOS EL PRIMER REGISTRO POR ID DE INTERACCION
	SELECT TOP 1 IEP.[Instance]									AS 'vcc',
					IEP.[IdAgent]								AS 'descriptionAgent',
					''											AS 'descriptionAuditor',
					IEP.[IdCampaign]							AS 'descriptionCampaign',
					EP.[Description]							AS 'descriptionEvaluationPlan',
					IEP.[InteractionDateStart]					AS 'dateIni',
					IEP.[InteractionDateEnd]					AS 'dateFin',
					IEP.[IdInteraction]							AS 'id',
					IEP.[IdAgent]								AS 'idAgent',
					IEP.[AgentName]								AS 'agentName',
					''											AS 'idAuditorEvaluationPlan',
					IEP.[IdCampaign]							AS 'idCampaign',
					IEP.[IdEvaluationPlan]						AS 'idEvaluationPlan',
					IEP.[InteractionType]						AS 'interactionType',
					IEP.[InteractionDuration]					AS 'interactionTime',
					A.[DurationLinguisticTime]					AS 'interactionValidTime',
					''											AS 'origin',
					IEP.[InteractionMessages]					AS 'totalMessages',
					A.[Number]									AS 'number'
		FROM [dbo].[InteractionEvaluationPlan] IEP (NOLOCK)
		LEFT JOIN [dbo].[EvaluationPlan] EP (NOLOCK) 
			ON EP.[Instance] = IEP.[Instance]
				AND EP.[ID] = IEP.[IdEvaluationPlan]
		LEFT JOIN [dbo].[Audio] A (NOLOCK)
			ON A.[VCC] = IEP.[Instance]
				AND A.[ID] = IEP.[IdInteraction]
				AND A.[Section] = IEP.[InteractionSection]
				AND A.[Part] = IEP.[InteractionPart]
		WHERE IEP.[Instance] = @VCC
			AND IEP.[IdEvaluationPlan] = @EvaluationPlanId
			AND IEP.[InteractionType] = @InteractionType
			AND IEP.[IdInteraction] = @InteractionId

	SET NOCOUNT OFF
END
GO
PRINT N'Modificando [dbo].[SaveEvaluationBaseResult]...';


GO

ALTER PROCEDURE [dbo].[SaveEvaluationBaseResult] (
	@VCC VARCHAR(50) = NULL,
	@EVALUATION_PLAN_ID VARCHAR(100) = NULL,
	@ABILITY_TYPE VARCHAR(50) = NULL
) AS
BEGIN
	-- ESTE SP INSERTA LOS RESULT BASE DE UN PLAN AUTOMATICO/MIXTO
	SET NOCOUNT ON

	-- SETTEAMOS EL TYPE ABILITY COMO AUTOMATIC PO DEFECTO
	IF @ABILITY_TYPE IS NULL SET @ABILITY_TYPE = 'AUTOMATIC'
	
	;
	-- EMULAMOS UNA NUEVA TABLA VARIABLE PARA OBTENER LOS REGISTROS UNICOS QUE INSERTAREMOS EN LA TABLA EVALUATION_RESULT
	--  ORDENANDO POR SECTION Y PART
	WITH CTE AS (
		SELECT IEP.[Instance]									'vcc', 
				IEP.[IdCampaign]								'IdCampaign',
				IEP.[IdInteraction]								'IdInteraction',
				IEP.[IdAgent]									'IdAgent', 
				EP.[IdEvaluationFormat]							'IdEvaluationFormat', 
				EF.[MinQualificationAcceptable]					'MinQualificationAcceptable',
				AEF.[IdGroup]									'IdGroup', 
				AEF.[IdSubGroup]								'IdSubGroup', 
				AEF.[IdAbility]									'IdAbility',
				S.[Value]										'Qualification', 
				EP.[ID]											'IdEvaluationPlan', 
				S.[Description]									'ScoreDescription', 
				IEP.[IdCampaign]								'CampaignDescription', 
				IEP.[IdAgent]									'AgentDescription',
				IEP.[InteractionDateStart]						'InteractionDateini', 
				IEP.[InteractionDateEnd]						'InteractionDatefin', 
				IEP.[ContactId]									'InteractionAddress', 
				AEF.[Order]										'AbilityOrder', 
				IEP.[InteractionType]							'InteractionType', 
				AEF.[ID]										'IdAbilityEvaluationFormat', 
				AEF.[Conditional]								'Conditional', 
				RN = ROW_NUMBER() OVER(PARTITION BY IEP.[IdCampaign],
													IEP.[IdInteraction],
													IEP.[IdAgent], 
													EP.[IdEvaluationFormat], 
													EF.[MinQualificationAcceptable],
													AEF.[IdGroup], 
													AEF.[IdSubGroup], 
													AEF.[IdAbility],
													S.[Value], 
													S.[Description], 
													IEP.[IdCampaign], 
													IEP.[IdAgent],
													IEP.[InteractionDateStart], 
													IEP.[InteractionDateEnd], 
													AEF.[Order], 
													IEP.[InteractionType], 
													AEF.[ID], 
													AEF.[Conditional]
										ORDER BY IEP.[InteractionSection] ASC, IEP.[InteractionPart] ASC) 
			FROM EvaluationPlan EP (NOLOCK)
			LEFT JOIN EvaluationFormat EF (NOLOCK) 
				ON EF.[Instance] = EP.[Instance]
					AND EF.[ID] = EP.[IdEvaluationFormat]
			LEFT JOIN InteractionEvaluationPlan IEP (NOLOCK)
				ON IEP.[Instance] = EP.[Instance]
					AND IEP.[IdEvaluationPlan] = EP.[ID]
			LEFT JOIN AbilityEvaluationFormat AEF (NOLOCK)
				ON AEF.[Instance] = EP.[Instance]
					AND AEF.[IdEvaluationFormat] = EF.[ID]
			LEFT JOIN Ability A (NOLOCK) 
				ON A.[Instance] = EP.[Instance]
					AND A.[ID] = AEF.[IdAbility]
			LEFT JOIN Intent I (NOLOCK) 
				ON I.[VCC] = EP.[Instance]
					AND I.[IntentId] = A.[QueryName]
			LEFT JOIN [dbo].[Score] S (NOLOCK) 
				ON S.[Instance] = IEP.[Instance]
					AND S.[IdAbility] = A.[ID]
					AND S.[Value] = 0
			LEFT JOIN [dbo].[EvaluationResult] ER (NOLOCK) 
				ON ER.[Instance] = IEP.[Instance]
					AND ER.[IdEvaluationPlan] = IEP.[IdEvaluationPlan]
					AND ER.[IdAgent] = IEP.[IdAgent]
					AND ER.[IdAbilityEvaluationFormat] = AEF.[ID]
			WHERE IEP.[IdInteraction] IS NOT NULL
				AND (
					-- (@ABILITY_TYPE = 'AUTOMATIC' AND I.[VCC] IS NOT NULL)
					(@ABILITY_TYPE = 'AUTOMATIC' AND A.[Type] = 'MANUAL_AUTOMATIC')
					OR
					-- (@ABILITY_TYPE = 'MANUAL' AND I.[VCC] IS NULL)
					(@ABILITY_TYPE = 'MANUAL' AND A.[Type] = 'MANUAL')
				)
				AND ER.[Instance] IS NULL
				AND EP.[ID] = @EVALUATION_PLAN_ID
				AND EP.[Instance] = @VCC

	)

	-- INSERTAMOS SOLO LAS PRIMERAS OCURRENCIAS PARA CADA INTERACCION
	INSERT INTO [dbo].[EvaluationResult] (
		[Instance], [IdCampaign], [IdInteraction],
		[IdAgent], [IdEvaluationFormat], [MinQualificationAcceptable],
		[IdGroup], [IdSubGroup], [IdAbility],
		[Qualification], [IdEvaluator], [EvaluationDate],
		[MaxAbilityScore], [IdEvaluationPlan], [CreatedDate],
		[CreatedByUserId], [LastModifiedDate], [LastModifiedByUserId],
		[TimeStamp], [Comment], [NotApplies],
		[ScoreDescription], [CampaignDescription], [AgentDescription],
		[InteractionDateini], [InteractionDatefin], [InteractionAddress], 
		[AbilityOrder], [InteractionType], [IdAbilityEvaluationFormat], 
		[IdAuditor], [Conditional]
	) 
		SELECT C.[vcc], C.[IdCampaign], C.[IdInteraction],
				C.[IdAgent], C.[IdEvaluationFormat], C.[MinQualificationAcceptable],
				C.[IdGroup], C.[IdSubGroup], C.[IdAbility],
				C.[Qualification], 'SPEECH', GETUTCDATE(),
				'100', C.[IdEvaluationPlan], GETUTCDATE(),
				'SPEECH', GETUTCDATE(), 'SPEECH',
				GETUTCDATE(), NULL, '0',
				C.[ScoreDescription], C.[CampaignDescription], C.[AgentDescription],
				C.[InteractionDateini], C.[InteractionDatefin], C.[InteractionAddress], 
				C.[AbilityOrder], C.[InteractionType], C.[IdAbilityEvaluationFormat], 
				'SPEECH', C.[Conditional]
			FROM CTE C 
			WHERE C.RN = 1
	
	SET NOCOUNT OFF
END
GO
PRINT N'Modificando [dbo].[SaveInteractionEvaluationPlan]...';


GO

ALTER PROCEDURE [dbo].[SaveInteractionEvaluationPlan] (
	@Instance Varchar(50) = NULL, 
	@IdEvaluationPlan Varchar(50) = NULL,
	@IdAgent Varchar(50) = NULL,
	@IdCampaign Varchar(50) = NULL,
	@IdInteraction Varchar(250) = NULL,
	@InteractionSection Int = 0,
	@InteractionPart Int = 0,
	@InteractionFolder VARCHAR(50) = NULL,
	@InteractionDateStart DateTime = '1980-01-01',
    @InteractionDateEnd DateTime = '2050-01-01',
	@InteractionType Varchar(50) = NULL,
	@TotalMessages INT = NULL,
	@InteractionDuration Int = 0,
	@InteractionOrigin Varchar(50) = NULL,
	@InteractionManagementResult Varchar(50) = NULL,
	@InteractionContactId Varchar(50) = NULL,
	@InteractionFormat Varchar(20) = NULL,
	@LastModifiedByUserId Varchar(50) = NULL,
	@LastModifiedDate DateTime = NULL,
	@CreatedByUserId Varchar(50) = NULL,
	@CreatedDate DateTime = NULL
	)
AS
BEGIN
	SET NOCOUNT ON

	-- DEPRECATED: REEMPLAZADO POR BULKINTERACTIONEVALUATIONPLAN
	IF(@InteractionManagementResult = '') SET @InteractionManagementResult = NULL;

	UPDATE [InteractionEvaluationPlan]
	SET
		[Instance] = @Instance, 
		[IdEvaluationPlan] = @IdEvaluationPlan, 
		[IdAgent] = @IdAgent,
		[IdCampaign] = @IdCampaign, 
		[IdInteraction] = @IdInteraction, 
		[InteractionSection] = @InteractionSection, 
		[InteractionPart] = @InteractionPart, 
		[InteractionDateStart] = @InteractionDateStart,
		[FormattedEndDate] = @InteractionFolder,
		[InteractionDateEnd] = @InteractionDateEnd, 
		[InteractionType] = @InteractionType, 
		[InteractionMessages] = @TotalMessages,
		[InteractionDuration] = @InteractionDuration,
		[InteractionOrigin] = @InteractionOrigin, 
		[ManagementResult] = @InteractionManagementResult, 
		[ContactId] = @InteractionContactId,
		[InteractionFormat] = @InteractionFormat,
		[LastModifiedByUserId] = CASE WHEN @LastModifiedByUserId IS NULL THEN [LastModifiedByUserId] ELSE @LastModifiedByUserId END,
		[LastModifiedDate] = GETUTCDATE(),
		[TimeStamp] = GETUTCDATE()

		WHERE [Instance] = @Instance
			AND [IdEvaluationPlan] = @IdEvaluationPlan
			AND	[IdInteraction] = @IdInteraction
			AND	[InteractionSection] = @InteractionSection
			AND	[InteractionPart] = @InteractionPart

	IF @@ROWCOUNT = 0
		INSERT INTO [InteractionEvaluationPlan] (
			[Instance], [IdEvaluationPlan], [IdAgent],
			[IdCampaign], [IdInteraction], [FormattedEndDate], 
			[InteractionSection], [InteractionPart], [InteractionDateStart], 
			[InteractionDateEnd], [InteractionType], [InteractionMessages],
			[InteractionDuration], [InteractionOrigin], [ManagementResult], 
			[ContactId], [InteractionFormat], [CreatedByUserId], 
			[CreatedDate], [TimeStamp]
		)
		VALUES (
			@Instance, @IdEvaluationPlan, @IdAgent,
			@IdCampaign, @IdInteraction, @InteractionFolder,
			@InteractionSection, @InteractionPart, @InteractionDateStart, 
			@InteractionDateEnd, @InteractionType, @TotalMessages,
			@InteractionDuration, @InteractionOrigin, @InteractionManagementResult, 
			@InteractionContactId, @InteractionFormat, @CreatedByUserId, 
			@CreatedDate, GETUTCDATE()
		)

	SELECT 1 AS 'result'

	SET NOCOUNT OFF
END
GO
PRINT N'Modificando [dbo].[GetAbilityQueries]...';


GO
ALTER PROCEDURE [dbo].[GetAbilityQueries] (
	@VCC VARCHAR(50) = NULL, 
	@AbilityId VARCHAR(100) = NULL
) AS
BEGIN
	SET NOCOUNT ON

	--
	SELECT [AQ].[ID]												'id',
			[AQ].[QueryId]											'queryId',
			[AQ].[QueryContent]										'queryContent',
			[AQ].[AcceptancePercentage]								'acceptancePercentage',
			ISNULL([AQ].[AcceptancePercentage], 0) * 100			'acceptanceInteger',
			[AQ].[Order]											'order'
		FROM [dbo].[AbilityQuery] AQ (NOLOCK)
		WHERE [AQ].[VCC] = @VCC
			AND [AQ].[AbilityId] = @AbilityId
		ORDER BY [AQ].[Order] ASC

	SET NOCOUNT OFF
END
GO
PRINT N'Modificando [dbo].[GetAbilityQueryEntities]...';


GO
ALTER PROCEDURE [dbo].[GetAbilityQueryEntities] (
	@VCC VARCHAR(50) = NULL, 
	@AbilityQueryId VARCHAR(100) = NULL
) AS
BEGIN
	SET NOCOUNT ON

	--
	SELECT [AQE].[EntityId]										'entityId',
			[AQE].[EntityName]									'entityName',
			[AQE].[AcceptancePercentage]						'acceptancePercentage',
			ISNULL([AQE].[AcceptancePercentage], 0) * 100		'acceptanceInteger',
			[AQE].[Order]										'order'
		FROM [dbo].[AbilityQueryEntity] AQE (NOLOCK)
		WHERE [AQE].[VCC] = @VCC
			AND [AQE].[AbilityQueryId] = @AbilityQueryId
		ORDER BY [AQE].[Order] ASC

	SET NOCOUNT OFF
END
GO
PRINT N'Modificando [dbo].[GetAllegroAgents]...';


GO
ALTER PROCEDURE [dbo].[GetAllegroAgents] (
	@Ip VARCHAR(50), 
	@VCC VARCHAR(50), 
	@Type INT, 
	@Campaign VARCHAR(50) = NULL
) AS
BEGIN

	-- DECLARAMOS UNA VARIABLE PARA LA QUERY A EJECUTAR
	DECLARE @Sql NVARCHAR(MAX)

	IF (@Type = 0)  
	BEGIN  
		SET @Sql = 'SET NOCOUNT ON
		SELECT
				UC.[VCC]							''vcc'',
				UC.[CampaignId]						''campaignId'',
				UC.[UserId]							''userId'',
				U.[Name]							''userName''
			FROM [' + @Ip + '].[mmprodat].[dbo].[Agent]  A (NOLOCK)
			LEFT JOIN [' + @Ip + '].[mmprodat].[dbo].[User] U (NOLOCK)
				ON U.[VCC] = A.[VCC]
					AND U.[Id] = A.[UserId]
			LEFT JOIN [' + @Ip + '].[mmprodat].[dbo].[UserCampaign] UC (NOLOCK) 
				ON UC.VCC = A.VCC 
					AND UC.UserId = A.UserId
			WHERE UC.[VCC] = ''' + @VCC + ''''

		IF(@Campaign IS NOT NULL and @Campaign <> '')
			SET @Sql += 'AND UC.[CampaignId] = '''+@Campaign+''' ';

		SET @Sql += ' 
		SET NOCOUNT OFF'
	END  
	ELSE IF(@Type = 1) 
	BEGIN
		SET @Sql = 'SET NOCOUNT ON
		SELECT
				UC.[VCC]							''vcc'',
				UC.[CampaignId]						''campaignId'',
				UC.[UserId]							''userId'',
				U.[Name]							''userName''
			FROM [mmprodat].[dbo].[Agent] A (NOLOCK)
			LEFT JOIN [mmprodat].[dbo].[User] U (NOLOCK)
				ON U.[VCC] = A.[VCC]
					AND U.[Id] = A.[UserId]
			LEFT JOIN [mmprodat].[dbo].[UserCampaign] UC (NOLOCK) 
				ON UC.VCC = A.VCC 
					AND uc.UserId = A.UserId
			WHERE UC.[VCC] = ''' + @VCC + ''''

		IF(@Campaign IS NOT NULL and @Campaign <> '')
			SET @Sql += 'AND UC.[CampaignId] = '''+@Campaign+''' ';

		SET @Sql += ' 
		SET NOCOUNT OFF'
	END  
	ELSE  
	BEGIN
		SET @Sql = 'SELECT 1 AS ''result'''  
	END

	--select @Sql
	EXEC (@Sql)

END
GO
PRINT N'Modificando [dbo].[GetAudiosTranscriptions]...';


GO
ALTER PROCEDURE [dbo].[GetAudiosTranscriptions]
(
	@PageSize				INT,
	@PageNumber				INT,
	@VCC					VARCHAR(50),
	@ProcessId				VARCHAR(50),
	@ID						VARCHAR(50),
	@StartDate				DATETIME = NULL,
	@EndDate				DATETIME = NULL,
	@StartHour				INT,
	@StartMinute			INT,
	@EndHour				INT,
	@EndMinute				INT,
	@Campaign				VARCHAR(MAX),
	@Agent					VARCHAR(MAX),
	@ResultCode				VARCHAR(MAX),
    @InteractionIds         VARCHAR(MAX) = NULL
)
AS
BEGIN
	DECLARE @SQL                    NVARCHAR(MAX);
    DECLARE @FILTERS_OPTIONAL_PART  VARCHAR(MAX) = '';
    DECLARE @FILTERS_EXCLUDING_PART VARCHAR(MAX) = '';
    DECLARE @FILTERS_FIXED_PART     VARCHAR(MAX) = '';
	SET @SQL = 'SET NOCOUNT ON
	DECLARE @rows INT
	SET @rows = (SELECT COUNT(A.ID)
		FROM [dbo].[Audio] A (NOLOCK)
		INNER JOIN [dbo].[ProcessAudio] PA (NOLOCK) 
			ON PA.[VCC] = A.[VCC]
				AND A.ID = PA.AudioId 
				AND A.Section = PA.Section 
				AND A.Part = PA.Part
		LEFT JOIN [dbo].[Process] P (NOLOCK)
			-- ON P.[Description] = PA.[ProcessId]
			ON P.[VCC] = A.[VCC]
				AND P.[Name] = PA.[ProcessId]
		WHERE A.[VCC] = ''' + @VCC + ''' 
			AND A.[IsTranscribed] = 1 
			AND P.[TYPE] = ''SPEECH'' '
			IF(@ProcessId IS NOT NULL)
			BEGIN
				SET @SQL += '
				AND PA.[ProcessId]= ''' + @ProcessId + ''' '
			END


	BEGIN
		IF(@ID IS NOT NULL)
		BEGIN
			SET @FILTERS_OPTIONAL_PART += '
				AND CONCAT(A.[ID], ''_'', A.[Section], ''_'', A.[Part]) LIKE ''%' + @ID + '%''
			'
		END
		IF(@Campaign IS NOT NULL AND LEN(@Campaign) > 0)
		BEGIN
			SET @FILTERS_OPTIONAL_PART += '
				AND A.[Campaign] IN(''' + @Campaign + ''')
			'
		END
		IF(@Agent IS NOT NULL AND LEN(@Agent) > 0)
		BEGIN
			SET @FILTERS_OPTIONAL_PART += '
				AND A.[Agent] IN(''' + @Agent + ''')
			'
		END
		IF(@ResultCode IS NOT NULL AND LEN(@ResultCode) > 0)
		BEGIN
			SET @FILTERS_OPTIONAL_PART += '
				AND CONCAT(A.Campaign, ''_'', ISNULL(CONVERT(VARCHAR(4), A.[DispositionCode]), '''')) IN (''' + @ResultCode + ''')
			'
		END
		IF(@StartDate IS NOT NULL AND @EndDate IS NOT NULL)
		BEGIN
			SET @FILTERS_OPTIONAL_PART += '
				AND A.[EndDate] BETWEEN ''' + CONVERT(VARCHAR(10), @StartDate, 120) + ''' AND ''' + CONVERT(VARCHAR(10), @EndDate, 120) + '''
			'
		END
		IF(@StartHour IS NOT NULL AND @EndHour IS NOT NULL)
		BEGIN
			SET @FILTERS_OPTIONAL_PART += '
				AND DATEPART(HOUR, A.[EndDate]) >= ' + CONVERT(VARCHAR, @StartHour) + ' AND DATEPART(HOUR, A.[EndDate]) <= ' + CONVERT(VARCHAR, @EndHour) + '
			'
		END
		IF(@StartMinute IS NOT NULL AND @EndMinute IS NOT NULL)
		BEGIN
			SET @FILTERS_OPTIONAL_PART += '
				AND DATEPART(MINUTE, A.[EndDate]) >= ' + CONVERT(VARCHAR, @StartMinute) + ' AND DATEPART(MINUTE, A.[EndDate]) <= ' + CONVERT(VARCHAR, @EndMinute) + '
			'
		END

        IF (@InteractionIds IS NOT NULL AND @InteractionIds <> '')
        BEGIN 
            SET @FILTERS_OPTIONAL_PART = '';
	        SET @FILTERS_EXCLUDING_PART=' AND A.[ID] IN (SELECT Value FROM [dbo].[split](''' + @InteractionIds + ''','','')) ';
        END

	END
	SET @SQL += @FILTERS_OPTIONAL_PART + @FILTERS_EXCLUDING_PART;
	SET @SQL += ') '
	SET @SQL += ' SELECT @rows AS total '

	SET @SQL += '
		SELECT
			A.[ID]						''id'',
			A.[Section]					''section'',
			A.[Part]					''part'',
			PA.[ProcessId]				''processId'',
			A.[Number]					''number'',
			B.[Name]					''name'',
			A.[SilenceTime]				''silenceTime'',
			A.[DurationTime]			''durationTime'',
			A.[DurationLinguisticTime]	''durationLinguisticTime'',
			A.[Category1]				''category1'',
			A.[Category2]				''category2'',
			A.[Category3]				''category3'',
			A.[Agent]					''agent'',
			A.[AgentName]				''agentName'',
			A.[Description]				''description'',
			B.[Environment]				''environment'',
			E.[Type]					''environmentType'',
			A.[IsTranscribed]			''isTranscribed'',
			COUNT(U.[TextContent])				''isSubrayed'',
			A.[CreatedDate]				''createdDate'',
			A.[EndDate]					''endDate''
		FROM [dbo].[Audio] A (NOLOCK)
		INNER JOIN [dbo].[ProcessAudio] PA (NOLOCK) 
			ON PA.[VCC] = A.[VCC]
				AND A.ID = PA.AudioId 
				AND A.Section = PA.Section 
				AND A.Part = PA.Part
		INNER JOIN [dbo].[Process] B (NOLOCK) 
			ON B.[VCC] = PA.[VCC]
				AND PA.[ProcessId] = B.[Name]
		inner JOIN [dbo].[Environment] E (NOLOCK) 
			ON E.[VCC] = B.[VCC]
				AND B.[Environment] = E.[Name] 
				AND B.VCC = E.VCC
		LEFT JOIN [dbo].[Utterance] U (NOLOCK) 
			ON U.[VCC] = A.[VCC]
				AND A.ID = U.AudioId 
				AND A.Section = U.Section 
				AND A.Part = U.Part
		WHERE
			A.[VCC] = ''' + @VCC + ''' AND A.[IsTranscribed] = 1 '
			IF(@ProcessId IS NOT NULL)
			BEGIN
				SET @SQL += '
				AND PA.[ProcessId] = ''' + @ProcessId + ''' '
			END
			SET @SQL += '
	'
	SET @SQL += @FILTERS_OPTIONAL_PART + @FILTERS_EXCLUDING_PART;
	SET @SQL += '
		AND B.[TYPE] = ''SPEECH''
		GROUP BY A.[ID], A.[Section], A.[Part], PA.[ProcessId], A.[Number],
				B.[Name], A.[SilenceTime], A.[DurationTime], A.[DurationLinguisticTime], A.[Category1],     
				A.[Category2], A.[Category3], A.[Agent], A.[AgentName], A.[Description], 
				B.[Environment], E.[Type], A.[IsTranscribed], A.[CreatedDate], A.[EndDate]
		ORDER BY A.[ID], PA.[ProcessId], A.[Agent], A.[Description], B.[Environment], A.[DurationTime], A.[CreatedDate]
		OFFSET ' + CONVERT(VARCHAR(50), @PageSize) + ' * (' + CONVERT(VARCHAR(50), @PageNumber) + ' - 1) ROWS
		FETCH NEXT ' + CONVERT(VARCHAR(50), @PageSize) + ' ROWS ONLY;
	'
	SET @SQL += ' SET NOCOUNT OFF'
	
	EXEC(@SQL)
END
GO
PRINT N'Modificando [dbo].[GetEvaluationResultsFromAuditorEvaluationPlan]...';


GO

ALTER PROCEDURE [dbo].[GetEvaluationResultsFromAuditorEvaluationPlan] (
	@Instance Varchar(50) = NULL,
    @EvaluationPlanId Varchar(50) = NULL,
    @InteractionId varchar(250) = NULL,
    @InteractionType varchar(50) = NULL,
    @AuditorId varchar(50) = NULL,
    @AgentId varchar(50) = NULL
)
AS
BEGIN
    SET NOCOUNT ON

	-- EMULAMOS UNA NUEVA TABLA VARIABLE PARA OBTENER LOS REGISTROS UNICOS QUE INSERTAREMOS EN LA TABLA EVALUATION_RESULT
	--  ORDENANDO POR SECTION Y PART
	;WITH CTE AS (
		SELECT TOP 1 IEP.[Instance],
						IEP.[IdEvaluationPlan],
						IEP.[IdInteraction],
						IEP.[IdAgent],
						IEP.[AgentName]
			FROM [dbo].[InteractionEvaluationPlan] IEP (NOLOCK)
			WHERE IEP.[Instance] = @Instance
				AND IEP.[IdEvaluationPlan] = @EvaluationPlanId
				AND IEP.[IdInteraction] = @InteractionId 
				AND IEP.[InteractionType] = @InteractionType
				AND IEP.[IdAgent] = @AgentId
	)

    SELECT DISTINCT
         EF.Id										'EvaluationFormatId'				-- Id
        ,EF.Description								'EvaluationFormatDescription'		-- Titulo del reporte
        ,ER.Instance								'Instance'							-- Subtitulo del reporte
        ,ER.IdAgent									'AgentId'							-- Agente
        ,ER.IdAgent									'AgentDescription'					-- Agente
		,C.[AgentName]								'agentName'							-- NOMBRE DEL AGENTE
        ,CONCAT(U.Firstname, ' ', U.Lastname)		'CoordinatorFullName'				-- Coordinador
        ,AEP.IdAuditor								'AuditorId'							-- Auditor
        ,CONCAT(UA.Firstname, ' ',UA.Lastname)		'AuditorDescription'				-- Auditor
		,AEP.IdAuditor
        ,ER.IdCampaign								'CampaignDescription'				-- Campana
        ,ER.IdInteraction							'InteractionId'						-- Grabacion
        ,ER.InteractionType							'InteractionType'					-- Tipo interaccion
        ,ER.InteractionDateini						'InteractionDateIni'				-- Fecha inicio de la interaccion
		,ER.[InteractionDatefin]					'InteractionDateFin'				-- Fecha fin de la interaccion
        ,ER.InteractionAddress						'Contacto'							-- Telefono
        ,ER.EvaluationDate							'EvaluationDate'					-- Fecha monitoreo
        ,AEP.Score									'TotalScore'						-- Puntaje total
        ,G.Id										'GroupId'							-- Grupo
        ,G.Description								'Group'								-- Grupo
        ,SG.Id										'SubGroupId'						-- Subgrupo
        ,SG.Description								'SubGroup'							-- Subgrupo
        ,AB.Id										'AbilityId'							-- Habilidad
        ,AB.Title									'Ability'							-- Habilidad
		,AB.[Detail]								'AbilityDetail'						-- Habilidad
        ,ER.Comment									'Observacion'						-- Observacion de la habilidad
        ,ER.MaxAbilityScore							'Puntaje'							-- Puntaje
        ,ER.ScoreDescription						'Eval'								-- Eval
        ,ER.Qualification							'Nota'								-- Nota
        ,ER.NotApplies								'NotApplies'
        ,ER.AbilityOrder							'Order'
        ,ER.Conditional                             'conditionalSelected'
    FROM [EvaluationResult] ER (NOLOCK)
    INNER JOIN	[EvaluationFormat] EF (NOLOCK)
	--LEFT JOIN [EvaluationFormat] EF (NOLOCK)
		ON (ER.Instance = EF.Instance 
			AND	ER.IdEvaluationFormat = EF.ID)
    LEFT JOIN [User] U (NOLOCK)
		ON (EF.Instance = U.VCC
			AND EF.CreatedByUserId = U.ID)
    --INNER JOIN [User] UA (NOLOCK)
	LEFT JOIN [User] UA (NOLOCK)
		ON (ER.Instance = UA.VCC 
			AND ER.IdEvaluator = UA.ID)
    --INNER JOIN [AuditorEvaluationPlan] AEP (NOLOCK)
	LEFT JOIN [AuditorEvaluationPlan] AEP (NOLOCK)
		ON (ER.IdEvaluationPlan	= AEP.IdEvaluationPlan
			AND ER.IdEvaluator = AEP.IdAuditor
			AND ER.IdInteraction = AEP.IdInteraction
			AND ER.InteractionType = AEP.InteractionType
			AND ER.IdAgent = AEP.IdAgent)
    LEFT JOIN [Group] G (NOLOCK)
		ON (ER.Instance = G.Instance
			AND ER.IdGroup = G.ID)
    LEFT JOIN [SubGroup] SG (NOLOCK)
		ON (ER.Instance = SG.Instance 
			AND ER.IdSubGroup = SG.ID)
    LEFT JOIN [Ability] AB (NOLOCK)
		ON (ER.Instance = AB.Instance 
			AND ER.IdAbility = AB.ID)
	LEFT JOIN CTE C (NOLOCK) -- LA TABLA AGENT NO ES DETERMINANTE POR ESO SE AGREGA POR LEFT JOIN
		ON C.[Instance] = ER.[Instance]
			AND C.[IdInteraction] = ER.IdInteraction
			AND C.[IdAgent] = ER.[IdAgent]
    WHERE ER.Instance = @Instance
		AND ER.IdEvaluationPlan	= @EvaluationPlanId
		AND ER.IdInteraction = @InteractionId
		AND ER.InteractionType = @InteractionType
		--AND ER.IdEvaluator = @AuditorId
		AND ER.IdAgent = @AgentId
    ORDER BY ER.AbilityOrder ASC;

    SET NOCOUNT OFF
END
GO
PRINT N'Modificando [dbo].[GetEvaluations]...';


GO
ALTER PROCEDURE [dbo].[GetEvaluations] (
	@Instance Varchar(50) = NULL,
	@IdAuditor VARCHAR(MAX) = NULL,
	@IdAgent Varchar(MAX) = NULL,
   	@IdCampaign VARCHAR(MAX) = NULL,
	@IdEvaluationPlan VARCHAR(MAX) = NULL,
 	@EvaluationDateFrom VARCHAR(50) = '1980-01-01T00:00:00',
    @EvaluationDateTo VARCHAR(50) = '2050-01-01T23:59:59',
	@EvaluationHourFrom VARCHAR(50) = '00:00:00',
    @EvaluationHourTo VARCHAR(50) = '23:59:59',
	@InteractionMinDuration Int = 0,
    @InteractionMaxDuration Int = 86400,
    @InteractionOrigins Varchar(50) = NULL,
	@InteractionResults Varchar(MAX) = NULL,
	@EvaluationTypes Varchar(MAX) = NULL,
	@InteractionTags Varchar(MAX) = NULL,
	@InteractionFormats Varchar(50) = NULL,
	@InteractionIds     VARCHAR(MAX) = NULL,
	@EvaluationsLimit Int = 0
)
AS
BEGIN
	SET NOCOUNT ON
	IF (@EvaluationHourFrom = '') SET @EvaluationHourFrom = '00:00:00';
	IF (@EvaluationHourTo = '') SET @EvaluationHourTo = '23:59:59';
	
	-- SI ORIGINS TIENE DOS VALORES, IGNORAMOS EL FILTRO
	IF (SELECT COUNT(*) FROM [dbo].[split](@InteractionOrigins, ',')) = 2 SET @InteractionOrigins = ''
	
	DECLARE @SQL_SELECT_1 VARCHAR(MAX) = ''
	DECLARE @SQL_FROM VARCHAR(MAX) = ''
	DECLARE @SQL_FILTER VARCHAR(MAX) = ''
	DECLARE @SQL_EXTRA VARCHAR(MAX) = ''
	DECLARE @FILTERS_OPTIONAL_PART VARCHAR(MAX) = ''
    DECLARE @FILTERS_EXCLUDING_PART VARCHAR(MAX) = ''
    DECLARE @FILTERS_FIXED_PART     VARCHAR(MAX) = ''

	-- EMULAMOS UNA NUEVA TABLA EN BASE A INTERACTIONEVALUATIONPLAN
	SET @SQL_SELECT_1 += '
		;WITH CTE AS (
			SELECT ER.[Instance],
					ER.[IdEvaluationPlan],
					ER.[IdInteraction], 
					ER.[IdAgent],
					IEP.[AgentName],
					RN = ROW_NUMBER() OVER(PARTITION BY IEP.[Instance], IEP.[IdEvaluationPlan], IEP.[IdInteraction] ORDER BY IEP.[CreatedDate] ASC)
				FROM [dbo].[EvaluationResult] ER (NOLOCK) 
				INNER JOIN [dbo].[EvaluationPlan] EP (NOLOCK)
					ON EP.[Instance] = ER.[Instance]
						AND EP.[Id] =  ER.[IdEvaluationPlan]
				INNER JOIN [dbo].[AuditorEvaluationPlan] AEP (NOLOCK) 
					ON (AEP.[Instance] = ER.[Instance] 
						AND AEP.[IdAuditor] = ER.[IdAuditor] 
						AND AEP.[IdInteraction] = ER.[IdInteraction] 
						AND AEP.[InteractionType] = ER.[InteractionType] 
						AND AEP.[IdEvaluationPlan] = ER.[IdEvaluationPlan]) 
				INNER JOIN [dbo].[InteractionEvaluationPlan] IEP (NOLOCK)
					ON IEP.[Instance] = ER.[Instance] 
						AND IEP.[IdEvaluationPlan] = EP.[ID]
						AND IEP.[IdInteraction] = ER.[IdInteraction]
						AND IEP.[IdAgent] = ER.[IdAgent]
				WHERE ER.[Instance] = ''' + @Instance + '''
					AND ER.[EvaluationDate] BETWEEN ''' + @EvaluationDateFrom + '''AND ''' + @EvaluationDateTo + '''
					AND EP.[Status] = CASE EP.[Evaluation_Mode] WHEN ''A'' THEN 7 ELSE EP.[Status] END 
					AND AEP.[Completed] = 1
		) '

	SET @SQL_SELECT_1 += '
		SELECT '

	SET @SQL_SELECT_1 += '
				AEP.Completed						''completed'',
    			AEP.score							''qualification'',
    			AEP.IdAuditor						''idAuditor'',
    			U.FirstName + '' '' + U.LastName	''auditorName'',
    			MAX(ER.EvaluationDate)				''evaluationDate'',
    			AEP.IdEvaluationPlan				''idEvaluationPlan'',
				EP.Description						''evaluationPlan'',
    			AEP.idAgent							''idAgent'',
    			C.[AgentName]						''agentName'',							-- NOMBRE DEL AGENTE
				AEP.idInteraction					''idInteraction'',
				AEP.InteractionDate					''interactionDate'',
    			AEP.InteractionType					''interactionType'',
    			AEP.IdCampaign						''idCampaign''  '

	SET @SQL_FROM += '
			FROM EvaluationResult ER (NOLOCK) 
			LEFT JOIN [EvaluationPlan] EP (NOLOCK) 
				ON (EP.[Instance] = ER.[Instance] 
					AND EP.[ID] = ER.IdEvaluationPlan) 
			LEFT JOIN [AuditorEvaluationPlan] AEP (NOLOCK) 
				ON (AEP.[Instance] = ER.[Instance] 
					AND AEP.[IdAuditor] = ER.[IdAuditor] 
					AND AEP.[IdInteraction] = ER.[IdInteraction] 
					AND AEP.[InteractionType] = ER.[InteractionType] 
					AND AEP.[IdEvaluationPlan] = ER.[IdEvaluationPlan]) 
			LEFT JOIN [User] U (NOLOCK) 
				ON (U.[VCC] = ER.[Instance] 
					AND U.ID = AEP.IdAuditor) 
			LEFT JOIN CTE C (NOLOCK) 
				ON C.[Instance] = ER.[Instance]
					AND C.[IdEvaluationPlan] = ER.[IdEvaluationPlan]
					AND C.[IdInteraction] = ER.[IdInteraction] 
					AND C.[IdAgent] = ER.[IdAgent] 
					AND C.RN = 1 '

	SET @FILTERS_FIXED_PART = '
			WHERE ER.[Instance] = ''' + @Instance + '''
				AND ER.[EvaluationDate] >= ''' + @EvaluationDateFrom + '''
				AND ER.[EvaluationDate] <= ''' + @EvaluationDateTo + '''
				AND EP.[Status] = CASE EP.[Evaluation_Mode] WHEN ''A'' THEN 7 ELSE EP.[Status] END 
				AND AEP.[Completed] = 1 ' -- LINEA PARA FILTRAR EVALUACIONES COMPLETADAS

	IF (@IdAuditor IS NOT NULL AND @IdAuditor != '') SET @FILTERS_OPTIONAL_PART += 'AND AEP.[IdAuditor] IN (SELECT Value FROM [dbo].[split](''' + @IdAuditor + ''','','')) '
	IF (@IdAgent IS NOT NULL AND @IdAgent != '') SET @FILTERS_OPTIONAL_PART += 'AND AEP.[IdAgent] IN (SELECT Value FROM [dbo].[split](''' + @IdAgent + ''','','')) '
	IF (@IdCampaign IS NOT NULL AND @IdCampaign != '') SET @FILTERS_OPTIONAL_PART += 'AND AEP.[IdCampaign] IN (SELECT Value FROM [dbo].[split](''' + @IdCampaign + ''','','')) '
	IF (@IdEvaluationPlan IS NOT NULL AND @IdEvaluationPlan != '') SET @FILTERS_OPTIONAL_PART += 'AND EP.[ID] IN (SELECT Value FROM [dbo].[split](''' + @IdEvaluationPlan + ''','','')) '
	IF (CAST(@EvaluationHourFrom AS TIME) <= CAST(@EvaluationHourTo AS TIME)) SET @FILTERS_OPTIONAL_PART += 'AND CAST(ER.[EvaluationDate] AS TIME) BETWEEN ''' + @EvaluationHourFrom + ''' AND ''' + @EvaluationHourTo + ''' '
	IF (CAST(@EvaluationHourFrom AS TIME) > CAST(@EvaluationHourTo AS TIME)) SET @FILTERS_OPTIONAL_PART += 'AND CAST(ER.[EvaluationDate] AS TIME) NOT BETWEEN ''' + @EvaluationHourTo + ''' AND ''' + @EvaluationHourFrom + ''' '
	IF (@InteractionMinDuration IS NOT NULL) SET @FILTERS_OPTIONAL_PART += 'AND AEP.[InteractionDuration] >= ' + (SELECT CONVERT(varchar(10), @InteractionMinDuration)) + ' '
	IF (@InteractionMaxDuration IS NOT NULL) SET @FILTERS_OPTIONAL_PART += 'AND AEP.[InteractionDuration] <= ' + (SELECT CONVERT(varchar(10), @InteractionMaxDuration))+ ' '
	IF (@InteractionOrigins IS NOT NULL AND @InteractionOrigins != '') SET @FILTERS_OPTIONAL_PART += 'AND AEP.[InteractionOrigin] IN (SELECT Value FROM [dbo].[split](''' + @InteractionOrigins + ''','','')) '
	--IF (@InteractionResults IS NOT NULL AND @InteractionResults != '') SET @FILTERS_OPTIONAL_PART += 'AND CONCAT(AEP.[IdCampaign], ''_'', AEP.[ManagementResult]) IN (SELECT Value FROM [dbo].[split](''' + @InteractionResults + ''','','')) '
	IF (@InteractionResults IS NOT NULL AND @InteractionResults != '') 
		SET @FILTERS_OPTIONAL_PART += 'AND (
								(CONCAT(AEP.[IdCampaign], ISNULL(REPLACE(AEP.[ManagementResult], ''/'', ''_''), ''_'')) IN (SELECT Value FROM [dbo].[split](''' + @InteractionResults + ''','','')))
								OR
								(CONCAT(AEP.[IdCampaign], ''_'', ISNULL(AEP.[ManagementResult], ''_'')) IN (SELECT Value FROM [dbo].[split](''' + @InteractionResults + ''','','')))
								OR
								(AEP.[ManagementResult] IN (SELECT Value FROM [dbo].[split](''' + @InteractionResults + ''','','')))
							)'
	
	IF (@EvaluationTypes IS NOT NULL AND @EvaluationTypes != '') 
	BEGIN
		SET @FILTERS_OPTIONAL_PART += '
				AND EP.[Evaluation_Mode] IN (SELECT Value FROM [dbo].[split](''' + @EvaluationTypes + ''','',''))  '
	END;
	IF (@InteractionTags IS NOT NULL AND @InteractionTags != '') 
	BEGIN
		SET @SQL_FROM += '
			LEFT JOIN [Tag] T (NOLOCK) 
				ON (T.[VCC] = ER.[Instance] 
					AND T.[Tag] IN (SELECT Value FROM [dbo].[split](''' + @InteractionTags + ''','',''))) '
		SET @FILTERS_OPTIONAL_PART += '
				AND T.[AudioId] LIKE CONCAT(AEP.[IdInteraction], ''%'') 
				AND T.[AudioId] IS NOT NULL '
	END;
	
	--IF (@InteractionFormats IS NOT NULL AND @InteractionFormats != '') SET @FILTERS_OPTIONAL_PART += 'AND AEP.[InteractionFormat] IN (SELECT Value FROM [dbo].[split](''' + @InteractionFormats + ''','','')) ';
	IF (@InteractionIds IS NOT NULL AND @InteractionIds <> '')
    BEGIN
        SET @FILTERS_OPTIONAL_PART = ''
	    SET @FILTERS_EXCLUDING_PART += ' AND AEP.[IdInteraction] IN (SELECT Value FROM [dbo].[split](''' + @InteractionIds + ''','','')) '
	END
	SET @SQL_EXTRA += '
			GROUP BY AEP.Completed,
								AEP.score,
								AEP.IdAuditor,
								U.FirstName + '' '' + U.LastName,
								AEP.IdEvaluationPlan,
								EP.Description,
								AEP.idAgent,
								C.[AgentName],
								AEP.idInteraction,
								AEP.InteractionDate,
								AEP.InteractionType,
								AEP.IdCampaign
    	ORDER BY MAX(ER.EvaluationDate) DESC'

	SET @SQL_SELECT_1 += @SQL_FROM  + @FILTERS_FIXED_PART + @FILTERS_OPTIONAL_PART + @FILTERS_EXCLUDING_PART + @SQL_EXTRA 

	-- SELECT @SQL_SELECT_1
	EXEC (@SQL_SELECT_1)
	
END
GO
PRINT N'Modificando [dbo].[GetEvaluationsOfInteraction]...';


GO

ALTER PROCEDURE [dbo].[GetEvaluationsOfInteraction] (
	@Instance Varchar(50) = NULL,
	@IdInteraction VARCHAR(MAX) = NULL,
	@InteractionType VARCHAR(MAX) = NULL,
	@EvaluationDateFrom VARCHAR(MAX) = '1980-01-01',
	@EvaluationDateTo VARCHAR(MAX) = '2050-01-01'
	)
AS
BEGIN
	SET NOCOUNT ON;
	
	-- CREAMOS UNA CTE PARA AGRUPAR LOS RESULTADOS DE CADA INTERACCION POR PLAN
	WITH ER_CTE AS (
		SELECT ER.[Instance]															'vcc',
				ER.[IdEvaluationPlan]													'idEvaluationPlan',
				ER.[InteractionType]													'interactionType',
				ER.[IdInteraction]														'idInteraction',
				SUM(ISNULL(TRY_CAST(ER.[ScoreDescription] AS DECIMAL(18, 2)), 0))		'scoreDescription',
				--SUM(ER.[ScoreDescription])				'scoreDescription',
				--ER.[IdEvaluator]														'idEvaluator', <= DESDE PLANES MIXTOS YA NO SE PUEDE AGRUPAR EN BASE A ESTA COLUMNA
				ER.[IdAuditor]															'idAuditor',
				MAX(ER.[EvaluationDate])												'evaluationDate'
			FROM [dbo].[EvaluationResult] ER (NOLOCK)
			WHERE ER.[Instance] = @Instance
				AND ER.[IdInteraction] = @IdInteraction
				AND ER.[InteractionType] = @InteractionType
				AND ER.[EvaluationDate] BETWEEN @EvaluationDateFrom AND @EvaluationDateTo
			GROUP BY ER.[Instance], ER.[IdEvaluationPlan], ER.[InteractionType], ER.[IdInteraction], ER.[idAuditor]
	) 

	SELECT AEP.[Completed]									'completed',
			AEP.[score]										'score',
			AEP.[IdAuditor]									'idAuditor',
			U.[FirstName] + ' ' + U.[LastName]				'auditorName',
			ER.[EvaluationDate]					            'evaluationDate',
			EP.[ID]											'idEvaluationPlan',
			EP.[Description]								'evaluationPlan',
			AEP.[idAgent]									'idAgent',
			AEP.[IdInteraction]								'idInteraction',
			AEP.[InteractionType]							'interactionType'
		FROM ER_CTE ER (NOLOCK)
		INNER JOIN [dbo].[EvaluationPlan] EP (NOLOCK)
			ON EP.[Instance] = ER.[vcc]
				AND EP.[ID] = ER.[idEvaluationPlan]
		INNER JOIN [dbo].[AuditorEvaluationPlan] AEP (NOLOCK)
			ON AEP.[Instance] = ER.[vcc]
				AND AEP.[IdEvaluationPlan] = ER.[idEvaluationPlan]
				AND AEP.[IdInteraction] = ER.[idInteraction]
				AND AEP.[IdAuditor] = ER.[idAuditor]
				AND AEP.[InteractionType] = ER.[interactionType]
		LEFT JOIN [dbo].[User] U (NOLOCK) -- QUEDA COMO LEFT JOIN EN CASO NO ENCUENTRE EL AUDITOR AUN SERA VISIBLE EL RESULTADO
			ON U.[VCC] = EP.[Instance]
				AND U.[ID] = AEP.[IdAuditor]
		ORDER BY ER.[evaluationDate] DESC

	/*

	SELECT * 
		FROM [dbo].[EvaluationPlan] EP (NOLOCK) 
		LEFT JOIN [dbo].[EvaluationResult] ER (NOLOCK)
			ON ER.[Instance] = EP.[Instance]
				AND ER.[IdEvaluationPlan] = EP.[ID]
		LEFT JOIN [dbo].[AuditorEvaluationPlan] AEP (NOLOCK)
			ON AEP.[Instance] = EP.[Instance]
				AND AEP.[IdEvaluationPlan] = EP.[ID]


				

	SELECT
		p.Completed						'completed',
		p.score							'score',
		p.IdAuditor						'idAuditor',
		a.FirstName + ' ' + a.LastName	'auditorName',
		MAX(e.EvaluationDate)             'evaluationDate',
		p.IdEvaluationPlan				'idEvaluationPlan',
		ep.Description					'evaluationPlan',
		p.idAgent						'idAgent',
		p.idInteraction					'idInteraction',
		p.InteractionType				'interactionType'
	FROM [EvaluationPlan] ep, EvaluationResult e, AuditorEvaluationPlan p, [User] a (NOLOCK)
	WHERE
	p.Instance = @Instance
	AND p.IdInteraction = @IdInteraction
	AND p.instance = e.instance
	AND p.IdInteraction = e.IdInteraction
	AND p.IdEvaluationPlan = e.IdEvaluationPlan
	AND p.IdAuditor = e.IdEvaluator
	AND p.InteractionType = e.InteractionType
	AND e.EvaluationDate >= @EvaluationDateFrom
	AND e.EvaluationDate <= @EvaluationDateTo
	AND a.ID = p.IdAuditor
	AND a.[VCC] = EP.[Instance]
	AND p.InteractionType = @InteractionType
	AND ep.Instance = e.instance
	AND ep.ID = p.IdEvaluationPlan
	GROUP BY p.Completed, 
				p.score, 
				p.IdAuditor, 
				a.FirstName + ' ' + a.LastName, 
				e.EvaluationDate, 
				p.IdEvaluationPlan, 
				ep.Description, 
				p.idAgent, 
				p.idInteraction, 
				p.InteractionType
	ORDER BY e.EvaluationDate DESC
	*/
END
GO
PRINT N'Modificando [dbo].[GetNotEvaluatedInteractionsAuditor]...';


GO
-- ESTE SP MUETRA LA LISTA DE EVALUACIONES PENDIENTES PARA UN AUDITOR
ALTER PROCEDURE [dbo].[GetNotEvaluatedInteractionsAuditor] (
	@Instance Varchar(50) = NULL, 
	@IdAuditor Varchar(50) = NULL,
	@IdCampaigns VARCHAR(MAX) = NULL,
	@IdAgents Varchar(MAX) = NULL,
	@EvaluationPlans Varchar(MAX) = NULL,
	@InteractionTypes Varchar(100) = NULL,
	@InteractionResults Varchar(MAX) = NULL,
 	@EvaluationDateTo   VARCHAR(MAX) = '2050-01-01T23:59:59',
 	@InteractionIds     VARCHAR(MAX) = NULL
	)
AS
BEGIN
	SET NOCOUNT ON
	DECLARE @SQL_SELECT_1 VARCHAR(MAX) = ''
	DECLARE @SQL_FROM VARCHAR(MAX) = ''
	DECLARE @FILTERS_OPTIONAL_PART VARCHAR(MAX) = ''
    DECLARE @FILTERS_FIXED_PART VARCHAR(MAX) = ''
    DECLARE @FILTERS_EXCLUDING_PART VARCHAR(MAX) = '';

	-- EMULAMOS UNA NUEVA TABLA EN BASE A AuditorEvaluationPlan DONDE SE REMOVERAN TODOS LOS REGISTROS DUPLICADOS PARA EL PK DE LA TABLA Audio
	SET @SQL_SELECT_1 += '
		WITH CTE AS (
			SELECT AEP.[Instance], 
					AEP.[IdEvaluationPlan], 
					AEP.[IdInteraction], 
					AEP.[IdAuditor], 
					AEP.[Score], 
					IEP.[AgentName],
					AEP.[LastModifiedDate],
					RN = ROW_NUMBER() OVER(PARTITION BY AEP.[Instance], AEP.[IdEvaluationPlan], AEP.[IdInteraction] ORDER BY AEP.[LastModifiedDate] DESC)
			FROM AuditorEvaluationPlan AEP (NOLOCK)
			LEFT JOIN [dbo].[InteractionEvaluationPlan] IEP (NOLOCK)
				ON IEP.[Instance] = AEP.[Instance] 
					AND IEP.[IdEvaluationPlan] = AEP.[IdEvaluationPlan]
					AND IEP.[IdInteraction] = AEP.[IdInteraction]
					AND IEP.[IdAgent] = AEP.[IdAgent]
			WHERE AEP.[Instance] = ''' + @Instance + ''' 
				AND AEP.[Completed] = 0 
				AND AEP.[IdAuditor] <> ''SPEECH''
		) ';
	-- EL CTE SOLO PUEDE SER INVOCADO UNA VEZ POR ESO LO PONEMOS EN EL SELECT FINAL DONDE EL CONTADOR(RN) ES 1
	
	-- ARMAMOS EL SELECT PRINCIPAL PARA LA BUSQUEDA DE EVALUACIONES PENDIENTES DEL AUDITOR
	SET @SQL_SELECT_1 += '
		SELECT DISTINCT '
	SET @SQL_SELECT_1 += '
				AEP.[IdInteraction]				''id'', 
				AEP.[IdCampaign]				''descriptionCampaign'',
				AEP.[IdAgent]					''idAgent'',
				AEP.[IdAgent]					''descriptionAgent'',
				AEP.[InteractionDate]			''dateIni'',
				AEP.[InteractionDateEnd]		''dateFin'',
				AEP.[InteractionDuration]		''interactionTime'',
				AEP.[Completed]					''evaluated'',
				AEP.[InteractionType]			''interactionType'',
				AEP.[ManagementResult]			''dispositionCode'',
				AEP.[ContactId]					''address'',
				AEP.[InteractionOrigin]			''origin'',
				AEP.[IdEvaluationPlan]			''idEvaluationPlan'',
				EP.[ProcessId]					''processId'',
				EP.[Description]				''descriptionEvaluationPlan'',
				EP.[DateFin]					''dateFinEvaluationPlan'', 
				A.[ID]							''idAuditor'', 
				A.[Description]					''descriptionAuditor'',
				C.[AgentName]					''agentName'',							-- NOMBRE DEL AGENTE
				C.[IdAuditor]					''lastEvaluationEvaluator'', 
				C.[Score]						''lastEvaluationScore'' '

	SET @SQL_FROM += '
			FROM [AuditorEvaluationPlan] AEP (NOLOCK) 
			LEFT JOIN [EvaluationPlan] EP (NOLOCK) 
				ON (EP.[Instance] = EP.Instance
					AND EP.[ID] = AEP.IdEvaluationPlan) 
			LEFT JOIN [Auditor] A (NOLOCK) 
				ON (A.[ID] = AEP.[IdAuditor])
			LEFT JOIN CTE C (NOLOCK) 
				ON C.[Instance] = AEP.[Instance] 
					AND C.[IdEvaluationPlan] = AEP.[IdEvaluationPlan] 
					AND C.[IdInteraction] = AEP.[IdInteraction]
					AND C.[RN] = 1 '

	SET @FILTERS_FIXED_PART = '
			WHERE AEP.[Instance] = ''' + @Instance + ''' 
				AND	AEP.[IdAuditor] = ''' + @IdAuditor + '''
				AND AEP.[Completed] = 0
				AND EP.[Enabled] = 1 
				AND (
					(EP.[Evaluation_Mode] = ''X'' AND EP.[Status] = 8)
					OR
					(EP.[Evaluation_Mode] = ''M'')
				) '

	IF (@IdCampaigns IS NOT NULL AND @IdCampaigns != '') SET @FILTERS_OPTIONAL_PART += 'AND AEP.[IdCampaign] IN (SELECT Value FROM [dbo].[split](''' + @IdCampaigns + ''','','')) ';
	IF (@IdAgents IS NOT NULL AND @IdAgents != '') SET @FILTERS_OPTIONAL_PART += 'AND AEP.[IdAgent] IN (SELECT Value FROM [dbo].[split](''' + @IdAgents + ''','','')) ';
	IF (@EvaluationPlans IS NOT NULL AND @EvaluationPlans != '') SET @FILTERS_OPTIONAL_PART += 'AND AEP.[IdEvaluationPlan] IN (SELECT Value FROM [dbo].[split](''' + @EvaluationPlans + ''','','')) ';
	IF (@InteractionTypes IS NOT NULL AND @InteractionTypes != '') SET @FILTERS_OPTIONAL_PART += 'AND AEP.[InteractionType] IN (SELECT Value FROM [dbo].[split](''' + @InteractionTypes + ''','','')) ';
	-- IF (@InteractionResults IS NOT NULL AND @InteractionResults != '') SET @FILTERS_EXCLUDING_PART += 'AND CONCAT(AEP.[IdCampaign], ''_'', AEP.[ManagementResult]) IN (SELECT Value FROM [dbo].[split](''' + @InteractionResults + ''','','')) ';
	IF (@InteractionResults IS NOT NULL AND @InteractionResults != '') 
		SET @FILTERS_OPTIONAL_PART += 'AND (
								(CONCAT(AEP.[IdCampaign], ISNULL(REPLACE(AEP.[ManagementResult], ''/'', ''_''), ''_'')) IN (SELECT Value FROM [dbo].[split](''' + @InteractionResults + ''','','')))
								OR
								(CONCAT(AEP.[IdCampaign], ''_'', ISNULL(AEP.[ManagementResult], ''_'')) IN (SELECT Value FROM [dbo].[split](''' + @InteractionResults + ''','','')))
								OR
								(AEP.[ManagementResult] IN (SELECT Value FROM [dbo].[split](''' + @InteractionResults + ''','','')))
							)'
	IF (@EvaluationDateTo IS NOT NULL AND @EvaluationDateTo != '') SET @FILTERS_OPTIONAL_PART += 'AND EP.[DateFin] <= ''' + @EvaluationDateTo + '''  ';
	
	IF (@InteractionIds IS NOT NULL AND @InteractionIds <> '')
       BEGIN 
            SET @FILTERS_OPTIONAL_PART = '';
	        SET @FILTERS_EXCLUDING_PART=' AND AEP.[IdInteraction] IN (SELECT Value FROM [dbo].[split](''' + @InteractionIds + ''','','')) ';
       END

	SET @SQL_SELECT_1 += @SQL_FROM + @FILTERS_FIXED_PART + @FILTERS_OPTIONAL_PART + @FILTERS_EXCLUDING_PART;

	--SELECT @SQL_SELECT_1
	EXEC (@SQL_SELECT_1)

 	SET NOCOUNT OFF
END
GO
PRINT N'Modificando [dbo].[SaveAbilityQuery]...';


GO
ALTER PROCEDURE [dbo].[SaveAbilityQuery] (
	@VCC							VARCHAR(50) = NULL,
	@ID								VARCHAR(50) = NULL,
	@AbilityId						VARCHAR(50) = NULL,
	@QueryId						VARCHAR(50) = NULL,
	@QueryContent					VARCHAR(1000) = NULL,
	@AcceptancePercentage			DECIMAL(18, 2) = NULL,
	@Order							INT = NULL,
	@CreatedByUserId				VARCHAR(50) = NULL,
	@LastModifiedByUserId			VARCHAR(50) = NULL
) AS
BEGIN
	SET NOCOUNT ON

	UPDATE [AbilityQuery]
		SET [AcceptancePercentage] = @AcceptancePercentage,
			[LastModifiedByUserId] = CASE WHEN @LastModifiedByUserId IS NULL THEN [LastModifiedByUserId] ELSE @LastModifiedByUserId END,
			[LastModifiedDate] = GETUTCDATE(),
			[TimeStamp] = GETUTCDATE()
		WHERE [VCC] = @VCC
			AND [ID] = @ID

	IF @@ROWCOUNT = 0
	BEGIN
		INSERT INTO [AbilityQuery] (
			[VCC], [ID], [AbilityId], [QueryId], [QueryContent],
			[AcceptancePercentage], [Order], [CreatedDate], [CreatedByUserId], [LastModifiedDate], 
			[LastModifiedByUserId], [TimeStamp]
		)
		VALUES (
			@VCC, @ID, @AbilityId, @QueryId, @QueryContent, 
			@AcceptancePercentage, @Order, GETUTCDATE(), @CreatedByUserId, GETUTCDATE(), 
			@LastModifiedByUserId, GETUTCDATE()
		)
	END

	SELECT 1 AS 'result'
    
    SET NOCOUNT OFF
END
GO
PRINT N'Modificando [dbo].[SaveEvaluationFormatAttachedSignature]...';


GO
ALTER PROCEDURE [dbo].[SaveEvaluationFormatAttachedSignature] (
	@VCC VARCHAR(50) = NULL, 
	@EvaluationFormatId VARCHAR(50) = NULL,
	@Description VARCHAR(100) = NULL,
	@Order Int = NULL,
	@CreatedByUserId VARCHAR(50) = NULL,
	@LastModifiedByUserId VARCHAR(50) = NULL
) AS
BEGIN
	SET NOCOUNT ON

	UPDATE [EvaluationFormatAttachedSignature]
		SET [Order] = @Order,
			[LastModifiedDate] = GETUTCDATE(),
			[LastModifiedByUserId] = CASE WHEN @LastModifiedByUserId IS NULL THEN [LastModifiedByUserId] ELSE @LastModifiedByUserId END,
			[TimeStamp] = GETUTCDATE()
		WHERE [VCC] = @VCC
			AND [EvaluationFormatId] = @EvaluationFormatId
			AND [Order] = @Order

    IF @@ROWCOUNT = 0
		INSERT INTO [EvaluationFormatAttachedSignature] (
			[VCC], 
			[EvaluationFormatId],
			[Description],
			[Order], 
			[CreatedDate],
			[CreatedByUserId],
			[TimeStamp]
		)
		VALUES (
			@VCC, 
			@EvaluationFormatId,
			@Description, 
			@Order,
			GETUTCDATE(),
			@CreatedByUserId,
			GETUTCDATE()
		)

	SELECT 1 AS 'result'

    SET NOCOUNT OFF
END
GO
PRINT N'Modificando [dbo].[SaveUtterance]...';


GO
-- [dbo].[SaveUtterance] 'allegro', '4bad9174-ea84-45ee-ab2f-b17c73c43734', '45799dd8-17e7-49a1-9bd8-cb74f00a788c', '{f2c9e160-8eeb-11e9-8562-b65bb2fb6bcb}', 0, 1, 'in', 10, 14, 1.23, 1.38, 0, 'hola', '2019-08-02 15:30:00.000', 'analytic', NULL, NULL
ALTER PROCEDURE [dbo].[SaveUtterance]
(
	@VCC						VARCHAR(50),
	@AppId						VARCHAR(50),
	@IntentId					VARCHAR(50),
	@AudioId					VARCHAR(50),
	@Section					NUMERIC(5, 0),
	@Part						NUMERIC(5, 0),
	@Speaker					VARCHAR(3),
	@AnchorOffset				INT,
	@FocusOffset				INT,
	@CurrentTime				FLOAT,
	@EndCurrentTime				FLOAT,
	@UtteranceId				NUMERIC(18, 0),
	@TextContent				VARCHAR(500),
	@CreatedDate				DATETIME,
	@CreatedByUserId			VARCHAR(50),
	@LastModifiedDate			DATETIME,
	@LastModifiedByUserId		VARCHAR(50)
)
AS
BEGIN
	SET NOCOUNT ON

	-- EN CASO LLEGUE COMO NULL LO IGUALAMOS A 0
	IF @Section IS NULL BEGIN SET @Section = 0 END 

	UPDATE [dbo].[Utterance] SET
		[VCC] = @VCC,
		[AppId] = @AppId,
		[IntentId] = @IntentId,
		[AudioId] = @AudioId,
		[Section] = @Section,
		[Part] = @Part,
		[Speaker] = @Speaker,
		[AnchorOffset] = @AnchorOffset,
		[FocusOffset] = @FocusOffset,
		[CurrentTime] = @CurrentTime,
		[EndCurrentTime] = @EndCurrentTime,
		[UtteranceId] = @UtteranceId,
		[TextContent] = @TextContent,
		[CreatedDate] = @CreatedDate,
		[CreatedByUserId] = @CreatedByUserId,
		[LastModifiedDate] = @LastModifiedDate,
		[LastModifiedByUserId] = @LastModifiedByUserId,
		[TimeStamp] = GETUTCDATE()
	WHERE
		[VCC] = @VCC
		AND [AppId] = @AppId
		AND [IntentId] = @IntentId
		AND [AudioId] = @AudioId
		AND [Section] = @Section
		AND [Part] = @Part
		AND [Speaker] = @Speaker
		AND [AnchorOffset] = @AnchorOffset
		AND [FocusOffset] = @FocusOffset
		AND [CurrentTime] = @CurrentTime
		AND [EndCurrentTime] = @EndCurrentTime
		AND [UtteranceId] = @UtteranceId
		AND [TextContent] = @TextContent

	IF @@ROWCOUNT = 0
	BEGIN
		INSERT INTO [dbo].[Utterance] (
			[VCC],
			[AppId],
			[IntentId],
			[AudioId],
			[Section],
			[Part],
			[Speaker],
			[AnchorOffset],
			[FocusOffset],
			[CurrentTime],
			[EndCurrentTime],
			[UtteranceId],
			[TextContent],
			[CreatedDate],
			[CreatedByUserId],
			[LastModifiedDate],
			[LastModifiedByUserId],
			[TimeStamp]
		)
		VALUES(
			@VCC,
			@AppId,
			@IntentId,
			@AudioId,
			@Section,
			@Part,
			@Speaker,
			@AnchorOffset,
			@FocusOffset,
			@CurrentTime,
			@EndCurrentTime,
			@UtteranceId,
			@TextContent,
			@CreatedDate,
			@CreatedByUserId,
			@LastModifiedDate,
			@LastModifiedByUserId,
			GETUTCDATE()
		)
	END

	SELECT 1 AS 'result'

	SET NOCOUNT OFF
END
GO
PRINT N'Creando [dbo].[BulkAgent]...';


GO
CREATE PROCEDURE [dbo].[BulkAgent]
AS
BEGIN

	-- ACTUALIZAMOS LOS REGISTROS QUE VIENEN EN LA TEMPORAL Y YA EXISTEN EN LA TABLA AGENT
	UPDATE A
		SET A.[Name] = A_TMP.[Name],
			A.[LastModifiedDate] = GETUTCDATE(),
			A.[TimeStamp] = GETUTCDATE()
		FROM [dbo].[Agent] A (NOLOCK)
		INNER JOIN [#AgentTemp] A_TMP 
			ON A_TMP.[VCC] = A.[VCC]
				AND A_TMP.[AgentId] = A.[AgentId] 

	-- INSERTAMOS LA DATA DE LA TABLA TEMPORAL
	INSERT INTO [dbo].[Agent] ([VCC], [AgentId], [Name], [CreatedDate], [TimeStamp])
		SELECT A_TMP.[VCC], 
				A_TMP.[AgentId], 
				REPLACE(LTRIM(RTRIM(A_TMP.[Name])), '  ', ' '), 
				GETUTCDATE(), 
				GETUTCDATE()
			FROM [#AgentTemp] A_TMP (NOLOCK) 
			LEFT JOIN [dbo].[Agent] A (NOLOCK)
				ON A.[VCC] = A_TMP.[VCC]
					AND A.[AgentId] = A_TMP.[AgentId]
			WHERE A.[VCC] IS NULL

	-- ELIMINAMOS LA TABLA TEMPORAL 
	DROP TABLE [#AgentTemp]

END
GO
PRINT N'Creando [dbo].[BulkInteractionEvaluationPlan]...';


GO
CREATE PROCEDURE [dbo].[BulkInteractionEvaluationPlan]
AS
BEGIN
	SET NOCOUNT ON

	-- INSERTAMOS LA DATA DE LA TABLA TEMPORAL
	INSERT INTO [dbo].[InteractionEvaluationPlan] (
			[Instance], [IdEvaluationPlan], [IdAgent],
			[AgentName], [IdCampaign], [IdInteraction], 
			[FormattedEndDate], [InteractionSection], [InteractionPart], 
			[InteractionDateStart], [InteractionDateEnd], [InteractionType], 
			[InteractionMessages], [InteractionDuration], [InteractionOrigin], 
			[ManagementResult], [ContactId], [InteractionFormat], 
			[CreatedByUserId], [CreatedDate], [TimeStamp])
		SELECT IEP.[VCC], IEP.[IdEvaluationPlan], IEP.[IdAgent],
				A.[Name], IEP.[IdCampaign], IEP.[IdInteraction], 
				IEP.[InteractionFolder], IEP.[InteractionSection], IEP.[InteractionPart], 
				IEP.[InteractionDateStart], IEP.[InteractionDateEnd], IEP.[InteractionType], 
				IEP.[TotalMessages], IEP.[InteractionDuration], IEP.[InteractionOrigin], 
				IEP.[InteractionManagementResult], IEP.[InteractionContactId], IEP.[InteractionFormat], 
				IEP.[CreatedByUserId], GETUTCDATE(), GETUTCDATE()
			FROM [#InteractionEvaluationPlanTemp] IEP (NOLOCK)
			LEFT JOIN [dbo].[Agent] A (NOLOCK)
				ON A.[VCC] = IEP.[VCC]
					AND A.[AgentId] = IEP.[IdAgent]

	-- ELIMINAMOS LA TABLA TEMPORAL 
	DROP TABLE [#InteractionEvaluationPlanTemp]
	
	SET NOCOUNT OFF
END
GO
PRINT N'Creando [dbo].[GetAgents]...';


GO
CREATE PROCEDURE [dbo].[GetAgents] (
	@VCC VARCHAR(50) = NULL,
	@AgentIds VARCHAR(MAX) = NULL
) AS 
BEGIN 
    SET NOCOUNT ON

	-- DECLARAMOS LA VARIABLES PARA LA QUERY A EJECUTAR
	DECLARE @SQL_SELECT VARCHAR(MAX) = ''
	DECLARE @SQL_FROM VARCHAR(MAX) = ''
	DECLARE @SQL_FILTER VARCHAR(MAX) = ''
	DECLARE @SQL_EXTRA VARCHAR(MAX) = ''
	
	-- ARMAMOS LA CONSULTA SIMPLE
	SET @SQL_SELECT += '
		SELECT A.[AgentId]												''agentId'',
				A.[Name]												''name'' '

	-- AGREGAMOS LA TABLA DE BUSQUEDA
	SET @SQL_FROM += '
			FROM [dbo].[Agent] A (NOLOCK) '

	-- 
	SET @SQL_FILTER += '
			WHERE A.[VCC] = ''' + @VCC + ''' '

	-- AGREGAMOS LOS FILTROS
	IF (@AgentIds IS NOT NULL AND @AgentIds != '') 
		-- FILTRAMOS LOS AGENTES QUE SE MODIFICARON HACE MAS DE 7 DIAS PARA ACTUALIZARLOS EN CASO SEA NECESARIO
		SET @SQL_FILTER += '
				AND A.[AgentId] IN (SELECT Value FROM [dbo].[split](''' + @AgentIds + ''','',''))
				AND DATEDIFF(DAY, A.[TimeStamp], GETUTCDATE()) <= 7 '

	-- JUNTAMOS LAS PARTES DE LA CONSULTA
	SET @SQL_SELECT += @SQL_FROM + @SQL_FILTER + @SQL_EXTRA

	-- EJECUTAMOS LA CONSULTA
	EXEC (@SQL_SELECT)
	
	SET NOCOUNT OFF
END
GO
PRINT N'Modificando [dbo].[BulkProgress]...';


GO
ALTER PROCEDURE [dbo].[BulkProgress]
AS
BEGIN
	INSERT INTO [Progress] ([Key]
		  ,[VCC]
		  ,[ProcessId]
		  ,[Type]
		  ,[TypeId]
		  ,[Total]
		  ,[Progress]
		  ,[Error]
		  ,[Percentage]
		  ,[StatusDescription])  
	SELECT [Key]
		  ,[VCC]
		  ,[ProcessId]
		  ,[Type]
		  ,[TypeId]
		  ,[Total]
		  ,[Progress]
		  ,[Error]
		  ,[Percentage]
		  ,[StatusDescription]
	  FROM [dbo].[#ProgressTemp]
	  
	------------Estados de procesos --------------
	UPDATE A
	SET [Total] = B.[Total]
		,[progress] = B.[Progress]
		,[error] = B.[Error]
		,[percentage] = CASE WHEN B.[Total] > 0 THEN B.[Percentage] ELSE 0 END
		,[StatusDescription] = CASE WHEN B.[Total] >= 0 AND B.[Percentage] = 1 AND  ISNULL(B.[Error],0) > 0 THEN 'COMPLETED_WITH_ERROR' 
									WHEN B.[Total] >= 0 AND B.[Percentage] = 1 AND  ISNULL(B.[Error],0) = 0 THEN 'COMPLETED' 
									ELSE  'IN_PROGRESS' END
		,[LastModifiedDate] = GETUTCDATE()
	FROM Process AS A
	INNER JOIN [dbo].[#ProgressTemp] B 
		ON A.[vcc] = B.[vcc] 
			AND A.[Name] = B.ProcessId 
			AND B.[Type] IS NULL 

	UPDATE A
	SET [Status] = CASE 
			WHEN B.total >= 0 AND B.total <= B.transcription + B.cancel AND B.cancel > B.transcription THEN 'FAILED' 
			WHEN B.total >= 0 AND B.total <= B.transcription + B.cancel THEN 'COMPLETE' 
			ELSE 'INPROCESS_TRANSCRIPTION' 
			END
		,[LastModifiedDate] = GETUTCDATE()
	FROM Process AS A
	INNER JOIN (
		SELECT SUM(UT.total)					'total',
				SUM(UT.cancel)					'cancel',
				SUM(UT.transcription)			'transcription',
				UT.processId					'processId',
				UT.vcc							'vcc'
			FROM (
			  SELECT 
				COUNT(1)					total
				,COUNT(C.isCancel)			cancel
				,COUNT(C.IsTranscribed)		transcription 
				,B.ProcessId				processId
				,B.vcc						vcc
			  FROM [ProcessAudio] A (NOLOCK)
			  INNER JOIN [#ProgressTemp] B 
				ON A.[vcc] = B.[vcc] 
					AND A.ProcessId = B.ProcessId 
					AND B.[Type] IS NULL 
					AND B.[Percentage] = 1
			  INNER JOIN Audio C (NOLOCK) 
				ON A.VCC = C.VCC 
					AND A.AudioId =C.ID 
					AND ISNULL(A.Section,0) = ISNULL(C.Section,0) 
					AND ISNULL(A.Part,0) = ISNULL(C.Part,0)
			  GROUP BY B.ProcessId, B.vcc
			  UNION
			  SELECT 
			  COUNT(1)						total
			  ,COUNT(AI.IsCancel)			cancel
			  ,COUNT(AI.IsTranscribed)		transcription
			  ,PT.[ProcessId]				processId
			  ,PT.[vcc]						vcc
			  FROM [ProcessAsyncInteraction] PAI (NOLOCK)
			  INNER JOIN [#ProgressTemp] PT
				ON PAI.[VCC] = PT.[vcc]
					AND PAI.[ProcessId] = PT.[ProcessId]
					AND PT.[Percentage] = 1
			  INNER JOIN [AsyncInteraction] AI (NOLOCK) 
				ON AI.[VCC] = PT.[vcc]
					AND AI.[Channel] = PAI.[InteractionType]
					AND AI.[Folder] = PAI.[FormattedEndDate]
					AND AI.[Campaign] = PAI.[Campaign]
					AND AI.[ID] = PAI.[InteractionId]
			  GROUP BY PT.ProcessId, PT.vcc
		) UT GROUP BY UT.processId, UT.vcc

	  ) B ON A.[vcc] = B.[vcc] 
		AND A.[Name] = B.ProcessId

	UPDATE P
		SET P.[Status] = CASE WHEN TMPP.[totalFailed] > TMPP.[totalSucced] THEN 'FAILED'
								ELSE 'COMPLETE' END,
			P.[StatusDescription] = CASE WHEN TMPP.[totalFailed] > 0 THEN 'COMPLETED_WITH_ERROR' 
											ELSE 'COMPLETED' END,
			P.[Percentage] = 1
			,P.[LastModifiedDate] = GETUTCDATE()
		FROM [dbo].[Process] P (NOLOCK)
		INNER JOIN (
			SELECT UT.[processId]							'processId',
					ISNULL(SUM(UT.[totalAudio]), 0)			'totalAudio',
					ISNULL(SUM(UT.[totalSucced]), 0)		'totalSucced',
					ISNULL(SUM(UT.[totalFailed]), 0)		'totalFailed'
				FROM (
					SELECT P.[Name] 'processId',
							COUNT(*) 'totalAudio',
							COUNT(CASE WHEN ISNULL(A.[IsTranscribed], 0) = 1 THEN 1 ELSE NULL END) 'totalSucced',
							COUNT(CASE WHEN ISNULL(A.[IsCancel], 0) = 1 THEN 1 ELSE NULL END) 'totalFailed'
						FROM [dbo].[Process] P (NOLOCK) 
						INNER JOIN [dbo].[ProcessAudio] PA (NOLOCK) 
							ON PA.[VCC] = P.[VCC]
								AND PA.[ProcessId] = P.[Name]
						INNER JOIN [dbo].[Audio] A (NOLOCK) 
							ON A.[VCC] = PA.[VCC]
								AND A.[ID] = PA.[AudioId]
								AND A.[Section] = PA.[Section]
								AND A.[Part] = PA.[Part]
						WHERE (P.[StatusDescription] <> 'COMPLETED' AND P.[Status] <> 'COMPLETE')
							OR (P.[StatusDescription] = 'COMPLETED' AND P.[Status] <> 'COMPLETE')
							OR (P.[StatusDescription] = 'COMPLETED' AND P.[Status] IS NULL)
							OR (P.[Total] = 0 AND P.[Percentage] = 0)
							-- AND P.[Status] = 'INPROCESS_TRANSCRIPTION'
							--AND P.[StatusDescription] = 'IN_PROGRESS'
						GROUP BY P.[Name]
			
					UNION

					SELECT P.[Name],
							COUNT(*) 'totalAudio',
							COUNT(CASE WHEN ISNULL(AI.[IsTranscribed], 0) = 1 THEN 1 ELSE NULL END) 'totalSucced',
							COUNT(CASE WHEN ISNULL(AI.[IsCancel], 0) = 1 THEN 1 ELSE NULL END) 'totalFailed'
						FROM [dbo].[Process] P (NOLOCK) 
						INNER JOIN [ProcessAsyncInteraction] PAI (NOLOCK)
							ON PAI.[VCC] = P.[vcc]
								AND PAI.[ProcessId] = P.[Name]
						INNER JOIN [AsyncInteraction] AI (NOLOCK) 
							ON AI.[VCC] = P.[vcc]
								AND AI.[Channel] = PAI.[InteractionType]
								AND AI.[Folder] = PAI.[FormattedEndDate]
								AND AI.[Campaign] = PAI.[Campaign]
								AND AI.[ID] = PAI.[InteractionId]
						WHERE (P.[StatusDescription] <> 'COMPLETED' AND P.[Status] <> 'COMPLETE')
							OR (P.[StatusDescription] = 'COMPLETED' AND P.[Status] <> 'COMPLETE')
							OR (P.[StatusDescription] = 'COMPLETED' AND P.[Status] IS NULL)
							OR (P.[Total] = 0 AND P.[Percentage] = 0)
						GROUP BY P.[Name]
					) UT GROUP BY UT.[processId]
		) TMPP
			ON TMPP.[processId] = P.[Name]
				AND TMPP.[totalAudio] = (ISNULL(TMPP.[totalSucced], 0) + ISNULL(TMPP.[totalFailed], 0))


	-- REGISTROS DE [dbo].[#ProgressTemp] CON [Percentage] = 1 YA ESTAN TERMINADO (CON O SIN ERRORES)
	-- SI EL PROCESS SE MARCA COMO FAILED TUVO MUCHO FRACASOS, PERO AUN ASI TUVO EXITOS QUE DEBERERIA COBRARSE
	INSERT INTO [dbo].[Batch] ([VCC], [BatchTypeName], [BatchTypeId], [IsFinished], [ClosedDate], [LastModifiedDate])
		SELECT PTMP.[vcc], 'TRANSCRIPTION', PTMP.[ProcessId], 1, GETUTCDATE(), GETUTCDATE()
			FROM [#ProgressTemp] PTMP
			INNER JOIN [dbo].[Process] P 
				ON P.[vcc] = PTMP.[vcc] 
					AND P.[Name] = PTMP.[ProcessId] 
					AND PTMP.[Type] IS NULL
			WHERE PTMP.[Percentage] = 1 
				AND PTMP.[Type] IS NULL
	
	------------ESTADOS DE ESTUDIOS --------------
	UPDATE A
		SET [Total] = B.[Total]
			,[progress] = B.[Progress]
			,[error] = B.[Error]
			,[percentage] = B.[Percentage]
			,[StatusDescription] = CASE WHEN B.[Percentage] = 1 AND  ISNULL(B.[Error],0) > 0 THEN 'COMPLETED_WITH_ERROR' 
										WHEN B.[Percentage] = 1 AND  ISNULL(B.[Error],0) = 0 THEN 'COMPLETED' 
										ELSE  'IN_PROGRESS' END
			,[Status] = B.[Percentage]
			,[LastModifiedDate] = GETUTCDATE()
			--,[BatchStatus] = CASE WHEN B.[Percentage] = 1 AND  ISNULL(B.[Error],0) > 0 THEN 'FINISHED_WITH_ERROR' 
				--					WHEN B.[Percentage] = 1 AND  ISNULL(B.[Error],0) = 0 THEN 'FINISHED' 
					--				ELSE 'RUNNING' END
		FROM Study AS A
		INNER JOIN [dbo].[#ProgressTemp] B 
			ON A.[vcc] = B.[vcc] 
				AND A.[ProcessId] = B.ProcessId 
				AND A.[Name] = B.[TypeId] 
				AND B.[Type] = 'study'

	-- REGISTROS DE [dbo].[#ProgressTemp] CON [Percentage] = 1 YA ESTAN TERMINADO (CON O SIN ERRORES)
	INSERT INTO [dbo].[Batch] ([VCC], [BatchTypeName], [BatchTypeId], [IsFinished], [ClosedDate], [LastModifiedDate])
		SELECT PTMP.[vcc], 'STUDY', PTMP.[TypeId], 1, GETUTCDATE(), GETUTCDATE()
			FROM [#ProgressTemp] PTMP
			INNER JOIN [dbo].[Study] S 
				ON S.[vcc] = PTMP.[vcc] 
					AND S.[ProcessId] = PTMP.[ProcessId] 
					AND S.[Name] = PTMP.[TypeId]
					AND PTMP.[Type] = 'study'
			WHERE PTMP.[Percentage] = 1 
				AND PTMP.[Type] = 'study'

	------------Estados de plan de evaluacion --------------

	-- UPDATE PARA LA PARTE DE TRANSCRIPCION
	UPDATE A
	SET [Total] = B.[Total]
		,[progress] = B.[Progress]
		,[error] = B.[Error]
		,[percentage] = B.[Percentage]
		,[StatusDescription] = CASE WHEN B.[Percentage] = 1 AND  ISNULL(B.[Error],0) > 0 THEN 'COMPLETED_WITH_ERROR' 
									WHEN B.[Percentage] = 1 AND  ISNULL(B.[Error],0) = 0 THEN 'COMPLETED' 
									ELSE 'IN_PROGRESS' END
		,[Status] = CASE WHEN B.[Percentage] = 1 THEN 3 ELSE 2 END
		,[LastModifiedDate] = GETUTCDATE()
	FROM EvaluationPlan AS A
	INNER JOIN [dbo].[#ProgressTemp] B 
		ON A.[Instance] = B.[vcc] 
			AND A.[ProcessId] = B.ProcessId 
			AND B.[Type] IS NULL 
			AND A.[FilterByContentQueryName] IS NOT NULL 
			AND A.[FilterByContentQuery] IS NOT NULL

	-- UPDATE CONTEMPLADO PARA PLAN DE EVALUACION CON PASO 3 (FILTRO DE CONTENIDO)
	UPDATE A
	SET [Total] = B.[Total]
		,[progress] = B.[Progress]
		,[error] = B.[Error]
		,[percentage] = B.[Percentage]
		,[StatusDescription] = CASE WHEN B.[Percentage] = 1 AND  ISNULL(B.[Error],0) > 0 THEN 'COMPLETED_WITH_ERROR' 
									WHEN B.[Percentage] = 1 AND  ISNULL(B.[Error],0) = 0 THEN 'COMPLETED' 
									ELSE  'IN_PROGRESS' END
		,[Status] = CASE WHEN B.[Percentage] = 1 THEN 5 ELSE 4 END
		,[LastModifiedDate] = GETUTCDATE()
	FROM EvaluationPlan AS A
	INNER JOIN [dbo].[#ProgressTemp] B 
		ON A.[Instance] = B.[vcc] 
			AND A.[ProcessId] = B.ProcessId 
			AND A.Id = B.[TypeId] 
			AND B.[Type] = 'evaluationPlan'

	-- UPDATE PARA LA PARTE DE ANALISIS SEMANTICO/COGNITIVO
	UPDATE A
	SET [Total] = B.[Total]
		,[progress] = B.[Progress]
		,[error] = B.[Error]
		,[percentage] = B.[Percentage]
		,[StatusDescription] = CASE WHEN B.[Percentage] = 1 AND  ISNULL(B.[Error],0) > 0 THEN 'COMPLETED_WITH_ERROR' 
									WHEN B.[Percentage] = 1 AND  ISNULL(B.[Error],0) = 0 THEN 'COMPLETED' 
									ELSE  'IN_PROGRESS' END
		,[Status] = CASE WHEN B.[Percentage] = 1 THEN 5 ELSE 2 END
		,[LastModifiedDate] = GETUTCDATE()
	FROM EvaluationPlan AS A
	INNER JOIN [dbo].[#ProgressTemp] B ON A.[Instance] = B.[vcc] 
	AND A.[ProcessId] = B.ProcessId 
	AND B.[Type] IS NULL 
	AND A.[FilterByContentQueryName] IS NULL 
	AND A.[FilterByContentQuery] IS NULL 
	AND (
		A.[Evaluation_Mode] = 'A' 
		OR
		A.[Evaluation_Mode] = 'X'
	)

	-- ACTUALIZAMOS EL ESTADO DE LOS PLANES DE LA TABLA TEMPORAL
	UPDATE A
	SET [Total] = B.[Total]
		,[progress] = B.[Progress]
		,[error] = B.[Error]
		,[percentage] = B.[Percentage]
		,[StatusDescription] = CASE WHEN B.[Percentage] = 1 AND  ISNULL(B.[Error],0) > 0 THEN 'COMPLETED_WITH_ERROR' 
									WHEN B.[Percentage] = 1 AND  ISNULL(B.[Error],0) = 0 THEN 'COMPLETED' 
									ELSE  'IN_PROGRESS' END
		,[Status] = CASE WHEN B.[Percentage] = 1 THEN 7 ELSE 6 END
		,[LastModifiedDate] = GETUTCDATE() 
	FROM EvaluationPlan AS A
	INNER JOIN [dbo].[#ProgressTemp] B 
		ON A.[Instance] = B.[vcc] 
			AND A.[ProcessId] = B.ProcessId 
			AND A.Id = B.[TypeId] 
			AND B.[Type] = 'ability'

	-- EN UNA TABLA ADICIONAL PODRIA INSERTAR LOS RP STATUS 7 PARA LUEGO ENVIARLOS A CERRAR EN EL SC
	UPDATE AEP 
		SET AEP.[Completed] = 1
			,[LastModifiedDate] = GETUTCDATE()
	FROM dbo.[AuditorEvaluationPlan] AEP 
	INNER JOIN dbo.[EvaluationPlan] EP 
		ON EP.[ID] = AEP.[IdEvaluationPlan]
	INNER JOIN [dbo].[#ProgressTemp] B 
		ON EP.[Instance] = B.[vcc] 
			AND EP.[ProcessId] = B.ProcessId 
			AND EP.Id = B.[TypeId] 
			AND B.[Type] = 'ability'
	WHERE EP.[Status] = 7
		AND AEP.[IdAuditor] = 'SPEECH' 
		AND (EP.[Evaluation_Mode] = 'A' OR EP.[Evaluation_Mode] = 'X') 

	-- REGISTROS DE [dbo].[#ProgressTemp] CON [Percentage] = 1 YA ESTAN TERMINADO (CON O SIN ERRORES)
	INSERT INTO [dbo].[Batch] ([VCC], [BatchTypeName], [BatchTypeId], [IsFinished], [ClosedDate], [LastModifiedDate])
		SELECT PTMP.[vcc], 'EVALUATION_PLAN', PTMP.[TypeId], 1, GETUTCDATE(), GETUTCDATE()
			FROM [#ProgressTemp] PTMP
			INNER JOIN [dbo].[EvaluationPlan] EP (NOLOCK)
				ON EP.[Instance] = PTMP.[vcc] 
					AND EP.[ProcessId] = PTMP.[ProcessId] 
					AND EP.[Id] = PTMP.[TypeId]
					AND (PTMP.[Type] = 'ability' OR PTMP.[Type] = 'evaluationPlan')
			WHERE PTMP.[Percentage] = 1 
				AND (PTMP.[Type] = 'ability' OR PTMP.[Type] = 'evaluationPlan')

	-- INICIO MEDIDA PARA PLANES FINALIZADOS QUE NO TIENE RESULTS REGISTRADOS
	-- DECLARAMOS UNA VARIABLE PARA ALMACENAR LOS PLANES Y SU CORRESPONDIENTE VCC
	DECLARE MY_CURSOR CURSOR 
	LOCAL STATIC READ_ONLY FORWARD_ONLY -- SCROLL 
		FOR 
		-- CONSULTAMOS LOS ID DE PLANES EN LA TABLA TEMPORAL
		SELECT PTMP.[vcc] 'VCC', 
				PTMP.[TypeId] 'EVALUATION_PLAN_ID'
			FROM [#ProgressTemp] PTMP
			INNER JOIN [dbo].[EvaluationPlan] EP (NOLOCK)
				ON EP.[Instance] = PTMP.[vcc] 
					AND EP.[ProcessId] = PTMP.[ProcessId] 
					AND EP.[Id] = PTMP.[TypeId]
					AND (PTMP.[Type] = 'ability' OR PTMP.[Type] = 'evaluationPlan')
			WHERE PTMP.[Percentage] = 1 
				AND (PTMP.[Type] = 'ability' OR PTMP.[Type] = 'evaluationPlan')
			
	-- DECLARARAMOS VARIABLES PARA INDICAR EL PLAN Y VCC
	DECLARE @CURRENT_VCC VARCHAR(50) = ''
	DECLARE @CURRENT_EVALUATION_PLAN_ID VARCHAR(100) = ''
	DECLARE @CURRENT_EVALUATION_PLAN_MIN_AUTOMATIC_QUALIFICATION NUMERIC(5, 2) = 0

	-- ABRIMOS Y RECORREMOS EL ARRAY DE CANALES
	OPEN MY_CURSOR
	FETCH NEXT FROM MY_CURSOR INTO @CURRENT_VCC, @CURRENT_EVALUATION_PLAN_ID
	WHILE @@FETCH_STATUS = 0
	BEGIN 
		-- BUSCAMOS SI EXISTE RESULTS PARA EL PLAN ACTUAL
		IF NOT EXISTS (
			SELECT 1 
				FROM [dbo].[EvaluationResult] ER (NOLOCK) 
				WHERE ER.[Instance] = @CURRENT_VCC
					AND ER.[IdEvaluationPlan] = @CURRENT_EVALUATION_PLAN_ID
		)
		BEGIN
			-- EJECUTAMOS EL SP QUE INSERTA LOS RESULT BASE DE LOS PLANES QUE AUN NO LOS TIENEN
			EXEC [dbo].[SaveEvaluationBaseResult] @CURRENT_VCC, @CURRENT_EVALUATION_PLAN_ID, 'AUTOMATIC'

			-- ACTUALIZAMOS A COMPLETED LOS REGISTROS AUDITOR_EVALUATION_PLAN DEL PLAN ACTUAL
			UPDATE AEP
				SET AEP.[Completed] = '1'
				FROM AuditorEvaluationPlan AEP (NOLOCK)
				WHERE AEP.[Instance] = @CURRENT_VCC
					AND AEP.[IdEvaluationPlan] = @CURRENT_EVALUATION_PLAN_ID
		END

		FETCH NEXT FROM MY_CURSOR INTO @CURRENT_VCC, @CURRENT_EVALUATION_PLAN_ID
	END
	CLOSE MY_CURSOR
	DEALLOCATE MY_CURSOR
	-- FIN MEDIDA PARA PLANES FINALIZADOS QUE NO TIENE RESULTS REGISTRADOS





	-- INICIO DE ACTUALIZACION DE ESTADO PARA PLANES MIXTOS(TERMINADA LA FASE AUTOMATICA(ESTADO 7), PASA A LA MANUAL(ESTADO 8) Y ACABADA LA MANUAL REGRESA AL ESTADO 7)

	DECLARE @CURRENT_AUDITOR_ID VARCHAR(50) = ''

	-- DECLARAMOS UNA VARIABLE PARA ALMACENAR LOS PLANES Y SU CORRESPONDIENTE VCC
	DECLARE MY_CURSOR_2 CURSOR 
	LOCAL STATIC READ_ONLY FORWARD_ONLY -- SCROLL 
		FOR 
		-- CONSULTAMOS LOS ID DE PLANES EN LA TABLA TEMPORAL
		SELECT DISTINCT
				PT.[vcc]								'VCC', 
				PT.[TypeId]								'EVALUATION_PLAN_ID',
				EF.[MinAutomaticQualification]			'MIN_AUTOMATIC_QUALIFICATION'
			FROM [dbo].[EvaluationPlan] AS EP (NOLOCK)
			INNER JOIN [dbo].[#ProgressTemp] PT 
				ON EP.[Instance] = PT.[vcc] 
					AND EP.[ProcessId] = PT.[ProcessId] 
					AND EP.[Id] = PT.[TypeId] 
					AND PT.[Type] = 'ability'
			INNER JOIN [dbo].[EvaluationFormat] EF (NOLOCK)
				ON EF.[Instance] = EP.[Instance]
					AND EF.[ID] = EP.[IdEvaluationFormat]
			WHERE EP.[Status] = 7
				AND EP.[Evaluation_Mode] = 'X'

	-- ABRIMOS Y RECORREMOS EL ARRAY DE PLANES
	OPEN MY_CURSOR_2
	FETCH NEXT FROM MY_CURSOR_2 INTO @CURRENT_VCC, @CURRENT_EVALUATION_PLAN_ID, @CURRENT_EVALUATION_PLAN_MIN_AUTOMATIC_QUALIFICATION
	WHILE @@FETCH_STATUS = 0
	BEGIN 
		-- EVALUAMOS SI EL AUDITOR SPEECH CALIFICO CON NOTA MAYOR O IGUAL AL ACEPTABLE MINIMO PARA LA PARTE AUTOMATICA
		IF EXISTS (
			SELECT 1
				FROM [dbo].[AuditorEvaluationPlan] AEP (NOLOCK)
				WHERE AEP.[Instance] = @CURRENT_VCC
					AND AEP.[IdEvaluationPlan] = @CURRENT_EVALUATION_PLAN_ID
					AND AEP.[IdAuditor] = 'SPEECH'
					AND AEP.[Score] >= @CURRENT_EVALUATION_PLAN_MIN_AUTOMATIC_QUALIFICATION
		)
		BEGIN
			-- ACTUALIZAMOS EL ESTADO DEL PLAN MIXTO PARA PASAR A LA PARTE MANUAL
			UPDATE EP 
				SET EP.[percentage] = 0
					,EP.[StatusDescription] = 'IN_PROGRESS'
					,EP.[Status] = 8
					,EP.[LastModifiedDate] = GETUTCDATE() 
				FROM [dbo].[EvaluationPlan] AS EP (NOLOCK)
				WHERE EP.[Instance] = @CURRENT_VCC
					AND EP.[ID] = @CURRENT_EVALUATION_PLAN_ID

			-- DECLARAMOS UNA VARIABLE PARA ALMACENAR LOS ID DE AUDITORES CORRESPONDIENTES AL PLAN
			DECLARE MY_AUDITOR_CURSOR CURSOR 
			LOCAL STATIC READ_ONLY FORWARD_ONLY -- SCROLL 
				FOR 
				-- CONSULTAMOS LOS ID DE AUDITORES
				SELECT DISTINCT AEP.[IdAuditor]
					FROM [dbo].[AuditorEvaluationPlan] AEP (NOLOCK)
					WHERE  AEP.[Instance] = @CURRENT_VCC
						AND AEP.[IdEvaluationPlan] = @CURRENT_EVALUATION_PLAN_ID
						AND AEP.[IdAuditor] <> 'SPEECH'

			-- ABRIMOS Y RECORREMOS EL ARRAY DE PLANES
			OPEN MY_AUDITOR_CURSOR
			FETCH NEXT FROM MY_AUDITOR_CURSOR INTO @CURRENT_AUDITOR_ID
			WHILE @@FETCH_STATUS = 0
			BEGIN 
				-- INSERTARMOS LOS REGISTROS DE ER QUE TENIA EL AUDITOR SPEECH
				INSERT INTO [dbo].[EvaluationResult] (
					[Instance], [IdCampaign], [IdInteraction], [IdAgent], [IdEvaluationFormat],
					[MinQualificationAcceptable], [IdGroup], [IdSubGroup], [IdAbility], [Qualification],
					[IdEvaluator], [EvaluationDate], [MaxAbilityScore], [IdEvaluationPlan], [CreatedDate],
					[CreatedByUserId], [TimeStamp], [NotApplies], [ScoreDescription], [CampaignDescription],
					[AgentDescription], [InteractionDateini], [InteractionDatefin], [InteractionAddress], [AbilityOrder],
					[InteractionType], [IdAbilityEvaluationFormat], [IdAuditor], [Conditional]
				) 
					-- SELECCIONAMOS LOS RESULTADOS REGISTRADOS POR SPEECH
					SELECT ER.[Instance], ER.[IdCampaign], ER.[IdInteraction], ER.[IdAgent], ER.[IdEvaluationFormat],
							ER.[MinQualificationAcceptable], ER.[IdGroup], ER.[IdSubGroup], ER.[IdAbility], ER.[Qualification],
							ER.[IdEvaluator], ER.[EvaluationDate], ER.[MaxAbilityScore], ER.[IdEvaluationPlan], ER.[CreatedDate],
							ER.[CreatedByUserId], GETUTCDATE(), ER.[NotApplies], ER.[ScoreDescription], ER.[CampaignDescription],
							ER.[AgentDescription], ER.[InteractionDateini], ER.[InteractionDatefin], ER.[InteractionAddress], ER.[AbilityOrder],
							ER.[InteractionType], ER.[IdAbilityEvaluationFormat], @CURRENT_AUDITOR_ID, ER.[Conditional]
						FROM [dbo].[EvaluationResult] ER (NOLOCK)
						INNER JOIN [dbo].[AuditorEvaluationPlan] AEP (NOLOCK)
							ON AEP.[Instance] = ER.[Instance]
								AND AEP.[IdEvaluationPlan] = ER.[IdEvaluationPlan]
								AND AEP.[IdAuditor] = ER.[IdAuditor]
								AND AEP.[IdInteraction] = ER.[IdInteraction]
								AND AEP.[Score] >= @CURRENT_EVALUATION_PLAN_MIN_AUTOMATIC_QUALIFICATION
						WHERE ER.[Instance] = @CURRENT_VCC
							AND ER.[IdEvaluationPlan] = @CURRENT_EVALUATION_PLAN_ID
							AND ER.[IdAuditor] = 'SPEECH'

				-- REABRIMOS LAS EVALUACIONES DE LAS INTERACCIONES CON SCORE MAYOR O IGUAL AL UMBRAL
				UPDATE [dbo].[AuditorEvaluationPlan]
					SET [Completed] = 0,
						[AutomaticScore] = [Score],
						[ManualScore] = 0,
						[LastModifiedDate] = GETUTCDATE(),
						[TimeStamp] = GETUTCDATE()
					WHERE [Instance] = @CURRENT_VCC
						AND [IdEvaluationPlan] = @CURRENT_EVALUATION_PLAN_ID
						AND [IdAuditor] = @CURRENT_AUDITOR_ID

				FETCH NEXT FROM MY_AUDITOR_CURSOR INTO @CURRENT_AUDITOR_ID
			END
			CLOSE MY_AUDITOR_CURSOR
			DEALLOCATE MY_AUDITOR_CURSOR

			-- COMPLETAMOS LOS REGISTROS DE ER PARA LAS HABILIDADES MANUALES <- LAS HAB. MANUALES DEBEN QUEDAN EN BLANCO PARA EL AUDITOR SPEECH
			-- EXEC [dbo].[SaveEvaluationBaseResult] @CURRENT_VCC, @CURRENT_EVALUATION_PLAN_ID, 'MANUAL'

			-- REMOVEMOS LOS REGISTROS DE SPEECH (AEP Y ER) QUE FUERON ASIGNADOS A LOS AUDITORES
			DELETE ER
				FROM [dbo].[EvaluationResult] ER
				INNER JOIN [dbo].[AuditorEvaluationPlan] AEP (NOLOCK)
					ON AEP.[Instance] = ER.[Instance]
						AND AEP.[IdEvaluationPlan] = ER.[IdEvaluationPlan]
						AND AEP.[IdInteraction] = ER.[IdInteraction]
						AND AEP.[Score] >= @CURRENT_EVALUATION_PLAN_MIN_AUTOMATIC_QUALIFICATION
				WHERE ER.[Instance] = @CURRENT_VCC
					AND ER.[IdEvaluationPlan] = @CURRENT_EVALUATION_PLAN_ID
					AND ER.[IdAuditor] = 'SPEECH'
					AND AEP.[Score] >= @CURRENT_EVALUATION_PLAN_MIN_AUTOMATIC_QUALIFICATION

			-- REMOVEMOS LOS REGISTROS DE SPEECH EN AEP QUE PASARON EL MINIMO PARA AUTOMATICO
			DELETE 
				FROM [dbo].[AuditorEvaluationPlan] 
				WHERE [Instance] = @CURRENT_VCC
					AND [IdEvaluationPlan] = @CURRENT_EVALUATION_PLAN_ID
					AND [IdAuditor] = 'SPEECH'
					AND [Score] >= @CURRENT_EVALUATION_PLAN_MIN_AUTOMATIC_QUALIFICATION

			-- REMOVEMOS LOS REGISTROS DE LOS OTROS AUDITORES QUE NO PASARON EL MINIMO PARA AUTOMATICO
			DELETE 
				FROM [dbo].[AuditorEvaluationPlan] 
				WHERE [Instance] = @CURRENT_VCC
					AND [IdEvaluationPlan] = @CURRENT_EVALUATION_PLAN_ID
					AND [IdAuditor] <> 'SPEECH'
					AND [IdInteraction] IN (
						SELECT [IdInteraction] 
							FROM [dbo].[AuditorEvaluationPlan] 
							WHERE [Instance] = @CURRENT_VCC
								AND [IdEvaluationPlan] = @CURRENT_EVALUATION_PLAN_ID
								AND [IdAuditor] = 'SPEECH'
								AND [Score] < @CURRENT_EVALUATION_PLAN_MIN_AUTOMATIC_QUALIFICATION
					)

			-- ACTUALIZAMOS LOS CAMPOS SCORE DE LAS EVALUACIONES DE SPEECH
			UPDATE [dbo].[AuditorEvaluationPlan]
					SET [AutomaticScore] = [Score],
						[ManualScore] = 0,
						[LastModifiedDate] = GETUTCDATE(),
						[TimeStamp] = GETUTCDATE()
					WHERE [Instance] = @CURRENT_VCC
						AND [IdEvaluationPlan] = @CURRENT_EVALUATION_PLAN_ID
						AND [IdAuditor] = 'SPEECH'

		END
		ELSE
		BEGIN
			-- ELIMINAMOS LOS REGISTROS DE LOS OTROS AUDITORES (AEP)
			DELETE FROM [dbo].[AuditorEvaluationPlan] 
				WHERE  [Instance] = @CURRENT_VCC
					AND [IdEvaluationPlan] = @CURRENT_EVALUATION_PLAN_ID
					AND [IdAuditor] <> 'SPEECH'

			-- COMPLETAMOS LOS REGISTROS DE ER PARA LAS HABILIDADES MANUALES <- LAS HAB. MANUALES DEBEN QUEDAN EN BLANCO PARA EL AUDITOR SPEECH
			-- EXEC [dbo].[SaveEvaluationBaseResult] @CURRENT_VCC, @CURRENT_EVALUATION_PLAN_ID, 'MANUAL'

		END

		FETCH NEXT FROM MY_CURSOR_2 INTO @CURRENT_VCC, @CURRENT_EVALUATION_PLAN_ID, @CURRENT_EVALUATION_PLAN_MIN_AUTOMATIC_QUALIFICATION
	END
	CLOSE MY_CURSOR_2
	DEALLOCATE MY_CURSOR_2


	-- RECUPERAMOS LAS EVALUACIONES DE SPEECH DE LA TABLA AUDITOR EVALUATION PARA REPLICARLA

	/*
	-- ACTUALIZAMOS EL ESTADO DEL PLAN MIXTO PARA PASAR A LA PARTE MANUAL
	UPDATE EP 
		SET EP.[percentage] = 0
			,EP.[StatusDescription] = 'IN_PROGRESS'
			,EP.[Status] = 8
			,EP.[LastModifiedDate] = GETUTCDATE() 
		FROM [dbo].[EvaluationPlan] AS EP (NOLOCK)
		INNER JOIN [dbo].[#ProgressTemp] PT 
			ON EP.[Instance] = PT.[vcc] 
				AND EP.[ProcessId] = PT.[ProcessId] 
				AND EP.[Id] = PT.[TypeId] 
				AND PT.[Type] = 'ability'
		WHERE EP.[Status] = 7
			AND EP.[Evaluation_Mode] = 'X'
	*/
	

	-- FIN DE ACTUALIZACION DE ESTADO PARA PLANES MIXTOS





	-----------------------------------------------------

	DROP TABLE [dbo].[#ProgressTemp]

END
GO
PRINT N'Actualizando [dbo].[BulkInteractionQueryStudy]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[BulkInteractionQueryStudy]';


GO
PRINT N'Actualizando [dbo].[BulkProcessInteraction]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[BulkProcessInteraction]';


GO
PRINT N'Actualizando [dbo].[GetAsyncBillingInteractions]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[GetAsyncBillingInteractions]';


GO
PRINT N'Actualizando [dbo].[GetEvaluationPlanCognitiveInteractionTask]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[GetEvaluationPlanCognitiveInteractionTask]';


GO
PRINT N'Actualizando [dbo].[GetInteractionTranscription]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[GetInteractionTranscription]';


GO
PRINT N'Actualizando [dbo].[GetProcessInteractionsByProcessId]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[GetProcessInteractionsByProcessId]';


GO
PRINT N'Actualizando [dbo].[GetProcessInteractionsHistory]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[GetProcessInteractionsHistory]';


GO
PRINT N'Actualizando [dbo].[GetStudyCognitiveInteractionsTask]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[GetStudyCognitiveInteractionsTask]';


GO
PRINT N'Actualizando [dbo].[GetStudyResultSummary]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[GetStudyResultSummary]';


GO
PRINT N'Actualizando [dbo].[BulkInteractionProcess]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[BulkInteractionProcess]';


GO
PRINT N'Actualizando [dbo].[EvaluateProcessStatus]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[EvaluateProcessStatus]';


GO
PRINT N'Actualizando [dbo].[GetAllegroBillingInteractionsForEvaluationPlan]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[GetAllegroBillingInteractionsForEvaluationPlan]';


GO
PRINT N'Actualizando [dbo].[GetAudio]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[GetAudio]';


GO
PRINT N'Actualizando [dbo].[GetAudios]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[GetAudios]';


GO
PRINT N'Actualizando [dbo].[GetAudiosByProcessId]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[GetAudiosByProcessId]';


GO
PRINT N'Actualizando [dbo].[GetEvaluationPlanCognitiveTask]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[GetEvaluationPlanCognitiveTask]';


GO
PRINT N'Actualizando [dbo].[GetExecuteTemplateProcess]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[GetExecuteTemplateProcess]';


GO
PRINT N'Actualizando [dbo].[GetInteractionsCognitive]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[GetInteractionsCognitive]';


GO
PRINT N'Actualizando [dbo].[GetInteractionsResult]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[GetInteractionsResult]';


GO
PRINT N'Actualizando [dbo].[GetLinguisticProcessStatus]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[GetLinguisticProcessStatus]';


GO
PRINT N'Actualizando [dbo].[GetPendingAudios]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[GetPendingAudios]';


GO
PRINT N'Actualizando [dbo].[GetProcessSummary]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[GetProcessSummary]';


GO
PRINT N'Actualizando [dbo].[GetStudiesInProcess]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[GetStudiesInProcess]';


GO
PRINT N'Actualizando [dbo].[SaveAudio]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[SaveAudio]';


GO
PRINT N'Actualizando [dbo].[SaveAudioLinguisticProcess]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[SaveAudioLinguisticProcess]';


GO
PRINT N'Actualizando [dbo].[BulkEvaluationPlanQuery]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[BulkEvaluationPlanQuery]';


GO
PRINT N'Actualizando [dbo].[DeleteEvaluationPlan]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[DeleteEvaluationPlan]';


GO
PRINT N'Actualizando [dbo].[GetEvaluationPlanByInteractionId]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[GetEvaluationPlanByInteractionId]';


GO
PRINT N'Actualizando [dbo].[GetInteractionsEvaluationPlan]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[GetInteractionsEvaluationPlan]';


GO
PRINT N'Actualizando [dbo].[SaveInteractionEvaluationPlanSample]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[SaveInteractionEvaluationPlanSample]';


GO
PRINT N'Actualizando [dbo].[BulkAbilityCognitive]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[BulkAbilityCognitive]';


GO
PRINT N'Actualizando [dbo].[BulkEvaluationPlanAbility]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[BulkEvaluationPlanAbility]';


GO
PRINT N'Actualización completada.';


GO
