PRINT N'Dropping [dbo].[DF__Evaluatio__IdEva__3DE82FB7]...';


GO
ALTER TABLE [dbo].[EvaluationResult] DROP CONSTRAINT [DF__Evaluatio__IdEva__3DE82FB7];


GO
PRINT N'Dropping [dbo].[DF__Evaluatio__Score__3EDC53F0]...';


GO
ALTER TABLE [dbo].[EvaluationResult] DROP CONSTRAINT [DF__Evaluatio__Score__3EDC53F0];


GO
PRINT N'Dropping [dbo].[DF__Evaluatio__Inter__3FD07829]...';


GO
ALTER TABLE [dbo].[EvaluationResult] DROP CONSTRAINT [DF__Evaluatio__Inter__3FD07829];


GO
PRINT N'Dropping [dbo].[DF_InteractionEvaluationPlan_InteractionDuration]...';


GO
ALTER TABLE [dbo].[InteractionEvaluationPlan] DROP CONSTRAINT [DF_InteractionEvaluationPlan_InteractionDuration];


GO
PRINT N'Starting rebuilding table [dbo].[AuditorEvaluationPlan]...';


GO
BEGIN TRANSACTION;

SET TRANSACTION ISOLATION LEVEL SERIALIZABLE;

SET XACT_ABORT ON;

CREATE TABLE [dbo].[tmp_ms_xx_AuditorEvaluationPlan] (
    [Instance]             VARCHAR (50)   NOT NULL,
    [IdEvaluationPlan]     VARCHAR (50)   NOT NULL,
    [IdAuditor]            VARCHAR (50)   NOT NULL,
    [IdInteraction]        VARCHAR (250)  NOT NULL,
    [TimeStamp]            DATETIME       NULL,
    [Completed]            BIT            NULL,
    [Score]                NUMERIC (5, 2) NULL,
    [LastModifiedByUserId] VARCHAR (50)   NULL,
    [LastModifiedDate]     DATETIME       NULL,
    [IdCampaign]           VARCHAR (50)   NOT NULL,
    [IdAgent]              VARCHAR (50)   NOT NULL,
    [InteractionDate]      DATETIME       NULL,
    [InteractionType]      VARCHAR (50)   NOT NULL,
    [InteractionDuration]  NUMERIC (8)    NULL,
    [InteractionOrigin]    VARCHAR (50)   NULL,
    [InteractionFormat]    VARCHAR (50)   NULL,
    [InteractionDateEnd]   DATETIME       NULL,
    [ManagementResult]     VARCHAR (50)   NULL,
    [ContactId]            VARCHAR (50)   NULL,
    CONSTRAINT [tmp_ms_xx_constraint_PK_AuditorEvaluationPlan_11] PRIMARY KEY CLUSTERED ([Instance] ASC, [IdEvaluationPlan] ASC, [IdAuditor] ASC, [IdInteraction] ASC, [IdAgent] ASC, [InteractionType] ASC)
);

IF EXISTS (SELECT TOP 1 1 
           FROM   [dbo].[AuditorEvaluationPlan])
    BEGIN
        INSERT INTO [dbo].[tmp_ms_xx_AuditorEvaluationPlan] ([Instance], [IdEvaluationPlan], [IdAuditor], [IdInteraction], [IdAgent], [InteractionType], [TimeStamp], [Completed], [Score], [LastModifiedByUserId], [LastModifiedDate], [IdCampaign], [InteractionDate], [InteractionDuration], [InteractionOrigin], [InteractionFormat], [InteractionDateEnd], [ManagementResult], [ContactId])
        SELECT   [Instance],
                 [IdEvaluationPlan],
                 [IdAuditor],
                 [IdInteraction],
                 [IdAgent],
                 [InteractionType],
                 [TimeStamp],
                 [Completed],
                 [Score],
                 [LastModifiedByUserId],
                 [LastModifiedDate],
                 [IdCampaign],
                 [InteractionDate],
                 [InteractionDuration],
                 [InteractionOrigin],
                 [InteractionFormat],
                 [InteractionDateEnd],
                 [ManagementResult],
                 [ContactId]
        FROM     [dbo].[AuditorEvaluationPlan]
        ORDER BY [Instance] ASC, [IdEvaluationPlan] ASC, [IdAuditor] ASC, [IdInteraction] ASC, [IdAgent] ASC, [InteractionType] ASC;
    END

DROP TABLE [dbo].[AuditorEvaluationPlan];

EXECUTE sp_rename N'[dbo].[tmp_ms_xx_AuditorEvaluationPlan]', N'AuditorEvaluationPlan';

EXECUTE sp_rename N'[dbo].[tmp_ms_xx_constraint_PK_AuditorEvaluationPlan_11]', N'PK_AuditorEvaluationPlan_1', N'OBJECT';

COMMIT TRANSACTION;

SET TRANSACTION ISOLATION LEVEL READ COMMITTED;


GO
PRINT N'Creating [dbo].[AuditorEvaluationPlan].[IX_AuditorEvaluationPlan]...';


GO
CREATE NONCLUSTERED INDEX [IX_AuditorEvaluationPlan]
    ON [dbo].[AuditorEvaluationPlan]([Instance] ASC, [IdAuditor] ASC, [IdCampaign] ASC, [IdAgent] ASC, [InteractionType] ASC, [InteractionOrigin] ASC, [InteractionFormat] ASC, [ManagementResult] ASC);


GO
PRINT N'Starting rebuilding table [dbo].[EvaluationResult]...';


GO
BEGIN TRANSACTION;

SET TRANSACTION ISOLATION LEVEL SERIALIZABLE;

SET XACT_ABORT ON;

CREATE TABLE [dbo].[tmp_ms_xx_EvaluationResult] (
    [Instance]                   VARCHAR (50)   NOT NULL,
    [IdCampaign]                 VARCHAR (50)   NOT NULL,
    [IdInteraction]              VARCHAR (250)  NOT NULL,
    [IdAgent]                    VARCHAR (50)   NOT NULL,
    [IdEvaluationFormat]         VARCHAR (50)   NOT NULL,
    [MinQualificationAcceptable] NUMERIC (5, 2) NOT NULL,
    [IdGroup]                    VARCHAR (50)   NULL,
    [IdSubGroup]                 VARCHAR (50)   NULL,
    [IdAbility]                  VARCHAR (50)   NOT NULL,
    [Qualification]              NUMERIC (5, 2) NOT NULL,
    [IdEvaluator]                VARCHAR (50)   NOT NULL,
    [EvaluationDate]             DATETIME       NULL,
    [MaxAbilityScore]            NUMERIC (5, 2) NOT NULL,
    [IdEvaluationPlan]           VARCHAR (50)   CONSTRAINT [DF__Evaluatio__IdEva__3DE82FB7] DEFAULT ((0)) NOT NULL,
    [CreatedDate]                DATETIME       NULL,
    [CreatedByUserId]            VARCHAR (50)   NULL,
    [LastModifiedDate]           DATETIME       NULL,
    [LastModifiedByUserId]       VARCHAR (50)   NULL,
    [TimeStamp]                  DATETIME       NULL,
    [Comment]                    VARCHAR (1000) NULL,
    [NotApplies]                 BIT            NULL,
    [ScoreDescription]           VARCHAR (100)  CONSTRAINT [DF__Evaluatio__Score__3EDC53F0] DEFAULT ('') NOT NULL,
    [CampaignDescription]        VARCHAR (100)  NULL,
    [AgentDescription]           VARCHAR (100)  NULL,
    [InteractionDateini]         DATETIME       NULL,
    [InteractionAddress]         VARCHAR (200)  CONSTRAINT [DF__Evaluatio__Inter__3FD07829] DEFAULT ('') NULL,
    [AbilityOrder]               NUMERIC (4)    NULL,
    [InteractionType]            VARCHAR (50)   NULL,
    [IdAbilityEvaluationFormat]  VARCHAR (50)   NOT NULL,
    [IdAuditor]                  VARCHAR (50)   NOT NULL,
    [Conditional]                VARCHAR (50)   NULL,
    CONSTRAINT [tmp_ms_xx_constraint_PK_EvaluationResult1] PRIMARY KEY CLUSTERED ([Instance] ASC, [IdEvaluationPlan] ASC, [IdAuditor] ASC, [IdInteraction] ASC, [IdAgent] ASC, [IdAbilityEvaluationFormat] ASC)
);

IF EXISTS (SELECT TOP 1 1 
           FROM   [dbo].[EvaluationResult])
    BEGIN
        INSERT INTO [dbo].[tmp_ms_xx_EvaluationResult] ([Instance], [IdEvaluationPlan], [IdAuditor], [IdInteraction], [IdAgent], [IdAbilityEvaluationFormat], [IdCampaign], [IdEvaluationFormat], [MinQualificationAcceptable], [IdGroup], [IdSubGroup], [IdAbility], [Qualification], [IdEvaluator], [EvaluationDate], [MaxAbilityScore], [CreatedDate], [CreatedByUserId], [LastModifiedDate], [LastModifiedByUserId], [TimeStamp], [Comment], [NotApplies], [ScoreDescription], [CampaignDescription], [AgentDescription], [InteractionDateini], [InteractionAddress], [AbilityOrder], [InteractionType], [Conditional])
        SELECT   [Instance],
                 [IdEvaluationPlan],
                 [IdAuditor],
                 [IdInteraction],
                 [IdAgent],
                 [IdAbilityEvaluationFormat],
                 [IdCampaign],
                 [IdEvaluationFormat],
                 [MinQualificationAcceptable],
                 [IdGroup],
                 [IdSubGroup],
                 [IdAbility],
                 [Qualification],
                 [IdEvaluator],
                 [EvaluationDate],
                 [MaxAbilityScore],
                 [CreatedDate],
                 [CreatedByUserId],
                 [LastModifiedDate],
                 [LastModifiedByUserId],
                 [TimeStamp],
                 [Comment],
                 [NotApplies],
                 [ScoreDescription],
                 [CampaignDescription],
                 [AgentDescription],
                 [InteractionDateini],
                 [InteractionAddress],
                 [AbilityOrder],
                 [InteractionType],
                 [Conditional]
        FROM     [dbo].[EvaluationResult]
        ORDER BY [Instance] ASC, [IdEvaluationPlan] ASC, [IdAuditor] ASC, [IdInteraction] ASC, [IdAgent] ASC, [IdAbilityEvaluationFormat] ASC;
    END

DROP TABLE [dbo].[EvaluationResult];

EXECUTE sp_rename N'[dbo].[tmp_ms_xx_EvaluationResult]', N'EvaluationResult';

EXECUTE sp_rename N'[dbo].[tmp_ms_xx_constraint_PK_EvaluationResult1]', N'PK_EvaluationResult', N'OBJECT';

COMMIT TRANSACTION;

SET TRANSACTION ISOLATION LEVEL READ COMMITTED;


GO
PRINT N'Starting rebuilding table [dbo].[InteractionEvaluationPlan]...';


GO
BEGIN TRANSACTION;

SET TRANSACTION ISOLATION LEVEL SERIALIZABLE;

SET XACT_ABORT ON;

CREATE TABLE [dbo].[tmp_ms_xx_InteractionEvaluationPlan] (
    [Instance]             VARCHAR (50)  NOT NULL,
    [IdEvaluationPlan]     VARCHAR (50)  NOT NULL,
    [InteractionType]      VARCHAR (50)  NOT NULL,
    [FormattedEndDate]     VARCHAR (50)  NULL,
    [IdCampaign]           VARCHAR (50)  NULL,
    [IdInteraction]        VARCHAR (250) NOT NULL,
    [InteractionSection]   NUMERIC (5)   NULL,
    [InteractionPart]      NUMERIC (5)   NULL,
    [IdAgent]              VARCHAR (50)  NULL,
    [InteractionMessages]  INT           NULL,
    [InteractionDateStart] DATETIME      NULL,
    [InteractionDateEnd]   DATETIME      CONSTRAINT [DF_InteractionEvaluationPlan_InteractionDateEnd] DEFAULT ((0)) NULL,
    [InteractionDuration]  NUMERIC (8)   CONSTRAINT [DF_InteractionEvaluationPlan_InteractionDuration] DEFAULT ((0)) NULL,
    [InteractionOrigin]    VARCHAR (50)  NULL,
    [InteractionFormat]    VARCHAR (50)  NULL,
    [ManagementResult]     VARCHAR (250) NULL,
    [ContactId]            VARCHAR (50)  NULL,
    [QueryPassed]          BIT           NULL,
    [CreatedByUserId]      VARCHAR (50)  NULL,
    [CreatedDate]          DATETIME      NULL,
    [LastModifiedByUserId] VARCHAR (50)  NULL,
    [LastModifiedDate]     DATETIME      NULL,
    [TimeStamp]            DATETIME      NULL
);

IF EXISTS (SELECT TOP 1 1 
           FROM   [dbo].[InteractionEvaluationPlan])
    BEGIN
        INSERT INTO [dbo].[tmp_ms_xx_InteractionEvaluationPlan] ([Instance], [IdEvaluationPlan], [InteractionType], [FormattedEndDate], [IdCampaign], [IdInteraction], [InteractionSection], [InteractionPart], [IdAgent], [InteractionDateStart], [InteractionDateEnd], [InteractionDuration], [InteractionOrigin], [InteractionFormat], [ManagementResult], [ContactId], [QueryPassed], [CreatedByUserId], [CreatedDate], [LastModifiedByUserId], [LastModifiedDate], [TimeStamp])
        SELECT [Instance],
               [IdEvaluationPlan],
               [InteractionType],
               [FormattedEndDate],
               [IdCampaign],
               [IdInteraction],
               [InteractionSection],
               [InteractionPart],
               [IdAgent],
               [InteractionDateStart],
               [InteractionDateEnd],
               [InteractionDuration],
               [InteractionOrigin],
               [InteractionFormat],
               [ManagementResult],
               [ContactId],
               [QueryPassed],
               [CreatedByUserId],
               [CreatedDate],
               [LastModifiedByUserId],
               [LastModifiedDate],
               [TimeStamp]
        FROM   [dbo].[InteractionEvaluationPlan];
    END

DROP TABLE [dbo].[InteractionEvaluationPlan];

EXECUTE sp_rename N'[dbo].[tmp_ms_xx_InteractionEvaluationPlan]', N'InteractionEvaluationPlan';

COMMIT TRANSACTION;

SET TRANSACTION ISOLATION LEVEL READ COMMITTED;


GO
PRINT N'Creating [dbo].[TMP_EVALUATION_PLAN_QUERY]...';


GO
CREATE TABLE [dbo].[TMP_EVALUATION_PLAN_QUERY] (
    [VCC]              VARCHAR (50)  NULL,
    [ProcessId]        VARCHAR (50)  NULL,
    [EvaluationPlanId] VARCHAR (50)  NULL,
    [AudioId]          VARCHAR (250) NULL,
    [Section]          INT           NULL,
    [Part]             INT           NULL,
    [QueryId]          VARCHAR (50)  NULL,
    [EndDate]          VARCHAR (50)  NULL,
    [Channel]          VARCHAR (50)  NULL,
    [Campaign]         VARCHAR (50)  NULL,
    [CreatedDate]      DATETIME      NULL
);


GO
PRINT N'Altering [dbo].[BulkEvaluationPlanQuery]...';


GO
ALTER PROCEDURE [dbo].[BulkEvaluationPlanQuery]
AS
BEGIN
	SET NOCOUNT ON
	
	/*
	CREATE TABLE TMP_EVALUATION_PLAN_QUERY(
		[VCC] VARCHAR(50)
		  ,[ProcessId] VARCHAR(50)
		  ,[EvaluationPlanId] VARCHAR(50)
		  ,[AudioId] VARCHAR(250)
		  ,[Section] INT
		  ,[Part] INT
		  ,[QueryId] VARCHAR(50)
		  ,[EndDate] VARCHAR(50)
		  ,[Channel] VARCHAR(50)
		  ,[Campaign] VARCHAR(50)
		  ,[CreatedDate] DATETIME
	)
	select * from TMP_EVALUATION_PLAN_QUERY ORDER BY CreatedDate DESC
	*/
	insert into TMP_EVALUATION_PLAN_QUERY (
			[VCC]
		  ,[ProcessId]
		  ,[EvaluationPlanId]
		  ,[AudioId]
		  ,[Section]
		  ,[Part]
		  ,[QueryId]
		  ,[EndDate]
		  ,[Channel]
		  ,[Campaign]
		  ,[CreatedDate]
		  )  
	SELECT [VCC]
		  ,[ProcessId]
		  ,[EvaluationPlanId]
		  ,[AudioId]
		  ,[Section]
		  ,[Part]
		  ,[QueryId]
		  ,[EndDate]
		  ,[Channel]
		  ,[Campaign]
		  ,CURRENT_TIMESTAMP
	  FROM [dbo].[#EvaluationPlanQueryTemp]
	  
	--select * from Dummy2 where AudioId = '60813629052019153349'
	--delete from Dummy2 where EvaluationPlanId <> '4f8baccd-c974-439c-b37a-0ac4ce34ada1'
	--truncate table Dummy2

	UPDATE IEP
	SET IEP.[QueryPassed] = 1
	FROM [dbo].[InteractionEvaluationPlan] IEP (NOLOCK)
	LEFT JOIN [dbo].[EvaluationPlan] EP (NOLOCK)
		ON EP.[Instance] = IEP.[Instance]
			AND EP.[ID] = IEP.[IdEvaluationPlan]
	LEFT JOIN [dbo].[#EvaluationPlanQueryTemp] IEPTMP (NOLOCK)
		ON IEPTMP.[VCC] = IEP.[Instance]
			AND IEPTMP.[EvaluationPlanId] = IEP.[IdEvaluationPlan]
			AND IEPTMP.[AudioId] = REPLACE(IEP.[IdInteraction], ':', '_')
	WHERE IEP.[Instance] = IEPTMP.[VCC]
		AND IEP.[IdEvaluationPlan] = IEPTMP.[EvaluationPlanId]
		AND EP.[ProcessId] = IEPTMP.[ProcessId]
		AND IEPTMP.[AudioId] IS NOT NULL;

	-- ELIMINAMOS LOS AUDIOS (INTERACCIONES) DE PROCESSAUDIO QUE NO PASARON LA VALIDACION DEL FILTRO POR CONTENIDO
	DELETE PA
	FROM [dbo].[ProcessAudio] PA
	INNER JOIN [dbo].[#EvaluationPlanQueryTemp] IEPTMP (NOLOCK)
		ON PA.[VCC] = IEPTMP.[VCC]
			AND PA.[ProcessId] = IEPTMP.[ProcessId]
			AND PA.[AudioId] = IEPTMP.[AudioId]
			AND PA.[Section] = IEPTMP.[Section]
			AND PA.[Part] = IEPTMP.[Part]
	WHERE PA.[VCC] = IEPTMP.[VCC]
		AND PA.[ProcessId] = IEPTMP.[ProcessId]
		AND PA.[AudioId] IN (
			SELECT IEP.[IdInteraction]
				FROM [dbo].[InteractionEvaluationPlan] IEP (NOLOCK)
				INNER JOIN [dbo].[#EvaluationPlanQueryTemp] IEPTMP (NOLOCK)
					ON IEP.[Instance] = IEPTMP.[vcc]
						AND IEP.[IdEvaluationPlan] = IEPTMP.[EvaluationPlanId]
				LEFT JOIN [dbo].[EvaluationPlan] EP (NOLOCK) 
					ON EP.[Instance] = IEP.[Instance]
						AND EP.[ID] = IEP.[IdEvaluationPlan]
				WHERE IEP.[Instance] = IEPTMP.[VCC]
					AND IEP.[IdEvaluationPlan]  = IEPTMP.[EvaluationPlanId]
					AND EP.[ProcessId] =  IEPTMP.[ProcessId]
					AND IEP.[QueryPassed] <> 1
		)

	DELETE PAI 
		FROM [dbo].[ProcessAsyncInteraction] PAI 
		INNER JOIN [dbo].[#EvaluationPlanQueryTemp] IEPTMP (NOLOCK)
			ON PAI.[VCC] = IEPTMP.[VCC]
				AND PAI.[ProcessId] = IEPTMP.[ProcessId]
				AND PAI.[InteractionId] = IEPTMP.[AudioId]
				AND PAI.[Campaign] = IEPTMP.[Campaign]
				AND PAI.[FormattedEndDate] = IEPTMP.[EndDate]
		WHERE PAI.[VCC] = IEPTMP.[VCC]
			AND PAI.[ProcessId] = IEPTMP.[ProcessId]
			AND REPLACE(PAI.[InteractionId], ':', '_' ) IN (
				SELECT IEP.[IdInteraction]
					FROM [dbo].[InteractionEvaluationPlan] IEP (NOLOCK)
					INNER JOIN [dbo].[#EvaluationPlanQueryTemp] IEPTMP (NOLOCK)
						ON IEP.[Instance] = IEPTMP.[vcc]
							AND IEP.[IdEvaluationPlan] = IEPTMP.[EvaluationPlanId]
					LEFT JOIN [dbo].[EvaluationPlan] EP (NOLOCK) 
						ON EP.[Instance] = IEP.[Instance]
							AND EP.[ID] = IEP.[IdEvaluationPlan]
					WHERE IEP.[Instance] = IEPTMP.[VCC]
						AND IEP.[IdEvaluationPlan]  = IEPTMP.[EvaluationPlanId]
						AND EP.[ProcessId] =  IEPTMP.[ProcessId]
						AND IEP.[QueryPassed] <> 1
			)

	--UPDATE IEP SET IEP.[QueryPassed] = 0
	DELETE IEP
	FROM [dbo].[InteractionEvaluationPlan] IEP
	INNER JOIN [dbo].[#EvaluationPlanQueryTemp] IEPTMP (NOLOCK)
		ON IEP.[Instance] = IEPTMP.[VCC]
			AND IEP.[IdEvaluationPlan] = IEPTMP.[EvaluationPlanId]
	WHERE [Instance] = IEPTMP.[VCC]
		AND [IdEvaluationPlan] = IEPTMP.[EvaluationPlanId]
		AND [QueryPassed] IS NULL;

	-- INGRESAMOS UN REGISTRO EN AUDITOREVALUATIONPLAN POR CADA INTERACCION QUE PASO EL FILTRO
	INSERT INTO [AuditorEvaluationPlan] (
		[Instance], [IdEvaluationPlan], [IdAuditor],
		[IdInteraction], [InteractionType], [InteractionDate],
		[InteractionDateEnd], [ManagementResult], [InteractionOrigin], 
		[IdAgent], [idCampaign], [InteractionDuration],
		[InteractionFormat], [TimeStamp], [Completed],
		[Score], [LastModifiedByUserId]
		)
	SELECT DISTINCT IEP.[Instance], IEP.[IdEvaluationPlan], 'SPEECH', 
		IEP.[IdInteraction], IEP.[InteractionType], IEP.[InteractionDateStart],
		CASE IEP.[InteractionType] 
			WHEN 'CALL' THEN IEP.[InteractionDateEnd]
			ELSE (
				SELECT MAX(IEP_INNER.[InteractionDateEnd])
				  FROM [InteractionEvaluationPlan] IEP_INNER (NOLOCK)
				  WHERE IEP_INNER.[IdInteraction] = IEP.[IdInteraction]
					AND IEP_INNER.[IdEvaluationPlan] = IEP.[IdEvaluationPlan]
			) END,
		STUFF((
			SELECT ',' + IEP_INNER.[ManagementResult]
				FROM [InteractionEvaluationPlan] IEP_INNER (NOLOCK)
				WHERE IEP_INNER.[IdInteraction] = IEP.[IdInteraction]
					AND IEP_INNER.[IdEvaluationPlan] = IEP.[IdEvaluationPlan]
				FOR XML PATH(''), TYPE).value('.', 'NVARCHAR(MAX)'), 1, 1, ''),
		IEP.[InteractionOrigin],
		IEP.[IdAgent], IEP.[IdCampaign], IEP.[InteractionDuration], 
		IEP.[InteractionFormat], GETUTCDATE(), 0,
		0, 'SPEECH'
	FROM [InteractionEvaluationPlan] IEP (NOLOCK)
	INNER JOIN [dbo].[#EvaluationPlanQueryTemp] IEPTMP (NOLOCK)
		ON IEP.[Instance] = IEPTMP.[VCC]
			AND IEP.[IdEvaluationPlan] = IEPTMP.[EvaluationPlanId]
			AND IEP.[InteractionType] = IEPTMP.[Channel]
			AND (
					(
						IEP.[InteractionType] = 'CALL'
						AND IEP.[IdInteraction] = IEPTMP.[AudioId]
						AND IEP.[InteractionSection] = IEPTMP.[Section]
						AND IEP.[InteractionPart] = IEPTMP.[Part])
					OR
					(
						IEP.[InteractionType] <> 'CALL'
						AND REPLACE(IEP.[IdInteraction], ':', '_') = IEPTMP.[AudioId]
						AND IEP.[FormattedEndDate] = IEPTMP.[EndDate]
						AND IEP.[IdCampaign] = IEPTMP.[Campaign]
					)
				)
	LEFT JOIN [AuditorEvaluationPlan] AEP (NOLOCK)
		ON AEP.[Instance] = IEP.[Instance]
			AND AEP.[IdEvaluationPlan] = IEP.[IdEvaluationPlan]
			AND AEP.[IdInteraction] = IEP.[IdInteraction]
	WHERE IEP.[Instance] = IEPTMP.[VCC]
		AND IEP.[IdEvaluationPlan] = IEPTMP.[EvaluationPlanId]
		AND AEP.[Instance] IS NULL

	DROP TABLE [dbo].[#EvaluationPlanQueryTemp]
	--DROP TABLE [dbo].[#EvaluationPlanQueryTemp1]
	
	SET NOCOUNT OFF
END;
GO
PRINT N'Altering [dbo].[BulkProgress]...';


GO
ALTER PROCEDURE [dbo].[BulkProgress]
AS
BEGIN
	INSERT INTO [Progress] ([Key]
		  ,[VCC]
		  ,[ProcessId]
		  ,[Type]
		  ,[TypeId]
		  ,[Total]
		  ,[Progress]
		  ,[Error]
		  ,[Percentage]
		  ,[StatusDescription])  
	SELECT [Key]
		  ,[VCC]
		  ,[ProcessId]
		  ,[Type]
		  ,[TypeId]
		  ,[Total]
		  ,[Progress]
		  ,[Error]
		  ,[Percentage]
		  ,[StatusDescription]
	  FROM [dbo].[#ProgressTemp]

	------------Estados de procesos --------------
	UPDATE A
	SET [Total] = B.[Total]
		,[progress] = B.[Progress]
		,[error] = B.[Error]
		,[percentage] = CASE WHEN B.[Total] > 0 THEN B.[Percentage] ELSE 0 END
		,[StatusDescription] = CASE WHEN B.[Total] > 0 AND B.[Percentage] = 1 AND  ISNULL(B.[Error],0) > 0 THEN 'COMPLETED_WITH_ERROR' 
									WHEN B.[Total] > 0 AND B.[Percentage] = 1 AND  ISNULL(B.[Error],0) = 0 THEN 'COMPLETED' 
									ELSE  'IN_PROGRESS' END
		,[LastModifiedDate] = GETUTCDATE()
	FROM Process AS A
	INNER JOIN [dbo].[#ProgressTemp] B 
		ON A.[vcc] = B.[vcc] 
			AND A.[Name] = B.ProcessId 
			AND B.[Type] IS NULL 

	UPDATE A
	SET [Status] = CASE 
			WHEN B.total > 0 AND B.total <= B.transcription + B.cancel AND B.cancel > B.transcription THEN 'FAILED' 
			WHEN B.total > 0 AND B.total <= B.transcription + B.cancel THEN 'COMPLETE' 
			ELSE 'INPROCESS_TRANSCRIPTION' 
			END
		,[LastModifiedDate] = GETUTCDATE()
	FROM Process AS A
	INNER JOIN (
		  SELECT 
			COUNT(1)					total
			,COUNT(C.isCancel)			cancel
			,COUNT(C.IsTranscribed)		transcription 
			,B.ProcessId				processId
			,B.vcc						vcc
		  FROM [ProcessAudio] A (NOLOCK)
		  INNER JOIN [#ProgressTemp] B 
			ON A.[vcc] = B.[vcc] 
				AND A.ProcessId = B.ProcessId 
				AND B.[Type] IS NULL 
				AND B.[Percentage] = 1
		  INNER JOIN Audio C (NOLOCK) 
			ON A.VCC = C.VCC 
				AND A.AudioId =C.ID 
				AND ISNULL(A.Section,0) = ISNULL(C.Section,0) 
				AND ISNULL(A.Part,0) = ISNULL(C.Part,0)
		  GROUP BY B.ProcessId, B.vcc
		  UNION
		  SELECT 
		  COUNT(1)						total
		  ,COUNT(AI.IsCancel)			cancel
		  ,COUNT(AI.IsTranscribed)		transcription
		  ,PT.[ProcessId]				processId
		  ,PT.[vcc]						vcc
		  FROM [ProcessAsyncInteraction] PAI (NOLOCK)
		  INNER JOIN [#ProgressTemp] PT
			ON PAI.[VCC] = PT.[vcc]
				AND PAI.[ProcessId] = PT.[ProcessId]
				AND PT.[Percentage] = 1
		  INNER JOIN [AsyncInteraction] AI (NOLOCK) 
			ON AI.[VCC] = PT.[vcc]
				AND AI.[Channel] = PAI.[InteractionType]
				AND AI.[Folder] = PAI.[FormattedEndDate]
				AND AI.[Campaign] = PAI.[Campaign]
				AND AI.[ID] = PAI.[InteractionId]
		  GROUP BY PT.ProcessId, PT.vcc
	  ) B ON A.[vcc] = B.[vcc] 
		AND A.[Name] = B.ProcessId

	UPDATE P
		SET P.[Status] = CASE WHEN TMPP.[totalFailed] > TMPP.[totalSucced] THEN 'FAILED'
								ELSE 'COMPLETE' END,
			P.[StatusDescription] = CASE WHEN TMPP.[totalFailed] > 0 THEN 'COMPLETED_WITH_ERROR' 
											ELSE 'COMPLETED' END,
			P.[Percentage] = 1
			,P.[LastModifiedDate] = GETUTCDATE()
		FROM [dbo].[Process] P (NOLOCK)
		INNER JOIN (
			SELECT P.[Name] 'processId',
					COUNT(*) 'totalAudio',
					COUNT(CASE WHEN ISNULL(A.[IsTranscribed], 0) = 1 THEN 1 ELSE NULL END) 'totalSucced',
					COUNT(CASE WHEN ISNULL(A.[IsCancel], 0) = 1 THEN 1 ELSE NULL END) 'totalFailed'
				FROM [dbo].[Process] P (NOLOCK) 
				INNER JOIN [dbo].[ProcessAudio] PA (NOLOCK) 
					ON PA.[ProcessId] = P.[Name]
				INNER JOIN [dbo].[Audio] A (NOLOCK) 
					ON A.[ID] = PA.[AudioId]
						AND A.[Section] = PA.[Section]
						AND A.[Part] = PA.[Part]
				WHERE (P.[StatusDescription] <> 'COMPLETED' AND P.[Status] <> 'COMPLETED')
					OR (P.[StatusDescription] = 'COMPLETED' AND P.[Status] <> 'COMPLETED')
					OR (P.[Total] = 0 AND P.[Percentage] = 0)
					-- AND P.[Status] = 'INPROCESS_TRANSCRIPTION'
					--AND P.[StatusDescription] = 'IN_PROGRESS'
				GROUP BY P.[Name]
			
			UNION

			SELECT P.[Name],
					COUNT(*) 'totalAudio',
					COUNT(CASE WHEN ISNULL(AI.[IsTranscribed], 0) = 1 THEN 1 ELSE NULL END) 'totalSucced',
					COUNT(CASE WHEN ISNULL(AI.[IsCancel], 0) = 1 THEN 1 ELSE NULL END) 'totalFailed'
				FROM [dbo].[Process] P (NOLOCK) 
				INNER JOIN [ProcessAsyncInteraction] PAI (NOLOCK)
					ON PAI.[VCC] = P.[vcc]
						AND PAI.[ProcessId] = P.[Name]
				INNER JOIN [AsyncInteraction] AI (NOLOCK) 
					ON AI.[VCC] = P.[vcc]
						AND AI.[Channel] = PAI.[InteractionType]
						AND AI.[Folder] = PAI.[FormattedEndDate]
						AND AI.[Campaign] = PAI.[Campaign]
						AND AI.[ID] = PAI.[InteractionId]
				WHERE (P.[StatusDescription] <> 'COMPLETED' AND P.[Status] <> 'COMPLETED')
					OR (P.[StatusDescription] = 'COMPLETED' AND P.[Status] <> 'COMPLETED')
					OR (P.[Total] = 0 AND P.[Percentage] = 0)
				GROUP BY P.[Name]
		) TMPP
			ON TMPP.[processId] = P.[Name]
				AND TMPP.[totalAudio] = (ISNULL(TMPP.[totalSucced], 0) + ISNULL(TMPP.[totalFailed], 0))


	-- REGISTROS DE [dbo].[#ProgressTemp] CON [Percentage] = 1 YA ESTAN TERMINADO (CON O SIN ERRORES)
	-- SI EL PROCESS SE MARCA COMO FAILED TUVO MUCHO FRACASOS, PERO AUN ASI TUVO EXITOS QUE DEBERERIA COBRARSE
	INSERT INTO [dbo].[Batch] ([VCC], [BatchTypeName], [BatchTypeId], [IsFinished], [ClosedDate], [LastModifiedDate])
		SELECT PTMP.[vcc], 'TRANSCRIPTION', PTMP.[ProcessId], 1, GETUTCDATE(), GETUTCDATE()
			FROM [#ProgressTemp] PTMP
			INNER JOIN [dbo].[Process] P 
				ON P.[vcc] = PTMP.[vcc] 
					AND P.[Name] = PTMP.[ProcessId] 
					AND PTMP.[Type] IS NULL
			WHERE PTMP.[Percentage] = 1 
				AND PTMP.[Type] IS NULL
	
	------------ESTADOS DE ESTUDIOS --------------
	UPDATE A
		SET [Total] = B.[Total]
			,[progress] = B.[Progress]
			,[error] = B.[Error]
			,[percentage] = B.[Percentage]
			,[StatusDescription] = CASE WHEN B.[Percentage] = 1 AND  ISNULL(B.[Error],0) > 0 THEN 'COMPLETED_WITH_ERROR' 
										WHEN B.[Percentage] = 1 AND  ISNULL(B.[Error],0) = 0 THEN 'COMPLETED' 
										ELSE  'IN_PROGRESS' END
			,[Status] = B.[Percentage]
			,[LastModifiedDate] = GETUTCDATE()
			--,[BatchStatus] = CASE WHEN B.[Percentage] = 1 AND  ISNULL(B.[Error],0) > 0 THEN 'FINISHED_WITH_ERROR' 
				--					WHEN B.[Percentage] = 1 AND  ISNULL(B.[Error],0) = 0 THEN 'FINISHED' 
					--				ELSE 'RUNNING' END
		FROM Study AS A
		INNER JOIN [dbo].[#ProgressTemp] B 
			ON A.[vcc] = B.[vcc] 
				AND A.[ProcessId] = B.ProcessId 
				AND A.[Name] = B.[TypeId] 
				AND B.[Type] = 'study'

	-- REGISTROS DE [dbo].[#ProgressTemp] CON [Percentage] = 1 YA ESTAN TERMINADO (CON O SIN ERRORES)
	INSERT INTO [dbo].[Batch] ([VCC], [BatchTypeName], [BatchTypeId], [IsFinished], [ClosedDate], [LastModifiedDate])
		SELECT PTMP.[vcc], 'STUDY', PTMP.[TypeId], 1, GETUTCDATE(), GETUTCDATE()
			FROM [#ProgressTemp] PTMP
			INNER JOIN [dbo].[Study] S 
				ON S.[vcc] = PTMP.[vcc] 
					AND S.[ProcessId] = PTMP.[ProcessId] 
					AND S.[Name] = PTMP.[TypeId]
					AND PTMP.[Type] = 'study'
			WHERE PTMP.[Percentage] = 1 
				AND PTMP.[Type] = 'study'

	------------Estados de plan de evaluacion --------------

	-- UPDATE PARA LA PARTE DE TRANSCRIPCION
	UPDATE A
	SET [Total] = B.[Total]
		,[progress] = B.[Progress]
		,[error] = B.[Error]
		,[percentage] = B.[Percentage]
		,[StatusDescription] = CASE WHEN B.[Percentage] = 1 AND  ISNULL(B.[Error],0) > 0 THEN 'COMPLETED_WITH_ERROR' 
									WHEN B.[Percentage] = 1 AND  ISNULL(B.[Error],0) = 0 THEN 'COMPLETED' 
									ELSE 'IN_PROGRESS' END
		,[Status] = CASE WHEN B.[Percentage] = 1 THEN 3 ELSE 2 END
		,[LastModifiedDate] = GETUTCDATE()
	FROM EvaluationPlan AS A
	INNER JOIN [dbo].[#ProgressTemp] B 
		ON A.[Instance] = B.[vcc] 
			AND A.[ProcessId] = B.ProcessId 
			AND B.[Type] IS NULL 
			AND A.[FilterByContentQueryName] IS NOT NULL 
			AND A.[FilterByContentQuery] IS NOT NULL

	-- UPDATE CONTEMPLADO PARA PLAN DE EVALUACION CON PASO 3 (FILTRO DE CONTENIDO)
	UPDATE A
	SET [Total] = B.[Total]
		,[progress] = B.[Progress]
		,[error] = B.[Error]
		,[percentage] = B.[Percentage]
		,[StatusDescription] = CASE WHEN B.[Percentage] = 1 AND  ISNULL(B.[Error],0) > 0 THEN 'COMPLETED_WITH_ERROR' 
									WHEN B.[Percentage] = 1 AND  ISNULL(B.[Error],0) = 0 THEN 'COMPLETED' 
									ELSE  'IN_PROGRESS' END
		,[Status] = CASE WHEN B.[Percentage] = 1 THEN 5 ELSE 4 END
		,[LastModifiedDate] = GETUTCDATE()
	FROM EvaluationPlan AS A
	INNER JOIN [dbo].[#ProgressTemp] B 
		ON A.[Instance] = B.[vcc] 
			AND A.[ProcessId] = B.ProcessId 
			AND A.Id = B.[TypeId] 
			AND B.[Type] = 'evaluationPlan'

	-- UPDATE PARA LA PARTE DE ANALISIS SEMANTICO/COGNITIVO
	UPDATE A
	SET [Total] = B.[Total]
		,[progress] = B.[Progress]
		,[error] = B.[Error]
		,[percentage] = B.[Percentage]
		,[StatusDescription] = CASE WHEN B.[Percentage] = 1 AND  ISNULL(B.[Error],0) > 0 THEN 'COMPLETED_WITH_ERROR' 
									WHEN B.[Percentage] = 1 AND  ISNULL(B.[Error],0) = 0 THEN 'COMPLETED' 
									ELSE  'IN_PROGRESS' END
		,[Status] = CASE WHEN B.[Percentage] = 1 THEN 5 ELSE 2 END
		,[LastModifiedDate] = GETUTCDATE()
	FROM EvaluationPlan AS A
	INNER JOIN [dbo].[#ProgressTemp] B ON A.[Instance] = B.[vcc] 
	AND A.[ProcessId] = B.ProcessId 
	AND B.[Type] IS NULL 
	AND A.[FilterByContentQueryName] IS NULL 
	AND A.[FilterByContentQuery] IS NULL 
	AND A.[Evaluation_Mode] = 'A' 

	-- 
	UPDATE A
	SET [Total] = B.[Total]
		,[progress] = B.[Progress]
		,[error] = B.[Error]
		,[percentage] = B.[Percentage]
		,[StatusDescription] = CASE WHEN B.[Percentage] = 1 AND  ISNULL(B.[Error],0) > 0 THEN 'COMPLETED_WITH_ERROR' 
									WHEN B.[Percentage] = 1 AND  ISNULL(B.[Error],0) = 0 THEN 'COMPLETED' 
									ELSE  'IN_PROGRESS' END
		,[Status] = CASE WHEN B.[Percentage] = 1 THEN 7 ELSE 6 END
		,[LastModifiedDate] = GETUTCDATE()
		--,[BatchStatus] = CASE WHEN B.[Percentage] = 1 AND  ISNULL(B.[Error],0) > 0 THEN 'FINISHED_WITH_ERROR' 
			--					WHEN B.[Percentage] = 1 AND  ISNULL(B.[Error],0) = 0 THEN 'FINISHED' 
				--				ELSE 'RUNNING' END
	FROM EvaluationPlan AS A
	INNER JOIN [dbo].[#ProgressTemp] B 
		ON A.[Instance] = B.[vcc] 
			AND A.[ProcessId] = B.ProcessId 
			AND A.Id = B.[TypeId] 
			AND B.[Type] = 'ability'

	-- EN UNA TABLA ADICIONAL PODRIA INSERTAR LOS RP STATUS 7 PARA LUEGO ENVIARLOS A CERRAR EN EL SC
	UPDATE AEP 
		SET AEP.[Completed] = 1
			,[LastModifiedDate] = GETUTCDATE()
	FROM dbo.[AuditorEvaluationPlan] AEP 
	INNER JOIN dbo.[EvaluationPlan] EP 
		ON EP.[ID] = AEP.[IdEvaluationPlan]
	INNER JOIN [dbo].[#ProgressTemp] B 
		ON EP.[Instance] = B.[vcc] 
			AND EP.[ProcessId] = B.ProcessId 
			AND EP.Id = B.[TypeId] 
			AND B.[Type] = 'ability'
	WHERE EP.[Status] = 7

	-- REGISTROS DE [dbo].[#ProgressTemp] CON [Percentage] = 1 YA ESTAN TERMINADO (CON O SIN ERRORES)
	INSERT INTO [dbo].[Batch] ([VCC], [BatchTypeName], [BatchTypeId], [IsFinished], [ClosedDate], [LastModifiedDate])
		SELECT PTMP.[vcc], 'EVALUATION_PLAN', PTMP.[TypeId], 1, GETUTCDATE(), GETUTCDATE()
			FROM [#ProgressTemp] PTMP
			INNER JOIN [dbo].[EvaluationPlan] EP 
				ON EP.[Instance] = PTMP.[vcc] 
					AND EP.[ProcessId] = PTMP.[ProcessId] 
					AND EP.[Id] = PTMP.[TypeId]
					AND (PTMP.[Type] = 'ability' OR PTMP.[Type] = 'evaluationPlan')
			WHERE PTMP.[Percentage] = 1 
				AND (PTMP.[Type] = 'ability' OR PTMP.[Type] = 'evaluationPlan')

	SELECT * FROM dbo.[AuditorEvaluationPlan]

	-----------------------------------------------------

	DROP TABLE [dbo].[#ProgressTemp]

END
GO
PRINT N'Altering [dbo].[DeleteAuditorEvaluationPlanByInteraction]...';


GO
-- ESTA FUNCION TIENE POR FINALIDAD ELIMINAR OTRAS EVALUACIONES PENDIENTES DE UNA INTERACCION CORRESPONDIENTES AL MISMO 
--  PLAN DE EVALUACION
ALTER PROCEDURE [dbo].[DeleteAuditorEvaluationPlanByInteraction] (
	@Instance Varchar(50) = NULL,
	@IdEvaluationPlan Varchar(50) = NULL,
	@IdInteraction Varchar(250) = NULL,
	@InteractionType Varchar(50) = NULL
	)
AS
BEGIN
	SET NOCOUNT ON
	DECLARE @EvaluationPlanMode Varchar(50) = NULL

	--CONSULTAMOS LA MODALIDAD DEL PLAN DE EVALUACION
	SELECT @EvaluationPlanMode = EP.[Modality] 
		FROM [dbo].[EvaluationPlan] EP (NOLOCK)
		WHERE EP.[Instance] = @Instance
			AND EP.[ID] = @IdEvaluationPlan

	--SI ES UN PLAN DE MODALIDAD COMPARTIDA(FREE) ELIMINAMOS LAS DEMAS EVALUACIONES DE LA MISMA INTERACCION QUE EXISTEN 
	-- PARA LOS OTROS AUDITORES
	IF (@EvaluationPlanMode = 'FREE')
	BEGIN 
		DELETE
			[AuditorEvaluationPlan]
		WHERE
			[Instance] = @Instance
			AND [IdEvaluationPlan] = @IdEvaluationPlan
			AND [IdInteraction] = @IdInteraction
			AND [InteractionType] = @InteractionType
			AND ISNULL([Completed], 0) = 0
	END 

	SELECT 1 AS 'result'

    SET NOCOUNT OFF
END
GO
PRINT N'Altering [dbo].[GetAuditorEvaluationPlanEvaluation]...';


GO
ALTER PROCEDURE [dbo].[GetAuditorEvaluationPlanEvaluation] (
	@Instance Varchar(50) = NULL,
	@AuditorId Varchar(50) = NULL,
	@EvaluationPlanId Varchar(50) = NULL,
	@InteractionId Varchar(250) = NULL,
	@InteractionType Varchar(25) = NULL
)
AS
BEGIN
	SET NOCOUNT ON

	SELECT AEP.[IdEvaluationPlan]				AS 'evaluationPlanId', 
			AEP.[IdAuditor]						AS 'auditorId', 
			AEP.[IdInteraction]					AS 'interactionId', 
			AEP.[Completed]						AS 'evaluationCompleted', 
			EP.[Description]					AS 'evaluationPlanDescription',
			EP.[IdEvaluationFormat]				AS 'evaluationFormatId'
	FROM [dbo].[AuditorEvaluationPlan] AEP (NOLOCK)
	LEFT JOIN [dbo].[EvaluationPlan] EP (NOLOCK)
		ON EP.[Instance] = AEP.[Instance]
			AND EP.ID = AEP.IdEvaluationPlan
	WHERE AEP.[Instance] = @Instance 
		AND AEP.[IdEvaluationPlan] = @EvaluationPlanId 
		AND AEP.[IdAuditor] = @AuditorId 
		AND AEP.[IdInteraction] = @InteractionId
		AND AEP.[InteractionType] = @InteractionType;

	SET NOCOUNT OFF
END
GO
PRINT N'Altering [dbo].[GetEvaluationResultsFromAuditorEvaluationPlan]...';


GO

ALTER PROCEDURE [dbo].[GetEvaluationResultsFromAuditorEvaluationPlan] (
	@Instance Varchar(50) = NULL,
    @EvaluationPlanId Varchar(50) = NULL,
    @InteractionId varchar(250) = NULL,
    @InteractionType varchar(50) = NULL,
    @AuditorId varchar(50) = NULL,
    @AgentId varchar(50) = NULL
)
AS
BEGIN
    SET NOCOUNT ON

    SELECT
         EF.Id										'EvaluationFormatId'				-- Id
        ,EF.Description								'EvaluationFormatDescription'		-- Titulo del reporte
        ,ER.Instance								'Instance'							-- Subtitulo del reporte
        ,ER.IdAgent									'AgentId'							-- Agente
        ,ER.IdAgent									'AgentDescription'					-- Agente
        ,CONCAT(U.Firstname, ' ', U.Lastname)		'CoordinatorFullName'				-- Coordinador
        ,AEP.IdAuditor								'AuditorId'							-- Auditor
        ,CONCAT(UA.Firstname, ' ',UA.Lastname)		'AuditorDescription'				-- Auditor
		,AEP.IdAuditor
        ,ER.IdCampaign								'CampaignDescription'				-- Campana
        ,ER.IdInteraction							'InteractionId'						-- Grabacion
        ,ER.InteractionType							'InteractionType'					-- Tipo interaccion
        ,ER.InteractionDateini						'InteractionDateIni'				-- Fecha llamada
        ,ER.InteractionAddress						'Contacto'							-- Telefono
        ,ER.EvaluationDate							'EvaluationDate'					-- Fecha monitoreo
        ,AEP.Score									'TotalScore'						-- Puntaje total
        ,G.Id										'GroupId'							-- Grupo
        ,G.Description								'Group'								-- Grupo
        ,SG.Id										'SubGroupId'						-- Subgrupo
        ,SG.Description								'SubGroup'							-- Subgrupo
        ,AB.Id										'AbilityId'							-- Habilidad
        ,AB.Title									'Ability'							-- Habilidad
        ,ER.Comment									'Observacion'						-- Observacion de la habilidad
        ,ER.MaxAbilityScore							'Puntaje'							-- Puntaje
        ,ER.ScoreDescription						'Eval'								-- Eval
        ,ER.Qualification							'Nota'								-- Nota
        ,ER.NotApplies								'NotApplies'
        ,ER.AbilityOrder							'Order'
        ,ER.Conditional                             'conditionalSelected'
    FROM [EvaluationResult] ER (NOLOCK)
    INNER JOIN	[EvaluationFormat] EF (NOLOCK)
	--LEFT JOIN [EvaluationFormat] EF (NOLOCK)
		ON (ER.Instance = EF.Instance 
			AND	ER.IdEvaluationFormat = EF.ID)
    LEFT JOIN [User] U (NOLOCK)
		ON (EF.Instance = U.VCC
			AND EF.CreatedByUserId = U.ID)
    --INNER JOIN [User] UA (NOLOCK)
	LEFT JOIN [User] UA (NOLOCK)
		ON (ER.Instance = UA.VCC 
			AND ER.IdEvaluator = UA.ID)
    --INNER JOIN [AuditorEvaluationPlan] AEP (NOLOCK)
	LEFT JOIN [AuditorEvaluationPlan] AEP (NOLOCK)
		ON (ER.IdEvaluationPlan	= AEP.IdEvaluationPlan
			AND UA.ID = AEP.IdAuditor
			AND ER.IdInteraction = AEP.IdInteraction
			AND ER.InteractionType = AEP.InteractionType
			AND ER.IdAgent = AEP.IdAgent)
    LEFT JOIN [Group] G (NOLOCK)
		ON (ER.Instance = G.Instance
			AND ER.IdGroup = G.ID)
    LEFT JOIN [SubGroup] SG (NOLOCK)
		ON (ER.Instance = SG.Instance 
			AND ER.IdSubGroup = SG.ID)
    LEFT JOIN [Ability] AB (NOLOCK)
		ON (ER.Instance = AB.Instance 
			AND ER.IdAbility = AB.ID)
    WHERE ER.Instance = @Instance
		AND ER.IdEvaluationPlan	= @EvaluationPlanId
		AND ER.IdInteraction = @InteractionId
		AND ER.InteractionType = @InteractionType
		AND ER.IdEvaluator = @AuditorId
		AND ER.IdAgent = @AgentId
    ORDER BY ER.AbilityOrder ASC;

    SET NOCOUNT OFF
END
GO
PRINT N'Altering [dbo].[SaveAuditorEvaluationPlan]...';


GO

ALTER PROCEDURE [dbo].[SaveAuditorEvaluationPlan] (
	@Instance Varchar(50) = NULL, 				
	@IdEvaluationPlan Varchar(50) = NULL,
	@IdAuditor Varchar(50) = NULL,				
	@IdInteraction Varchar(250) = NULL,
	@InteractionType varchar(50) = NULL,	
	@InteractionDate Datetime = NULL,
	@InteractionDateEnd Datetime = NULL,	
	@InteractionDuration numeric(8) = NULL,
	@IdAgent varchar(50) = NULL,
	@idCampaign varchar(50) = NULL,
	@InteractionDispositionCode varchar(50) = NULL,
	@InteractionOrigin varchar(50) = NULL,
	@InteractionFormat varchar(20) = NULL,
	@LastModifiedByUserId Varchar(100) = NULL
	)
AS
BEGIN
	SET NOCOUNT ON
	DECLARE @ID INT = 0;

	-- Verificamos si existen un registros con las datos recibidos
	SELECT @ID = COUNT([Instance])
		FROM [AuditorEvaluationPlan] AEP (NOLOCK)
		WHERE AEP.[Instance] = @Instance
			AND AEP.[IdEvaluationPlan] = @IdEvaluationPlan
			AND AEP.[IdAuditor] = @IdAuditor
			AND AEP.[IdInteraction] = @IdInteraction
			AND AEP.[IdAgent] = @IdAgent
			AND AEP.[InteractionType] = @InteractionType

	-- Si existe, actualizamos dicho registro
	IF @ID > 0
		BEGIN
			UPDATE [AuditorEvaluationPlan]
				SET [InteractionOrigin] = @InteractionOrigin,
					[InteractionFormat] = @InteractionFormat
				WHERE [Instance] = @Instance
					AND [IdEvaluationPlan] = @IdEvaluationPlan
					AND [IdAuditor] = @IdAuditor
					AND [IdInteraction] = @IdInteraction
					AND [IdAgent] = @IdAgent
					AND [InteractionType] = @InteractionType
		END
	-- Si no existe lo insertamos
	ELSE 
		BEGIN
			INSERT INTO [AuditorEvaluationPlan] (
				[Instance], [IdEvaluationPlan], [IdAuditor],
				[IdInteraction], [InteractionType], [InteractionDate],
				[InteractionDateEnd], [ManagementResult], [InteractionOrigin], 
				[IdAgent], [idCampaign], [InteractionDuration],
				[InteractionFormat], [TimeStamp], [Completed],
				[Score], [LastModifiedByUserId]
				)
			VALUES (
				@Instance, @IdEvaluationPlan, @IdAuditor,
				@IdInteraction, @InteractionType, @InteractionDate, 
				@InteractionDateEnd, @InteractionDispositionCode, @InteractionOrigin,
				@IdAgent, @IdCampaign, @InteractionDuration,
				@InteractionFormat, GETUTCDATE(), 0, 
				0, @LastModifiedByUserId
			)
		END
	
    SELECT 1 AS 'result'

    SET NOCOUNT OFF
END
GO
PRINT N'Altering [dbo].[SaveInteractionEvaluationPlanResult]...';


GO

ALTER PROCEDURE [dbo].[SaveInteractionEvaluationPlanResult] (
	@Instance Varchar(50),
	@IdEvaluationPlan Varchar(50),
	@IdAuditor Varchar(50),
	@IdInteraction Varchar(250),
	@InteractionType Varchar(50),
	@Score numeric(5,2)
	)
AS
BEGIN
	SET NOCOUNT ON
 	UPDATE AuditorEvaluationPlan
		SET Completed = 1, Score = @Score, LastModifiedDate = GETUTCDATE()
	WHERE
		Instance = @Instance
		AND IdEvaluationPlan = @IdEvaluationPlan
		AND IdInteraction = @IdInteraction
		AND InteractionType = @InteractionType
		AND IdAuditor = @IdAuditor;

    SELECT 1 AS 'result'

 	SET NOCOUNT OFF
END
GO
PRINT N'Altering [dbo].[SaveEvaluationResult]...';


GO

ALTER PROCEDURE [dbo].[SaveEvaluationResult] (
	@Instance Varchar(50) = NULL,
	@Id Varchar(250) = NULL,
	@IdCampaign Varchar(50) = NULL,
	@IdInteraction Varchar(250) = NULL,
	@IdAgent Varchar(50) = NULL,
	@IdEvaluationFormat Varchar(50) = NULL,
	@MinQualificationAcceptable numeric(5,2) = NULL,
	@IdGroup Varchar(50) = NULL,
	@IdSubGroup Varchar(50) = NULL,
	@IdAbility Varchar(50) = NULL,
	@Qualification numeric(5,2) = NULL,
	@IdEvaluator Varchar(50) = NULL,
	@EvaluationDate Datetime = NULL,
	@MaxAbilityScore numeric(5,2) = NULL,
	@IdEvaluationPlan Varchar(50) = NULL,
	@Comment Varchar(1000) = NULL,
	@NotApplies bit = NULL,
	@ScoreDescription varchar(100) = NULL,
	@CampaignDescription varchar(100) = NULL,
	@AgentDescription varchar(100) = NULL,
	@InteractionDateini [datetime] = NULL,
	@InteractionAddress [varchar](200) = NULL,
	@InteractionType varchar(50) = NULL,
	@AbilityOrder numeric(4,0) = NULL,
	@CreatedDate Datetime = NULL,@CreatedByUserId Varchar(50) = NULL,
	@LastModifiedDate Datetime = NULL,@LastModifiedByUserId Varchar(50) = NULL,
	@Conditional varchar(50) = NULL
	)
AS
BEGIN
	SET NOCOUNT ON

	DECLARE @IdAbilityEvaluationFormat Varchar(50) = NULL

	SELECT @IdAbilityEvaluationFormat = ID
	FROM [AbilityEvaluationFormat]
	WHERE [IdEvaluationFormat] = @IdEvaluationFormat
	AND [IdAbility] = @IdAbility
	AND [IdGroup] = @IdGroup
	AND [IdSubGroup] = @IdSubGroup
	AND [Instance] = @Instance
	AND isNull([Conditional],'') = isNull(@Conditional,'')

	INSERT INTO [dbo].[EvaluationResult]
           ([Instance]
           ,[IdCampaign]
           ,[IdInteraction]
           ,[IdAgent]
           ,[IdEvaluationFormat]
           ,[MinQualificationAcceptable]
           ,[IdGroup]
           ,[IdSubGroup]
           ,[IdAbility]
           ,[Qualification]
           ,[IdEvaluator]
		   ,[IdAuditor]
           ,[EvaluationDate]
           ,[MaxAbilityScore]
           ,[IdEvaluationPlan]
		   ,[Comment]
		   ,[NotApplies]
		   ,[ScoreDescription]
			,[CampaignDescription]
			,[AgentDescription]
			,[InteractionDateini]
			,[InteractionAddress]
			,[InteractionType]
			,[AbilityOrder]
		   ,[CreatedDate]
           ,[CreatedByUserId]
           ,[LastModifiedDate]
           ,[LastModifiedByUserId]
		   ,[IdAbilityEvaluationFormat]
		   ,[Conditional]
           ,[TimeStamp]
           )
     VALUES
           (
		   @Instance,
		   @IdCampaign,
			@IdInteraction,
			@IdAgent,
			@IdEvaluationFormat,
			@MinQualificationAcceptable ,
			@IdGroup, @IdSubGroup, @IdAbility,
			@Qualification,
			@IdEvaluator,
			@IdEvaluator,
			@EvaluationDate,
			@MaxAbilityScore,
			@IdEvaluationPlan,
			@Comment,
			@NotApplies,
			@ScoreDescription,
			@CampaignDescription,
			@AgentDescription,
			@InteractionDateini,
			@InteractionAddress,
			@InteractionType,
			@AbilityOrder,
			@CreatedDate,@CreatedByUserId,@LastModifiedDate,@LastModifiedByUserId,
			@IdAbilityEvaluationFormat,
			@Conditional,
		   GETUTCDATE())

    SELECT 1 AS 'result'

    SET NOCOUNT OFF
END
GO
PRINT N'Altering [dbo].[SaveInteractionEvaluationPlan]...';


GO

ALTER PROCEDURE [dbo].[SaveInteractionEvaluationPlan] (
	@Instance Varchar(50) = NULL, 
	@IdEvaluationPlan Varchar(50) = NULL,
	@IdAgent Varchar(50) = NULL,
	@IdCampaign Varchar(50) = NULL,
	@IdInteraction Varchar(250) = NULL,
	@InteractionSection Int = 0,
	@InteractionPart Int = 0,
	@InteractionFolder VARCHAR(50) = NULL,
	@InteractionDateStart DateTime = '1980-01-01',
    @InteractionDateEnd DateTime = '2050-01-01',
	@InteractionType Varchar(50) = NULL,
	@TotalMessages INT = NULL,
	@InteractionDuration Int = 0,
	@InteractionOrigin Varchar(50) = NULL,
	@InteractionManagementResult Varchar(50) = NULL,
	@InteractionContactId Varchar(50) = NULL,
	@InteractionFormat Varchar(20) = NULL,
	@LastModifiedByUserId Varchar(50) = NULL,
	@LastModifiedDate DateTime = NULL,
	@CreatedByUserId Varchar(50) = NULL,
	@CreatedDate DateTime = NULL
	)
AS
BEGIN
	SET NOCOUNT ON

	IF(@InteractionManagementResult = '') SET @InteractionManagementResult = NULL;

	UPDATE [InteractionEvaluationPlan]
	SET
		[Instance] = @Instance, 
		[IdEvaluationPlan] = @IdEvaluationPlan, 
		[IdAgent] = @IdAgent,
		[IdCampaign] = @IdCampaign, 
		[IdInteraction] = @IdInteraction, 
		[InteractionSection] = @InteractionSection, 
		[InteractionPart] = @InteractionPart, 
		[InteractionDateStart] = @InteractionDateStart,
		[FormattedEndDate] = @InteractionFolder,
		[InteractionDateEnd] = @InteractionDateEnd, 
		[InteractionType] = @InteractionType, 
		[InteractionMessages] = @TotalMessages,
		[InteractionDuration] = @InteractionDuration,
		[InteractionOrigin] = @InteractionOrigin, 
		[ManagementResult] = @InteractionManagementResult, 
		[ContactId] = @InteractionContactId,
		[InteractionFormat] = @InteractionFormat,
		[LastModifiedByUserId] = CASE WHEN @LastModifiedByUserId IS NULL THEN [LastModifiedByUserId] ELSE @LastModifiedByUserId END,
		[LastModifiedDate] = GETUTCDATE(),
		[TimeStamp] = GETUTCDATE()

		WHERE [Instance] = @Instance
			AND [IdEvaluationPlan] = @IdEvaluationPlan
			AND	[IdInteraction] = @IdInteraction
			AND	[InteractionSection] = @InteractionSection
			AND	[InteractionPart] = @InteractionPart

	IF @@ROWCOUNT = 0
		INSERT INTO [InteractionEvaluationPlan] (
			[Instance], [IdEvaluationPlan], [IdAgent],
			[IdCampaign], [IdInteraction], [FormattedEndDate], 
			[InteractionSection], [InteractionPart], [InteractionDateStart], 
			[InteractionDateEnd], [InteractionType], [InteractionMessages],
			[InteractionDuration], [InteractionOrigin], [ManagementResult], 
			[ContactId], [InteractionFormat], [CreatedByUserId], 
			[CreatedDate], [TimeStamp]
		)
		VALUES (
			@Instance, @IdEvaluationPlan, @IdAgent,
			@IdCampaign, @IdInteraction, @InteractionFolder,
			@InteractionSection, @InteractionPart, @InteractionDateStart, 
			@InteractionDateEnd, @InteractionType, @TotalMessages,
			@InteractionDuration, @InteractionOrigin, @InteractionManagementResult, 
			@InteractionContactId, @InteractionFormat, @CreatedByUserId, 
			@CreatedDate, GETUTCDATE()
		)

	SELECT 1 AS 'result'

	SET NOCOUNT OFF
END
GO
PRINT N'Altering [dbo].[BulkAsyncInteraction]...';


GO
ALTER PROCEDURE [dbo].[BulkAsyncInteraction]
AS
BEGIN
	-- ESTE SP INSERTA REGISTROS UNICOS DE ASYNCINTERACTION PROVENIENTES DE LA BD EXTERNA EN LA TABLA ASYNCINTERACTION Y PROCESSASYNCINTERACTION

	--
	INSERT INTO [dbo].[AsyncInteraction] (
		[VCC], [ID], [Folder], [ExportedContent], [Channel]
		, [Campaign], [StartDate], [EndDate], [Account], [Initiative]
		, [ContactName], [FirstTakedAgent], [LastTakedAgent], [IsTaken], [TotalMessages]
		, [DurationTime], [AttentionTime], [DispositionCode], [DispositionTreePath], [RawChar] 
		, [CreatedDate], [CreatedByUserId], [LastModifiedDate], [LastModifiedByUserId], [TimeStamp]
	)
		-- SELECCIONAMOS TODOS LOS REGISTROS DE LA TABLA TEMPORAL [#AsyncInteractionTemp] QUE NO EXISTEN EN [AsyncInteraction] POR LOS PK
		SELECT AIT.[VCC], AIT.[ID], AIT.[Folder], AIT.[ExportedContent], AIT.[Channel]
				, AIT.[Campaign], AIT.[StartDate], AIT.[EndDate], AIT.[Account], AIT.[Initiative]
				, AIT.[ContactName], AIT.[FirstTakedAgent], AIT.[LastTakedAgent], AIT.[IsTaken], AIT.[TotalMessages]
				, AIT.[DurationTime], AIT.[AttentionTime], AIT.[DispositionCode], AIT.[DispositionTreePath], AIT.[RawChar]
				, AIT.[CreatedDate], AIT.[CreatedByUserId], AIT.[LastModifiedDate], AIT.[LastModifiedByUserId], GETUTCDATE()
			FROM [#AsyncInteractionTemp] AIT
			LEFT JOIN [dbo].[AsyncInteraction] AI (NOLOCK)
				ON AI.[VCC] = AIT.[VCC]
					AND AI.[ID] = AIT.[ID]
					AND AI.[EndDate] = AIT.[EndDate]
			WHERE AI.[ID] IS NULL

	--
	INSERT INTO [dbo].[ProcessAsyncInteraction] (
		[VCC], [ProcessId], [InteractionType], [Campaign], [InteractionId]
		, [EndDate], [FormattedEndDate], [CreatedDate], [CreatedByUserId], [LastModifiedDate]
		, [LastModifiedByUserId], [TimeStamp]
	)
		-- SELECCIONAMOS TODOS LOS REGISTROS DE LA TABLA TEMPORAL [#ProcessAsyncInteractionTemp] QUE NO EXISTEN EN [ProcessAsyncInteraction] POR LOS PK
		SELECT PAIT.[VCC], PAIT.[ProcessId], PAIT.[InteractionType], PAIT.[Campaign], PAIT.[InteractionId] 
				, PAIT.[EndDate], PAIT.[FormattedEndDate], PAIT.[CreatedDate], PAIT.[CreatedByUserId], PAIT.[LastModifiedDate]
				, PAIT.[LastModifiedByUserId], GETUTCDATE()
			FROM [#ProcessAsyncInteractionTemp] PAIT
			LEFT JOIN [dbo].[ProcessAsyncInteraction] PAI (NOLOCK)
				ON PAI.[VCC] = PAIT.[VCC]
					AND PAI.[ProcessId] = PAIT.[ProcessId]
					AND PAI.[InteractionType] = PAIT.[InteractionType]
					AND PAI.[InteractionId] = PAIT.[InteractionId]
					AND PAI.[EndDate] = PAIT.[EndDate]
			WHERE PAI.[InteractionId] IS NULL
	
	-- ELIMINAMOS LAS TABLAS TEMPORALES
	DROP TABLE [#AsyncInteractionTemp]
	DROP TABLE [#ProcessAsyncInteractionTemp]
END
GO
PRINT N'Altering [dbo].[BulkInteractionProcess]...';


GO
ALTER PROCEDURE [dbo].[BulkInteractionProcess]
AS
BEGIN
	-- SE USA ESTE SP?
	UPDATE [dbo].[Audio] SET
		[dbo].[Audio].DurationLinguisticTime = [dbo].[#InteractionProcessTemp].DurationLinguisticTime,
		[dbo].[Audio].IsTranscribed = [dbo].[#InteractionProcessTemp].IsTranscribed,
		[dbo].[Audio].IsCancel = [dbo].[#InteractionProcessTemp].IsCancel,
		[dbo].[Audio].[FileName] = [dbo].[#InteractionProcessTemp].[FileName],
		[dbo].[Audio].[ErrorMessage] = [dbo].[#InteractionProcessTemp].[ErrorMessage],
		[dbo].[Audio].LastModifiedDate = GETUTCDATE()
	FROM [dbo].[#InteractionProcessTemp]
	WHERE
		[dbo].[Audio].VCC = [dbo].[#InteractionProcessTemp].VCC
		AND [dbo].[Audio].ID = [dbo].[#InteractionProcessTemp].ID
		AND [dbo].[Audio].Section = [dbo].[#InteractionProcessTemp].Section
		AND [dbo].[Audio].Part = [dbo].[#InteractionProcessTemp].Part

	  UPDATE Process
	  SET [Status] = CASE 
		WHEN total <= transcription + cancel AND cancel > transcription THEN 'FAILED' 
		WHEN total <= transcription + cancel THEN 'COMPLETE' 
		ELSE 'INPROCESS_TRANSCRIPTION' 
		END
	  FROM (
		  SELECT 
			COUNT(1)					total
			,COUNT(C.isCancel)			cancel
			,COUNT(C.IsTranscribed)		transcription 
			,B.ProcessId				processId
			,B.vcc						vcc
		  FROM [ProcessAudio] A (NOLOCK)
		  INNER JOIN (SELECT DISTINCT vcc, processId FROM [#InteractionProcessTemp]) B ON A.[vcc] = B.[vcc] AND A.ProcessId = B.ProcessId 
		  INNER JOIN Audio C (NOLOCK) ON A.VCC = C.VCC AND A.AudioId =C.ID AND ISNULL(A.Section,0) = ISNULL(C.Section,0) AND ISNULL(A.Part,0) = ISNULL(C.Part,0)
		  GROUP BY B.ProcessId, B.vcc
	  ) B
	  WHERE  B.VCC = [Process].VCC AND B.ProcessId = Process.[Name]

	 UPDATE EvaluationPlan
	  set [Status] = 5
	  --SELECT * 
	  FROM EvaluationPlan A (NOLOCK)
	  INNER JOIN Process B (NOLOCK) ON A.Instance = B.Vcc AND A.ProcessId =  B.[Name] AND B.[Status] = 'COMPLETE'
	  WHERE A.Evaluation_Mode = 'A' AND A.FilterByContentQueryName IS NULL AND A.[Status] < 5

	  UPDATE EvaluationPlan
	  set [Status] = 4
	  --SELECT * 
	  FROM EvaluationPlan A (NOLOCK)
	  INNER JOIN Process B (NOLOCK) ON A.Instance = B.Vcc AND A.ProcessId =  B.[Name] AND B.[Status] = 'COMPLETE'
	  WHERE A.Evaluation_Mode = 'A' AND A.FilterByContentQueryName IS NOT NULL AND A.[Status] < 4

	DROP TABLE [dbo].[#InteractionProcessTemp]
END
GO
PRINT N'Altering [dbo].[FinishedBatchClose]...';


GO
ALTER PROCEDURE [dbo].[FinishedBatchClose](
	@VCC VARCHAR(50) = NULL,
	@BatchTypeName VARCHAR(50) = NULL,
	@BatchTypeId VARCHAR(50) = NULL
)
AS
BEGIN
	-- ESTE SP TIENE LA FINALIDAD DE ACTUALIZAR LOS SALDOS DE LAS CARTERAS DEL VCC
	SET NOCOUNT ON

	-- VERIFICAMOS QUE TENEMOS LOS PARAMETROS NECESARIOS
	IF @VCC IS NULL OR @BatchTypeName IS NULL OR @BatchTypeId IS NULL
		-- LANZAMOS MENSAJE AVISANDO QUE FALTA ACCOUNTID
		RAISERROR('DATABABASE_ERROR_MISSING_PARAMETERS', 16, 16)

	--SELECT * FROM [dbo].[Batch] 
	UPDATE [dbo].[Batch] 
		SET [FinishReported] = 1
			,[LastModifiedDate] = GETUTCDATE()
		WHERE [VCC] = @VCC
			AND [BatchTypeName] = @BatchTypeName 
			AND [BatchTypeId] = @BatchTypeId

	-- SEGUN EL BATCHTYPENAME ACTUALIZAMOS EL STATUS DE LA TABLA DEL BATCH
	IF @BatchTypeName = 'TRANSCRIPTION'
	BEGIN
		UPDATE [dbo].[Process] 
			SET [Status] = CASE WHEN ([Total] - ISNULL([Error], 0)) > ISNULL([Error], 0) THEN 'COMPLETE'
							WHEN ([Total] - ISNULL([Error], 0)) < ISNULL([Error], 0) THEN 'FAILED' END
				,[StatusDescription] = CASE WHEN ISNULL([Error], 0) > 0 THEN 'COMPLETED_WITH_ERROR' 
										WHEN ISNULL([Error], 0) = 0 THEN 'COMPLETED' END
			WHERE [VCC] = @VCC
				AND [Name] = @BatchTypeId
				AND [Percentage] = 1
	END
	ELSE IF @BatchTypeName = 'STUDY'
	BEGIN 
		UPDATE [dbo].[Study] 
			SET [StatusDescription] = CASE WHEN [Percentage] = 1 AND  ISNULL([Error],0) > 0 THEN 'COMPLETED_WITH_ERROR' 
										WHEN [Percentage] = 1 AND  ISNULL([Error],0) = 0 THEN 'COMPLETED' END
			WHERE [VCC] = @VCC
				AND [Name] = @BatchTypeId
				AND [Percentage] = 1
	END
	ELSE IF @BatchTypeName = 'EVALUATION_PLAN'
	BEGIN 
		UPDATE [dbo].[EvaluationPlan] 
			SET [StatusDescription] = CASE WHEN [Percentage] = 1 AND  ISNULL([Error], 0) > 0 THEN 'COMPLETED_WITH_ERROR' 
									WHEN [Percentage] = 1 AND  ISNULL([Error], 0) = 0 THEN 'COMPLETED' END 
			WHERE [Instance] = @VCC
				AND [ID] = @BatchTypeId
				AND [Percentage] = 1
				AND ([Status] = 3 OR [Status] = 5 OR [Status] = 7)
	END

	SELECT 1 'result'

	SET NOCOUNT OFF
END
GO
PRINT N'Altering [dbo].[GetAllegroFilterInteractions]...';


GO
ALTER PROCEDURE [dbo].[GetAllegroFilterInteractions]
(
	@Ip						VARCHAR(50),
	@VCC					VARCHAR(50),
	@StartDate				DATETIME = '1980-01-01T00:00:00',
	@EndDate				DATETIME = '2050-01-01T23:59:59',
	@StartHour				VARCHAR(50) = NULL,
	@EndHour				VARCHAR(50) = NULL,
	@Campaign				NVARCHAR(MAX),
	@Agent					NVARCHAR(MAX),
	@ResultCode				NVARCHAR(MAX),
	@Type					INT,
	@Origin					NVARCHAR(MAX),
	@MinDuration			Int,
	@MaxDuration			Int
)
AS
BEGIN
	-- SETTEAMOS VALORES MINIMOS PARA LAS HORAS DE INICIO Y FIN
	IF (@StartHour IS NOT NULL AND @StartHour = '') SET @StartHour = '00:00:00'
	IF (@EndHour IS NOT NULL AND @EndHour = '') SET @EndHour = '23:59:59'

	-- DECLARAMOS CADENAS PARA EL QUERY FINAL
	DECLARE @SQL_SELECT_0 VARCHAR(MAX) = '';
	DECLARE @SQL_SELECT_1 VARCHAR(MAX) = '';
	DECLARE @SQL_FROM VARCHAR(MAX) = ''
	DECLARE @SQL_FILTER VARCHAR(MAX) = ''
	DECLARE @SQL_EXTRA VARCHAR(MAX) = ''
	
	DECLARE @Sql NVARCHAR(MAX)

	-- CREAMOS LAS VARIABLES QUE HARAN REFERENCIA A LAS TABLAS QUE PUEDEN SER EXTERNAS
	DECLARE @TblHistoricalDataRef NVARCHAR(50) = '';
	DECLARE @TblMmprodataRef NVARCHAR(50) = '';

	-- EL TYPE 0 INDICA QUE LAS TABLAS SE ENCUENTRAN EN UN SERVIDOR EXTERNO
	IF(@Type = 0)  
	BEGIN  
		SET @TblHistoricalDataRef = '[' + @Ip + ']' + '.[HistoricalData].[dbo].'
		SET @TblMmprodataRef = '[' + @Ip + ']' + '.[MMProDat].[dbo].'
	END
	ELSE IF(@Type = 1) 
	BEGIN
		SET @TblHistoricalDataRef = '[HistoricalData].[dbo].'
		SET @TblMmprodataRef = '[MMProDat].[dbo].'
	END


	IF(@Type = 0 OR @Type = 1)  
	BEGIN  
		-- ARMAMOS EL QUERY PARA HACER LA CONSULTA DE RESUMEN
		SET @SQL_SELECT_0 += '
			SET NOCOUNT ON
			SELECT COUNT(DISTINCT ID.[Id])								''totalInteractions'',
					COUNT(*)											''totalAudios'',
					SUM(ID.[AttentionTime])								''totalAttentionTime'' 
				'

		-- ARMAMOS EL QUERY PARA HACER LA CONSULTA DE CONTENIDO
		SET @SQL_SELECT_1 += '
			SET NOCOUNT ON
			SELECT ID.[Id] + ''_'' + CONVERT(VARCHAR(10), IMP.[Section]) + ''_'' + CONVERT(VARCHAR(10), IMP.Part)			''ID'',
					ID.[Id]																									''InteractionId'',
					IMP.[Section]																							''Section'',
					IMP.[Part]																								''Part'',
					''CALL''																								''Channel'',
					CASE WHEN ID.Direction = ''E'' THEN CID.CallerId ELSE CID.CalledId END									''Number'',
					''''																									''Gender'',
					ID.[HoldTime]																							''SilenceTime'',
					ID.[AttentionTime]																						''DurationTime'', -- ESTO SE DEBE CORREGIR
					ID.[AttentionTime]																						''AttentionTime'', -- SE AGREGO CAMPO PARA AMBOS EXISTAN
					ISNULL(CGRM.[Category1], '''')																			''Category1'',
					ISNULL(CGRM.[Category2], '''')																			''Category2'',
					ISNULL(CGRM.[Category3], '''')																			''Category3'',
					ISNULL(CGRM.[Description], '''')																		''Description'',
					ISNULL(CONVERT(VARCHAR(4), CGRM.[Code]), '''')															''DispositionCode'',
					ID.[Campaign]																							''Campaign'',
					ID.[LastAgent]																							''Agent'',
					ID.[Direction]																							''Type'',
					CONVERT(VARCHAR, ID.[StartDate], 120)																	''StartDate'',
					CONVERT(VARCHAR, ID.[EndDate], 120)																		''EndDate'',
					IMP.[Format]																							''Format''
				'
		-- ARMAMOS LA PARTE DE TABLAS 
		SET @SQL_FROM += '
				FROM ' + @TblHistoricalDataRef + '[InteractionMultimediaParts] IMP (NOLOCK)
				LEFT JOIN ' + @TblHistoricalDataRef + '[InteractionDetail] ID (NOLOCK) 
					ON ID.Id = IMP.Id
				LEFT JOIN (
					SELECT TOP 1 VCC, CampaignID, [Order], [Code], 
									[Description], Category1, Category2, Category3 
						FROM ' + @TblMmprodataRef + '[CampaignGoalResultManagement] (NOLOCK)
				) CGRM  
					ON CGRM.VCC = ID.VirtualCC 
						AND CGRM.CampaignId = ID.Campaign 
						AND CGRM.[Description] = ID.ManagementResult
				INNER JOIN ' + @TblHistoricalDataRef + '[CallInteractionDetail] CID (NOLOCK) 
					ON ID.Id = CID.Id 
				'

		-- ARMAMOS LA PARTE BASE DE FILTROS
		SET @SQL_FILTER += '
				WHERE ID.[VirtualCC] = ''' + @VCC + '''
					AND ID.Id IS NOT NULL
					AND id.[EndDate] BETWEEN ''' + (SELECT CONVERT(VARCHAR(21), @StartDate, 127)) + ''' AND ''' + (SELECT CONVERT(VARCHAR(21), @EndDate, 127)) + '''
					AND IMP.[Format] in (''mp3'', ''wav'')
					'

		IF (CAST(@StartHour AS TIME) <= CAST(@EndHour AS TIME)) SET @SQL_FILTER += 'AND CAST(ID.[EndDate] AS TIME) BETWEEN ''' + @StartHour + ''' AND ''' + @EndHour + ''' ';
		IF (CAST(@StartHour AS TIME) > CAST(@EndHour AS TIME)) SET @SQL_FILTER += 'AND CAST(ID.[EndDate] AS TIME) NOT BETWEEN ''' + @EndHour + ''' AND ''' + @StartHour + ''' ';
		
		IF(@Campaign IS NOT NULL AND @Campaign <> '') SET @SQL_FILTER += 'AND ID.[Campaign] IN (SELECT Value FROM [dbo].[split](''' + @Campaign + ''','','')) ';

		IF(@Agent IS NOT NULL AND @Agent <> '') SET @SQL_FILTER += 'AND ID.[FirstAgent] IN (SELECT Value FROM [dbo].[split](''' + @Agent + ''','','')) ';

		IF(@Origin IS NOT NULL AND @Origin <> '') SET @SQL_FILTER += 'AND ID.[Direction] IN (SELECT Value FROM [dbo].[split](''' + @Origin + ''','','')) ';

		IF(@MinDuration IS NOT NULL) SET @SQL_FILTER += 'AND ID.[AttentionTime] >= ' + (SELECT CONVERT(varchar(10), @MinDuration)) + ' ';

		IF(@MaxDuration IS NOT NULL) SET @SQL_FILTER += 'AND ID.[AttentionTime] <= ' + (SELECT CONVERT(varchar(10), @MaxDuration)) + ' ';

		IF(@ResultCode IS NOT NULL AND @ResultCode <> '') SET @SQL_FILTER += 'AND CONCAT(ID.Campaign, ''_'', ISNULL(CONVERT(VARCHAR(4), CGRM.[Code]), '''')) IN (SELECT Value FROM [dbo].[split](''' + @ResultCode + ''','','')) '

		SET @SQL_EXTRA = '
			SET NOCOUNT OFF '

		-- UNIMOS LAS PARTES DEL QUERY
		SET @SQL_SELECT_0 += @SQL_FROM + @SQL_FILTER + @SQL_EXTRA
		SET @SQL_SELECT_1 += @SQL_FROM + @SQL_FILTER + @SQL_EXTRA

		-- EJECUTAMOS LA CONSULTA
		EXEC (@SQL_SELECT_0)
		EXEC (@SQL_SELECT_1)
	END
	ELSE
	BEGIN
		SET @Sql = 'SELECT 1 AS ''result'''
		EXEC (@Sql)
	END

	

	

	/*
	SET @Sql = ''

	IF(@Type = 0 OR @Type = 1)  
	BEGIN  
		SET @Sql = 'SET NOCOUNT ON
		SELECT
			ID.[Id] + ''_'' + CONVERT(VARCHAR(10), IMP.[Section]) + ''_'' + CONVERT(VARCHAR(10), IMP.Part)			''ID'',
			CASE WHEN ID.Direction = ''E'' THEN CID.CallerId ELSE CID.CalledId END									''Number'',
			''''																									''Gender'',
			ID.[HoldTime]																							''SilenceTime'',
			ID.[AttentionTime]																						''DurationTime'', -- ESTO SE DEBE CORREGIR
			ID.[AttentionTime]																						''AttentionTime'', -- SE AGREGO CAMPO PARA AMBOS EXISTAN
			ISNULL(CGRM.[Category1], '''')																			''Category1'',
			ISNULL(CGRM.[Category2], '''')																			''Category2'',
			ISNULL(CGRM.[Category3], '''')																			''Category3'',
			ISNULL(CGRM.[Description], '''')																		''Description'',
			ISNULL(CONVERT(VARCHAR(4), CGRM.[Code]), '''')															''DispositionCode'',
			ID.[Campaign]																							''Campaign'',
			ID.[LastAgent]																							''Agent'',
			ID.[Direction]																							''Type'',
			CONVERT(VARCHAR, ID.[StartDate], 120)																	''StartDate'',
			CONVERT(VARCHAR, ID.[EndDate], 120)																		''EndDate''
		FROM ' + @TblHistoricalDataRef + '[InteractionMultimediaParts] IMP (NOLOCK)
		LEFT JOIN ' + @TblHistoricalDataRef + '[InteractionDetail] ID (NOLOCK) 
			ON ID.Id = IMP.Id
		LEFT JOIN (
			SELECT TOP 1 VCC, CampaignID, [Order], [Code], 
							[Description], Category1, Category2, Category3 
				FROM ' + @TblMmprodataRef + '[CampaignGoalResultManagement] (NOLOCK)
		) CGRM  
			ON CGRM.VCC = ID.VirtualCC 
				AND CGRM.CampaignId = ID.Campaign 
				AND CGRM.[Description] = ID.ManagementResult
		INNER JOIN ' + @TblHistoricalDataRef + '[CallInteractionDetail] CID (NOLOCK) 
			ON ID.Id = CID.Id
		WHERE ID.[VirtualCC] = ''' + @VCC + '''
			AND ID.Id IS NOT NULL
			AND ID.[EndDate] >= ''' + (SELECT CONVERT(VARCHAR(21), @StartDate, 127)) + '''
			AND ID.[EndDate] <= ''' + (SELECT CONVERT(VARCHAR(21), @EndDate, 127)) + ''' 
			AND IMP.[Format] in (''mp3'', ''wav'') '
		
		IF (CAST(@StartHour AS TIME) <= CAST(@EndHour AS TIME)) SET @Sql += 'AND CAST(ID.[EndDate] AS TIME) BETWEEN ''' + @StartHour + ''' AND ''' + @EndHour + ''' ';
		IF (CAST(@StartHour AS TIME) > CAST(@EndHour AS TIME)) SET @Sql += 'AND CAST(ID.[EndDate] AS TIME) NOT BETWEEN ''' + @EndHour + ''' AND ''' + @StartHour + ''' ';
		
		IF(@Campaign IS NOT NULL AND @Campaign <> '')
		SET @Sql += 'AND ID.[Campaign] IN (SELECT Value FROM [dbo].[split](''' + @Campaign + ''','','')) ';

		IF(@Agent IS NOT NULL AND @Agent <> '')
		SET @Sql += 'AND ID.[FirstAgent] IN (SELECT Value FROM [dbo].[split](''' + @Agent + ''','','')) ';

		IF(@Origin IS NOT NULL AND @Origin <> '')
		SET @Sql += 'AND ID.[Direction] IN (SELECT Value FROM [dbo].[split](''' + @Origin + ''','','')) ';

		IF(@MinDuration IS NOT NULL)
		SET @Sql += 'AND ID.[AttentionTime] >= ' + (SELECT CONVERT(varchar(10), @MinDuration)) + ' ';

		IF(@MaxDuration IS NOT NULL)
		SET @Sql += 'AND ID.[AttentionTime] <= ' + (SELECT CONVERT(varchar(10), @MaxDuration)) + ' ';

		IF(@ResultCode IS NOT NULL AND @ResultCode <> '')
		SET @Sql += '
		AND CONCAT(ID.Campaign, ''_'', ISNULL(CONVERT(VARCHAR(4), CGRM.[Code]), '''')) IN (SELECT Value FROM [dbo].[split](''' + @ResultCode + ''','',''))'

 		SET @Sql += '
		SET NOCOUNT OFF '
	END
	ELSE
	BEGIN
		SET @Sql = 'SELECT 1 AS ''result'''
	END

	EXEC (@Sql)
	*/
END
GO
PRINT N'Altering [dbo].[GetAsyncInteractions]...';


GO
-- ESTE SP RETORNA LAS INTERACCIONES ASINCRONAS 
ALTER PROCEDURE [dbo].[GetAsyncInteractions]
(
	@VCC					VARCHAR(50) = NULL,
	@IP						VARCHAR(50),						-- IP DEL SERVIDOR PARA LA BASE I6
	@Type					INT,								-- FLAG PARA INDICAR SI EL SERVIDOR I6 SE ENCUENTRA LOCAL O REMOTO
	@InteractionType		VARCHAR(50) = NULL,
	@StartDate				DATETIME = '1980-01-01T00:00:00',
    @EndDate				DATETIME = '2050-01-01T23:59:59',
	@StartHour				VARCHAR(50) = NULL,
	@EndHour				VARCHAR(50) = NULL,
	@Campaigns				VARCHAR(MAX) = NULL,
 	@Agents					VARCHAR(MAX) = NULL,
	@DispositionCodes		VARCHAR(MAX) = NULL,
	@Origins				VARCHAR(MAX) = NULL,
	@UniqueIds				BIT = 0,							-- ESTE FLAG TIENE COMO PROPOSITO RETORNAR LA LISTA CONSOLIDAD POR IDS O EL TOTAL DEL LISTADO
	@ResultType				VARCHAR(50) = NULL					-- VARIABLE PARA DETERMINAR SI LA BUSQUEDA SERA SOBRE SOBRE DETALLES O ID (DETAILED, SUMMARIZED)
)
AS
BEGIN
	-- INFO: EN CHAT SE CREAN UN ID EN CADA INTERACCION(EJM: CHATS DE ATENCION EN LAS WEB DE BANCOS), LOS DEMAS CANALES ID + ENDDATE
	
	-- SETTEAMOS VALORES MINIMOS PARA LAS HORAS DE INICIO Y FIN
	IF (@StartHour IS NOT NULL AND @StartHour = '') SET @StartHour = '00:00:00'
	IF (@EndHour IS NOT NULL AND @EndHour = '') SET @EndHour = '23:59:59'

	-- DECLARAMOS UNA VARIABLE PARA IDENTIFICAR SI EL SP ES LLAMADO DEL SISTEMA O POR OTRO SP
	DECLARE @IS_NESTED BIT = 0

	-- DECLARAMOASUN CADENA PARA EL QUERY FINAL
	DECLARE @SQL_SELECT VARCHAR(MAX) = ''
	DECLARE @SQL_FROM VARCHAR(MAX) = ''
	DECLARE @SQL_FILTER VARCHAR(MAX) = ''
	DECLARE @SQL_EXTRA VARCHAR(MAX) = ''
	
	-- DECLARAMOS VARIABLES PARA NOS NOMBRES DE LAS TABLAS
	DECLARE @HISTORICAL_DATA_I6_TABLE NVARCHAR(100)
	DECLARE @HISTORICAL_DATA_I6_APPSTORE_TABLE NVARCHAR(100)
	DECLARE @HISTORICAL_DATA_I6_CHAT_TABLE NVARCHAR(100)
	DECLARE @HISTORICAL_DATA_I6_FACEBOOK_TABLE NVARCHAR(100)
	DECLARE @HISTORICAL_DATA_I6_GOOGLEPLAY_TABLE NVARCHAR(100)
	DECLARE @HISTORICAL_DATA_I6_INSTAGRAM_TABLE NVARCHAR(100)
	DECLARE @HISTORICAL_DATA_I6_MAIL_TABLE NVARCHAR(100)
	DECLARE @HISTORICAL_DATA_I6_TWITTER_TABLE NVARCHAR(100)
	DECLARE @HISTORICAL_DATA_I6_WEBCONTACT_TABLE NVARCHAR(100)
	DECLARE @HISTORICAL_DATA_I6_WHATSAPP_TABLE NVARCHAR(100)
	DECLARE @HISTORICAL_DATA_I6_YOUTUBE_TABLE NVARCHAR(100)

	-- EL PARAMETRO TYPE DEFINE SI LA BD HISTORICALDATAI6 SE ENCUENTRA LOCAL O REMOTO
	IF (@Type = 0)  
	BEGIN  
		SET @HISTORICAL_DATA_I6_APPSTORE_TABLE = '[' + @Ip + ']' + '.[HistoricalDataI6].[dbo].[Detail_Appstore]'
		SET @HISTORICAL_DATA_I6_CHAT_TABLE = '[' + @Ip + ']' + '.[HistoricalDataI6].[dbo].[Detail_Chat]'
		SET @HISTORICAL_DATA_I6_FACEBOOK_TABLE = '[' + @Ip + ']' + '.[HistoricalDataI6].[dbo].[Detail_Facebook]'
		SET @HISTORICAL_DATA_I6_GOOGLEPLAY_TABLE = '[' + @Ip + ']' + '.[HistoricalDataI6].[dbo].[Detail_Googleplay]'
		SET @HISTORICAL_DATA_I6_INSTAGRAM_TABLE = '[' + @Ip + ']' + '.[HistoricalDataI6].[dbo].[Detail_Instagram]'
		SET @HISTORICAL_DATA_I6_MAIL_TABLE = '[' + @Ip + ']' + '.[HistoricalDataI6].[dbo].[Detail_Mail]'
		SET @HISTORICAL_DATA_I6_TWITTER_TABLE = '[' + @Ip + ']' + '.[HistoricalDataI6].[dbo].[Detail_Twitter]'
		SET @HISTORICAL_DATA_I6_WEBCONTACT_TABLE = '[' + @Ip + ']' + '.[HistoricalDataI6].[dbo].[Detail_Webcontact]'
		SET @HISTORICAL_DATA_I6_WHATSAPP_TABLE = '[' + @Ip + ']' + '.[HistoricalDataI6].[dbo].[Detail_Whatsapp]'
		SET @HISTORICAL_DATA_I6_YOUTUBE_TABLE = '[' + @Ip + ']' + '.[HistoricalDataI6].[dbo].[Detail_Youtube]'
	END
	ELSE IF(@Type = 1) 
	BEGIN
		SET @HISTORICAL_DATA_I6_APPSTORE_TABLE = '[HistoricalDataI6].[dbo].[Detail_Appstore]'
		SET @HISTORICAL_DATA_I6_CHAT_TABLE = '[HistoricalDataI6].[dbo].[Detail_Chat]'
		SET @HISTORICAL_DATA_I6_FACEBOOK_TABLE = '[HistoricalDataI6].[dbo].[Detail_Facebook]'
		SET @HISTORICAL_DATA_I6_GOOGLEPLAY_TABLE = '[HistoricalDataI6].[dbo].[Detail_Googleplay]'
		SET @HISTORICAL_DATA_I6_INSTAGRAM_TABLE = '[HistoricalDataI6].[dbo].[Detail_Instagram]'
		SET @HISTORICAL_DATA_I6_MAIL_TABLE = '[HistoricalDataI6].[dbo].[Detail_Mail]'
		SET @HISTORICAL_DATA_I6_TWITTER_TABLE = '[HistoricalDataI6].[dbo].[Detail_Twitter]'
		SET @HISTORICAL_DATA_I6_WEBCONTACT_TABLE = '[HistoricalDataI6].[dbo].[Detail_Webcontact]'
		SET @HISTORICAL_DATA_I6_WHATSAPP_TABLE = '[HistoricalDataI6].[dbo].[Detail_Whatsapp]'
		SET @HISTORICAL_DATA_I6_YOUTUBE_TABLE = '[HistoricalDataI6].[dbo].[Detail_Youtube]'
	END  

	-- ARMAMOS EL QUERY PARA HACER LA CONSULTA
	SET @SQL_SELECT += '
		SELECT '

	-- ARMAMOS LA PARTE BASE DE FILTROS
	SET @SQL_FILTER += '
			WHERE HDI6.[Vcc] = ''' + @VCC + '''
				AND HDI6.[EndDate] BETWEEN ''' + (SELECT CONVERT(VARCHAR(21), @StartDate, 127)) + ''' AND ''' + (SELECT CONVERT(VARCHAR(21), @EndDate, 127)) + ''' '

	-- DEPENDIENDO SI LA HORA DE FIN ES MAYOR A LA DE INICIO O NO DAMOS FORMA AL FILTRO DE HORA
	IF (CAST(@StartHour AS TIME) <= CAST(@EndHour AS TIME)) SET @SQL_FILTER += 'AND CAST(HDI6.[EndDate] AS TIME) BETWEEN ''' + @StartHour + ''' AND ''' + @EndHour + ''' ';
	IF (CAST(@StartHour AS TIME) > CAST(@EndHour AS TIME)) SET @SQL_FILTER += 'AND CAST(HDI6.[EndDate] AS TIME) NOT BETWEEN ''' + @EndHour + ''' AND ''' + @StartHour + ''' ';
		
	IF (@Campaigns IS NOT NULL AND @Campaigns != '') SET @SQL_FILTER += 'AND HDI6.[Campaign] IN (SELECT VALUE FROM [dbo].[split](''' + @Campaigns + ''','','')) '
	
	IF (@DispositionCodes IS NOT NULL AND @DispositionCodes != '') SET @SQL_FILTER += 'AND HDI6.[DispositionTreePath] IN (SELECT VALUE FROM [dbo].[split](''' + @DispositionCodes + ''','','')) '

	-- ARMAMOS EL SELECT PARA LOS DIFERENTES INTERACTION TYPES
	IF (@InteractionType = 'APPSTORE')
	BEGIN
		-- SETTEAMOS LA TABLA DE BUSQUEDA
		SET @HISTORICAL_DATA_I6_TABLE = @HISTORICAL_DATA_I6_APPSTORE_TABLE

		-- ARMAMOS EL SELECT A LA TABLA DETAIL_APPSTORE
		SET @SQL_SELECT += '
								Vcc														''vcc'', 
								ID														''id'', 
								CONVERT(VARCHAR, EndDate, 23)							''folder'',
								ExportedContent											''exportedContent'', 
								''APPSTORE''											''channel'',
								Campaign												''campaign'', 
								StartDate												''startDate'', 
								EndDate													''endDate'', 
								Account													''account'', 
								Initiative												''initiative'',
								ContactName												''contactName'', 
								FirstAgent												''firstTakedAgent'', 
								NULL													''lastTakedAgent'', 
								NULL													''isTaken'',
								ISNULL(TRY_CAST(TotalMessages AS INT), 1)				''totalMessages'',
								DurationTime											''durationTime'', 
								AttentionTime											''attentionTime'', 
								DispositionCode											''dispositionCode'', 
								DispositionTreePath										''dispositionTreePath'',
								RawChar													''rawChar'' '

		IF (@Agents IS NOT NULL AND @Agents != '') SET @SQL_FILTER += 'AND HDI6.[FirstAgent] IN (SELECT VALUE FROM [dbo].[split](''' + @Agents + ''','','')) '
		
	END
	ELSE IF (@InteractionType = 'CHAT')
	BEGIN
		-- SETTEAMOS LA TABLA DE BUSQUEDA
		SET @HISTORICAL_DATA_I6_TABLE = @HISTORICAL_DATA_I6_CHAT_TABLE

		-- ARMAMOS EL SELECT A LA TABLA DETAIL_CHAT
		SET @SQL_SELECT += '
								Vcc															''vcc'', 
								ID															''id'', 
								CONVERT(VARCHAR, EndDate, 23)								''folder'',
								ExportedContent												''exportedContent'', 
								''CHAT''													''channel'',
								Campaign													''campaign'', 
								StartDate													''startDate'', 
								EndDate														''endDate'', 
								Account														''account'', 
								''IN''														''initiative'', 
								ContactName													''contactName'', 
								FirstTakeAgent												''firstTakedAgent'', 
								LastTakeAgent												''lastTakedAgent'', 
								IsTaken														''isTaken'',
								ISNULL(TRY_CAST(ChatMessages AS INT), 1)					''totalMessages'',
								DurationTime												''durationTime'', 
								AttentionTime												''attentionTime'', 
								DispositionCode												''dispositionCode'', 
								DispositionTreePath											''dispositionTreePath'' ,
								100															''rawChar'' '

		IF (@Agents IS NOT NULL AND @Agents != '') SET @SQL_FILTER += 'AND HDI6.[LastTakeAgent] IN (SELECT VALUE FROM [dbo].[split](''' + @Agents + ''','','')) '

		-- PARA HACER EL FILTRO POR ORIGEN DE CHAT, SOLO ES VALIDO CUANDO EL INPUT INCLUYE IN
		IF (@Origins IS NOT NULL AND @Origins != '') SET @SQL_FILTER += 'AND ''E'' IN (SELECT VALUE FROM [dbo].[split](''' + @Origins + ''','','')) '
	END 
	ELSE IF (@InteractionType = 'FACEBOOK')
	BEGIN
		-- SETTEAMOS LA TABLA DE BUSQUEDA
		SET @HISTORICAL_DATA_I6_TABLE = @HISTORICAL_DATA_I6_FACEBOOK_TABLE

		-- ARMAMOS EL SELECT A LA TABLA DETAIL_FACEBOOK
		SET @SQL_SELECT += '
								Vcc															''vcc'', 
								ID															''id'', 
								CONVERT(VARCHAR, EndDate, 23)								''folder'',
								ExportedContent												''exportedContent'', 
								''FACEBOOK''												''channel'',
								Campaign													''campaign'', 
								StartDate													''startDate'', 
								EndDate														''endDate'', 
								Account														''account'', 
								CASE Initiative WHEN ''INBOUND'' THEN ''IN''
									WHEN ''OUTBOUND'' THEN ''OUT''
									ELSE NULL END											''initiative'', 
								ContactName													''contactName'', 
								FirstAgent													''firstTakedAgent'', 
								NULL														''lastTakedAgent'', 
								NULL														''isTaken'',
								ISNULL(TRY_CAST(TotalMessages AS INT), 1)					''totalMessages'',
								DurationTime												''durationTime'', 
								AttentionTime												''attentionTime'', 
								DispositionCode												''dispositionCode'', 
								DispositionTreePath											''dispositionTreePath'' ,
								250															''rawChar'' '
		
		IF (@Agents IS NOT NULL AND @Agents != '') SET @SQL_FILTER += 'AND HDI6.[FirstAgent] IN (SELECT VALUE FROM [dbo].[split](''' + @Agents + ''','','')) '
		
		-- PARA HACER EL FILTRO POR ORIGEN, REEMPLAZAMOS EN EL INPUT POR LOS VALORES DE LA TABLA
		IF (@Origins IS NOT NULL AND @Origins != '') 
		BEGIN
			SET @Origins = REPLACE(@Origins, 'E', 'INBOUND')
			SET @Origins = REPLACE(@Origins, 'S', 'OUTBOUND')
			SET @SQL_FILTER += 'AND HDI6.[Initiative] IN (SELECT VALUE FROM [dbo].[split](''' + @Origins + ''','','')) '
		END
	END 
	ELSE IF (@InteractionType = 'GOOGLEPLAY')
	BEGIN
		-- SETTEAMOS LA TABLA DE BUSQUEDA
		SET @HISTORICAL_DATA_I6_TABLE = @HISTORICAL_DATA_I6_GOOGLEPLAY_TABLE

		-- ARMAMOS EL SELECT A LA TABLA DETAIL_GOOGLEPLAY
		SET @SQL_SELECT += '
								Vcc															''vcc'', 
								ID															''id'', 
								CONVERT(VARCHAR, EndDate, 23)								''folder'',
								ExportedContent												''exportedContent'', 
								''GOOGLEPLAY''												''channel'',
								Campaign													''campaign'', 
								StartDate													''startDate'', 
								EndDate														''endDate'', 
								Account														''account'',  
								Initiative													''initiative'', 
								ContactName													''contactName'', 
								FirstAgent													''firstTakedAgent'', 
								NULL														''lastTakedAgent'', 
								HasResponse													''isTaken'',
								ISNULL(TRY_CAST(TotalMessages AS INT), 1)					''totalMessages'',
								DurationTime												''durationTime'', 
								AttentionTime												''attentionTime'', 
								DispositionCode												''dispositionCode'', 
								DispositionTreePath											''dispositionTreePath'' ,
								RawChar														''rawChar'' '

		IF (@Agents IS NOT NULL AND @Agents != '') SET @SQL_FILTER += 'AND HDI6.[FirstAgent] IN (SELECT VALUE FROM [dbo].[split](''' + @Agents + ''','','')) '
	END
	ELSE IF (@InteractionType = 'INSTAGRAM')
	BEGIN
		-- SETTEAMOS LA TABLA DE BUSQUEDA
		SET @HISTORICAL_DATA_I6_TABLE = @HISTORICAL_DATA_I6_INSTAGRAM_TABLE

		-- ARMAMOS EL SELECT A LA TABLA DETAIL_INSTAGRAM
		SET @SQL_SELECT += '
								Vcc															''vcc'', 
								ID															''id'', 
								CONVERT(VARCHAR, EndDate, 23)								''folder'',
								ExportedContent												''exportedContent'', 
								''INSTAGRAM''												''channel'',
								Campaign													''campaign'', 
								StartDate													''startDate'', 
								EndDate														''endDate'', 
								Account														''account'', 
								CASE Initiative WHEN ''INBOUND'' THEN ''IN''
									WHEN ''OUTBOUND'' THEN ''OUT''
									ELSE NULL END											''initiative'', 
								ContactName													''contactName'', 
								FirstAgent													''firstTakedAgent'', 
								NULL														''lastTakedAgent'', 
								HasResponse													''isTaken'',
								ISNULL(TRY_CAST(TotalMessages AS INT), 1)					''totalMessages'',
								DurationTime												''durationTime'', 
								AttentionTime												''attentionTime'', 
								DispositionCode												''dispositionCode'', 
								DispositionTreePath											''dispositionTreePath'' ,
								RawChar														''rawChar'' '

		IF (@Agents IS NOT NULL AND @Agents != '') SET @SQL_FILTER += 'AND HDI6.[FirstAgent] IN (SELECT VALUE FROM [dbo].[split](''' + @Agents + ''','','')) '

		-- PARA HACER EL FILTRO POR ORIGEN, REEMPLAZAMOS EN EL INPUT POR LOS VALORES DE LA TABLA
		IF (@Origins IS NOT NULL AND @Origins != '') 
		BEGIN
			SET @Origins = REPLACE(@Origins, 'E', 'INBOUND')
			SET @Origins = REPLACE(@Origins, 'S', 'OUTBOUND')
			SET @SQL_FILTER += 'AND HDI6.[Initiative] IN (SELECT VALUE FROM [dbo].[split](''' + @Origins + ''','','')) '
		END
	END  
	ELSE IF (@InteractionType = 'MAIL')
	BEGIN
		-- SETTEAMOS LA TABLA DE BUSQUEDA
		SET @HISTORICAL_DATA_I6_TABLE = @HISTORICAL_DATA_I6_MAIL_TABLE

		-- ARMAMOS EL SELECT A LA TABLA DETAIL_MAIL
		SET @SQL_SELECT += '
								Vcc															''vcc'', 
								ID															''id'', 
								CONVERT(VARCHAR, EndDate, 23)								''folder'',
								ExportedContent												''exportedContent'', 
								''MAIL''													''channel'',
								Campaign													''campaign'', 
								StartDate													''startDate'', 
								EndDate														''endDate'', 
								Account														''account'', 
								CASE Initiative WHEN ''INBOUND'' THEN ''IN''
									WHEN ''OUTBOUND'' THEN ''OUT''
									ELSE NULL END											''initiative'', 
								ContactName													''contactName'', 
								FirstAgent													''firstTakedAgent'', 
								NULL														''lastTakedAgent'', 
								MailHasResponse												''isTaken'',
								ISNULL(TRY_CAST(MailTotalMessages AS INT), 1)				''totalMessages'',
								DurationTime												''durationTime'', 
								AttentionTime												''attentionTime'', 
								DispositionCode												''dispositionCode'', 
								DispositionTreePath											''dispositionTreePath'' ,
								1501														''rawChar'' '
								
		IF (@Agents IS NOT NULL AND @Agents != '') SET @SQL_FILTER += 'AND HDI6.[FirstAgent] IN (SELECT VALUE FROM [dbo].[split](''' + @Agents + ''','','')) '

		-- PARA HACER EL FILTRO POR ORIGEN, REEMPLAZAMOS EN EL INPUT POR LOS VALORES DE LA TABLA
		IF (@Origins IS NOT NULL AND @Origins != '') 
		BEGIN
			SET @Origins = REPLACE(@Origins, 'E', 'INBOUND')
			SET @Origins = REPLACE(@Origins, 'S', 'OUTBOUND')
			SET @SQL_FILTER += 'AND HDI6.[Initiative] IN (SELECT VALUE FROM [dbo].[split](''' + @Origins + ''','','')) '
		END
	END  
	ELSE IF (@InteractionType = 'TWITTER')
	BEGIN
		-- SETTEAMOS LA TABLA DE BUSQUEDA
		SET @HISTORICAL_DATA_I6_TABLE = @HISTORICAL_DATA_I6_TWITTER_TABLE

		-- ARMAMOS EL SELECT A LA TABLA DETAIL_TWITTER
		SET @SQL_SELECT += '
								Vcc															''vcc'', 
								ID															''id'', 
								CONVERT(VARCHAR, EndDate, 23)								''folder'',
								ExportedContent												''exportedContent'', 
								''TWITTER''													''channel'',
								Campaign													''campaign'', 
								StartDate													''startDate'', 
								EndDate														''endDate'', 
								Account														''account'', 
								CASE Initiative WHEN ''INBOUND'' THEN ''IN''
									WHEN ''OUTBOUND'' THEN ''OUT''
									ELSE NULL END											''initiative'', 
								ContactName													''contactName'', 
								FirstAgent													''firstTakedAgent'', 
								NULL														''lastTakedAgent'', 
								HasResponse													''isTaken'',
								ISNULL(TRY_CAST(TotalMessages AS INT), 1)					''totalMessages'',
								DurationTime												''durationTime'', 
								AttentionTime												''attentionTime'', 
								DispositionCode												''dispositionCode'', 
								DispositionTreePath											''dispositionTreePath'' ,
								325															''rawChar'' '
								
		IF (@Agents IS NOT NULL AND @Agents != '') SET @SQL_FILTER += 'AND HDI6.[FirstAgent] IN (SELECT VALUE FROM [dbo].[split](''' + @Agents + ''','','')) '

		-- PARA HACER EL FILTRO POR ORIGEN, REEMPLAZAMOS EN EL INPUT POR LOS VALORES DE LA TABLA
		IF (@Origins IS NOT NULL AND @Origins != '') 
		BEGIN
			SET @Origins = REPLACE(@Origins, 'E', 'INBOUND')
			SET @Origins = REPLACE(@Origins, 'S', 'OUTBOUND')
			SET @SQL_FILTER += 'AND HDI6.[Initiative] IN (SELECT VALUE FROM [dbo].[split](''' + @Origins + ''','','')) '
		END
	END  
	ELSE IF (@InteractionType = 'WEBCONTACT')
	BEGIN
		-- SETTEAMOS LA TABLA DE BUSQUEDA
		SET @HISTORICAL_DATA_I6_TABLE = @HISTORICAL_DATA_I6_WEBCONTACT_TABLE

		-- ARMAMOS EL SELECT A LA TABLA DETAIL_WEBCONTACT
		SET @SQL_SELECT += '
								Vcc															''vcc'', 
								ID															''id'', 
								CONVERT(VARCHAR, EndDate, 23)								''folder'',
								ExportedContent												''exportedContent'', 
								''WEBCONTACT''												''channel'',
								Campaign													''campaign'', 
								StartDate													''startDate'', 
								EndDate														''endDate'', 
								Account														''account'', 
								''IN''														''initiative'', 
								ContactName													''contactName'', 
								FirstAgent													''firstTakedAgent'', 
								NULL														''lastTakedAgent'', 
								HasResponse													''isTaken'',
								ISNULL(TRY_CAST(TotalResponses AS INT), 1)					''totalMessages'',
								DurationTime												''durationTime'', 
								AttentionTime												''attentionTime'', 
								DispositionCode												''dispositionCode'', 
								DispositionTreePath											''dispositionTreePath'' ,
								175															''rawChar'' '

		IF (@Agents IS NOT NULL AND @Agents != '') SET @SQL_FILTER += 'AND HDI6.[FirstAgent] IN (SELECT VALUE FROM [dbo].[split](''' + @Agents + ''','','')) '

		-- PARA HACER EL FILTRO POR ORIGEN DE WEBCONTACT, SOLO ES VALIDO CUANDO EL INPUT INCLUYE IN
		IF (@Origins IS NOT NULL AND @Origins != '') SET @SQL_FILTER += 'AND ''E'' IN (SELECT VALUE FROM [dbo].[split](''' + @Origins + ''','','')) '
	END
	ELSE IF (@InteractionType = 'WHATSAPP')
	BEGIN
		-- SETTEAMOS LA TABLA DE BUSQUEDA
		SET @HISTORICAL_DATA_I6_TABLE = @HISTORICAL_DATA_I6_WHATSAPP_TABLE

		-- ARMAMOS EL SELECT A LA TABLA DETAIL_WHATSAPP
		SET @SQL_SELECT += '
								Vcc															''vcc'', 
								ID															''id'', 
								CONVERT(VARCHAR, EndDate, 23)								''folder'',
								ExportedContent												''exportedContent'', 
								''WHATSAPP''												''channel'',
								Campaign													''campaign'', 
								StartDate													''startDate'', 
								EndDate														''endDate'', 
								Account														''account'', 
								CASE Initiative WHEN ''In.'' THEN ''IN''
									WHEN ''Out.'' THEN ''OUT''
									ELSE NULL END											''initiative'', 
								ContactName													''contactName'', 
								FirstAgent													''firstTakedAgent'', 
								NULL														''lastTakedAgent'', 
								HasResponse													''isTaken'',
								ISNULL(TRY_CAST(WhatsappTotalMessages AS INT), 1)			''totalMessages'',
								DurationTime												''durationTime'', 
								AttentionTime												''attentionTime'', 
								DispositionCode												''dispositionCode'', 
								DispositionTreePath											''dispositionTreePath'' ,
								175															''rawChar'' '
								
		IF (@Agents IS NOT NULL AND @Agents != '') SET @SQL_FILTER += 'AND HDI6.[FirstAgent] IN (SELECT VALUE FROM [dbo].[split](''' + @Agents + ''','','')) '
		
		-- PARA HACER EL FILTRO POR ORIGEN, REEMPLAZAMOS EN EL INPUT POR LOS VALORES DE LA TABLA
		IF (@Origins IS NOT NULL AND @Origins != '') 
		BEGIN
			SET @Origins = REPLACE(@Origins, 'E', 'In.')
			SET @Origins = REPLACE(@Origins, 'S', 'Out.')
			SET @SQL_FILTER += 'AND HDI6.[Initiative] IN (SELECT VALUE FROM [dbo].[split](''' + @Origins + ''','','')) '
		END
	END  
	ELSE IF (@InteractionType = 'YOUTUBE')
	BEGIN
		-- SETTEAMOS LA TABLA DE BUSQUEDA
		SET @HISTORICAL_DATA_I6_TABLE = @HISTORICAL_DATA_I6_YOUTUBE_TABLE

		-- ARMAMOS EL SELECT A LA TABLA DETAIL_YOUTUBE
		SET @SQL_SELECT += '
								Vcc															''vcc'', 
								ID															''id'', 
								CONVERT(VARCHAR, EndDate, 23)								''folder'',
								ExportedContent												''exportedContent'', 
								''YOUTUBE''													''channel'',
								Campaign													''campaign'', 
								StartDate													''startDate'', 
								EndDate														''endDate'', 
								Account														''account'', 
								CASE Initiative WHEN ''INBOUND'' THEN ''IN''
									WHEN ''OUTBOUND'' THEN ''OUT''
									ELSE NULL END											''initiative'', 
								ContactName													''contactName'', 
								FirstAgent													''firstTakedAgent'', 
								NULL														''lastTakedAgent'', 
								HasResponse													''isTaken'',
								ISNULL(TRY_CAST(TotalMessages AS INT), 1)					''totalMessages'',
								DurationTime												''durationTime'', 
								AttentionTime												''attentionTime'', 
								DispositionCode												''dispositionCode'', 
								DispositionTreePath											''dispositionTreePath'' ,
								RawChar														''rawChar'' '
								
		IF (@Agents IS NOT NULL AND @Agents != '') SET @SQL_FILTER += 'AND HDI6.[FirstAgent] IN (SELECT VALUE FROM [dbo].[split](''' + @Agents + ''','','')) '

		-- PARA HACER EL FILTRO POR ORIGEN, REEMPLAZAMOS EN EL INPUT POR LOS VALORES DE LA TABLA
		IF (@Origins IS NOT NULL AND @Origins != '') 
		BEGIN
			SET @Origins = REPLACE(@Origins, 'E', 'INBOUND')
			SET @Origins = REPLACE(@Origins, 'S', 'OUTBOUND')
			SET @SQL_FILTER += 'AND HDI6.[Initiative] IN (SELECT VALUE FROM [dbo].[split](''' + @Origins + ''','','')) '
		END
	END

	-- ARMAMOS LA PARTE DE TABLAS 
	SET @SQL_FROM += '
			FROM ' + @HISTORICAL_DATA_I6_TABLE + ' HDI6 (NOLOCK) '

	-- UNIMOS LAS PARTES DEL QUERY
	SET @SQL_SELECT += @SQL_FROM + @SQL_FILTER + @SQL_EXTRA

	-- VERIFICAMOS SI EXISTE LA TABLA TEMPORAL #TMP_HD_INTERACTIONS
	IF OBJECT_ID('TEMPDB..#TMP_HD_INTERACTIONS') IS NULL
	BEGIN
		-- CREAMOS UNA TABLA TEMPORAL PARA INSERTAR LOS REGISTROS DE LA HDI6
		CREATE TABLE #TMP_HD_INTERACTIONS
		(
			vcc VARCHAR(50), 
			id VARCHAR(250),  
			folder VARCHAR(50),
			exportedContent VARCHAR(250),  
			channel VARCHAR(50), 
			campaign VARCHAR(50), 
			startDate DATETIME,
			endDate DATETIME,
			account VARCHAR(50), 
			initiative VARCHAR(50), 
			contactName VARCHAR(250), 
			firstTakedAgent VARCHAR(50), 
			lastTakedAgent VARCHAR(50), 
			isTaken VARCHAR(50), 
			totalMessages INT,
			durationTime VARCHAR(50),  
			attentionTime VARCHAR(50), 
			dispositionCode VARCHAR(250), 
			dispositionTreePath VARCHAR(250), 
			rawChar INT
		)

		-- REAFIRMAMOS QUE EL SP NO ESTA ANIDADO EN OTRO
		SET @IS_NESTED = 0

		-- PRINT 'SP NO ANIDADO'
	END
	ELSE
	BEGIN
		-- SI LA TABLA TEMPORAL YA EXISTIA, EL SP ESTA ANIDADO EN OTRO (P.E.: [dbo].[GetAsyncBillingInteractions])
		SET @IS_NESTED = 1

		-- PRINT 'SP ANIDADO'
	END 

	-- INSERTAMOS EL RESULTADO EN LA TABLA TEMPORAL
	INSERT INTO #TMP_HD_INTERACTIONS
		-- EJECUTAMOS LA CONSULTA
		EXEC (@SQL_SELECT)

	-- SI EL SP NO ESTA ANIDADO, HACEMOS SELECT AL RESULTADO A MOSTRAR
	IF @IS_NESTED = 0
	BEGIN
		-- HACEMOS EL SELECT SEGUN EL TIPO DE BUSQUEDA SETTEADO
		IF @UniqueIds = 1 -- ENFOCADO A INTERACCIONES
		BEGIN
			IF @ResultType = 'SUMMARIZED'
			BEGIN
				SELECT TBL.[channel]										AS 'interactionType',
						COUNT(DISTINCT (
							CASE WHEN @InteractionType = 'CALL' 
							THEN TBL.[id] 
							ELSE TBL.[id] 
							END))											AS 'interactions',
						COUNT(*)											AS 'details',
						SUM(TBL.[rawChar])									AS 'rawChars'
					FROM #TMP_HD_INTERACTIONS TBL
					GROUP BY TBL.[channel]
			END
			ELSE IF @ResultType = 'DETAILED'
			BEGIN
				SELECT HDI.[vcc]											AS 'vcc',
						HDI.[channel]										AS 'interactionType',
						HDI.[campaign]										AS 'campaign',
						HDI.[id]											AS 'id',
						HDI.[firstTakedAgent]								AS 'agent',
						HDI.[initiative]									AS 'origin',
						SUM(HDI.[rawChar])									AS 'rawChar'
					FROM #TMP_HD_INTERACTIONS HDI
					GROUP BY HDI.[vcc], HDI.[channel], HDI.[campaign], HDI.[id], HDI.[firstTakedAgent], HDI.[initiative]
			END
		END
		ELSE -- ENFOCADO A DETALLES
		BEGIN
			IF @ResultType = 'SUMMARIZED'
			BEGIN
				SELECT TBL.[channel]										AS 'interactionType',
						COUNT(DISTINCT (
							CASE WHEN @InteractionType = 'CALL' 
							THEN TBL.[id] 
							ELSE CONCAT(TBL.[id], TBL.[endDate]) 
							END))											AS 'interactions',
						COUNT(*)											AS 'details',
						SUM(TBL.[rawChar])									AS 'rawChar'
					FROM #TMP_HD_INTERACTIONS TBL
					GROUP BY TBL.[channel]
			END
			ELSE IF @ResultType = 'DETAILED'
			BEGIN
				SELECT * FROM #TMP_HD_INTERACTIONS
			END 
		END
	END

	/*
	-- DECLARAMOS LAS CTE
	WITH CTE_AVAILABLE_BALANCE_REPORT AS (
		SELECT * FROM #TMP_HD_INTERACTIONS
	)
	select * from CTE_AVAILABLE_BALANCE_REPORT 
	*/
END
GO
PRINT N'Altering [dbo].[GetEvaluations]...';


GO
ALTER PROCEDURE [dbo].[GetEvaluations] (
	@Instance Varchar(50) = NULL,
	@IdAuditor VARCHAR(MAX) = NULL,
	@IdAgent Varchar(MAX) = NULL,
   	@IdCampaign VARCHAR(MAX) = NULL,
	@IdEvaluationPlan VARCHAR(MAX) = NULL,
 	@EvaluationDateFrom VARCHAR(50) = '1980-01-01T00:00:00',
    @EvaluationDateTo VARCHAR(50) = '2050-01-01T23:59:59',
	@EvaluationHourFrom VARCHAR(50) = '00:00:00',
    @EvaluationHourTo VARCHAR(50) = '23:59:59',
	@InteractionMinDuration Int = 0,
    @InteractionMaxDuration Int = 86400,
    @InteractionOrigins Varchar(50) = NULL,
	@InteractionResults Varchar(MAX) = NULL,
	@EvaluationTypes Varchar(MAX) = NULL,
	@InteractionTags Varchar(MAX) = NULL,
	@InteractionFormats Varchar(50) = NULL,
	@EvaluationsLimit Int = 0
)
AS
BEGIN
	SET NOCOUNT ON
	IF (@EvaluationHourFrom = '') SET @EvaluationHourFrom = '00:00:00';
	IF (@EvaluationHourTo = '') SET @EvaluationHourTo = '23:59:59';
	
	-- SI ORIGINS TIENE DOS VALORES, IGNORAMOS EL FILTRO
	IF (SELECT COUNT(*) FROM [dbo].[split](@InteractionOrigins, ',')) = 2 SET @InteractionOrigins = ''
	

	DECLARE @SQL_SELECT_0 VARCHAR(MAX) = '';
	DECLARE @SQL_SELECT_1 VARCHAR(MAX) = '';
	DECLARE @SQL_FROM VARCHAR(MAX) = '';
	DECLARE @SQL_FILTER VARCHAR(MAX) = '';
	DECLARE @SQL_EXTRA VARCHAR(MAX) = '';
	
	SET @SQL_SELECT_1 += 'SELECT ';
	SET @SQL_SELECT_1 += '
				AEP.Completed						''completed'',
    			AEP.score							''qualification'',
    			AEP.IdAuditor						''idAuditor'',
    			U.FirstName + '' '' + U.LastName	''auditorName'',
    			MAX(ER.EvaluationDate)				''evaluationDate'',
    			AEP.IdEvaluationPlan				''idEvaluationPlan'',
				EP.Description						''evaluationPlan'',
    			AEP.idAgent							''idAgent'',
    			AEP.idInteraction					''idInteraction'',
				AEP.InteractionDate					''interactionDate'',
    			AEP.InteractionType					''interactionType'',
    			AEP.IdCampaign						''idCampaign''  ';

	SET @SQL_FROM += '
			FROM EvaluationResult ER (NOLOCK) 
			LEFT JOIN [EvaluationPlan] EP (NOLOCK) 
				ON (EP.[Instance] = ER.[Instance] 
					AND EP.[ID] = ER.IdEvaluationPlan) 
			LEFT JOIN [AuditorEvaluationPlan] AEP (NOLOCK) 
				ON (AEP.[Instance] = ER.[Instance] 
					AND AEP.[IdAuditor] = ER.[IdEvaluator] 
					AND AEP.[IdInteraction] = ER.[IdInteraction] 
					AND AEP.[InteractionType] = ER.[InteractionType] 
					AND AEP.[IdEvaluationPlan] = ER.[IdEvaluationPlan]) 
			LEFT JOIN [User] U (NOLOCK) 
				ON (U.[VCC] = ER.[Instance] 
					AND U.ID = AEP.IdAuditor) ';

	SET @SQL_FILTER += '
			WHERE ER.[Instance] = ''' + @Instance + '''
				AND ER.[EvaluationDate] >= ''' + @EvaluationDateFrom + '''
				AND ER.[EvaluationDate] <= ''' + @EvaluationDateTo + '''
				AND EP.[Status] = CASE EP.[Evaluation_Mode] WHEN ''A'' THEN 7 ELSE EP.[Status] END ';

	IF (@IdAuditor IS NOT NULL AND @IdAuditor != '') SET @SQL_FILTER += 'AND AEP.[IdAuditor] IN (SELECT Value FROM [dbo].[split](''' + @IdAuditor + ''','','')) ';
	IF (@IdAgent IS NOT NULL AND @IdAgent != '') SET @SQL_FILTER += 'AND AEP.[IdAgent] IN (SELECT Value FROM [dbo].[split](''' + @IdAgent + ''','','')) ';
	IF (@IdCampaign IS NOT NULL AND @IdCampaign != '') SET @SQL_FILTER += 'AND AEP.[IdCampaign] IN (SELECT Value FROM [dbo].[split](''' + @IdCampaign + ''','','')) ';
	IF (@IdEvaluationPlan IS NOT NULL AND @IdEvaluationPlan != '') SET @SQL_FILTER += 'AND EP.[ID] IN (SELECT Value FROM [dbo].[split](''' + @IdEvaluationPlan + ''','','')) ';
	IF (CAST(@EvaluationHourFrom AS TIME) <= CAST(@EvaluationHourTo AS TIME)) SET @SQL_FILTER += 'AND CAST(ER.[EvaluationDate] AS TIME) BETWEEN ''' + @EvaluationHourFrom + ''' AND ''' + @EvaluationHourTo + ''' ';
	IF (CAST(@EvaluationHourFrom AS TIME) > CAST(@EvaluationHourTo AS TIME)) SET @SQL_FILTER += 'AND CAST(ER.[EvaluationDate] AS TIME) NOT BETWEEN ''' + @EvaluationHourTo + ''' AND ''' + @EvaluationHourFrom + ''' ';
	IF (@InteractionMinDuration IS NOT NULL) SET @SQL_FILTER += 'AND AEP.[InteractionDuration] >= ' + (SELECT CONVERT(varchar(10), @InteractionMinDuration)) + ' ';
	IF (@InteractionMaxDuration IS NOT NULL) SET @SQL_FILTER += 'AND AEP.[InteractionDuration] <= ' + (SELECT CONVERT(varchar(10), @InteractionMaxDuration))+ ' ';
	IF (@InteractionOrigins IS NOT NULL AND @InteractionOrigins != '') SET @SQL_FILTER += 'AND AEP.[InteractionOrigin] IN (SELECT Value FROM [dbo].[split](''' + @InteractionOrigins + ''','','')) ';
	IF (@InteractionResults IS NOT NULL AND @InteractionResults != '') SET @SQL_FILTER += 'AND AEP.[ManagementResult] IN (SELECT Value FROM [dbo].[split](''' + @InteractionResults + ''','','')) ';
	IF (@EvaluationTypes IS NOT NULL AND @EvaluationTypes != '') 
	BEGIN
		SET @SQL_FILTER += '
				AND EP.[Evaluation_Mode] IN (SELECT Value FROM [dbo].[split](''' + @EvaluationTypes + ''','',''))  ';
	END;
	IF (@InteractionTags IS NOT NULL AND @InteractionTags != '') 
	BEGIN
		SET @SQL_FROM += '
			LEFT JOIN [Tag] T (NOLOCK) 
				ON (T.[VCC] = ER.[Instance] 
					AND T.[Tag] IN (SELECT Value FROM [dbo].[split](''' + @InteractionTags + ''','',''))) ';
		SET @SQL_FILTER += '
				AND T.[AudioId] LIKE CONCAT(AEP.[IdInteraction], ''%'') 
				AND T.[AudioId] IS NOT NULL ';
	END;
	
	--IF (@InteractionFormats IS NOT NULL AND @InteractionFormats != '') SET @SQL_FILTER += 'AND AEP.[InteractionFormat] IN (SELECT Value FROM [dbo].[split](''' + @InteractionFormats + ''','','')) ';
	
	SET @SQL_EXTRA += '
			GROUP BY AEP.Completed,
								AEP.score,
								AEP.IdAuditor,
								U.FirstName + '' '' + U.LastName,
								AEP.IdEvaluationPlan,
								EP.Description,
								AEP.idAgent,
								AEP.idInteraction,
								AEP.InteractionDate,
								AEP.InteractionType,
								AEP.IdCampaign
    	ORDER BY MAX(ER.EvaluationDate) DESC;';

	SET @SQL_SELECT_1 += @SQL_FROM + @SQL_FILTER + @SQL_EXTRA;

	-- SELECT @SQL_SELECT_1;
	EXEC (@SQL_SELECT_1);
	
END
GO
PRINT N'Altering [dbo].[GetInteractionTranscription]...';


GO
-- ESTE SP RETORN LAS TRANSCRIPCIONES DE UNA INTERACCION SEGUN SU VCC, INTERACTIONTYPE(CHANNEL), INTERACTIONID
ALTER PROCEDURE [dbo].[GetInteractionTranscription] (
	@VCC VARCHAR(50) = NULL,
	@EvaluationPlanId VARCHAR(50) = null,
	@ProcessId VARCHAR(50) = NULL,
	@InteractionType VARCHAR(50) = NULL,
	@InteractionId VARCHAR(250) = NULL
)
AS
BEGIN
	SET NOCOUNT ON

	-- SI PROCESSID IS NULL RETORNA TODAS LAS TRANSCRIPCIONES DEL ID
	-- SI PROCESSID IS NOT NULL RETORNA TOADAS LAS TRANSCRIPCIONES DE ID RELACIONADAS CON EL PROCESSASYNCINTERACTION

	-- AGREGAMOS LA BUSQUEDA PARA CANALES DE TEXTO
	IF @InteractionType <> 'CALL'
	BEGIN
		-- PARA EL CASO QUE PLAN DE EVALUACION ID ES NULL
		IF @EvaluationPlanId IS NULL
		BEGIN
			SELECT DISTINCT AI.[VCC]					'vcc',
							AI.[Campaign]				'campaign',
							AI.[Channel]				'interactionType',
							AI.[ID]						'interactionId',
							AI.[Folder]					'folder',
							AI.[FileName]				'jsonFileName',
							AI.[ViewFileName]			'viewFileName',
							P.[Name]					'processId',
							AI.[TotalMessages]			'totalMessages'
				FROM [dbo].[AsyncInteraction] AI (NOLOCK)
				LEFT JOIN [dbo].[ProcessAsyncInteraction] PAI (NOLOCK)
					ON PAI.[VCC] = AI.[VCC]
						AND PAI.[Campaign] = AI.[Campaign]
						AND PAI.[InteractionType] = AI.[Channel]
						AND PAI.[FormattedEndDate] = AI.[Folder]
						AND PAI.[InteractionId] = AI.[ID]
						AND PAI.[ProcessId] = @ProcessId
				LEFT JOIN [dbo].[Process] P (NOLOCK)
					ON P.[VCC] = AI.[VCC]
						AND P.[Name] = PAI.[ProcessId]
				WHERE AI.[VCC] = @VCC
					AND AI.[Channel] = @InteractionType
					AND AI.[ID] = @InteractionId
					AND AI.[IsTranscribed] = 1
					AND (
						(@ProcessId IS NOT NULL AND PAI.[ProcessId] IS NOT NULL)
						OR
						(@ProcessId IS NULL AND PAI.[ProcessId] IS NULL)	
					)
				ORDER BY AI.[Folder] ASC

		END
		ELSE
		BEGIN
			SELECT IEP.[Instance]						'vcc',
					IEP.[IdCampaign]					'campaign',
					IEP.[InteractionType]				'interactionType',
					IEP.[IdInteraction]					'interactionId',
					IEP.[FormattedEndDate]				'folder',
					NULL								'jsonFileName',
					NULL								'viewFileName',
					NULL								'processId',
					IEP.[InteractionMessages]			'totalMessages'
				FROM [dbo].[InteractionEvaluationPlan] IEP (NOLOCK)
				WHERE IEP.[Instance] = @VCC
					AND IEP.[IdEvaluationPlan] = @EvaluationPlanId
					AND IEP.[InteractionType] = @InteractionType
					AND IEP.[IdInteraction] = @InteractionId 
		END
	END
	ELSE 
	BEGIN
		-- PARTE OPCIONAL PARA INTERACCIONES CALL, AUN NO IMPLEMENTADO
		DECLARE @ID VARCHAR(50) = ''
		IF EXISTS (
			SELECT 1 
				FROM [dbo].[Audio] A (NOLOCK)
				WHERE A.[VCC] = 'occ_test'--@VCC 
					AND (
						(CONCAT(A.[ID], '_', A.[Section], '_', A.[Part]) = '{23c5b766-4d29-11ea-b486-a4420ef40d06}_0_1')
						OR
						(A.[ID] = '{23c5b766-4d29-11ea-b486-a4420ef40d06}_0_1')
					)
		) 
		BEGIN
			SET @ID = (
						SELECT TOP 1 A.[ID]
							FROM [dbo].[Audio] A (NOLOCK)
								WHERE A.[VCC] = 'occ_test'--@VCC 
									AND (
										(CONCAT(A.[ID], '_', A.[Section], '_', A.[Part]) = '{23c5b766-4d29-11ea-b486-a4420ef40d06}_0_1')
										OR
										(A.[ID] = '{23c5b766-4d29-11ea-b486-a4420ef40d06}_0_1')
									)
						)

			SELECT *
				FROM [dbo].[Audio] A (NOLOCK)
				WHERE A.[VCC] = 'occ_test'--@VCC 
					AND A.[ID] = @ID
		END

		SELECT 'SOON...'

	END

	SET NOCOUNT OFF
END
GO
PRINT N'Altering [dbo].[GetNotEvaluatedInteractionsAuditor]...';


GO
-- ESTE SP MUETRA LA LISTA DE EVALUACIONES PENDIENTES PARA UN AUDITOR
ALTER PROCEDURE [dbo].[GetNotEvaluatedInteractionsAuditor] (
	@Instance Varchar(50) = NULL, 
	@IdAuditor Varchar(50) = NULL,
	@IdCampaigns VARCHAR(MAX) = NULL,
	@IdAgents Varchar(MAX) = NULL,
	@EvaluationPlans Varchar(MAX) = NULL,
	@InteractionTypes Varchar(100) = NULL,
	@InteractionResults Varchar(MAX) = NULL,
 	@EvaluationDateTo VARCHAR(MAX) = '2050-01-01T23:59:59'
	)
AS
BEGIN
	SET NOCOUNT ON

	DECLARE @SQL_SELECT_0 VARCHAR(MAX) = '';
	DECLARE @SQL_SELECT_1 VARCHAR(MAX) = '';
	DECLARE @SQL_FROM VARCHAR(MAX) = '';
	DECLARE @SQL_FILTER VARCHAR(MAX) = '';
	DECLARE @SQL_EXTRA VARCHAR(MAX) = '';

	-- EMULAMOS UNA NUEVA TABLA EN BASE A AuditorEvaluationPlan DONDE SE REMOVERAN TODOS LOS REGISTROS DUPLICADOS PARA EL PK DE LA TABLA Audio
	SET @SQL_SELECT_1 += '
		WITH CTE AS (
			SELECT AEP.[Instance], 
					AEP.[IdEvaluationPlan], 
					AEP.[IdInteraction], 
					AEP.[IdAuditor], 
					AEP.[Score], 
					AEP.[LastModifiedDate],
					RN = ROW_NUMBER() OVER(PARTITION BY AEP.[Instance], AEP.[IdEvaluationPlan], AEP.[IdInteraction] ORDER BY AEP.[LastModifiedDate] DESC)
			FROM AuditorEvaluationPlan AEP (NOLOCK)
			WHERE AEP.[Instance] = ''' + @Instance + ''' 
				AND AEP.[Completed] = 0 
				AND AEP.[IdAuditor] <> ''SPEECH''
		) ';
	-- EL CTE SOLO PUEDE SER INVOCADO UNA VEZ POR ESO LO PONEMOS EN EL SELECT FINAL DONDE EL CONTADOR(RN) ES 1
	
	-- ARMAMOS EL SELECT PRINCIPAL PARA LA BUSQUEDA DE EVALUACIONES PENDIENTES DEL AUDITOR
	SET @SQL_SELECT_1 += '
		SELECT DISTINCT '
	SET @SQL_SELECT_1 += '
				AEP.[IdInteraction]				''id'', 
				AEP.[IdCampaign]				''descriptionCampaign'',
				AEP.[IdAgent]					''idAgent'',
				AEP.[IdAgent]					''descriptionAgent'',
				AEP.[InteractionDate]			''dateIni'',
				AEP.[InteractionDuration]		''interactionTime'',
				AEP.[Completed]					''evaluated'',
				AEP.[InteractionType]			''interactionType'',
				AEP.[ManagementResult]			''dispositionCode'',
				AEP.[ContactId]					''address'',
				AEP.[InteractionOrigin]			''origin'',
				AEP.[IdEvaluationPlan]			''idEvaluationPlan'',
				EP.[ProcessId]					''processId'',
				EP.[Description]				''descriptionEvaluationPlan'',
				EP.[DateFin]					''dateFinEvaluationPlan'', 
				A.[ID]							''idAuditor'', 
				A.[Description]					''descriptionAuditor'',
				C.[IdAuditor]					''lastEvaluationEvaluator'', 
				C.[Score]						''lastEvaluationScore'' '

	SET @SQL_FROM += '
			FROM [AuditorEvaluationPlan] AEP (NOLOCK) 
			LEFT JOIN [EvaluationPlan] EP (NOLOCK) 
				ON (EP.[Instance] = EP.Instance
					AND EP.[ID] = AEP.IdEvaluationPlan) 
			LEFT JOIN [Auditor] A (NOLOCK) 
				ON (A.[ID] = AEP.[IdAuditor])
			LEFT JOIN CTE C (NOLOCK) 
				ON C.[Instance] = AEP.[Instance] 
					AND C.[IdEvaluationPlan] = AEP.[IdEvaluationPlan] 
					AND C.[IdInteraction] = AEP.[IdInteraction]
					AND C.[RN] = 1 '

	SET @SQL_FILTER += '
			WHERE AEP.[Instance] = ''' + @Instance + ''' 
				AND	AEP.[IdAuditor] = ''' + @IdAuditor + '''
				AND AEP.[Completed] = 0
				AND EP.[Enabled] = 1 '

	IF (@IdCampaigns IS NOT NULL AND @IdCampaigns != '') SET @SQL_FILTER += 'AND AEP.[IdCampaign] IN (SELECT Value FROM [dbo].[split](''' + @IdCampaigns + ''','','')) ';
	IF (@IdAgents IS NOT NULL AND @IdAgents != '') SET @SQL_FILTER += 'AND AEP.[IdAgent] IN (SELECT Value FROM [dbo].[split](''' + @IdAgents + ''','','')) ';
	IF (@EvaluationPlans IS NOT NULL AND @EvaluationPlans != '') SET @SQL_FILTER += 'AND AEP.[IdEvaluationPlan] IN (SELECT Value FROM [dbo].[split](''' + @EvaluationPlans + ''','','')) ';
	IF (@InteractionTypes IS NOT NULL AND @InteractionTypes != '') SET @SQL_FILTER += 'AND AEP.[InteractionType] IN (SELECT Value FROM [dbo].[split](''' + @InteractionTypes + ''','','')) ';
	IF (@InteractionResults IS NOT NULL AND @InteractionResults != '') SET @SQL_FILTER += 'AND AEP.[ManagementResult] IN (SELECT Value FROM [dbo].[split](''' + @InteractionResults + ''','','')) ';
	IF (@EvaluationDateTo IS NOT NULL AND @EvaluationDateTo != '') SET @SQL_FILTER += 'AND EP.[DateFin] <= ''' + @EvaluationDateTo + '''  ';

	SET @SQL_SELECT_1 += @SQL_FROM + @SQL_FILTER + @SQL_EXTRA;

	--SELECT @SQL_SELECT_1
	EXEC (@SQL_SELECT_1)

 	SET NOCOUNT OFF
END
GO
PRINT N'Altering [dbo].[GetProcessValidDurationTime]...';


GO
ALTER  PROCEDURE [dbo].[GetProcessValidDurationTime](
	@VCC VARCHAR(50) = NULL,
	@ProcessId VARCHAR(50)
)
AS
BEGIN
	-- ESTE SP TIENE LA FINALIDAD DE RETORNAR LA CANTIDAD DE SEGUNDOS DE TRANSCRIPCION DE AUDIO CORRESPONDIENTE A UN PROCESS
	SET XACT_ABORT, NOCOUNT ON
	
	SELECT P.[Name] 'name',
			SUM(A.[DurationLinguisticTime]) 'validDurationTime'
		FROM Process P (NOLOCK)
		LEFT JOIN [dbo].[ProcessAudio] PA (NOLOCK) 
			ON PA.[ProcessId] = P.[Name]
		LEFT JOIN [dbo].[Audio] A (NOLOCK) 
			ON A.[ID] = PA.[AudioId]
				AND A.[Section] = PA.[Section]
				AND A.[Part] = PA.[Part]
		WHERE P.[VCC] = @VCC 
			AND P.[Name] = @ProcessId
		GROUP BY P.[Name] 

	SET XACT_ABORT, NOCOUNT OFF
END
GO
PRINT N'Creating [dbo].[GetEvaluationPlanInteractionByTypeAndId]...';


GO
-- ESTE SP RETORN LAS TRANSCRIPCIONES DE UNA INTERACCION SEGUN SU VCC, INTERACTIONTYPE(CHANNEL), INTERACTIONID
CREATE PROCEDURE [dbo].[GetEvaluationPlanInteractionByTypeAndId] (
	@VCC VARCHAR(50) = NULL,
	@EvaluationPlanId VARCHAR(50) = NULL,
	@InteractionType VARCHAR(50) = NULL,
	@InteractionId VARCHAR(250) = NULL
)
AS
BEGIN
	SET NOCOUNT ON

	-- RECUPERAMOS EL PRIMER REGISTRO POR ID DE INTERACCION
	SELECT TOP 1 IEP.[Instance]									AS 'vcc',
					IEP.[IdAgent]								AS 'descriptionAgent',
					''											AS 'descriptionAuditor',
					IEP.[IdCampaign]							AS 'descriptionCampaign',
					EP.[Description]							AS 'descriptionEvaluationPlan',
					NULL										AS 'dateIni',
					IEP.[IdInteraction]							AS 'id',
					IEP.[IdAgent]								AS 'idAgent',
					''											AS 'idAuditorEvaluationPlan',
					IEP.[IdCampaign]							AS 'idCampaign',
					IEP.[IdEvaluationPlan]						AS 'idEvaluationPlan',
					IEP.[InteractionType]						AS 'interactionType',
					''											AS 'origin',
					IEP.[InteractionMessages]					AS 'totalMessages'
		FROM [dbo].[InteractionEvaluationPlan] IEP (NOLOCK)
		LEFT JOIN [dbo].[EvaluationPlan] EP (NOLOCK) 
			ON EP.[Instance] = IEP.[Instance]
				AND EP.[ID] = IEP.[IdEvaluationPlan]
		WHERE IEP.[Instance] = @VCC
			AND IEP.[IdEvaluationPlan] = @EvaluationPlanId
			AND IEP.[InteractionType] = @InteractionType
			AND IEP.[IdInteraction] = @InteractionId

	SET NOCOUNT OFF
END
GO
PRINT N'Creating [dbo].[GetProcessInteractionsByProcessId]...';


GO
CREATE PROCEDURE [dbo].[GetProcessInteractionsByProcessId]
(
	@VCC		VARCHAR(50) = NULL,
	@ProcessId	VARCHAR(50) = NULL,
	@ResultType VARCHAR(50) = NULL
)
AS
BEGIN
	SET NOCOUNT ON

	-- ESTA FUNCION RETORNA LAS INTERACCIONES DE TEXTO Y AUDIO RELACIONADA A UN PROCESS

	IF @ResultType = 'RAW' 
	BEGIN
		-- RESULTADO TIPO RAW GENERA UN RESULTADO CON LOS DATOS Y NOMBRES DE COLUMNAS COMO VIENEN DE HD

		SELECT CONCAT(A.[ID], '_', A.[Section], '_', A.[PArt])				'ID',
				A.[ID]														'InteractionId',
				A.[Section]													'Section',
				A.[Part]													'Part',
				'CALL'														'Channel',
				A.[Number]													'Number',
				A.[Gender]													'Gender',
				A.[SilenceTime]												'Silence',
				A.[DurationTime]											'DurationTime',
				A.[DurationTime]											'AtentionTime',
				A.[Category1]												'Category1',
				A.[Category2]												'Category2',
				A.[Category3]												'Category3',
				A.[Description]												'Description',
				A.[DispositionCode]											'DispositionCode',
				A.[Campaign]												'Campaign',
				A.[Agent]													'Agent',
				A.[Type]													'Type',
				A.[StartDate]												'StartDate',
				A.[EndDate]													'EndDate',
				NULL														'Format',
				A.[ValidChar]												'validChar',
				A.[TotalPhrases]											'totalPhrases'
			FROM [dbo].[ProcessAudio] PA (NOLOCK)
			INNER JOIN [dbo].[Audio] A (NOLOCK)
				ON A.[ID] = PA.[AudioId]
					AND A.[Section] = PA.[Section]
					AND A.[Part] = PA.[Part]
			WHERE PA.[VCC] = @VCC
				AND PA.[ProcessId] = @ProcessId
				

		SELECT PAI.[VCC]								'vcc', 
				PAI.[InteractionId]						'id', 
				PAI.[FormattedEndDate]					'folder',
				AI.[ExportedContent]					'exportedContent',
				PAI.[InteractionType]					'channel',
				PAI.[Campaign]							'campaign',
				AI.[StartDate]							'startDate',
				AI.[EndDate]							'endDate',
				AI.[Account]							'account',
				AI.[Initiative]							'initiative',
				AI.[ContactName]						'contactName',
				AI.[FirstTakedAgent]					'firstTakedAgent',
				AI.[LastTakedAgent]						'lastTakedAgent', 
				AI.[IsTaken]							'isTaken',
				AI.[TotalMessages]						'totalMessages',
				AI.[DurationTime]						'durationTime',
				AI.[AttentionTime]						'attentionTime',
				AI.[DispositionCode]					'dispositionCode',
				AI.[DispositionTreePath]				'dispositionTreePath',
				AI.[RawChar]							'rawChar',
				AI.[TotalPhrases]						'totalPhrases'
			FROM [dbo].[ProcessAsyncInteraction] PAI (NOLOCK)
			INNER JOIN [dbo].[AsyncInteraction] AI (NOLOCK)
				ON AI.[VCC] = PAI.[VCC]
					AND AI.[ID] = PAI.[InteractionId]
					AND AI.[Channel] = PAI.[InteractionType]
					AND AI.[Folder] = PAI.[FormattedEndDate]
			WHERE PAI.[VCC] = @VCC
				AND PAI.[ProcessId] = @ProcessId
				
	END

	SET NOCOUNT OFF
END
GO
PRINT N'Creating [dbo].[SaveInteractionEvaluationPlanSample]...';


GO
CREATE PROCEDURE [dbo].[SaveInteractionEvaluationPlanSample] (
	@VCC VARCHAR(50) = NULL,
	@EvaluationPlanId VARCHAR(50) = NULL,
	@EvaluatePercentage DECIMAL(18, 2) = NULL
) AS
BEGIN
	SET NOCOUNT ON

	-- ESTE SP REDUCE LAS INTERACCIONES DE UN PLAN AL PORCENTAJE DADO EN EL INPUT
	/*
	DECLARE @VCC VARCHAR(50) = 'occ_test'
	DECLARE @EvaluationPlanId VARCHAR(50)  = '50c7da87-c79d-4f05-b66d-4f94d76f8e55' 
	DECLARE @EvaluatePercentage DECIMAL(18, 2) = 0.20
	*/

	-- DECLARAMOS UNA VARIABLE PARA ALMACENAR EL NUMERO TOTAL DE INTERACCIONES
	DECLARE @CHANNEL_COUNTER INT = 0
	DECLARE @CURRENT_TOTAL_INTERACTIONS INT = 0
	DECLARE @NEW_TOTAL_INTERACTIONS DECIMAL(18, 2) = 0

	-- ALMACENAMOS EL TOTAL DE INTERACCIONES QUE EXISTEN ACTUALMENTE
	SELECT @CURRENT_TOTAL_INTERACTIONS = COUNT(DISTINCT IEP.[IdInteraction])
		FROM [InteractionEvaluationPlan] IEP (NOLOCK)
		WHERE IEP.[Instance] = @VCC
			AND IEP.[IdEvaluationPlan] = @EvaluationPlanId

	-- SETTEAMOS EL NUEVO TOTAL DE INTERACCIONES
	SET @NEW_TOTAL_INTERACTIONS =  CASE WHEN ((@CURRENT_TOTAL_INTERACTIONS * @EvaluatePercentage) % 1) >= 0.5 
									THEN CEILING(@CURRENT_TOTAL_INTERACTIONS * @EvaluatePercentage) 
									ELSE FLOOR(@CURRENT_TOTAL_INTERACTIONS * @EvaluatePercentage) 
									END

	-- DECLARAMOS UNA VARIABLE PARA ALMACENAR LOS CANALES Y NUMERO DE INTERACCIONES 
	DECLARE MY_CURSOR CURSOR 
	LOCAL STATIC READ_ONLY FORWARD_ONLY -- SCROLL 
		FOR 
		-- CONSULTAMOS LA CANTIDAD DE INTERACCIONES QUE EXISTEN EN EL PLAN
		SELECT IEP.[InteractionType]													'CHANNEL',
				COUNT(DISTINCT IEP.[IdInteraction])										'CHANNEL_INTERACTIONS',
				CEILING(COUNT(DISTINCT IEP.[IdInteraction]) * @EvaluatePercentage)		'NEW_CHANNEL_INTERACTIONS'
			FROM [InteractionEvaluationPlan] IEP (NOLOCK)
			WHERE IEP.[Instance] = @VCC
				AND IEP.[IdEvaluationPlan] = @EvaluationPlanId
			GROUP BY IEP.[InteractionType]
			ORDER BY COUNT(DISTINCT IEP.[IdInteraction]) ASC

	-- DECLARARAMOS UNA VARIABLE PARA INDICAR EL BACTH ACTUAL QUE ESTAMOS RECORRIENDO
	DECLARE @CURRENT_CHANNEL VARCHAR(50) = ''
	DECLARE @CURRENT_CHANNEL_INTERACTIONS INT = 0
	DECLARE @NEW_CHANNEL_INTERACTIONS INT = 0
	
	-- ABRIMOS Y RECORREMOS EL ARRAY DE CANALES
	OPEN MY_CURSOR
	FETCH NEXT FROM MY_CURSOR INTO @CURRENT_CHANNEL, @CURRENT_CHANNEL_INTERACTIONS, @NEW_CHANNEL_INTERACTIONS
	WHILE @@FETCH_STATUS = 0
	BEGIN 
		-- AUMENTAMOS EL CONTADOR DE CANALES
		SET @CHANNEL_COUNTER = @CHANNEL_COUNTER + 1

		-- VERIFICAMOS SI AUN QUEDAN CUPOS DISPONIBLES
		IF @NEW_TOTAL_INTERACTIONS > 0
		BEGIN
			-- VERIFICMAOS SI LA CANTIDAD PARA EL CANAL ES MAYOR A LA CANTIDAD DE CUPOS DISPONIBLES
			IF @NEW_TOTAL_INTERACTIONS <= @NEW_CHANNEL_INTERACTIONS 
			BEGIN
				-- SI LOS CUPOS DISPONIBLES SON MENORES A LA CANTIDAD PARA EL CANAL ACTUAL, LA CANTIDAD DISPONIBLE PASA A SER LA CANTIDAD PARA EL CANAL
				SET @NEW_CHANNEL_INTERACTIONS = @NEW_TOTAL_INTERACTIONS

			END
			ELSE
			BEGIN
				-- SI EL CONTADOR ES IGUAL A @@CURSOR_ROWS  ESTAMOS EN EL ULTIMO ITEM DEL CURSOR
				IF @CHANNEL_COUNTER = @@CURSOR_ROWS 
				BEGIN 
					-- ACTUALIZAMOS LA CANTIDAD PARA EL CANAL ACTUAL
					SET @NEW_CHANNEL_INTERACTIONS = @NEW_TOTAL_INTERACTIONS
					-- SELECT @CURRENT_CHANNEL, '=> AJUSTE =>', @NEW_CHANNEL_INTERACTIONS 
				END
			END
		END
		ELSE
		BEGIN
			-- SI NO QUEDAN CUPOS PENDIENTES, NO SE CONSERVARA NINGUN REGISTROS DEL CANAL
			SET @NEW_CHANNEL_INTERACTIONS = 0
		END
		
		---- ELIMINAMOS LAS INTERACCIONES QUE NO COINCIDEN CON LAS INTERACCIONES DE LA MUESTRA
		DELETE FROM [dbo].[InteractionEvaluationPlan]
			WHERE [Instance] = @VCC
				AND [IdEvaluationPlan] = @EvaluationPlanId
				AND [InteractionType] = @CURRENT_CHANNEL
				AND [IdInteraction] NOT IN (
					-- RETORNAMOS X INTERACCIONES ALEATORIAS POR ID DE INTERACCION
					SELECT TOP (@NEW_CHANNEL_INTERACTIONS) [IEP].[IdInteraction] 
						FROM [dbo].[InteractionEvaluationPlan] IEP (NOLOCK) 
						WHERE IEP.[Instance] = @VCC
							AND IEP.[IdEvaluationPlan] = @EvaluationPlanId
							AND IEP.[InteractionType] = @CURRENT_CHANNEL
						GROUP BY [IEP].[IdInteraction] 
						ORDER BY NEWID()
				)
	
		-- FINALIZAMOS EL BUCLE RESTANDO A LOS CUPOS LA CANTIDAD USADA PARA EL CANAL
		SET @NEW_TOTAL_INTERACTIONS  = @NEW_TOTAL_INTERACTIONS - @NEW_CHANNEL_INTERACTIONS
		
		FETCH NEXT FROM MY_CURSOR INTO @CURRENT_CHANNEL, @CURRENT_CHANNEL_INTERACTIONS, @NEW_CHANNEL_INTERACTIONS
	END
	CLOSE MY_CURSOR
	DEALLOCATE MY_CURSOR

	-- RETORNAMOS UNA RESPUESTA
	SELECT 1 AS 'result'

	SET NOCOUNT OFF
END
GO
PRINT N'Altering [dbo].[GetAsyncBillingInteractions]...';


GO
-- ESTE SP RETORNA UN RESUMEN DE LA BUSQUEDA DE INTERACCIONES DE ALLEGRO PARA INDETIFICAR LOS YA TRANSCRITOS O INPROCESS SEGUN LOS FILTROS RECIBIDOS 
-- FUNCIONA IGUAL QUE LA FUNCION EN KNEX
ALTER PROCEDURE [dbo].[GetAsyncBillingInteractions] (
   	@VCC					VARCHAR(50) = NULL,
	@IP						VARCHAR(50),						-- IP DEL SERVIDOR PARA LA BASE I6
	@Type					INT,								-- FLAG PARA INDICAR SI EL SERVIDOR I6 SE ENCUENTRA LOCAL O REMOTO
	@InteractionType		VARCHAR(50) = NULL,
	@StartDate				DATETIME = '1980-01-01T00:00:00',
    @EndDate				DATETIME = '2050-01-01T23:59:59',
	@StartHour				VARCHAR(50) = NULL,
	@EndHour				VARCHAR(50) = NULL,
	@Campaigns				VARCHAR(MAX) = NULL,
 	@Agents					VARCHAR(MAX) = NULL,
   	@DispositionCodes		VARCHAR(MAX) = NULL,
   	@Origins				VARCHAR(100) = NULL,
	@CharsPerPhrase			INT = 0
)
AS 
BEGIN 
	-- SETTEAMOS VALORES MINIMOS PARA LAS HORAS DE INICIO Y FIN
	IF (@StartHour IS NOT NULL AND @StartHour = '') SET @StartHour = '00:00:00'
	IF (@EndHour IS NOT NULL AND @EndHour = '') SET @EndHour = '23:59:59'

	-- CREAMOS UNA TABLA TEMPORAL PARA INSERTAR LOS REGISTROS DE LA HDI6
	CREATE TABLE #TMP_HD_INTERACTIONS
	(
		vcc VARCHAR(50), 
		id VARCHAR(250), 
		folder VARCHAR(50),
		exportedContent VARCHAR(250),  
		channel VARCHAR(50), 
		campaign VARCHAR(50), 
		startDate DATETIME,
		endDate DATETIME,
		account VARCHAR(50), 
		initiative VARCHAR(50), 
		contactName VARCHAR(250), 
		firstTakedAgent VARCHAR(50), 
		lastTakedAgent VARCHAR(50), 
		isTaken VARCHAR(50), 
		totalMessages INT,
		durationTime VARCHAR(50),  
		attentionTime VARCHAR(50), 
		dispositionCode VARCHAR(250), 
		dispositionTreePath VARCHAR(250), 
		rawChar INT
	)

	-- EJECUTAMOS EL SP DE CONSULTA QUE LLENARA LA TABLA TEMPORAL
	EXEC [dbo].[GetAsyncInteractions]
		@Ip = @IP, @VCC = @VCC, @Type = @Type, @InteractionType = @InteractionType, @StartDate = @StartDate, 
		@EndDate = @EndDate, @StartHour = @StartHour, @EndHour = @EndHour, @Campaigns = @Campaigns, @Agents = @Agents,
		@DispositionCodes = @DispositionCodes, @Origins = @Origins, @UniqueIds = 0, @ResultType = 'DETAILED'

	-- DECLARAMOS UNA VARIABLE PARA PARA EL TOTALDE RESULTADOS
	DECLARE @TOTAL_INTERACTIONS INT = 0

	-- SETTEAMOS EL NUMERO DE REGISTROS A LA VARIABLE DE TOTAL
	SELECT @TOTAL_INTERACTIONS = COUNT(*) FROM #TMP_HD_INTERACTIONS
	
	IF @TOTAL_INTERACTIONS = 0 
	BEGIN
		-- SI NO EXISTEN RESULTADOS EN HD LLENAMOSUN RESULTADOS CON 0
		SELECT @InteractionType												'interactionType',
				0															'totalInteractionDetails',
				0															'alreadyTranscribedInteraction',
				0															'inProcessInteraction',
				0															'notTranscribedInteraction',
				0															'totalPhrases',
				0															'totalRawChars'
	END 
	ELSE
	BEGIN
		-- CRUZAMOS LA TABLA TEMPORAL DE INTERACCIONES ASINCRONAS CON LA TABLA LOCAL INTERACTION PARA LAS INTERACCIONES ASINCRONAS YA REGISTRADAS
		SELECT HDI.[channel]												'interactionType',
				COUNT(*)													'totalInteractionDetails',
				SUM(CASE WHEN (AI.[VCC] IS NOT NULL 
					AND AI.[IsTranscribed] = 1) THEN 1 ELSE 0 END)			'alreadyTranscribedInteraction',
				0															'inProcessInteraction',
				SUM(CASE WHEN (AI.[VCC] IS NULL 
					OR AI.[IsTranscribed] <> 1) THEN 1 ELSE 0 END)			'notTranscribedInteraction',
				SUM(ISNULL(AI.[TotalPhrases], 0))							'totalPhrases',
				-- CUANDO TENEMOS VALIDPHRASES, YA NO CONTAMOS LAS RAWCHAR 
				SUM(
					CASE WHEN (AI.[TotalPhrases] IS NULL 
							OR AI.[TotalPhrases] = 0)
					THEN (
						ISNULL(AI.[RawChar], ISNULL(HDI.[rawChar], 0))
					)
					ELSE 0 END
				)															'totalRawChars',
				SUM(
					CASE WHEN (AI.[TotalPhrases] IS NULL 
							OR AI.[TotalPhrases] = 0)
					THEN (
						CEILING(ISNULL(AI.[RawChar], ISNULL(HDI.[rawChar], 0)) * 1.00 / @CharsPerPhrase)
					)
					ELSE 0 END
				)															'totalRawPhrases'
			FROM #TMP_HD_INTERACTIONS HDI (NOLOCK)
			LEFT JOIN [dbo].[AsyncInteraction] AI (NOLOCK)
				ON HDI.[vcc] = AI.[VCC]
					AND HDI.[channel] = AI.[Channel]
					AND HDI.[campaign] = AI.[Campaign]
					AND HDI.[id] = AI.[ID]
					AND HDI.[endDate] = AI.[EndDate]
			GROUP BY HDI.[vcc],
						HDI.[channel]
			--ORDER BY AI.[TotalPhrases], AI.[RawChar] DESC, HDI.[RawChar] DESC

	END

END
GO
PRINT N'Refreshing [dbo].[BulkAbilityCognitive]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[BulkAbilityCognitive]';


GO
PRINT N'Refreshing [dbo].[BulkEvaluationPlanAbility]...';


GO
SET ANSI_NULLS ON;

SET QUOTED_IDENTIFIER OFF;


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[BulkEvaluationPlanAbility]';


GO
SET ANSI_NULLS, QUOTED_IDENTIFIER ON;


GO
PRINT N'Refreshing [dbo].[DeleteAuditorEvaluationPlan]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[DeleteAuditorEvaluationPlan]';


GO
PRINT N'Refreshing [dbo].[DeleteEvaluationPlan]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[DeleteEvaluationPlan]';


GO
PRINT N'Refreshing [dbo].[GetAuditorsEvaluationPlan]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[GetAuditorsEvaluationPlan]';


GO
PRINT N'Refreshing [dbo].[GetAuditorsInteractions]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[GetAuditorsInteractions]';


GO
PRINT N'Refreshing [dbo].[GetCampaignFulfillment]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[GetCampaignFulfillment]';


GO
PRINT N'Refreshing [dbo].[GetEvaluationPlans]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[GetEvaluationPlans]';


GO
PRINT N'Refreshing [dbo].[GetEvaluationPlansByStatus]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[GetEvaluationPlansByStatus]';


GO
PRINT N'Refreshing [dbo].[GetEvaluationsOfInteraction]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[GetEvaluationsOfInteraction]';


GO
PRINT N'Refreshing [dbo].[GetInteractionsByType]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[GetInteractionsByType]';


GO
PRINT N'Refreshing [dbo].[GetInteractionsEvaluationPlanWithoutFilters]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[GetInteractionsEvaluationPlanWithoutFilters]';


GO
PRINT N'Refreshing [dbo].[GetTopAgents]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[GetTopAgents]';


GO
PRINT N'Refreshing [dbo].[SaveAuditorEvPlanResult]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[SaveAuditorEvPlanResult]';


GO
PRINT N'Refreshing [dbo].[SaveEvaluationFormat]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[SaveEvaluationFormat]';


GO
PRINT N'Refreshing [dbo].[SaveEvaluationPlanCompleted]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[SaveEvaluationPlanCompleted]';


GO
PRINT N'Refreshing [dbo].[DeleteEvaluationResults]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[DeleteEvaluationResults]';


GO
PRINT N'Refreshing [dbo].[GetAgentQualificationAverage]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[GetAgentQualificationAverage]';


GO
PRINT N'Refreshing [dbo].[GetAverageGroupRating]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[GetAverageGroupRating]';


GO
PRINT N'Refreshing [dbo].[GetCampaignQualificationAverage]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[GetCampaignQualificationAverage]';


GO
PRINT N'Refreshing [dbo].[GetEvaluationFormatQualificationAverage]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[GetEvaluationFormatQualificationAverage]';


GO
PRINT N'Refreshing [dbo].[GetEvaluationTypesInteraction]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[GetEvaluationTypesInteraction]';


GO
PRINT N'Refreshing [dbo].[GetReportByDetailAgent]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[GetReportByDetailAgent]';


GO
PRINT N'Refreshing [dbo].[GetReportBySummaryAgent]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[GetReportBySummaryAgent]';


GO
PRINT N'Refreshing [dbo].[ReportAuditsByAgent]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[ReportAuditsByAgent]';


GO
PRINT N'Refreshing [dbo].[ReportByDetailAgent]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[ReportByDetailAgent]';


GO
PRINT N'Refreshing [dbo].[ReportBySummaryAgent]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[ReportBySummaryAgent]';


GO
PRINT N'Refreshing [dbo].[ReportBySummaryFormat]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[ReportBySummaryFormat]';


GO
PRINT N'Refreshing [dbo].[ReportTestEvaluationResult]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[ReportTestEvaluationResult]';


GO
PRINT N'Refreshing [dbo].[GetEvaluationPlanCognitiveInteractionTask]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[GetEvaluationPlanCognitiveInteractionTask]';


GO
PRINT N'Refreshing [dbo].[GetEvaluationPlanCognitiveTask]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[GetEvaluationPlanCognitiveTask]';


GO
PRINT N'Refreshing [dbo].[GetInteractionsEvaluationPlan]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[GetInteractionsEvaluationPlan]';


GO
PRINT N'Update complete.';


GO
