PRINT N'Dropping [dbo].[DF__Evaluatio__IdEva__3DE82FB7]...';


GO
ALTER TABLE [dbo].[EvaluationResult] DROP CONSTRAINT [DF__Evaluatio__IdEva__3DE82FB7];


GO
PRINT N'Dropping [dbo].[DF__Evaluatio__Score__3EDC53F0]...';


GO
ALTER TABLE [dbo].[EvaluationResult] DROP CONSTRAINT [DF__Evaluatio__Score__3EDC53F0];


GO
PRINT N'Dropping [dbo].[DF__Evaluatio__Inter__3FD07829]...';


GO
ALTER TABLE [dbo].[EvaluationResult] DROP CONSTRAINT [DF__Evaluatio__Inter__3FD07829];


GO
PRINT N'Starting rebuilding table [dbo].[EvaluationResult]...';


GO
BEGIN TRANSACTION;

SET TRANSACTION ISOLATION LEVEL SERIALIZABLE;

SET XACT_ABORT ON;

CREATE TABLE [dbo].[tmp_ms_xx_EvaluationResult] (
    [Instance]                   VARCHAR (50)   NOT NULL,
    [IdCampaign]                 VARCHAR (50)   NOT NULL,
    [IdInteraction]              VARCHAR (250)  NOT NULL,
    [IdAgent]                    VARCHAR (50)   NOT NULL,
    [IdEvaluationFormat]         VARCHAR (50)   NOT NULL,
    [MinQualificationAcceptable] NUMERIC (5, 2) NOT NULL,
    [IdGroup]                    VARCHAR (50)   NULL,
    [IdSubGroup]                 VARCHAR (50)   NULL,
    [IdAbility]                  VARCHAR (50)   NOT NULL,
    [Qualification]              NUMERIC (5, 2) NOT NULL,
    [IdEvaluator]                VARCHAR (50)   NOT NULL,
    [EvaluationDate]             DATETIME       NULL,
    [MaxAbilityScore]            NUMERIC (5, 2) NOT NULL,
    [IdEvaluationPlan]           VARCHAR (50)   CONSTRAINT [DF__Evaluatio__IdEva__3DE82FB7] DEFAULT ((0)) NOT NULL,
    [CreatedDate]                DATETIME       NULL,
    [CreatedByUserId]            VARCHAR (50)   NULL,
    [LastModifiedDate]           DATETIME       NULL,
    [LastModifiedByUserId]       VARCHAR (50)   NULL,
    [TimeStamp]                  DATETIME       NULL,
    [Comment]                    VARCHAR (1000) NULL,
    [NotApplies]                 BIT            NULL,
    [ScoreDescription]           VARCHAR (100)  CONSTRAINT [DF__Evaluatio__Score__3EDC53F0] DEFAULT ('') NOT NULL,
    [CampaignDescription]        VARCHAR (100)  NULL,
    [AgentDescription]           VARCHAR (100)  NULL,
    [InteractionDateini]         DATETIME       NULL,
    [InteractionDatefin]         DATETIME       NULL,
    [InteractionAddress]         VARCHAR (200)  CONSTRAINT [DF__Evaluatio__Inter__3FD07829] DEFAULT ('') NULL,
    [AbilityOrder]               NUMERIC (4)    NULL,
    [InteractionType]            VARCHAR (50)   NULL,
    [IdAbilityEvaluationFormat]  VARCHAR (50)   NOT NULL,
    [IdAuditor]                  VARCHAR (50)   NOT NULL,
    [Conditional]                VARCHAR (50)   NULL,
    CONSTRAINT [tmp_ms_xx_constraint_PK_EvaluationResult1] PRIMARY KEY CLUSTERED ([Instance] ASC, [IdEvaluationPlan] ASC, [IdAuditor] ASC, [IdInteraction] ASC, [IdAgent] ASC, [IdAbilityEvaluationFormat] ASC)
);

IF EXISTS (SELECT TOP 1 1 
           FROM   [dbo].[EvaluationResult])
    BEGIN
        INSERT INTO [dbo].[tmp_ms_xx_EvaluationResult] ([Instance], [IdEvaluationPlan], [IdAuditor], [IdInteraction], [IdAgent], [IdAbilityEvaluationFormat], [IdCampaign], [IdEvaluationFormat], [MinQualificationAcceptable], [IdGroup], [IdSubGroup], [IdAbility], [Qualification], [IdEvaluator], [EvaluationDate], [MaxAbilityScore], [CreatedDate], [CreatedByUserId], [LastModifiedDate], [LastModifiedByUserId], [TimeStamp], [Comment], [NotApplies], [ScoreDescription], [CampaignDescription], [AgentDescription], [InteractionDateini], [InteractionAddress], [AbilityOrder], [InteractionType], [Conditional])
        SELECT   [Instance],
                 [IdEvaluationPlan],
                 [IdAuditor],
                 [IdInteraction],
                 [IdAgent],
                 [IdAbilityEvaluationFormat],
                 [IdCampaign],
                 [IdEvaluationFormat],
                 [MinQualificationAcceptable],
                 [IdGroup],
                 [IdSubGroup],
                 [IdAbility],
                 [Qualification],
                 [IdEvaluator],
                 [EvaluationDate],
                 [MaxAbilityScore],
                 [CreatedDate],
                 [CreatedByUserId],
                 [LastModifiedDate],
                 [LastModifiedByUserId],
                 [TimeStamp],
                 [Comment],
                 [NotApplies],
                 [ScoreDescription],
                 [CampaignDescription],
                 [AgentDescription],
                 [InteractionDateini],
                 [InteractionAddress],
                 [AbilityOrder],
                 [InteractionType],
                 [Conditional]
        FROM     [dbo].[EvaluationResult]
        ORDER BY [Instance] ASC, [IdEvaluationPlan] ASC, [IdAuditor] ASC, [IdInteraction] ASC, [IdAgent] ASC, [IdAbilityEvaluationFormat] ASC;
    END

DROP TABLE [dbo].[EvaluationResult];

EXECUTE sp_rename N'[dbo].[tmp_ms_xx_EvaluationResult]', N'EvaluationResult';

EXECUTE sp_rename N'[dbo].[tmp_ms_xx_constraint_PK_EvaluationResult1]', N'PK_EvaluationResult', N'OBJECT';

COMMIT TRANSACTION;

SET TRANSACTION ISOLATION LEVEL READ COMMITTED;


GO
PRINT N'Altering [dbo].[BulkAbilityCognitive]...';


GO
ALTER PROCEDURE [dbo].[BulkAbilityCognitive]
AS
BEGIN
	SET NOCOUNT ON
	--select * from Dummy 
	--truncate table Dummy
	/*
	CREATE TABLE TMP_EVALUATIONPLANABILITY(
		VCC VARCHAR(50),
		ProcessId VARCHAR(50),
		EvaluationPlanId  VARCHAR(200),
		ID VARCHAR(250),
		Section  VARCHAR(50),
		Part VARCHAR(50),
		QueryId VARCHAR(50),
		TranscriptionId VARCHAR(200),
		NluId VARCHAR(50),
		IntentName VARCHAR(50),
		EndDate VARCHAR(50),
		Channel VARCHAR(50),
		Campaign VARCHAR(50)
	)
	*/

	/*insert into DummyEvaluationPlanAbility ([VCC]) values ('BULK')
	insert into TMP_EVALUATIONPLANABILITY ([VCC]
		  ,[ProcessId]
		  ,[EvaluationPlanId]
		  ,[ID]
		  ,[Section]
		  ,[Part]
		  ,[QueryId]
		  ,[TranscriptionId]
		  ,[NluId]
		  ,[IntentName]
		  ,[EndDate]
		  ,[Channel]
		  ,[Campaign])  
	SELECT [VCC]
		  ,[ProcessId]
		  ,[EvaluationPlanId]
		  ,[ID]
		  ,[Section]
		  ,[Part]
		  ,[QueryId]
		  ,[TranscriptionId]
		  ,[NluId]
		  ,[IntentName]
		  ,[EndDate]
		  ,[Channel]
		  ,[Campaign]
	  FROM [dbo].[#AbilityCognitiveTemp]
	*/  
	
	-- Este script crea registros en la tabla EvaluationResult para cada habilidad de los planes que hemos recibido en la tabla temporal 
	INSERT INTO [dbo].[EvaluationResult] (
		[Instance], [IdCampaign], [IdInteraction],
		[IdAgent], [IdEvaluationFormat], [MinQualificationAcceptable],
		[IdGroup], [IdSubGroup], [IdAbility],
		[Qualification], [IdEvaluator], [EvaluationDate],
		[MaxAbilityScore], [IdEvaluationPlan], [CreatedDate],
		[CreatedByUserId], [LastModifiedDate], [LastModifiedByUserId],
		[TimeStamp], [Comment], [NotApplies],
		[ScoreDescription], [CampaignDescription], [AgentDescription],
		[InteractionDateini], [InteractionDatefin], [InteractionAddress], 
		[AbilityOrder], [InteractionType], [IdAbilityEvaluationFormat], 
		[IdAuditor], [Conditional]
	) 
	SELECT DISTINCT IEP.[Instance], IEP.[IdCampaign], IEP.[IdInteraction],
			IEP.[IdAgent], EP.[IdEvaluationFormat], EF.[MinQualificationAcceptable],
			AEF.[IdGroup], AEF.[IdSubGroup], AEF.[IdAbility],
			S.[Value], 'SPEECH', GETUTCDATE(),
			'100', EP.[ID], GETUTCDATE(),
			'SPEECH', GETUTCDATE(), GETUTCDATE(), 
			GETUTCDATE(), NULL, '0', 
			S.[Description], IEP.[IdCampaign], IEP.[IdAgent],
			IEP.[InteractionDateStart], IEP.[InteractionDateEnd], NULL, 
			AEF.[Order], IEP.[InteractionType], AEF.[ID], 
			'SPEECH', AEF.[Conditional] 
		FROM EvaluationPlan EP (NOLOCK)
		LEFT JOIN EvaluationFormat EF (NOLOCK) 
			ON EF.[Instance] = EP.[Instance]
				AND EF.[ID] = EP.[IdEvaluationFormat]
		LEFT JOIN InteractionEvaluationPlan IEP (NOLOCK)
			ON IEP.[Instance] = EP.[Instance]
				AND IEP.[IdEvaluationPlan] = EP.[ID]
		LEFT JOIN AbilityEvaluationFormat AEF (NOLOCK)
			ON AEF.[Instance] = EP.[Instance]
				AND AEF.[IdEvaluationFormat] = EF.[ID]
		LEFT JOIN Ability A (NOLOCK) 
			ON A.[Instance] = EP.[Instance]
				AND A.[ID] = AEF.[IdAbility]
		LEFT JOIN Intent I (NOLOCK) 
			ON I.[VCC] = EP.[Instance]
				AND I.[IntentId] = A.[QueryName]
		LEFT JOIN [dbo].[Score] S (NOLOCK) 
			ON S.[Instance] = IEP.[Instance]
				AND S.[IdAbility] = A.[ID]
				AND S.[Value] = 0
		LEFT JOIN [dbo].[EvaluationResult] ER 
			ON ER.[Instance] = IEP.[Instance]
				AND ER.[IdEvaluationPlan] = IEP.[IdEvaluationPlan]
				AND ER.[IdAgent] = IEP.[IdAgent]
				AND ER.[IdAbilityEvaluationFormat] = AEF.[ID]
		INNER JOIN (SELECT DISTINCT ACTMP.[VCC],
							ACTMP.[EvaluationPlanId]
						FROM [#AbilityCognitiveTemp] ACTMP (NOLOCK)
						WHERE ACTMP.[VCC] IS NOT NULL 
							AND ACTMP.[EvaluationPlanId] IS NOT NULL) TMP
			ON TMP.[VCC] = EP.[Instance]
				AND TMP.[EvaluationPlanId] = EP.[ID]
		WHERE TMP.[VCC] IS NOT NULL
			AND IEP.[IdInteraction] IS NOT NULL
			AND I.[VCC] IS NOT NULL
			AND ER.[Instance] IS NULL

	/* Script para actualizar a puntaje 100 la calificacion de cada habilidad retornada por luis */
	/*
	SELECT EP.[Description],
			ACTMP.[ID],
			I.[IntentId],
			I.[Name],
			A.[Title],
			AEP.Completed,
			ER.[Qualification],
			I.[AppId]
			*/
	UPDATE ER 
		SET ER.[Qualification] = (AEF.[Score] * S.[Value])/100,
			ER.[ScoreDescription] = S.[Description]
		FROM EvaluationPlan EP (NOLOCK)
		LEFT JOIN InteractionEvaluationPlan IEP (NOLOCK)
			ON IEP.[Instance] = EP.[Instance]
				AND IEP.[IdEvaluationPlan] = EP.[ID]
		LEFT JOIN EvaluationFormat EF (NOLOCK) 
			ON EF.[Instance] = EP.[Instance]
				AND EF.[ID] = EP.[IdEvaluationFormat]
		LEFT JOIN AbilityEvaluationFormat AEF (NOLOCK)
			ON AEF.[Instance] = EP.[Instance]
				AND AEF.[IdEvaluationFormat] = EF.[ID] --EP.[IdEvaluationFormat]
		LEFT JOIN Score S (NOLOCK)
			ON S.[IdAbility] = AEF.[IdAbility]
				AND S.[Value] = 100
		LEFT JOIN Ability A (NOLOCK) 
			ON A.[Instance] = EP.[Instance]
				AND A.[ID] = AEF.[IdAbility]
		LEFT JOIN Intent I (NOLOCK) 
			ON I.[VCC] = EP.[Instance]
				AND I.[IntentId] = A.[QueryName]
		LEFT JOIN AuditorEvaluationPlan AEP (NOLOCK)
			ON AEP.[IdEvaluationPlan] = EP.[ID]
				AND AEP.[IdInteraction] = IEP.[IdInteraction]
		LEFT JOIN EvaluationResult ER (NOLOCK)
			ON ER.[Instance] = EP.[Instance] 
				AND ER.[IdEvaluationFormat] = EF.[ID]
				AND ER.[IdInteraction] = IEP.[IdInteraction]
		INNER JOIN [#AbilityCognitiveTemp] ACTMP 
			ON ACTMP.[VCC] = EP.[Instance] 
				AND ACTMP.[EvaluationPlanId] = EP.[ID]
				AND ACTMP.[ID] = IEP.[IdInteraction]
				AND ACTMP.[IntentName] = I.[Name]
		WHERE ACTMP.[EvaluationPlanId] = EP.[ID]
			AND ACTMP.[ID] = IEP.[IdInteraction]
			AND ACTMP.[IntentName] = I.[Name]
			AND AEF.[IdAbility] = ER.[IdAbility]
			AND A.[ID] IS NOT NULL
			AND ER.[IdAuditor] = 'SPEECH'

	/* Script para actualizar la tabla AuditorEvaluationPlan a Completed y Suma de Scores de la evaluacion */
	UPDATE AEP
		SET AEP.[Completed] = '1',
			AEP.[Score] = AEPR.[SCORE]
		FROM AuditorEvaluationPlan AEP (NOLOCK)
		LEFT JOIN (
			SELECT AEP.[Instance],
				AEP.[IdEvaluationPlan],
				AEP.[IdInteraction],
				SUM(ER.[Qualification]) AS SCORE
			FROM AuditorEvaluationPlan AEP (NOLOCK)
			LEFT JOIN EvaluationPlan EP (NOLOCK)
				ON EP.[Instance] = AEP.[Instance]
					AND EP.[ID] = AEP.[IdEvaluationPlan] 
			LEFT JOIN EvaluationResult ER (NOLOCK)
				ON ER.[Instance] = AEP.[Instance]
					AND ER.[IdEvaluationPlan] = AEP.[IdEvaluationPlan]
					AND ER.[IdInteraction] = AEP.[IdInteraction]
			LEFT JOIN AbilityEvaluationFormat AEF (NOLOCK) 
				ON AEF.[Instance] = EP.[Instance]
					AND AEF.[IdEvaluationFormat] = EP.[IdEvaluationFormat]
					AND AEF.[IdAbility] = ER.[IdAbility]
			LEFT JOIN (SELECT DISTINCT ACTMP.[VCC],
									ACTMP.[EvaluationPlanId]
								FROM [#AbilityCognitiveTemp] ACTMP (NOLOCK)
								WHERE ACTMP.[VCC] IS NOT NULL 
									AND ACTMP.[EvaluationPlanId] IS NOT NULL) TMP 
				ON TMP.[VCC] = AEP.[Instance]
					AND TMP.[EvaluationPlanId] = AEP.[IdEvaluationPlan]
			WHERE TMP.[EvaluationPlanId] = AEP.[IdEvaluationPlan]
			GROUP BY AEP.[Instance], AEP.[IdEvaluationPlan], AEP.[IdInteraction]	
		) AEPR 
		ON AEPR.[Instance] = AEP.[Instance]
			AND AEPR.[IdEvaluationPlan] = AEP.[IdEvaluationPlan]
			AND AEPR.[IdInteraction] = AEP.[IdInteraction]
		WHERE AEPR.[Instance] = AEP.[Instance]
			AND AEPR.[IdEvaluationPlan] = AEP.[IdEvaluationPlan]
			AND AEPR.[IdInteraction] = AEP.[IdInteraction]
	
	;
	/****************************************************************************************/
	/*INICIO SECCION PARA ACTUALIZAR LA CALIFICACION TOTAL DE LA EVALUACION C/S PENALIZACION*/
	/****************************************************************************************/
	
	-- EMULAMOS UNA NUEVA TABLA VARIABLE PARA DETERMINAR LAS INTERACCIONES QUE TIENEN HABILIDAD(ES) PENALIZADA(S) POR NOTA CERO
	--  ORDENANDO POR PRIORIDAD (INTERACCION 1, GRUPO 2 Y SUBGRUPO 3)
	WITH CTEFP AS (
		SELECT DISTINCT 
				ER.[Instance],
				ER.[IdInteraction],
				ER.[IdEvaluationPlan],
				ER.[IdEvaluationFormat],
				ER.[IdAbility],
				CASE WHEN ER.[Qualification] = 0 AND AEF.[Penalizes] <> 'NO' THEN 1 ELSE 0 END 'Penalized',
				AEF.[Penalizes],
				CASE AEF.[Penalizes]
					WHEN 'INT' THEN ER.[IdInteraction] 
					WHEN 'GRP' THEN ER.[IdGroup] 
					WHEN 'SGR' THEN ER.[IdSubGroup] 
				END 'PenalizedOn',
				RN = ROW_NUMBER() OVER(PARTITION BY ER.[IdInteraction], CASE WHEN ER.[Qualification] = 0 THEN 1 ELSE 0 END 
					ORDER BY CASE AEF.[Penalizes]
					WHEN 'INT' THEN 1 
					WHEN 'GRP' THEN 2 
					WHEN 'SGR' THEN 3 
				END)
			FROM [EvaluationResult] ER (NOLOCK) 
			LEFT JOIN [AbilityEvaluationFormat] AEF (NOLOCK) 
				ON AEF.[Instance] = ER.[Instance] 
					AND AEF.[IdEvaluationFormat] = ER.[IdEvaluationFormat]
					AND AEF.[IdAbility] = ER.[IdAbility]
			WHERE ER.[IdEvaluationPlan] IN (SELECT DISTINCT EvaluationPlanId FROM [#AbilityCognitiveTemp]) 
				AND ER.[Qualification] = 0 
				AND AEF.[Penalizes] <> 'NO'
			-- WHERE ER.[IdEvaluationPlan] IN (SELECT DISTINCT EPA.[EvaluationPlanId] FROM [DummyEvaluationPlanAbility] EPA (NOLOCK) WHERE EPA.[EvaluationPlanId] IS NOT NULL)
	),

	-- ALMACENAMOS EL RESULTADO AGRUPADO DE LAS EVALUACIONES EN UNA TABLA VARIABLE PARA HACER UN CRUCE DIRECTO CON
	--  LA TABLA AuditorEvaluationPlan
	CTEFS AS (
		SELECT ER.[Instance],
				ER.[IdEvaluationPlan],
				ER.[IdInteraction],
				SUM(ER.[Qualification]) 'TOTAL_SCORE',
				SUM(ER.[Qualification] * CASE WHEN FP.[Penalized] IS NULL THEN 1 ELSE 0 END) 'PENALIZED_SCORE'
		
			FROM EvaluationResult ER (NOLOCK) 
			LEFT JOIN (
				-- HACEMOS UN CRUCE CON LA TABLA VARIABLE Y TOMAMOS SOLO UNA DE LAS PENALIZACIONES POR INTERACCION, EMPEZANDO 
				--  POR LA MAS PRIORITARIA (FP.[RN])
				SELECT DISTINCT FP.[Instance],
								FP.[IdEvaluationPlan], 
								FP.[Penalized],
								FP.[Penalizes], 
								FP.[PenalizedOn]
					FROM CTEFP FP (NOLOCK)
					WHERE FP.[Penalizes] <> 'NO'
						AND FP.[RN] = 1
			) FP
				ON FP.[Instance] = ER.[Instance]
					AND ER.[IdEvaluationPlan] = FP.[IdEvaluationPlan]
					AND CASE FP.[Penalizes]
							WHEN 'INT' THEN ER.[IdInteraction] 
							WHEN 'GRP' THEN ER.[IdGroup] 
							WHEN 'SGR' THEN ER.[IdSubGroup] 
						END = FP.[PenalizedOn]
					AND FP.[Penalized] = 1
			--WHERE ER.[Instance] = 'multisalud'
			WHERE ER.[Instance] = FP.[Instance]
				AND ER.[IdEvaluationPlan] IN (SELECT DISTINCT EvaluationPlanId FROM [#AbilityCognitiveTemp])
			GROUP BY ER.[Instance],
				ER.[IdEvaluationPlan],
				ER.[IdInteraction]
	)
	--SELECT * FROM CTEFS

	-- ACTUALIZAMOS LOS REGISTROS DE EVALUACION CON LA NOTA PENALIZADA OBTENIDA EN LOS PASOS ANTERIORES
	UPDATE AEP 
		SET AEP.[Score] = FS.[PENALIZED_SCORE]
		FROM AuditorEvaluationPlan AEP 
		LEFT JOIN CTEFS FS (NOLOCK) 
			ON FS.[Instance] = AEP.[Instance] 
				AND FS.[IdEvaluationPlan] = AEP.[IdEvaluationPlan] 
				AND FS.[IdInteraction] = AEP.[IdInteraction]
		WHERE FS.[Instance] IS NOT NULL
		
	/*************************************************************************************/
	/*FIN SECCION PARA ACTUALIZAR LA CALIFICACION TOTAL DE LA EVALUACION C/S PENALIZACION*/
	/*************************************************************************************/
	
	DROP TABLE [dbo].[#AbilityCognitiveTemp];
	
	SET NOCOUNT OFF
END;
GO
PRINT N'Altering [dbo].[BulkEvaluationPlanAbility]...';


GO
SET ANSI_NULLS ON;

SET QUOTED_IDENTIFIER OFF;


GO
ALTER PROCEDURE [dbo].[BulkEvaluationPlanAbility]
AS
BEGIN
	SET NOCOUNT ON
	-- ESTE PROCEDURE RECIBE COMO RESULTADO LAS INTERACCIONES QUE COINCIDEN CON UN QUERY
	--SELECT * FROM Dummy
	--TRUNCATE TABLE Dummy
	--DROP TABLE Dummy
	/*
	drop table [dbo].[DummyEvaluationPlanAbility]
	CREATE TABLE [dbo].[DummyEvaluationPlanAbility](
		[VCC] [varchar](50) NULL,
		[ProcessId] [varchar](50) NULL,
		[EvaluationPlanId] [varchar](50) NULL,
		[AudioId] [varchar](100) NULL,
		[Section] [int] NULL,
		[Part] [int] NULL,
		[QueryId][varchar](1000) NULL
	)

	insert into DummyEvaluationPlanAbility ([VCC]) values ('BULK')
	insert into DummyEvaluationPlanAbility ([VCC]
		  ,[ProcessId]
		  ,[EvaluationPlanId]
		  ,[AudioId]
		  ,[Section]
		  ,[Part]
		  ,[QueryId])  
	SELECT [VCC]
		  ,[ProcessId]
		  ,[EvaluationPlanId]
		  ,[AudioId]
		  ,[Section]
		  ,[Part]
		  ,[QueryId]
	  FROM [dbo].[#EvaluationPlanAbilityTemp]
	*/
	
	--ASEGURAMOS QUE SE INSERTEN TODAS LAS INTERACIONES POR HABILIDAD
	INSERT INTO [dbo].[EvaluationResult]
		(
			[Instance]
			,[IdCampaign]
			,[IdInteraction]
			,[IdAgent]
			,[IdEvaluationFormat]
			,[MinQualificationAcceptable]
			,[IdGroup]
			,[IdSubGroup]
			,[IdAbility]
			,[Qualification]
			,[IdEvaluator]
			,[EvaluationDate]
			,[MaxAbilityScore]
			,[IdEvaluationPlan]
			,[CreatedDate]
			,[CreatedByUserId]
			,[LastModifiedDate]
			,[LastModifiedByUserId]
			,[TimeStamp]
			,[Comment]
			,[NotApplies]
			,[ScoreDescription]
			,[CampaignDescription]
			,[AgentDescription]
			,[InteractionDateini]
			,[InteractionDatefin]
			,[InteractionAddress]
			,[AbilityOrder]
			,[InteractionType]
			,[IdAbilityEvaluationFormat]
			,[IdAuditor]
			,[Conditional]
		)
	SELECT DISTINCT
		IEP.[Instance]
		,IEP.[IdCampaign]
		,IEP.[IdInteraction]
		,IEP.[IdAgent]
		,EP.[IdEvaluationFormat]
		,EF.[MinQualificationAcceptable]
		,AEF.[IdGroup]
		,AEF.[IdSubGroup]
		,AEF.[IdAbility]
		,0
		,'SPEECH'
		,GETUTCDATE()
		,'100'
		,EP.[ID]
		,GETUTCDATE()
		,'SPEECH'
		,GETUTCDATE()
		,GETUTCDATE()
		,GETUTCDATE()
		,NULL
		,'0'
		,S.[Description]
		,IEP.[IdCampaign]
		,IEP.[IdAgent]
		,IEP.[InteractionDateStart]
		,MAX(IEP.[InteractionDateEnd])
		,NULL
		,AEF.[Order]
		,IEP.[InteractionType]
		,AEF.[ID]
		,'SPEECH'
		,AEF.[Conditional] 
	FROM [dbo].[InteractionEvaluationPlan] IEP (NOLOCK)
	INNER JOIN [EvaluationPlan] EP (NOLOCK)
		ON EP.[Instance] = IEP.[Instance]
		AND EP.[ID] = IEP.[IdEvaluationPlan]
	LEFT JOIN [dbo].[EvaluationFormat] EF (NOLOCK)
		ON EF.[Instance] = IEP.[Instance]
		AND EF.[ID] = EP.[IdEvaluationFormat]
	INNER JOIN [dbo].[#EvaluationPlanAbilityTemp] EPATMP (NOLOCK)
	--INNER JOIN [dbo].[DummyEvaluationPlanAbility] EPATMP (NOLOCK)
		ON IEP.[Instance] = EPATMP.[VCC]
		AND IEP.[IdEvaluationPlan] = EPATMP.[EvaluationPlanId]
	INNER JOIN [dbo].[AbilityEvaluationFormat]  AEF (NOLOCK)
		ON AEF.[Instance] = IEP.[Instance]
		AND AEF.[IdEvaluationFormat] = EP.[IdEvaluationFormat]
	INNER JOIN [dbo].[Ability] A
		ON A.[Instance] = IEP.[Instance]
		AND A.[ID] = AEF.[IdAbility]
		AND A.[QueryName] = EPATMP.[QueryId]
	LEFT JOIN [dbo].[Score] S (NOLOCK) 
		ON S.[Instance] = A.[Instance] 
		AND S.[IdAbility] = A.[ID]
		AND S.[Value] = 0
	LEFT JOIN [EvaluationResult] ER (NOLOCK)
		ON ER.[Instance] = EPATMP.[VCC]
		AND ER.[IdEvaluationPlan] = EPATMP.[EvaluationPlanId]
		AND ER.[IdAbility] = AEF.[IdAbility]
	WHERE ER.[IdAbility] IS NULL
	GROUP BY IEP.[Instance]
		,IEP.[IdCampaign]
		,IEP.[IdInteraction]
		,IEP.[IdAgent]
		,EP.[IdEvaluationFormat]
		,EF.[MinQualificationAcceptable]
		,AEF.[IdGroup]
		,AEF.[IdSubGroup]
		,AEF.[IdAbility]
		,EP.[ID]
		,S.[Description]
		,IEP.[IdCampaign]
		,IEP.[IdAgent]
		,IEP.[InteractionDateStart]
		,AEF.[Order]
		,IEP.[InteractionType]
		,AEF.[ID]
		,AEF.[Conditional] 

	--ACTUALIZAR LOS SCORES DE LAS HABILIDADES RETORNADAS EN LA TABLA TEMPORAL
	UPDATE ER 
	SET ER.[Qualification] = (S.[Value] * AEF.[Score] / 100), 
		ER.[ScoreDescription] = S.[Description]
	FROM [dbo].[EvaluationResult] ER (NOLOCK)
	INNER JOIN [dbo].[#EvaluationPlanAbilityTemp] EPATMP (NOLOCK)
	--INNER JOIN [dbo].[DummyEvaluationPlanAbility] EPATMP (NOLOCK)
		ON ER.[Instance] = EPATMP.[VCC]
		AND ER.[IdEvaluationPlan] = EPATMP.[EvaluationPlanId]
		AND ER.[IdInteraction] = EPATMP.[AudioId] 
	LEFT JOIN [dbo].[AbilityEvaluationFormat] AEF (NOLOCK)
		ON AEF.[Instance] = ER.[Instance] 
		AND AEF.[IdEvaluationFormat] = ER.[IdEvaluationFormat]
		AND AEF.[IdAbility] = ER.[IdAbility]
	INNER JOIN [dbo].[Ability] A (NOLOCK) 
		ON A.[Instance] = ER.[Instance] 
		AND A.[ID] = ER.[IdAbility]
		AND A.[QueryName] = EPATMP.[QueryId]
	LEFT JOIN [dbo].[Score] S (NOLOCK) 
		ON S.[Instance] = ER.[Instance] 
		AND S.[IdAbility] = ER.[IdAbility]
		AND S.[Value] = 100;

	WITH 
	-- DECLARAMOS UNA CTE PARA DEPOSITAR LOS RESULTADOS DE LA SUMA DE HABILIDADES PARA LA EVALUACION
	CteEvaluationScoreResult AS (
		-- ESTE BLOQUE ACTUALIZA LAS NOTAS DE EVALUACIONES AUTOMATICAS SEGUN LOS PLANES CONTENIDOS EN LA TEMPORAL
		SELECT ER.[Instance], ER.[IdEvaluationPlan], ER.[IdEvaluator], ER.[IdInteraction], SUM(ER.[Qualification]) TOTAL
			FROM EvaluationResult ER 
			INNER JOIN (SELECT DISTINCT EvaluationPlanId FROM #EvaluationPlanAbilityTemp) EPATMP 
				ON EPATMP.[EvaluationPlanId] = ER.[IdEvaluationPlan] 
			LEFT JOIN AbilityEvaluationFormat AEF 
				ON AEF.[Instance] = ER.[Instance]
					AND AEF.[IdEvaluationFormat] = ER.[IdEvaluationFormat]
					AND AEF.[IdAbility] = ER.[IdAbility]
					AND AEF.[ID] = ER.[IdAbilityEvaluationFormat]
			GROUP BY ER.[Instance], ER.[IdEvaluationPlan], ER.[IdEvaluator], ER.[IdInteraction]
	)
	
	-- SE ACTUALIZA LAS EVALUACIONES QUE COINCIDEN CON LOS RESULTADOS
	UPDATE AEP 
		SET AEP.[Score] = ESR.[TOTAL]
		FROM AuditorEvaluationPlan AEP (NOLOCK)
		INNER JOIN CteEvaluationScoreResult ESR 
			ON AEP.[Instance] = ESR.[Instance]
				AND AEP.[IdEvaluationPlan] = ESR.[IdEvaluationPlan]
				AND AEP.[IdAuditor] = ESR.[IdEvaluator]
				AND AEP.[IdInteraction] = ESR.[IdInteraction]

	;
	/****************************************************************************************/
	/*INICIO SECCION PARA ACTUALIZAR LA CALIFICACION TOTAL DE LA EVALUACION C/S PENALIZACION*/
	/****************************************************************************************/
	
	-- EMULAMOS UNA NUEVA TABLA VARIABLE PARA DETERMINAR LAS INTERACCIONES QUE TIENEN HABILIDAD(ES) PENALIZADA(S) POR NOTA CERO
	--  ORDENANDO POR PRIORIDAD (INTERACCION 1, GRUPO 2 Y SUBGRUPO 3)
	WITH CTEFP AS (
		SELECT DISTINCT 
				ER.[Instance],
				ER.[IdInteraction],
				ER.[IdEvaluationPlan],
				ER.[IdEvaluationFormat],
				ER.[IdAbility],
				CASE WHEN ER.[Qualification] = 0 AND AEF.[Penalizes] <> 'NO' THEN 1 ELSE 0 END 'Penalized',
				AEF.[Penalizes],
				CASE AEF.[Penalizes]
					WHEN 'INT' THEN ER.[IdInteraction] 
					WHEN 'GRP' THEN ER.[IdGroup] 
					WHEN 'SGR' THEN ER.[IdSubGroup] 
				END 'PenalizedOn',
				RN = ROW_NUMBER() OVER(PARTITION BY ER.[IdInteraction], CASE WHEN ER.[Qualification] = 0 THEN 1 ELSE 0 END 
					ORDER BY CASE AEF.[Penalizes]
					WHEN 'INT' THEN 1 
					WHEN 'GRP' THEN 2 
					WHEN 'SGR' THEN 3 
				END)
			FROM [EvaluationResult] ER (NOLOCK) 
			LEFT JOIN [AbilityEvaluationFormat] AEF (NOLOCK) 
				ON AEF.[Instance] = ER.[Instance] 
					AND AEF.[IdEvaluationFormat] = ER.[IdEvaluationFormat]
					AND AEF.[IdAbility] = ER.[IdAbility]
			WHERE ER.[IdEvaluationPlan] IN (SELECT DISTINCT EvaluationPlanId FROM #EvaluationPlanAbilityTemp) 
				AND ER.[Qualification] = 0 
				AND AEF.[Penalizes] <> 'NO'
			-- WHERE ER.[IdEvaluationPlan] IN (SELECT DISTINCT EPA.[EvaluationPlanId] FROM [DummyEvaluationPlanAbility] EPA (NOLOCK) WHERE EPA.[EvaluationPlanId] IS NOT NULL)
	),

	-- ALMACENAMOS EL RESULTADO AGRUPADO DE LAS EVALUACIONES EN UNA TABLA VARIABLE PARA HACER UN CRUCE DIRECTO CON
	--  LA TABLA AuditorEvaluationPlan
	CTEFS AS (
		SELECT ER.[Instance],
				ER.[IdEvaluationPlan],
				ER.[IdInteraction],
				SUM(ER.[Qualification]) 'TOTAL_SCORE',
				SUM(ER.[Qualification] * CASE WHEN FP.[Penalized] IS NULL THEN 1 ELSE 0 END) 'PENALIZED_SCORE'
		
			FROM EvaluationResult ER (NOLOCK) 
			LEFT JOIN (
				-- HACEMOS UN CRUCE CON LA TABLA VARIABLE Y TOMAMOS SOLO UNA DE LAS PENALIZACIONES POR INTERACCION, EMPEZANDO 
				--  POR LA MAS PRIORITARIA (FP.[RN])
				SELECT DISTINCT FP.[Instance],
								FP.[IdEvaluationPlan], 
								FP.[Penalized],
								FP.[Penalizes], 
								FP.[PenalizedOn]
					FROM CTEFP FP (NOLOCK)
					WHERE FP.[Penalizes] <> 'NO'
						AND FP.[RN] = 1
			) FP
				ON FP.[Instance] = ER.[Instance]
					AND ER.[IdEvaluationPlan] = FP.[IdEvaluationPlan]
					AND CASE FP.[Penalizes]
							WHEN 'INT' THEN ER.[IdInteraction] 
							WHEN 'GRP' THEN ER.[IdGroup] 
							WHEN 'SGR' THEN ER.[IdSubGroup] 
						END = FP.[PenalizedOn]
					AND FP.[Penalized] = 1
			--WHERE ER.[Instance] = 'multisalud'
			WHERE ER.[Instance] = FP.[Instance]
				AND ER.[IdEvaluationPlan] IN (SELECT DISTINCT EvaluationPlanId FROM #EvaluationPlanAbilityTemp)
			GROUP BY ER.[Instance],
				ER.[IdEvaluationPlan],
				ER.[IdInteraction]
	)
	--SELECT * FROM CTEFS

	-- ACTUALIZAMOS LOS REGISTROS DE EVALUACION CON LA NOTA PENALIZADA OBTENIDA EN LOS PASOS ANTERIORES
	UPDATE AEP 
		SET AEP.[Score] = FS.[PENALIZED_SCORE]
		FROM AuditorEvaluationPlan AEP (NOLOCK)
		LEFT JOIN CTEFS FS (NOLOCK) 
			ON FS.[Instance] = AEP.[Instance] 
				AND FS.[IdEvaluationPlan] = AEP.[IdEvaluationPlan] 
				AND FS.[IdInteraction] = AEP.[IdInteraction]
		WHERE FS.[Instance] IS NOT NULL
		
	/*************************************************************************************/
	/*FIN SECCION PARA ACTUALIZAR LA CALIFICACION TOTAL DE LA EVALUACION C/S PENALIZACION*/
	/*************************************************************************************/
	

	-- ELIMINAMOS LA TABLA TEMPORAL
	DROP TABLE [dbo].[#EvaluationPlanAbilityTemp]
	
	SET NOCOUNT OFF
END
GO
SET ANSI_NULLS, QUOTED_IDENTIFIER ON;


GO
PRINT N'Altering [dbo].[GetEvaluationResultsFromAuditorEvaluationPlan]...';


GO

ALTER PROCEDURE [dbo].[GetEvaluationResultsFromAuditorEvaluationPlan] (
	@Instance Varchar(50) = NULL,
    @EvaluationPlanId Varchar(50) = NULL,
    @InteractionId varchar(250) = NULL,
    @InteractionType varchar(50) = NULL,
    @AuditorId varchar(50) = NULL,
    @AgentId varchar(50) = NULL
)
AS
BEGIN
    SET NOCOUNT ON

    SELECT
         EF.Id										'EvaluationFormatId'				-- Id
        ,EF.Description								'EvaluationFormatDescription'		-- Titulo del reporte
        ,ER.Instance								'Instance'							-- Subtitulo del reporte
        ,ER.IdAgent									'AgentId'							-- Agente
        ,ER.IdAgent									'AgentDescription'					-- Agente
        ,CONCAT(U.Firstname, ' ', U.Lastname)		'CoordinatorFullName'				-- Coordinador
        ,AEP.IdAuditor								'AuditorId'							-- Auditor
        ,CONCAT(UA.Firstname, ' ',UA.Lastname)		'AuditorDescription'				-- Auditor
		,AEP.IdAuditor
        ,ER.IdCampaign								'CampaignDescription'				-- Campana
        ,ER.IdInteraction							'InteractionId'						-- Grabacion
        ,ER.InteractionType							'InteractionType'					-- Tipo interaccion
        ,ER.InteractionDateini						'InteractionDateIni'				-- Fecha inicio de la interaccion
		,ER.[InteractionDatefin]					'InteractionDateFin'				-- Fecha fin de la interaccion
        ,ER.InteractionAddress						'Contacto'							-- Telefono
        ,ER.EvaluationDate							'EvaluationDate'					-- Fecha monitoreo
        ,AEP.Score									'TotalScore'						-- Puntaje total
        ,G.Id										'GroupId'							-- Grupo
        ,G.Description								'Group'								-- Grupo
        ,SG.Id										'SubGroupId'						-- Subgrupo
        ,SG.Description								'SubGroup'							-- Subgrupo
        ,AB.Id										'AbilityId'							-- Habilidad
        ,AB.Title									'Ability'							-- Habilidad
        ,ER.Comment									'Observacion'						-- Observacion de la habilidad
        ,ER.MaxAbilityScore							'Puntaje'							-- Puntaje
        ,ER.ScoreDescription						'Eval'								-- Eval
        ,ER.Qualification							'Nota'								-- Nota
        ,ER.NotApplies								'NotApplies'
        ,ER.AbilityOrder							'Order'
        ,ER.Conditional                             'conditionalSelected'
    FROM [EvaluationResult] ER (NOLOCK)
    INNER JOIN	[EvaluationFormat] EF (NOLOCK)
	--LEFT JOIN [EvaluationFormat] EF (NOLOCK)
		ON (ER.Instance = EF.Instance 
			AND	ER.IdEvaluationFormat = EF.ID)
    LEFT JOIN [User] U (NOLOCK)
		ON (EF.Instance = U.VCC
			AND EF.CreatedByUserId = U.ID)
    --INNER JOIN [User] UA (NOLOCK)
	LEFT JOIN [User] UA (NOLOCK)
		ON (ER.Instance = UA.VCC 
			AND ER.IdEvaluator = UA.ID)
    --INNER JOIN [AuditorEvaluationPlan] AEP (NOLOCK)
	LEFT JOIN [AuditorEvaluationPlan] AEP (NOLOCK)
		ON (ER.IdEvaluationPlan	= AEP.IdEvaluationPlan
			AND UA.ID = AEP.IdAuditor
			AND ER.IdInteraction = AEP.IdInteraction
			AND ER.InteractionType = AEP.InteractionType
			AND ER.IdAgent = AEP.IdAgent)
    LEFT JOIN [Group] G (NOLOCK)
		ON (ER.Instance = G.Instance
			AND ER.IdGroup = G.ID)
    LEFT JOIN [SubGroup] SG (NOLOCK)
		ON (ER.Instance = SG.Instance 
			AND ER.IdSubGroup = SG.ID)
    LEFT JOIN [Ability] AB (NOLOCK)
		ON (ER.Instance = AB.Instance 
			AND ER.IdAbility = AB.ID)
    WHERE ER.Instance = @Instance
		AND ER.IdEvaluationPlan	= @EvaluationPlanId
		AND ER.IdInteraction = @InteractionId
		AND ER.InteractionType = @InteractionType
		--AND ER.IdEvaluator = @AuditorId
		AND ER.IdAgent = @AgentId
    ORDER BY ER.AbilityOrder ASC;

    SET NOCOUNT OFF
END
GO
PRINT N'Altering [dbo].[SaveEvaluationResult]...';


GO

ALTER PROCEDURE [dbo].[SaveEvaluationResult] (
	@Instance Varchar(50) = NULL,
	@Id Varchar(250) = NULL,
	@IdCampaign Varchar(50) = NULL,
	@IdInteraction Varchar(250) = NULL,
	@IdAgent Varchar(50) = NULL,
	@IdEvaluationFormat Varchar(50) = NULL,
	@MinQualificationAcceptable numeric(5,2) = NULL,
	@IdGroup Varchar(50) = NULL,
	@IdSubGroup Varchar(50) = NULL,
	@IdAbility Varchar(50) = NULL,
	@Qualification numeric(5,2) = NULL,
	@IdEvaluator Varchar(50) = NULL,
	@EvaluationDate Datetime = NULL,
	@MaxAbilityScore numeric(5,2) = NULL,
	@IdEvaluationPlan Varchar(50) = NULL,
	@Comment Varchar(1000) = NULL,
	@NotApplies bit = NULL,
	@ScoreDescription varchar(100) = NULL,
	@CampaignDescription varchar(100) = NULL,
	@AgentDescription varchar(100) = NULL,
	@InteractionDateini [datetime] = NULL,
	@InteractionDatefin [datetime] = NULL,
	@InteractionAddress [varchar](200) = NULL,
	@InteractionType varchar(50) = NULL,
	@AbilityOrder numeric(4,0) = NULL,
	@CreatedDate Datetime = NULL,@CreatedByUserId Varchar(50) = NULL,
	@LastModifiedDate Datetime = NULL,@LastModifiedByUserId Varchar(50) = NULL,
	@Conditional varchar(50) = NULL
	)
AS
BEGIN
	SET NOCOUNT ON

	DECLARE @IdAbilityEvaluationFormat Varchar(50) = NULL

	SELECT @IdAbilityEvaluationFormat = ID
	FROM [AbilityEvaluationFormat]
	WHERE [IdEvaluationFormat] = @IdEvaluationFormat
	AND [IdAbility] = @IdAbility
	AND [IdGroup] = @IdGroup
	AND [IdSubGroup] = @IdSubGroup
	AND [Instance] = @Instance
	AND isNull([Conditional],'') = isNull(@Conditional,'')

	INSERT INTO [dbo].[EvaluationResult]
           ([Instance]
           ,[IdCampaign]
           ,[IdInteraction]
           ,[IdAgent]
           ,[IdEvaluationFormat]
           ,[MinQualificationAcceptable]
           ,[IdGroup]
           ,[IdSubGroup]
           ,[IdAbility]
           ,[Qualification]
           ,[IdEvaluator]
		   ,[IdAuditor]
           ,[EvaluationDate]
           ,[MaxAbilityScore]
           ,[IdEvaluationPlan]
		   ,[Comment]
		   ,[NotApplies]
		   ,[ScoreDescription]
			,[CampaignDescription]
			,[AgentDescription]
			,[InteractionDateini]
			,[InteractionDatefin]
			,[InteractionAddress]
			,[InteractionType]
			,[AbilityOrder]
		   ,[CreatedDate]
           ,[CreatedByUserId]
           ,[LastModifiedDate]
           ,[LastModifiedByUserId]
		   ,[IdAbilityEvaluationFormat]
		   ,[Conditional]
           ,[TimeStamp]
           )
     VALUES
           (
		   @Instance,
		   @IdCampaign,
			@IdInteraction,
			@IdAgent,
			@IdEvaluationFormat,
			@MinQualificationAcceptable ,
			@IdGroup, @IdSubGroup, @IdAbility,
			@Qualification,
			@IdEvaluator,
			@IdEvaluator,
			@EvaluationDate,
			@MaxAbilityScore,
			@IdEvaluationPlan,
			@Comment,
			@NotApplies,
			@ScoreDescription,
			@CampaignDescription,
			@AgentDescription,
			@InteractionDateini,
			@InteractionDatefin,
			@InteractionAddress,
			@InteractionType,
			@AbilityOrder,
			@CreatedDate,@CreatedByUserId,@LastModifiedDate,@LastModifiedByUserId,
			@IdAbilityEvaluationFormat,
			@Conditional,
		   GETUTCDATE())

    SELECT 1 AS 'result'

    SET NOCOUNT OFF
END
GO
PRINT N'Altering [dbo].[BulkProgress]...';


GO
ALTER PROCEDURE [dbo].[BulkProgress]
AS
BEGIN
	INSERT INTO [Progress] ([Key]
		  ,[VCC]
		  ,[ProcessId]
		  ,[Type]
		  ,[TypeId]
		  ,[Total]
		  ,[Progress]
		  ,[Error]
		  ,[Percentage]
		  ,[StatusDescription])  
	SELECT [Key]
		  ,[VCC]
		  ,[ProcessId]
		  ,[Type]
		  ,[TypeId]
		  ,[Total]
		  ,[Progress]
		  ,[Error]
		  ,[Percentage]
		  ,[StatusDescription]
	  FROM [dbo].[#ProgressTemp]
	  
	------------Estados de procesos --------------
	UPDATE A
	SET [Total] = B.[Total]
		,[progress] = B.[Progress]
		,[error] = B.[Error]
		,[percentage] = CASE WHEN B.[Total] > 0 THEN B.[Percentage] ELSE 0 END
		,[StatusDescription] = CASE WHEN B.[Total] >= 0 AND B.[Percentage] = 1 AND  ISNULL(B.[Error],0) > 0 THEN 'COMPLETED_WITH_ERROR' 
									WHEN B.[Total] >= 0 AND B.[Percentage] = 1 AND  ISNULL(B.[Error],0) = 0 THEN 'COMPLETED' 
									ELSE  'IN_PROGRESS' END
		,[LastModifiedDate] = GETUTCDATE()
	FROM Process AS A
	INNER JOIN [dbo].[#ProgressTemp] B 
		ON A.[vcc] = B.[vcc] 
			AND A.[Name] = B.ProcessId 
			AND B.[Type] IS NULL 

	UPDATE A
	SET [Status] = CASE 
			WHEN B.total >= 0 AND B.total <= B.transcription + B.cancel AND B.cancel > B.transcription THEN 'FAILED' 
			WHEN B.total >= 0 AND B.total <= B.transcription + B.cancel THEN 'COMPLETE' 
			ELSE 'INPROCESS_TRANSCRIPTION' 
			END
		,[LastModifiedDate] = GETUTCDATE()
	FROM Process AS A
	INNER JOIN (
		SELECT SUM(UT.total)					'total',
				SUM(UT.cancel)					'cancel',
				SUM(UT.transcription)			'transcription',
				UT.processId					'processId',
				UT.vcc							'vcc'
			FROM (
			  SELECT 
				COUNT(1)					total
				,COUNT(C.isCancel)			cancel
				,COUNT(C.IsTranscribed)		transcription 
				,B.ProcessId				processId
				,B.vcc						vcc
			  FROM [ProcessAudio] A (NOLOCK)
			  INNER JOIN [#ProgressTemp] B 
				ON A.[vcc] = B.[vcc] 
					AND A.ProcessId = B.ProcessId 
					AND B.[Type] IS NULL 
					AND B.[Percentage] = 1
			  INNER JOIN Audio C (NOLOCK) 
				ON A.VCC = C.VCC 
					AND A.AudioId =C.ID 
					AND ISNULL(A.Section,0) = ISNULL(C.Section,0) 
					AND ISNULL(A.Part,0) = ISNULL(C.Part,0)
			  GROUP BY B.ProcessId, B.vcc
			  UNION
			  SELECT 
			  COUNT(1)						total
			  ,COUNT(AI.IsCancel)			cancel
			  ,COUNT(AI.IsTranscribed)		transcription
			  ,PT.[ProcessId]				processId
			  ,PT.[vcc]						vcc
			  FROM [ProcessAsyncInteraction] PAI (NOLOCK)
			  INNER JOIN [#ProgressTemp] PT
				ON PAI.[VCC] = PT.[vcc]
					AND PAI.[ProcessId] = PT.[ProcessId]
					AND PT.[Percentage] = 1
			  INNER JOIN [AsyncInteraction] AI (NOLOCK) 
				ON AI.[VCC] = PT.[vcc]
					AND AI.[Channel] = PAI.[InteractionType]
					AND AI.[Folder] = PAI.[FormattedEndDate]
					AND AI.[Campaign] = PAI.[Campaign]
					AND AI.[ID] = PAI.[InteractionId]
			  GROUP BY PT.ProcessId, PT.vcc
		) UT GROUP BY UT.processId, UT.vcc

	  ) B ON A.[vcc] = B.[vcc] 
		AND A.[Name] = B.ProcessId

	UPDATE P
		SET P.[Status] = CASE WHEN TMPP.[totalFailed] > TMPP.[totalSucced] THEN 'FAILED'
								ELSE 'COMPLETE' END,
			P.[StatusDescription] = CASE WHEN TMPP.[totalFailed] > 0 THEN 'COMPLETED_WITH_ERROR' 
											ELSE 'COMPLETED' END,
			P.[Percentage] = 1
			,P.[LastModifiedDate] = GETUTCDATE()
		FROM [dbo].[Process] P (NOLOCK)
		INNER JOIN (
			SELECT UT.[processId]							'processId',
					ISNULL(SUM(UT.[totalAudio]), 0)			'totalAudio',
					ISNULL(SUM(UT.[totalSucced]), 0)		'totalSucced',
					ISNULL(SUM(UT.[totalFailed]), 0)		'totalFailed'
				FROM (
					SELECT P.[Name] 'processId',
							COUNT(*) 'totalAudio',
							COUNT(CASE WHEN ISNULL(A.[IsTranscribed], 0) = 1 THEN 1 ELSE NULL END) 'totalSucced',
							COUNT(CASE WHEN ISNULL(A.[IsCancel], 0) = 1 THEN 1 ELSE NULL END) 'totalFailed'
						FROM [dbo].[Process] P (NOLOCK) 
						INNER JOIN [dbo].[ProcessAudio] PA (NOLOCK) 
							ON PA.[ProcessId] = P.[Name]
						INNER JOIN [dbo].[Audio] A (NOLOCK) 
							ON A.[ID] = PA.[AudioId]
								AND A.[Section] = PA.[Section]
								AND A.[Part] = PA.[Part]
						WHERE (P.[StatusDescription] <> 'COMPLETED' AND P.[Status] <> 'COMPLETED')
							OR (P.[StatusDescription] = 'COMPLETED' AND P.[Status] <> 'COMPLETED')
							OR (P.[Total] = 0 AND P.[Percentage] = 0)
							-- AND P.[Status] = 'INPROCESS_TRANSCRIPTION'
							--AND P.[StatusDescription] = 'IN_PROGRESS'
						GROUP BY P.[Name]
			
					UNION

					SELECT P.[Name],
							COUNT(*) 'totalAudio',
							COUNT(CASE WHEN ISNULL(AI.[IsTranscribed], 0) = 1 THEN 1 ELSE NULL END) 'totalSucced',
							COUNT(CASE WHEN ISNULL(AI.[IsCancel], 0) = 1 THEN 1 ELSE NULL END) 'totalFailed'
						FROM [dbo].[Process] P (NOLOCK) 
						INNER JOIN [ProcessAsyncInteraction] PAI (NOLOCK)
							ON PAI.[VCC] = P.[vcc]
								AND PAI.[ProcessId] = P.[Name]
						INNER JOIN [AsyncInteraction] AI (NOLOCK) 
							ON AI.[VCC] = P.[vcc]
								AND AI.[Channel] = PAI.[InteractionType]
								AND AI.[Folder] = PAI.[FormattedEndDate]
								AND AI.[Campaign] = PAI.[Campaign]
								AND AI.[ID] = PAI.[InteractionId]
						WHERE (P.[StatusDescription] <> 'COMPLETED' AND P.[Status] <> 'COMPLETED')
							OR (P.[StatusDescription] = 'COMPLETED' AND P.[Status] <> 'COMPLETED')
							OR (P.[Total] = 0 AND P.[Percentage] = 0)
						GROUP BY P.[Name]
					) UT GROUP BY UT.[processId]
		) TMPP
			ON TMPP.[processId] = P.[Name]
				AND TMPP.[totalAudio] = (ISNULL(TMPP.[totalSucced], 0) + ISNULL(TMPP.[totalFailed], 0))


	-- REGISTROS DE [dbo].[#ProgressTemp] CON [Percentage] = 1 YA ESTAN TERMINADO (CON O SIN ERRORES)
	-- SI EL PROCESS SE MARCA COMO FAILED TUVO MUCHO FRACASOS, PERO AUN ASI TUVO EXITOS QUE DEBERERIA COBRARSE
	INSERT INTO [dbo].[Batch] ([VCC], [BatchTypeName], [BatchTypeId], [IsFinished], [ClosedDate], [LastModifiedDate])
		SELECT PTMP.[vcc], 'TRANSCRIPTION', PTMP.[ProcessId], 1, GETUTCDATE(), GETUTCDATE()
			FROM [#ProgressTemp] PTMP
			INNER JOIN [dbo].[Process] P 
				ON P.[vcc] = PTMP.[vcc] 
					AND P.[Name] = PTMP.[ProcessId] 
					AND PTMP.[Type] IS NULL
			WHERE PTMP.[Percentage] = 1 
				AND PTMP.[Type] IS NULL
	
	------------ESTADOS DE ESTUDIOS --------------
	UPDATE A
		SET [Total] = B.[Total]
			,[progress] = B.[Progress]
			,[error] = B.[Error]
			,[percentage] = B.[Percentage]
			,[StatusDescription] = CASE WHEN B.[Percentage] = 1 AND  ISNULL(B.[Error],0) > 0 THEN 'COMPLETED_WITH_ERROR' 
										WHEN B.[Percentage] = 1 AND  ISNULL(B.[Error],0) = 0 THEN 'COMPLETED' 
										ELSE  'IN_PROGRESS' END
			,[Status] = B.[Percentage]
			,[LastModifiedDate] = GETUTCDATE()
			--,[BatchStatus] = CASE WHEN B.[Percentage] = 1 AND  ISNULL(B.[Error],0) > 0 THEN 'FINISHED_WITH_ERROR' 
				--					WHEN B.[Percentage] = 1 AND  ISNULL(B.[Error],0) = 0 THEN 'FINISHED' 
					--				ELSE 'RUNNING' END
		FROM Study AS A
		INNER JOIN [dbo].[#ProgressTemp] B 
			ON A.[vcc] = B.[vcc] 
				AND A.[ProcessId] = B.ProcessId 
				AND A.[Name] = B.[TypeId] 
				AND B.[Type] = 'study'

	-- REGISTROS DE [dbo].[#ProgressTemp] CON [Percentage] = 1 YA ESTAN TERMINADO (CON O SIN ERRORES)
	INSERT INTO [dbo].[Batch] ([VCC], [BatchTypeName], [BatchTypeId], [IsFinished], [ClosedDate], [LastModifiedDate])
		SELECT PTMP.[vcc], 'STUDY', PTMP.[TypeId], 1, GETUTCDATE(), GETUTCDATE()
			FROM [#ProgressTemp] PTMP
			INNER JOIN [dbo].[Study] S 
				ON S.[vcc] = PTMP.[vcc] 
					AND S.[ProcessId] = PTMP.[ProcessId] 
					AND S.[Name] = PTMP.[TypeId]
					AND PTMP.[Type] = 'study'
			WHERE PTMP.[Percentage] = 1 
				AND PTMP.[Type] = 'study'

	------------Estados de plan de evaluacion --------------

	-- UPDATE PARA LA PARTE DE TRANSCRIPCION
	UPDATE A
	SET [Total] = B.[Total]
		,[progress] = B.[Progress]
		,[error] = B.[Error]
		,[percentage] = B.[Percentage]
		,[StatusDescription] = CASE WHEN B.[Percentage] = 1 AND  ISNULL(B.[Error],0) > 0 THEN 'COMPLETED_WITH_ERROR' 
									WHEN B.[Percentage] = 1 AND  ISNULL(B.[Error],0) = 0 THEN 'COMPLETED' 
									ELSE 'IN_PROGRESS' END
		,[Status] = CASE WHEN B.[Percentage] = 1 THEN 3 ELSE 2 END
		,[LastModifiedDate] = GETUTCDATE()
	FROM EvaluationPlan AS A
	INNER JOIN [dbo].[#ProgressTemp] B 
		ON A.[Instance] = B.[vcc] 
			AND A.[ProcessId] = B.ProcessId 
			AND B.[Type] IS NULL 
			AND A.[FilterByContentQueryName] IS NOT NULL 
			AND A.[FilterByContentQuery] IS NOT NULL

	-- UPDATE CONTEMPLADO PARA PLAN DE EVALUACION CON PASO 3 (FILTRO DE CONTENIDO)
	UPDATE A
	SET [Total] = B.[Total]
		,[progress] = B.[Progress]
		,[error] = B.[Error]
		,[percentage] = B.[Percentage]
		,[StatusDescription] = CASE WHEN B.[Percentage] = 1 AND  ISNULL(B.[Error],0) > 0 THEN 'COMPLETED_WITH_ERROR' 
									WHEN B.[Percentage] = 1 AND  ISNULL(B.[Error],0) = 0 THEN 'COMPLETED' 
									ELSE  'IN_PROGRESS' END
		,[Status] = CASE WHEN B.[Percentage] = 1 THEN 5 ELSE 4 END
		,[LastModifiedDate] = GETUTCDATE()
	FROM EvaluationPlan AS A
	INNER JOIN [dbo].[#ProgressTemp] B 
		ON A.[Instance] = B.[vcc] 
			AND A.[ProcessId] = B.ProcessId 
			AND A.Id = B.[TypeId] 
			AND B.[Type] = 'evaluationPlan'

	-- UPDATE PARA LA PARTE DE ANALISIS SEMANTICO/COGNITIVO
	UPDATE A
	SET [Total] = B.[Total]
		,[progress] = B.[Progress]
		,[error] = B.[Error]
		,[percentage] = B.[Percentage]
		,[StatusDescription] = CASE WHEN B.[Percentage] = 1 AND  ISNULL(B.[Error],0) > 0 THEN 'COMPLETED_WITH_ERROR' 
									WHEN B.[Percentage] = 1 AND  ISNULL(B.[Error],0) = 0 THEN 'COMPLETED' 
									ELSE  'IN_PROGRESS' END
		,[Status] = CASE WHEN B.[Percentage] = 1 THEN 5 ELSE 2 END
		,[LastModifiedDate] = GETUTCDATE()
	FROM EvaluationPlan AS A
	INNER JOIN [dbo].[#ProgressTemp] B ON A.[Instance] = B.[vcc] 
	AND A.[ProcessId] = B.ProcessId 
	AND B.[Type] IS NULL 
	AND A.[FilterByContentQueryName] IS NULL 
	AND A.[FilterByContentQuery] IS NULL 
	AND A.[Evaluation_Mode] = 'A' 

	-- 
	UPDATE A
	SET [Total] = B.[Total]
		,[progress] = B.[Progress]
		,[error] = B.[Error]
		,[percentage] = B.[Percentage]
		,[StatusDescription] = CASE WHEN B.[Percentage] = 1 AND  ISNULL(B.[Error],0) > 0 THEN 'COMPLETED_WITH_ERROR' 
									WHEN B.[Percentage] = 1 AND  ISNULL(B.[Error],0) = 0 THEN 'COMPLETED' 
									ELSE  'IN_PROGRESS' END
		,[Status] = CASE WHEN B.[Percentage] = 1 THEN 7 ELSE 6 END
		,[LastModifiedDate] = GETUTCDATE()
		--,[BatchStatus] = CASE WHEN B.[Percentage] = 1 AND  ISNULL(B.[Error],0) > 0 THEN 'FINISHED_WITH_ERROR' 
			--					WHEN B.[Percentage] = 1 AND  ISNULL(B.[Error],0) = 0 THEN 'FINISHED' 
				--				ELSE 'RUNNING' END
	FROM EvaluationPlan AS A
	INNER JOIN [dbo].[#ProgressTemp] B 
		ON A.[Instance] = B.[vcc] 
			AND A.[ProcessId] = B.ProcessId 
			AND A.Id = B.[TypeId] 
			AND B.[Type] = 'ability'

	-- EN UNA TABLA ADICIONAL PODRIA INSERTAR LOS RP STATUS 7 PARA LUEGO ENVIARLOS A CERRAR EN EL SC
	UPDATE AEP 
		SET AEP.[Completed] = 1
			,[LastModifiedDate] = GETUTCDATE()
	FROM dbo.[AuditorEvaluationPlan] AEP 
	INNER JOIN dbo.[EvaluationPlan] EP 
		ON EP.[ID] = AEP.[IdEvaluationPlan]
	INNER JOIN [dbo].[#ProgressTemp] B 
		ON EP.[Instance] = B.[vcc] 
			AND EP.[ProcessId] = B.ProcessId 
			AND EP.Id = B.[TypeId] 
			AND B.[Type] = 'ability'
	WHERE EP.[Status] = 7

	-- REGISTROS DE [dbo].[#ProgressTemp] CON [Percentage] = 1 YA ESTAN TERMINADO (CON O SIN ERRORES)
	INSERT INTO [dbo].[Batch] ([VCC], [BatchTypeName], [BatchTypeId], [IsFinished], [ClosedDate], [LastModifiedDate])
		SELECT PTMP.[vcc], 'EVALUATION_PLAN', PTMP.[TypeId], 1, GETUTCDATE(), GETUTCDATE()
			FROM [#ProgressTemp] PTMP
			INNER JOIN [dbo].[EvaluationPlan] EP 
				ON EP.[Instance] = PTMP.[vcc] 
					AND EP.[ProcessId] = PTMP.[ProcessId] 
					AND EP.[Id] = PTMP.[TypeId]
					AND (PTMP.[Type] = 'ability' OR PTMP.[Type] = 'evaluationPlan')
			WHERE PTMP.[Percentage] = 1 
				AND (PTMP.[Type] = 'ability' OR PTMP.[Type] = 'evaluationPlan')

	SELECT * FROM dbo.[AuditorEvaluationPlan]

	-----------------------------------------------------

	DROP TABLE [dbo].[#ProgressTemp]

END
GO
PRINT N'Altering [dbo].[GetEvaluationPlanCognitiveInteractionTask]...';


GO

ALTER PROCEDURE [dbo].[GetEvaluationPlanCognitiveInteractionTask] (
    @VCC Varchar(50) = NULL, @ID Varchar(50) = NULL
)
AS
BEGIN
SET NOCOUNT ON

	SELECT DISTINCT
			A.Instance					'vcc'
			,A.ProcessId				'processId'
			,C.Campaign					'campaign'
			,B.[InteractionType]		'interactionType'
			,A.[Id]						'evaluationPlanId'
			,B.IdInteraction			'id'
			,C.Section					'section'
			,C.Part						'part'
			,NULL						'folder'
			,F.nluId					'nluId'
			,F.appId					'appId'
			,C.[FileName]				'fileName'
			,F.[cognitiveId]
	FROM [EvaluationPlan] A (NOLOCK)
	INNER JOIN [InteractionEvaluationPlan] B (NOLOCK) 
		ON A.Instance = B.Instance 
			AND A.Id = B.IdEvaluationPlan
	INNER JOIN [dbo].[Audio] C WITH (NOLOCK) 
		ON A.Instance = C.VCC 
			AND B.IdInteraction = C.ID 
	INNER JOIN [AbilityEvaluationFormat] D 
		ON A.Instance = D.Instance 
			AND A.IdEvaluationFormat = D.IdEvaluationFormat
	INNER JOIN [Ability] E 
		ON A.Instance = E.Instance 
			AND D.IdAbility = E.ID 
			AND E.QueryName IS NOT NULL
	INNER JOIN (SELECT DISTINCT
				A.VCC 'vcc'
				,A.[Name] + '|'+ B.[Name] 'cognitiveId'
				,A.[Name] 'nluId'
				,A.AppId 'appId'
				,B.[IntentId] 'intentId',B.Name
			FROM NLU A (NOLOCK)
			INNER JOIN Intent B (NOLOCK) 
				ON A.VCC = B.VCC
					AND B.AppId = A.AppId) F 
		ON A.Instance = F.VCC 
			--AND E.ID = F.cognitiveId
			AND E.Query = F.cognitiveId
			AND E.QueryName = F.intentId
	WHERE A.[Instance] = @VCC
		AND A.[ID] = @ID
	
	SELECT DISTINCT
			A.Instance					'vcc'
			,A.ProcessId				'processId'
			,C.[Campaign]				'campaign'
			,B.[InteractionType]		'interactionType'
			,A.[Id]						'evaluationPlanId'
			,B.IdInteraction			'id'
			,NULL						'section'
			,NULL						'part'
			,C.[EndDate]				'endDate'
			,C.[Folder]					'folder'
			,C.[DispositionCode]		'dispositionCode'
			,F.nluId					'nluId'
			,F.appId					'appId'
			,C.[FileName]				'fileName'
			,F.[cognitiveId]
	FROM [EvaluationPlan] A (NOLOCK)
	INNER JOIN [InteractionEvaluationPlan] B (NOLOCK) 
		ON A.Instance = B.Instance 
			AND A.Id = B.IdEvaluationPlan
	INNER JOIN [dbo].[AsyncInteraction] C WITH (NOLOCK) 
		ON A.Instance = C.VCC 
			AND B.IdInteraction = C.ID
			AND B.FormattedEndDate = C.Folder
	INNER JOIN [AbilityEvaluationFormat] D 
		ON A.Instance = D.Instance 
			AND A.IdEvaluationFormat = D.IdEvaluationFormat
	INNER JOIN [Ability] E 
		ON A.Instance = E.Instance 
			AND D.IdAbility = E.ID 
			AND E.QueryName IS NOT NULL
	INNER JOIN (SELECT DISTINCT
				A.VCC 'vcc'
				,A.[Name] + '|'+ B.[Name] 'cognitiveId'
				,A.[Name] 'nluId'
				,A.AppId 'appId'
				,B.[IntentId] 'intentId',B.Name
			FROM NLU A (NOLOCK)
			INNER JOIN Intent B (NOLOCK) 
				ON A.VCC = B.VCC
					AND B.AppId = A.AppId) F 
		ON A.Instance = F.VCC 
			--AND E.ID = F.cognitiveId
			AND E.Query = F.cognitiveId
			AND E.QueryName = F.intentId
	WHERE A.[Instance] = @VCC
		AND A.[ID] = @ID

SET NOCOUNT OFF
END
GO
PRINT N'Altering [dbo].[GetEvaluationPlanInteractionByTypeAndId]...';


GO
-- ESTE SP RETORN LAS TRANSCRIPCIONES DE UNA INTERACCION SEGUN SU VCC, INTERACTIONTYPE(CHANNEL), INTERACTIONID
ALTER PROCEDURE [dbo].[GetEvaluationPlanInteractionByTypeAndId] (
	@VCC VARCHAR(50) = NULL,
	@EvaluationPlanId VARCHAR(50) = NULL,
	@InteractionType VARCHAR(50) = NULL,
	@InteractionId VARCHAR(250) = NULL
)
AS
BEGIN
	SET NOCOUNT ON

	-- RECUPERAMOS EL PRIMER REGISTRO POR ID DE INTERACCION
	SELECT TOP 1 IEP.[Instance]									AS 'vcc',
					IEP.[IdAgent]								AS 'descriptionAgent',
					''											AS 'descriptionAuditor',
					IEP.[IdCampaign]							AS 'descriptionCampaign',
					EP.[Description]							AS 'descriptionEvaluationPlan',
					IEP.[InteractionDateStart]					AS 'dateIni',
					IEP.[InteractionDateEnd]					AS 'dateFin',
					IEP.[IdInteraction]							AS 'id',
					IEP.[IdAgent]								AS 'idAgent',
					''											AS 'idAuditorEvaluationPlan',
					IEP.[IdCampaign]							AS 'idCampaign',
					IEP.[IdEvaluationPlan]						AS 'idEvaluationPlan',
					IEP.[InteractionType]						AS 'interactionType',
					''											AS 'origin',
					IEP.[InteractionMessages]					AS 'totalMessages'
		FROM [dbo].[InteractionEvaluationPlan] IEP (NOLOCK)
		LEFT JOIN [dbo].[EvaluationPlan] EP (NOLOCK) 
			ON EP.[Instance] = IEP.[Instance]
				AND EP.[ID] = IEP.[IdEvaluationPlan]
		WHERE IEP.[Instance] = @VCC
			AND IEP.[IdEvaluationPlan] = @EvaluationPlanId
			AND IEP.[InteractionType] = @InteractionType
			AND IEP.[IdInteraction] = @InteractionId

	SET NOCOUNT OFF
END
GO
PRINT N'Altering [dbo].[GetInteractionsEvaluationPlanWithoutFilters]...';


GO
ALTER PROCEDURE [dbo].[GetInteractionsEvaluationPlanWithoutFilters] (
	@Instance Varchar(50) = NULL,
	@IdEvaluationPlan Varchar(50) = NULL
)
AS
BEGIN
	SET NOCOUNT ON

 	SELECT
		ae.[IdInteraction]				'id',
		ae.[IdCampaign]					'idCampaign',
		ae.[IdCampaign]					'descriptionCampaign',
		ae.[IdAgent]					'idAgent',
		ae.[IdAgent]					'descriptionAgent',
		ae.[InteractionDate]			'dateIni',
		ae.[InteractionDateEnd]			'dateFin',
		ae.[InteractionDuration]		'interactionTime',
		ae.[Completed]					'evaluated',
		ae.[InteractionType]			'interactionType',
		null							'dispositionCode',
		null							'address',
		null							'origin',
		ae.[Completed]					'completed'
	FROM
	    AuditorEvaluationPlan ae(NOLOCK)
	WHERE
	    ae.Instance = @Instance
	    AND ae.IdEvaluationPlan=@IdEvaluationPlan

 	SET NOCOUNT OFF
END
GO
PRINT N'Altering [dbo].[GetInteractionsResult]...';


GO
ALTER PROCEDURE [dbo].[GetInteractionsResult]
(
	@VCC				VARCHAR(50),
	@ProcessId			VARCHAR(50),
	@Channels			VARCHAR(100)
)
AS
BEGIN
	SET NOCOUNT ON
	
	-- SELECCIONAMOS UN QUERY DEPENDIENDO DEL CANAL
	IF @Channels = 'CALL' 
	BEGIN
		-- HACEMOS LA BUSQUEDA PARA LAS INTERACCIONES SINCRONAS(CALL)
		SELECT 'CALL'																'interactionType', 
				COUNT(DISTINCT CONCAT(A.[ID], '_', A.[Section], '_', A.[Part]))		'quantity',
				ISNULL(SUM(A.[DurationTime]), 0)									'timeQuantity',
				COUNT(DISTINCT A.[ID])												'totalSyncInteractions'
				--COUNT(DISTINCT A.[ID])												'timeQuantity'
			FROM [dbo].[Process] P (NOLOCK)
			LEFT JOIN [dbo].[ProcessAudio] PA (NOLOCK)
				ON PA.[ProcessId] = P.[Name]
			LEFT JOIN [dbo].[Audio] A (NOLOCK)
				ON A.[ID] = PA.[AudioId]
					AND A.[Section] = PA.[Section]
					AND A.[Part] = PA.[Part]
			WHERE P.[VCC] = @VCC
				AND P.[Name] = @ProcessId
				AND A.[ID] IS NOT NULL

	END
	ELSE 
	BEGIN
		-- HACEMOS LA BUSQUEDA PARA LAS INTERACCIONES SINCRONAS(OTROS CANALES)
		SELECT PAI.[InteractionType]												'interactionType',
				COUNT(DISTINCT CONCAT(PAI.[InteractionId], PAI.[EndDate]))			'totalInteractionDetails',
				COUNT(DISTINCT PAI.[InteractionId])									'totalInteractions'
			FROM [dbo].[ProcessAsyncInteraction] PAI (NOLOCK) 
			WHERE PAI.[VCC] = @VCC 
				AND PAI.[ProcessId] = @ProcessId
				AND PAI.[InteractionType] IN (SELECT VALUE FROM [dbo].[split](@Channels, ','))
			GROUP BY PAI.[InteractionType]
	END

	/* -- ESTA FUNCION RETORNA SOLO EL TOTAL Y TIEMPO DE LOS AUDIOS QUE NO HAN SIDO TRANSCRITOS
	SELECT
		COUNT(PA.[AudioId])						'interactionsTotal',
		ISNULL(SUM(A.[DurationTime]), 0)		'timeInSeconds'
	FROM ProcessAudio PA (NOLOCK)
	INNER JOIN Audio A (NOLOCK) 
		ON CONCAT(PA.[AudioId], '_', PA.[Section], '_', PA.[Part]) = CONCAT(A.[ID], '_', A.[Section], '_', A.[Part]) 
			AND PA.[VCC] = A.[VCC]
	WHERE
		PA.[VCC] = @VCC
		AND [ProcessId] = @ProcessId
		AND A.[IsTranscribed] IS NULL
	*/
	SET NOCOUNT OFF
END
GO
PRINT N'Creating [dbo].[SaveSpeechAnalyticAuditorUser]...';


GO
CREATE PROCEDURE [dbo].[SaveSpeechAnalyticAuditorUser] (
	@VCC Varchar(50) = NULL
) AS
BEGIN
    SET NOCOUNT ON

	-- DECLARAMOS UN FLAG PARA INDICAR SI EXISTE EL USUARIO SPEECH
	DECLARE @SPEECH_EXISTS BIT = 0
	
	-- VERIFICAMOS SI EL USUARIO SPEECH EXISTE EN EL VCC INGRESADO
	IF EXISTS (
		SELECT 1
			FROM [dbo].[User] U (NOLOCK)
			WHERE U.[VCC] = @VCC
				AND U.[ID] = 'speech'
	)
		SET @SPEECH_EXISTS = 1

	-- VALIDAMOS EL VALOR DEL FLAG
	IF @SPEECH_EXISTS = 0
	BEGIN
		-- INSERTAMOS EL USUARIO SPEECH EN EL VCC
		INSERT [dbo].[User] (
			[VCC], [ID], [Email], [Firstname], [Lastname], 
			[Password], [Role], [Country], [Language], [TimeZone], 
			[Preferences], [IsSystemUser], [LimitClients], [CreatedDate], [CreatedByUserId], 
			[LastModifiedDate], [LastModifiedByUserId], [TimeStamp]
		) VALUES (
			@VCC, N'speech', N'speech@inconcertcc.com', N'SPEECH', N'ANALYTIC', 
			N'289128e9a91391c0198705308a88ea5c', N'quality_auditor', N'PE', N'es', N'America/Mexico_City', N'{}', 
			1, 1, CAST(N'2016-08-09T17:36:45.647' AS DateTime), N'admin', GETUTCDATE(), 
			N'admin', GETUTCDATE()
		)
	END

	-- RETORNAMOS UN VALOR PARA EL RESULTADO
	SELECT 1 'result'

	SET NOCOUNT OFF
END
GO
PRINT N'Refreshing [dbo].[DeleteEvaluationPlan]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[DeleteEvaluationPlan]';


GO
PRINT N'Refreshing [dbo].[DeleteEvaluationResults]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[DeleteEvaluationResults]';


GO
PRINT N'Refreshing [dbo].[GetAgentQualificationAverage]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[GetAgentQualificationAverage]';


GO
PRINT N'Refreshing [dbo].[GetAverageGroupRating]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[GetAverageGroupRating]';


GO
PRINT N'Refreshing [dbo].[GetCampaignFulfillment]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[GetCampaignFulfillment]';


GO
PRINT N'Refreshing [dbo].[GetCampaignQualificationAverage]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[GetCampaignQualificationAverage]';


GO
PRINT N'Refreshing [dbo].[GetEvaluationFormatQualificationAverage]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[GetEvaluationFormatQualificationAverage]';


GO
PRINT N'Refreshing [dbo].[GetEvaluationsOfInteraction]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[GetEvaluationsOfInteraction]';


GO
PRINT N'Refreshing [dbo].[GetEvaluationTypesInteraction]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[GetEvaluationTypesInteraction]';


GO
PRINT N'Refreshing [dbo].[GetInteractionsByType]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[GetInteractionsByType]';


GO
PRINT N'Refreshing [dbo].[GetReportByDetailAgent]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[GetReportByDetailAgent]';


GO
PRINT N'Refreshing [dbo].[GetReportBySummaryAgent]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[GetReportBySummaryAgent]';


GO
PRINT N'Refreshing [dbo].[GetTopAgents]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[GetTopAgents]';


GO
PRINT N'Refreshing [dbo].[ReportAuditsByAgent]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[ReportAuditsByAgent]';


GO
PRINT N'Refreshing [dbo].[ReportByDetailAgent]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[ReportByDetailAgent]';


GO
PRINT N'Refreshing [dbo].[ReportBySummaryAgent]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[ReportBySummaryAgent]';


GO
PRINT N'Refreshing [dbo].[ReportBySummaryFormat]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[ReportBySummaryFormat]';


GO
PRINT N'Refreshing [dbo].[ReportTestEvaluationResult]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[ReportTestEvaluationResult]';


GO
PRINT N'Update complete.';


GO
