PRINT N'Altering [dbo].[GetAllegroBillingInteractions]...';


GO
-- ESTE SP RETORNA UN RESUMEN DE LA BUSQUEDA DE INTERACCIONES DE ALLEGRO PARA INDETIFICAR LOS YA TRANSCRITOS O INPROCESS SEGUN LOS FILTROS RECIBIDOS 
-- FUNCIONA IGUAL QUE LA FUNCION EN KNEX
ALTER PROCEDURE [dbo].[GetAllegroBillingInteractions] (
   	@VCC VARCHAR(50) = NULL,
	@IP VARCHAR(50), 
	@Type INT,
	@SecondsPerRequest DECIMAL(18, 5),
   	@StartDate DATETIME = '1980-01-01T00:00:00',
    @EndDate DATETIME = '2050-01-01T23:59:59',
	@Campaigns VARCHAR(MAX) = '',
 	@Agents VARCHAR(MAX) = '',
   	@Origins VARCHAR(100) = NULL,
	@StartHour VARCHAR(50) = NULL,
	@EndHour VARCHAR(50) = NULL,
	@MinDuration INT = 0,
    @MaxDuration INT = 100000,
    @Results VARCHAR(MAX) = NULL,
	@Formats VARCHAR(50) = NULL
)
AS 
BEGIN 
	-- SETTEAMOS VALORES MINIMOS PARA LAS HORAS DE INICIO Y FIN
	IF (@StartHour IS NOT NULL AND @StartHour = '') SET @StartHour = '00:00:00'
	IF (@EndHour IS NOT NULL AND @EndHour = '') SET @EndHour = '23:59:59'

	-- DECLARAMOASUN CADENA PARA EL QUERY FINAL
	DECLARE @SQL_SELECT_0 VARCHAR(MAX) = ''
	DECLARE @SQL_SELECT_1 VARCHAR(MAX) = ''
	DECLARE @SQL_FROM VARCHAR(MAX) = ''
	DECLARE @SQL_FILTER VARCHAR(MAX) = ''
	DECLARE @SQL_EXTRA VARCHAR(MAX) = ''
	
	-- DECLARAMOS VARIABLES PARA NOS NOMBRES DE LAS TABLAS
	DECLARE @INTERACTION_DETAIL_TABLE NVARCHAR(100)
	DECLARE @INTERACTION_ACTOR_DETAIL_TABLE NVARCHAR(100)
	DECLARE @INTERACTION_MULTIMEDIA_PARTS_TABLE NVARCHAR(100)
	DECLARE @CAMPAIGN_GOAL_RESULT_MANAGEMENT_TABLE NVARCHAR(100)

	-- SETTEAMOS LOS VALORES DE DURACION MINIMA Y MAXIMA A UNO VALIDO
	IF @MinDuration = @MaxDuration AND @MaxDuration = 0 SET @MaxDuration = 100000
	IF @MinDuration IS NULL SET @MinDuration = 0
	IF @MaxDuration IS NULL SET @MaxDuration = 100000

	-- EL PARAMETRO TYPE DEFINE SI LA BD ALLEGRO SE ENCUENTRA LOCAL O REMOTO
	IF (@Type = 0)  
	BEGIN  
		SET @INTERACTION_DETAIL_TABLE = '[' + @Ip + ']' + '.HistoricalData.dbo.[InteractionDetail]'
		SET @INTERACTION_ACTOR_DETAIL_TABLE = '[' + @Ip + ']' + '.HistoricalData.dbo.[InteractionActorDetail]'
		SET @INTERACTION_MULTIMEDIA_PARTS_TABLE = '[' + @Ip + ']' + '.HistoricalData.dbo.[InteractionMultimediaParts]'
		SET @CAMPAIGN_GOAL_RESULT_MANAGEMENT_TABLE = '[' + @Ip + ']' + '.mmprodat.dbo.[CampaignGoalResultManagement]'
	END
	ELSE IF(@Type = 1) 
	BEGIN
		SET @INTERACTION_DETAIL_TABLE = 'HistoricalData.dbo.[InteractionDetail]';
		SET @INTERACTION_ACTOR_DETAIL_TABLE = 'HistoricalData.dbo.[InteractionActorDetail]'
		SET @INTERACTION_MULTIMEDIA_PARTS_TABLE = 'HistoricalData.dbo.[InteractionMultimediaParts]';
		SET @CAMPAIGN_GOAL_RESULT_MANAGEMENT_TABLE = 'mmprodat.dbo.[CampaignGoalResultManagement]';
	END  

	-- ARMAMOS EL QUERY PARA HACER LA CONSULTA
	SET @SQL_SELECT_1 += '
		SELECT '

	SET @SQL_SELECT_1 += '
				ID.[Id] + ''_'' + CONVERT(VARCHAR(10), IMP.[Section]) + ''_'' + CONVERT(VARCHAR(10), IMP.Part)			''ID'',
				ID.[Id]																									''InteractionId'',
				A.[IsProcess],
				A.[IsCancel],
				A.[IsTranscribed],
				A.[TotalPhrases],
				ID.[AttentionTime],
				RN = ROW_NUMBER() OVER(PARTITION BY (ID.[Id] + ''_'' + CONVERT(VARCHAR(10), IMP.[Section]) + ''_'' + CONVERT(VARCHAR(10), IMP.Part)) ORDER BY ID.[Id])
			'
				
	-- ARMAMOS LA PARTE DE TABLAS 
	SET @SQL_FROM += '
			FROM ' + @INTERACTION_MULTIMEDIA_PARTS_TABLE + ' IMP (NOLOCK)
			LEFT JOIN ' + @INTERACTION_DETAIL_TABLE + ' ID (NOLOCK) 
				ON ID.[Id] = IMP.[Id]
			LEFT JOIN ' + @INTERACTION_ACTOR_DETAIL_TABLE + ' IAD (NOLOCK) 
				ON IAD.[Id] = ID.[id]
			LEFT JOIN (
				SELECT VCC, CampaignID, [Order], [Code], 
								[Description], Category1, Category2, Category3 
					FROM ' + @CAMPAIGN_GOAL_RESULT_MANAGEMENT_TABLE + ' (NOLOCK)
					WHERE VCC = ''' + @VCC + '''
			) CGRM  
				ON CGRM.VCC = ID.VirtualCC 
					AND CGRM.CampaignId = ID.Campaign 
					AND CGRM.[Description] = ID.ManagementResult
			LEFT JOIN [dbo].[Audio] A (NOLOCK) 
				ON A.[ID] = ID.[Id]
					AND A.[Section] = IMP.[Section]
					AND A.[Part] = IMP.[Part] 
			'

	-- ARMAMOS LA PARTE DE FILTROS
	SET @SQL_FILTER += '
			WHERE ID.[VirtualCC] = ''' + @VCC + '''
				AND ID.[Id] IS NOT NULL 
				AND ID.[EndDate] BETWEEN ''' + (SELECT CONVERT(VARCHAR(21), @StartDate, 127)) + ''' AND ''' + (SELECT CONVERT(VARCHAR(21), @EndDate, 127)) + ''' 
				AND ID.[AttentionTime] BETWEEN ' + (SELECT CONVERT(VARCHAR(10), @MinDuration)) + ' AND ' + (SELECT CONVERT(VARCHAR(10), @MaxDuration)) + ' 
				'
	
	-- CONTINUAMOS CON LOS DEMAS FILTROS RECIBIDOS
	IF (@Campaigns IS NOT NULL AND @Campaigns != '') SET @SQL_FILTER += 'AND ID.[Campaign] IN (SELECT Value FROM [dbo].[split](''' + @Campaigns + ''','','')) '
	IF (@Agents IS NOT NULL AND @Agents != '') SET @SQL_FILTER += 'AND IAD.[Actor] IN (SELECT Value FROM [dbo].[split](''' + @Agents + ''','','')) '
	IF (@Origins IS NOT NULL AND @Origins != '') SET @SQL_FILTER += 'AND ID.[Direction] IN (SELECT Value FROM [dbo].[split](''' + @Origins + ''','','')) '
	IF (@Results IS NOT NULL AND @Results != '') 
		/*SET @SQL_FILTER += 'AND (
								(ID.[ManagementResult] IN (SELECT Value FROM [dbo].[split](''' + @Results + ''','','')))
								OR 
								() 
							) '*/
		SET @SQL_FILTER += 'AND (
									(CONCAT(ID.Campaign, ''_'', ISNULL(CONVERT(VARCHAR(4), CGRM.[Code]), '''')) IN (SELECT Value FROM [dbo].[split](''' + @Results + ''','','')))
									OR
									(ID.[ManagementResult] IN (SELECT Value FROM [dbo].[split](''' + @Results + ''','',''))) 
								) '
	IF (@Formats IS NOT NULL AND @Formats != '') SET @SQL_FILTER += 'AND IMP.[Format] IN (SELECT Value FROM [dbo].[split](''' + @Formats + ''','','')) ';
	
	-- PARA EL CASO EN QUE HORA DE INICIO Y FIN NO SEAN NULL
	IF @StartHour IS NOT NULL AND @EndHour IS NOT NULL
	BEGIN
		IF (CAST(@StartHour AS TIME) <= CAST(@EndHour AS TIME)) 
			SET @SQL_FILTER += 'AND CAST(ID.[EndDate] AS TIME) BETWEEN ''' + @StartHour + ''' AND ''' + @EndHour + ''' '
		IF (CAST(@StartHour AS TIME) > CAST(@EndHour AS TIME)) 
			SET @SQL_FILTER += 'AND CAST(ID.[EndDate] AS TIME) NOT BETWEEN ''' + @EndHour + ''' AND ''' + @StartHour + ''' '
	END
	-- PARA EL CASO EN QUE HORA DE INICIO NO SEA NULL Y FIN SEA NULL
	ELSE IF @StartHour IS NOT NULL AND @EndHour IS NULL
	BEGIN
		SET @SQL_FILTER += 'AND CAST(ID.[EndDate] AS TIME) > ''' + @StartHour + ''' '
	END
	-- PARA EL CASO EN QUE HORA DE INICIO SEA NULL Y FIN NO SEA NULL
	ELSE IF @StartHour IS NULL AND @EndHour IS NOT NULL
	BEGIN
		SET @SQL_FILTER += 'AND CAST(ID.[EndDate] AS TIME) < ''' + @EndHour + ''' '
	END
	
	-- UNIMOS LAS PARTES DEL QUERY
	SET @SQL_SELECT_1 += @SQL_FROM + @SQL_FILTER + @SQL_EXTRA

	-- VERIFICAMOS SI EXISTE LA TABLA TEMPORAL #TMP_HD_INTERACTIONS
	IF OBJECT_ID('TEMPDB..#TMP_HD_BILLING_INTERACTIONS') IS NULL
	BEGIN
		-- CREAMOS UNA TABLA TEMPORAL PARA INSERTAR LOS REGISTROS DE LA HDI6
		CREATE TABLE #TMP_HD_BILLING_INTERACTIONS
		(
			[ID] VARCHAR(150),
			[InteractionId] VARCHAR(100),
			[IsProcess] BIT,
			[IsCancel] BIT,
			[IsTranscribed] BIT,
			[TotalPhrases] DECIMAL(18, 5),
			[AttentionTime] DECIMAL(18, 5),
			RN INT
		)
	END

	-- EJECUTAMOS EL QUERY Y DEPOSITAMOS EL RESULTADO EN UNA TABLA TEMPORAL
	INSERT INTO #TMP_HD_BILLING_INTERACTIONS
		-- EJECUTAMOS LA CONSULTA
		EXEC (@SQL_SELECT_1)

	-- select * from #TMP_HD_BILLING_INTERACTIONS
		
	-- HACEMOS EL SELECT A LA TABLA TEMPORAL
	SELECT SUM(CASE WHEN A.[IsTranscribed] = 1 THEN 1 ELSE 0 END)									'alreadyTranscribedAudio',
			SUM(CASE WHEN A.[IsTranscribed] = 1 THEN A.[AttentionTime] ELSE 0 END)					'alreadyTranscribedDurationTime',
			SUM(CASE WHEN (A.[IsProcess] = 1 
							AND A.[IsTranscribed] IS NULL 
							AND A.[IsCancel] IS NULL) 
						THEN 1 ELSE 0 END)															'inProcessAudio',
			SUM(CASE WHEN (A.[IsProcess] = 1 
							AND A.[IsTranscribed] IS NULL 
							AND A.[IsCancel] IS NULL) 
						THEN A.[AttentionTime] ELSE 0 END)											'inProcessDurationTime',
			SUM(CASE WHEN (A.[IsProcess] IS NULL 
							OR (A.[IsProcess] = 1 
								AND A.[IsCancel] = 1)) 
						THEN 1 ELSE 0 END)															'notTranscribedAudio',
			SUM(CASE WHEN (A.[IsProcess] IS NULL 
							OR (A.[IsProcess] = 1 
								AND A.[IsCancel] = 1)) 
						THEN A.[AttentionTime] ELSE 0 END)											'notTranscribedDurationTime',
			SUM(CASE WHEN A.[IsTranscribed] = 1 
							AND A.[TotalPhrases] IS NOT NULL
						THEN A.[TotalPhrases] ELSE 0 END)											'totalPhrases',
			SUM(CASE WHEN (A.[IsProcess] IS NULL 
							OR (A.[IsProcess] = 1 
								AND A.[IsCancel] = 1)
							OR (A.[TotalPhrases] IS NULL)) 
						THEN (A.[AttentionTime] / @SecondsPerRequest) ELSE 0 END)					'totalRawPhrases',
			SUM(A.[AttentionTime] / @SecondsPerRequest)												'averageModelRequest' 
		FROM #TMP_HD_BILLING_INTERACTIONS A
		WHERE A.RN = 1

	-- ELIMINAMOS LA TABLA TEMPORARL
	DROP TABLE #TMP_HD_BILLING_INTERACTIONS

	-- EJECUTAMOS LA CONSULTA
	-- EXEC (@SQL_SELECT_1)

END
GO
PRINT N'Altering [dbo].[GetAllegroBillingInteractionsForEvaluationPlan]...';


GO
-- ESTE SCRIPT TIENE POR FINALIDAD RETORNAR UN RESUMEN DE LOS AUDIOS EN EL PROCESSID INPUT QUE YA EXISTEN EN UN PROCESSID ANTERIOR
-- DEBIDO A QUE PLANES CREAN EL PROCESS Y EL EVALUATION_PLAN EN DIFERENTES ENDPOINTS, DEJARA DE SER NECESARIO SI SE INTEGRA EL 
-- GUARDADO DE PLAN DE EVALUACION
ALTER PROCEDURE [dbo].[GetAllegroBillingInteractionsForEvaluationPlan] (
	@VCC VARCHAR(50) = NULL,
	@ProcessId VARCHAR(50) = NULL,
	@SecondsPerRequest DECIMAL(18, 5) = NULL
)
AS 
BEGIN 
	-- CREAMOS UNA VARIEBLE PARA ALMACENAR LA FECHA DE CREACION DEL PROCESS INPUT
	--DECLARE @vcc VARCHAR(50) = 'allegro'
	--DECLARE @ProcessId VARCHAR(50) = '3EU91680-UB6U-3GT5-8T50-73474D13WVB8'
	DECLARE @PROCESS_CREATED_DATE DATETIME = NULL

	-- RECUPERAMOS LA FECHA DE CREACION DEL PROCESS INPUT
	SELECT @PROCESS_CREATED_DATE = P.[CreatedDate] 
		FROM [dbo].[Process] P (NOLOCK) 
		WHERE P.[VCC] = @vcc
			AND P.[Name] = @processId;

	-- CREAMOS LAS CTE QUE USAREMOS PARA RECUPERAR EL HISTORICO DE LOS AUDIOS DEL PROCESS INPUT
	WITH CTE_PROCESS_AUDIO AS (
		-- RECUPERAMOS LOS AUDIOS DEL PROCESS INPUT
		SELECT PA.[AudioId],
				PA.[Section],
				PA.[Part]
			FROM [dbo].[ProcessAudio] PA (NOLOCK) 
			WHERE PA.[VCC] = @vcc
				AND PA.[ProcessId] = @processId
	), CTE_PROCESS_AUDIO_2 AS (
		-- CON LA PRIMERA CTE, RECUPERAMOSEL DETALLE DE LOS AUDIOS Y LA CANTIDAD DE VECES QUE SE REPITE EN PROCESS ANTERIORES
		SELECT PA.[AudioId],
				PA.[Section],
				PA.[Part],
				COUNT(*) 'Times' 
			FROM CTE_PROCESS_AUDIO CPA
			LEFT JOIN [dbo].[ProcessAudio] PA (NOLOCK) 
				ON PA.[AudioId] = CPA.[AudioId]
					AND PA.[Section] = CPA.[Section]
					AND PA.[Part] = CPA.[Part]
			WHERE PA.[VCC] = @vcc
				AND PA.[CreatedDate] < @PROCESS_CREATED_DATE
			GROUP BY PA.[AudioId], PA.[Section], PA.[Part]
	), CTE_PROCESS_AUDIO_3 AS (
		-- ARMAMOS UNA CTE CON TODOS LOS AUDIOS QUE SE REPITEN Y EL DETALLE DE CADA AUDIO
		SELECT CPA2.[AudioId],
				CPA2.[Section],
				CPA2.[Part],
				A.[DurationTime],
				A.[DurationLinguisticTime],
				A.[IsProcess],
				A.[IsCancel],
				A.[IsTranscribed],
				A.[TotalPhrases]
			FROM CTE_PROCESS_AUDIO_2 CPA2
			LEFT JOIN [dbo].[Audio] A
				ON A.[ID] = CPA2.[AudioId]
					AND A.[Section] = CPA2.[Section]
					AND A.[Part] = CPA2.[Part]
			WHERE A.[VCC] = @vcc
				AND CPA2.[Times] > 0
	)

	SELECT SUM(CASE WHEN PA3.[IsTranscribed] = 1 THEN 1 ELSE 0 END)							'alreadyTranscribedAudio', 
			SUM(CASE WHEN PA3.[IsTranscribed] = 1 THEN PA3.[DurationTime] ELSE 0 END)		'alreadyTranscribedDurationTime',
			SUM(CASE WHEN PA3.[IsTranscribed] IS NULL 
							AND PA3.[IsCancel] IS NULL 
						THEN 1 ELSE 0 END)													'inProcessAudio', 
			SUM(CASE WHEN PA3.[IsTranscribed] IS NULL 
							AND PA3.[IsCancel] IS NULL 
						THEN PA3.[DurationTime] ELSE 0 END)									'inProcessDurationTime', 
			SUM(CASE WHEN PA3.[IsCancel] = 1 THEN 1 ELSE 0 END)								'canceledAudio', 
			SUM(CASE WHEN PA3.[IsCancel] = 1 THEN PA3.[DurationTime] ELSE 0 END)			'canceledDurationTime',
			SUM(CASE WHEN PA3.[IsTranscribed] = 1 
							AND PA3.[TotalPhrases] IS NOT NULL
						THEN PA3.[TotalPhrases] ELSE 0 END)									'totalPhrases',
			SUM(CASE WHEN PA3.[TotalPhrases] IS NULL 
						THEN (PA3.[DurationTime] / @SecondsPerRequest) ELSE 0 END)			'averageModelRequest' 
		FROM CTE_PROCESS_AUDIO_3 PA3 
	--SELECT * FROM CTE_PROCESS_AUDIO_4
END
GO
PRINT N'Altering [dbo].[GetAsyncBillingInteractions]...';


GO
-- ESTE SP RETORNA UN RESUMEN DE LA BUSQUEDA DE INTERACCIONES DE ALLEGRO PARA INDETIFICAR LOS YA TRANSCRITOS O INPROCESS SEGUN LOS FILTROS RECIBIDOS 
-- FUNCIONA IGUAL QUE LA FUNCION EN KNEX
ALTER PROCEDURE [dbo].[GetAsyncBillingInteractions] (
   	@VCC					VARCHAR(50) = NULL,
	@IP						VARCHAR(50),						-- IP DEL SERVIDOR PARA LA BASE I6
	@Type					INT,								-- FLAG PARA INDICAR SI EL SERVIDOR I6 SE ENCUENTRA LOCAL O REMOTO
	@InteractionType		VARCHAR(50) = NULL,
	@StartDate				DATETIME = '1980-01-01T00:00:00',
    @EndDate				DATETIME = '2050-01-01T23:59:59',
	@StartHour				VARCHAR(50) = NULL,
	@EndHour				VARCHAR(50) = NULL,
	@Campaigns				VARCHAR(MAX) = NULL,
 	@Agents					VARCHAR(MAX) = NULL,
   	@DispositionCodes		VARCHAR(MAX) = NULL,
   	@Origins				VARCHAR(100) = NULL,
	@CharsPerPhrase			INT = 0
)
AS 
BEGIN 
	-- SETTEAMOS VALORES MINIMOS PARA LAS HORAS DE INICIO Y FIN
	IF (@StartHour IS NOT NULL AND @StartHour = '') SET @StartHour = '00:00:00'
	IF (@EndHour IS NOT NULL AND @EndHour = '') SET @EndHour = '23:59:59'

	-- CREAMOS UNA TABLA TEMPORAL PARA INSERTAR LOS REGISTROS DE LA HDI6
	CREATE TABLE #TMP_HD_INTERACTIONS
	(
		vcc VARCHAR(50), 
		id VARCHAR(250), 
		folder VARCHAR(50),
		exportedContent VARCHAR(250),  
		channel VARCHAR(50), 
		campaign VARCHAR(50), 
		startDate DATETIME,
		endDate DATETIME,
		account VARCHAR(50), 
		initiative VARCHAR(50), 
		contactName VARCHAR(250), 
		firstTakedAgent VARCHAR(50), 
		lastTakedAgent VARCHAR(50), 
		isTaken VARCHAR(50), 
		totalMessages INT,
		durationTime VARCHAR(50),  
		attentionTime VARCHAR(50), 
		dispositionCode VARCHAR(250), 
		dispositionTreePath VARCHAR(250), 
		rawChar INT,
		RN INT
	)

	-- EJECUTAMOS EL SP DE CONSULTA QUE LLENARA LA TABLA TEMPORAL
	EXEC [dbo].[GetAsyncInteractions]
		@Ip = @IP, @VCC = @VCC, @Type = @Type, @InteractionType = @InteractionType, @StartDate = @StartDate, 
		@EndDate = @EndDate, @StartHour = @StartHour, @EndHour = @EndHour, @Campaigns = @Campaigns, @Agents = @Agents,
		@DispositionCodes = @DispositionCodes, @Origins = @Origins, @UniqueIds = 0, @ResultType = 'DETAILED'

	-- DECLARAMOS UNA VARIABLE PARA PARA EL TOTALDE RESULTADOS
	DECLARE @TOTAL_INTERACTIONS INT = 0

	-- SETTEAMOS EL NUMERO DE REGISTROS A LA VARIABLE DE TOTAL
	SELECT @TOTAL_INTERACTIONS = COUNT(*) FROM #TMP_HD_INTERACTIONS
	
	IF @TOTAL_INTERACTIONS = 0 
	BEGIN
		-- SI NO EXISTEN RESULTADOS EN HD LLENAMOSUN RESULTADOS CON 0
		SELECT @InteractionType												'interactionType',
				0															'totalInteractionDetails',
				0															'alreadyTranscribedInteraction',
				0															'inProcessInteraction',
				0															'notTranscribedInteraction',
				0															'totalPhrases',
				0															'totalRawChars',
				0															'totalRawPhrases'
	END 
	ELSE
	BEGIN
		-- CRUZAMOS LA TABLA TEMPORAL DE INTERACCIONES ASINCRONAS CON LA TABLA LOCAL INTERACTION PARA LAS INTERACCIONES ASINCRONAS YA REGISTRADAS
		SELECT HDI.[channel]												'interactionType',
				COUNT(*)													'totalInteractionDetails',
				SUM(CASE WHEN (AI.[VCC] IS NOT NULL 
					AND AI.[IsTranscribed] = 1) THEN 1 ELSE 0 END)			'alreadyTranscribedInteraction',
				0															'inProcessInteraction',
				SUM(CASE WHEN (AI.[VCC] IS NULL 
					OR AI.[IsTranscribed] <> 1) THEN 1 ELSE 0 END)			'notTranscribedInteraction',
				SUM(ISNULL(AI.[TotalPhrases], 0))							'totalPhrases',
				-- CUANDO TENEMOS VALIDPHRASES, YA NO CONTAMOS LAS RAWCHAR 
				SUM(
					CASE WHEN (AI.[TotalPhrases] IS NULL 
							OR AI.[TotalPhrases] = 0)
					THEN (
						ISNULL(AI.[RawChar], ISNULL(HDI.[rawChar], 0))
					)
					ELSE 0 END
				)															'totalRawChars',
				SUM(
					CASE WHEN (AI.[TotalPhrases] IS NULL 
							OR AI.[TotalPhrases] = 0)
					THEN (
						-- SI RAWCHAR ES NULL, SE DEBE VALUAR COMO MINIMO 1 FRASE(@CharsPerPhrase)
						-- CEILING(ISNULL(AI.[RawChar], ISNULL(HDI.[rawChar], @CharsPerPhrase)) * 1.00 / @CharsPerPhrase)
						CEILING(ISNULL(AI.[RawChar], ISNULL(HDI.[rawChar], 0)) * 1.00 / @CharsPerPhrase)
					)
					ELSE 0 END
				)															'totalRawPhrases'
			FROM #TMP_HD_INTERACTIONS HDI (NOLOCK)
			LEFT JOIN [dbo].[AsyncInteraction] AI (NOLOCK)
				ON HDI.[vcc] = AI.[VCC]
					AND HDI.[channel] = AI.[Channel]
					AND HDI.[campaign] = AI.[Campaign]
					AND HDI.[id] = AI.[ID]
					AND HDI.[endDate] = AI.[EndDate]
			GROUP BY HDI.[vcc],
						HDI.[channel]
			--ORDER BY AI.[TotalPhrases], AI.[RawChar] DESC, HDI.[RawChar] DESC

	END

END
GO
PRINT N'Altering [dbo].[GetProcessInteractionsByProcessId]...';


GO
ALTER PROCEDURE [dbo].[GetProcessInteractionsByProcessId]
(
	@VCC		VARCHAR(50) = NULL,
	@ProcessId	VARCHAR(50) = NULL,
	@ResultType VARCHAR(50) = NULL
)
AS
BEGIN
	SET NOCOUNT ON

	-- ESTA FUNCION RETORNA LAS INTERACCIONES DE TEXTO Y AUDIO RELACIONADA A UN PROCESS

	IF @ResultType = 'RAW' 
	BEGIN
		-- RESULTADO TIPO RAW GENERA UN RESULTADO CON LOS DATOS Y NOMBRES DE COLUMNAS COMO VIENEN DE HD

		SELECT CONCAT(A.[ID], '_', A.[Section], '_', A.[PArt])				'ID',
				A.[ID]														'InteractionId',
				A.[Section]													'Section',
				A.[Part]													'Part',
				'CALL'														'Channel',
				A.[Number]													'Number',
				A.[Gender]													'Gender',
				A.[SilenceTime]												'Silence',
				A.[DurationTime]											'DurationTime',
				A.[DurationTime]											'AtentionTime',
				A.[Category1]												'Category1',
				A.[Category2]												'Category2',
				A.[Category3]												'Category3',
				A.[Description]												'Description',
				A.[DispositionCode]											'DispositionCode',
				A.[Campaign]												'Campaign',
				A.[Agent]													'Agent',
				A.[Number]													'contactName',
				A.[Type]													'Type',
				A.[StartDate]												'StartDate',
				A.[EndDate]													'EndDate',
				NULL														'Format',
				A.[ValidChar]												'validChar',
				A.[TotalPhrases]											'totalPhrases'
			FROM [dbo].[ProcessAudio] PA (NOLOCK)
			INNER JOIN [dbo].[Audio] A (NOLOCK)
				ON A.[ID] = PA.[AudioId]
					AND A.[Section] = PA.[Section]
					AND A.[Part] = PA.[Part]
			WHERE PA.[VCC] = @VCC
				AND PA.[ProcessId] = @ProcessId
				

		SELECT PAI.[VCC]								'vcc', 
				PAI.[InteractionId]						'id', 
				PAI.[FormattedEndDate]					'folder',
				AI.[ExportedContent]					'exportedContent',
				PAI.[InteractionType]					'channel',
				PAI.[Campaign]							'campaign',
				AI.[StartDate]							'startDate',
				AI.[EndDate]							'endDate',
				AI.[Account]							'account',
				AI.[Initiative]							'initiative',
				AI.[ContactName]						'contactName',
				AI.[FirstTakedAgent]					'firstTakedAgent',
				AI.[LastTakedAgent]						'lastTakedAgent', 
				AI.[IsTaken]							'isTaken',
				AI.[TotalMessages]						'totalMessages',
				AI.[DurationTime]						'durationTime',
				AI.[AttentionTime]						'attentionTime',
				AI.[DispositionCode]					'dispositionCode',
				AI.[DispositionTreePath]				'dispositionTreePath',
				CASE WHEN AI.[TotalPhrases] IS NULL 
					THEN AI.[RawChar] ELSE 0 END		'rawChar',
				ISNULL(AI.[TotalPhrases], 0)			'totalPhrases'
			FROM [dbo].[ProcessAsyncInteraction] PAI (NOLOCK)
			INNER JOIN [dbo].[AsyncInteraction] AI (NOLOCK)
				ON AI.[VCC] = PAI.[VCC]
					AND AI.[ID] = PAI.[InteractionId]
					AND AI.[Channel] = PAI.[InteractionType]
					AND AI.[Folder] = PAI.[FormattedEndDate]
			WHERE PAI.[VCC] = @VCC
				AND PAI.[ProcessId] = @ProcessId
				
	END

	SET NOCOUNT OFF
END
GO
PRINT N'Altering [dbo].[GetProcessInteractionsHistory]...';


GO
ALTER PROCEDURE [dbo].[GetProcessInteractionsHistory](
	@VCC		VARCHAR(50),
	@ProcessId	VARCHAR(50),
	@SecondsPerRequest DECIMAL(18, 5) = 1
) AS
BEGIN
	SET NOCOUNT ON

	BEGIN

		-- RECUPERAMOS LA INFORMACION DE LOS AUDIOS DEL PROCESS QUE YA HAN SIDO TRANSCRITOS 
		SELECT 'CALL'																															'interactionType',
				COUNT(*)																														'totalAudio',
				SUM(CASE WHEN A.[IsTranscribed] = 1 THEN 1 ELSE 0 END)																			'alreadyTranscribedAudio',
				SUM(CASE WHEN A.[IsCancel] = 1 THEN 1 ELSE 0 END)																				'alreadyCanceledAudio',
				SUM(CASE WHEN A.[IsTranscribed] = 1 THEN A.[DurationTime] ELSE 0 END)															'alreadyTranscribedDurationTime',
				SUM(CASE WHEN A.[IsTranscribed] = 1 THEN (CEILING(A.[DurationTime] / 60) * 60) ELSE 0 END)										'alreadyTranscribedRoundedDurationTime',
				SUM(CASE WHEN A.[IsTranscribed] = 1 THEN A.[DurationLinguisticTime] ELSE 0 END)													'alreadyTranscribedValidDurationTime',
				SUM(CASE WHEN A.[IsTranscribed] = 1 THEN (CEILING(A.[DurationLinguisticTime] / 60) * 60) ELSE 0 END)							'alreadyTranscribedRoundedValidDurationTime',
				SUM(CASE WHEN (A.[IsProcess] = 1 AND A.[IsTranscribed] IS NULL AND A.[IsCancel] IS NULL) THEN 1 ELSE 0 END)						'inProcessAudio',
				SUM(CASE WHEN (A.[IsProcess] = 1 AND A.[IsTranscribed] IS NULL AND A.[IsCancel] IS NULL) THEN A.[DurationTime] ELSE 0 END)		'inProcessDurationTime',
				SUM(CASE WHEN (A.[IsProcess] IS NULL OR (A.[IsProcess] = 1 AND A.[IsCancel] = 1)) THEN 1 ELSE 0 END)							'notTranscribedAudio',
				SUM(CASE WHEN (A.[IsProcess] IS NULL OR (A.[IsProcess] = 1 AND A.[IsCancel] = 1)) THEN A.[DurationTime] ELSE 0 END)				'notTranscribedDurationTime',
				--SUM(A.[DurationTime] / @SecondsPerRequest)																						'averageModelRequest',
				SUM(CASE WHEN A.[TotalPhrases] IS NULL THEN (A.[DurationTime] / @SecondsPerRequest) ELSE 0 END)									'averageModelRequest',
				ISNULL(SUM(A.[TotalPhrases]), 0)																								'totalCallPhrases',
				0																																'totalTextPhrases'
			FROM [dbo].[ProcessAudio] PA (NOLOCK)
			LEFT JOIN [dbo].[Audio] A (NOLOCK) 
				ON A.[ID] = PA.[AudioId]
					AND A.[Section] = PA.[Section]
					AND A.[Part] = PA.[Part]
			WHERE PA.[VCC] = @VCC
				AND PA.[ProcessID] = @ProcessId
				-- AND A.[IsTranscribed] = 1 
				-- AND ISNULL(A.[IsProcess], 0) = 0

		SELECT PAI.[InteractionType]																											'interactionType',
				COUNT(*)																														'totalAsyncInteraction',
				SUM(CASE WHEN AI.[IsTranscribed] = 1 THEN 1 ELSE 0 END)																			'alreadyTranscribedAsyncInteraction',
				SUM(CASE WHEN AI.[IsCancel] = 1 THEN 1 ELSE 0 END)																				'alreadyCanceledAsyncInteraction',
				SUM(CASE WHEN AI.[IsTranscribed] = 1 THEN AI.[RawChar] ELSE 0 END)																'alreadyTranscribedRawChar',
				SUM(CASE WHEN AI.[IsTranscribed] = 1 THEN AI.[ValidChar] ELSE 0 END)															'alreadyTranscribedValidChar',
				SUM(CASE WHEN (AI.[IsProcess] = 1 AND AI.[IsTranscribed] IS NULL AND AI.[IsCancel] IS NULL) THEN 1 ELSE 0 END)					'inProcessAsyncInteraction',
				SUM(CASE WHEN AI.[IsProcess] = 1 THEN AI.[RawChar] ELSE 0 END)																	'inProcessRawChar',
				SUM(CASE WHEN (AI.[IsProcess] IS NULL OR (AI.[IsProcess] = 1 AND AI.[IsCancel] = 1)) THEN 1 ELSE 0 END)							'notTranscribedAsyncInteraction',
				SUM(CASE WHEN AI.[IsTranscribed] = 1 THEN AI.[RawChar] ELSE 0 END)																'notTranscribedRawChar',
				--SUM(A.[DurationTime] / @SecondsPerRequest)																					'averageModelRequest'
				0																																'averageModelRequest',
				0																																'totalCallPhrases',
				ISNULL(SUM(AI.[TotalPhrases]), 0)																								'totalTextPhrases'
			FROM [dbo].[ProcessAsyncInteraction] PAI (NOLOCK)
			LEFT JOIN [dbo].[AsyncInteraction] AI (NOLOCK)
				ON AI.[Channel] = PAI.[InteractionType]
					AND AI.[ID] = PAI.[InteractionId]
					AND AI.[Folder] = PAI.[FormattedEndDate]
			WHERE PAI.[ProcessId] = @ProcessId
			GROUP BY PAI.[InteractionType]
		
	END

	

	SET NOCOUNT OFF
END
GO

GO
ALTER PROCEDURE [dbo].[GetFinishedBatch] 
AS
BEGIN
	-- ESTE SP TIENE LA FINALIDAD DE RETORNAR LOS BATCH QUE HAN SIDO FINALIZADOS HACE MAS DE 5 MINUTOS
	SET NOCOUNT ON

	SELECT B.[VCC]				'vcc',
		B.[BatchTypeName]		'batchTypeName',
		B.[BatchTypeId]			'batchTypeId',
		B.[ClosedDate]			'closedDate'
	FROM [dbo].[Batch] B (NOLOCK)
	WHERE B.[IsFinished] = 1 
		AND B.[FinishReported] = 0
		AND B.[LastModifiedDate] < DATEADD(MINUTE, -5, GETUTCDATE())

	SET NOCOUNT OFF
END
GO

PRINT N'Update complete.';


GO
