PRINT N'Quitando [dbo].[DF_Audio_Channel]...';


GO
ALTER TABLE [dbo].[Audio] DROP CONSTRAINT [DF_Audio_Channel];


GO
PRINT N'Quitando [dbo].[DF_Audio_Char]...';


GO
ALTER TABLE [dbo].[Audio] DROP CONSTRAINT [DF_Audio_Char];


GO
PRINT N'Quitando [dbo].[DF_Audio_Words]...';


GO
ALTER TABLE [dbo].[Audio] DROP CONSTRAINT [DF_Audio_Words];


GO
PRINT N'Quitando [dbo].[DF_Audio_TotalPhrases]...';


GO
ALTER TABLE [dbo].[Audio] DROP CONSTRAINT [DF_Audio_TotalPhrases];


GO
PRINT N'Quitando [dbo].[DF_Audio_CharsPerPhrase]...';


GO
ALTER TABLE [dbo].[Audio] DROP CONSTRAINT [DF_Audio_CharsPerPhrase];


GO
PRINT N'Iniciando recompilación de la tabla [dbo].[Audio]...';


GO
BEGIN TRANSACTION;

SET TRANSACTION ISOLATION LEVEL SERIALIZABLE;

SET XACT_ABORT ON;

CREATE TABLE [dbo].[tmp_ms_xx_Audio] (
    [VCC]                    VARCHAR (50)    NOT NULL,
    [ID]                     VARCHAR (100)   NOT NULL,
    [Section]                NUMERIC (5)     NOT NULL,
    [Part]                   NUMERIC (5)     NOT NULL,
    [Channel]                VARCHAR (50)    CONSTRAINT [DF_Audio_Channel] DEFAULT ('CALL') NULL,
    [Number]                 VARCHAR (50)    NULL,
    [Gender]                 VARCHAR (50)    NULL,
    [Format]                 VARCHAR (50)    NULL,
    [SilenceTime]            NUMERIC (12, 3) NULL,
    [DurationTime]           NUMERIC (12, 3) NULL,
    [MediaInfoTime]          NUMERIC (12, 3) NULL,
    [DurationLinguisticTime] NUMERIC (12, 3) NULL,
    [IsDiariced]             BIT             NULL,
    [ChannelsChanged]        BIT             NULL,
    [ValidChar]              INT             CONSTRAINT [DF_Audio_Char] DEFAULT ((0)) NULL,
    [ValidWords]             INT             CONSTRAINT [DF_Audio_Words] DEFAULT ((0)) NULL,
    [TotalPhrases]           INT             CONSTRAINT [DF_Audio_TotalPhrases] DEFAULT ((0)) NULL,
    [CharsPerPhrase]         INT             CONSTRAINT [DF_Audio_CharsPerPhrase] DEFAULT ((0)) NULL,
    [Category1]              VARCHAR (100)   NULL,
    [Category2]              VARCHAR (100)   NULL,
    [Category3]              VARCHAR (100)   NULL,
    [Description]            VARCHAR (100)   NULL,
    [Campaign]               VARCHAR (100)   NULL,
    [Agent]                  VARCHAR (50)    NULL,
    [Type]                   VARCHAR (50)    NULL,
    [Init]                   VARCHAR (50)    NULL,
    [IsProcess]              BIT             NULL,
    [IsCancel]               BIT             NULL,
    [IsTranscribed]          INT             NULL,
    [StartDate]              DATETIME        NULL,
    [EndDate]                DATETIME        NULL,
    [DispositionCode]        VARCHAR (50)    NULL,
    [FileName]               VARCHAR (200)   NULL,
    [ErrorMessage]           VARCHAR (MAX)   NULL,
    [CreatedDate]            DATETIME        NULL,
    [CreatedByUserId]        VARCHAR (50)    NULL,
    [LastModifiedDate]       DATETIME        NULL,
    [LastModifiedByUserId]   VARCHAR (50)    NULL,
    [TimeStamp]              DATETIME        NULL,
    CONSTRAINT [tmp_ms_xx_constraint_PK_Audio_11] PRIMARY KEY CLUSTERED ([VCC] ASC, [ID] ASC, [Section] ASC, [Part] ASC)
);

IF EXISTS (SELECT TOP 1 1 
           FROM   [dbo].[Audio])
    BEGIN
        INSERT INTO [dbo].[tmp_ms_xx_Audio] ([VCC], [ID], [Section], [Part], [Channel], [Number], [Gender], [SilenceTime], [DurationTime], [DurationLinguisticTime], [ValidChar], [ValidWords], [TotalPhrases], [CharsPerPhrase], [Category1], [Category2], [Category3], [Description], [Campaign], [Agent], [Type], [Init], [IsProcess], [IsCancel], [IsTranscribed], [StartDate], [EndDate], [DispositionCode], [FileName], [ErrorMessage], [CreatedDate], [CreatedByUserId], [LastModifiedDate], [LastModifiedByUserId], [TimeStamp])
        SELECT   [VCC],
                 [ID],
                 [Section],
                 [Part],
                 [Channel],
                 [Number],
                 [Gender],
                 [SilenceTime],
                 [DurationTime],
                 [DurationLinguisticTime],
                 [ValidChar],
                 [ValidWords],
                 [TotalPhrases],
                 [CharsPerPhrase],
                 [Category1],
                 [Category2],
                 [Category3],
                 [Description],
                 [Campaign],
                 [Agent],
                 [Type],
                 [Init],
                 [IsProcess],
                 [IsCancel],
                 [IsTranscribed],
                 [StartDate],
                 [EndDate],
                 [DispositionCode],
                 [FileName],
                 [ErrorMessage],
                 [CreatedDate],
                 [CreatedByUserId],
                 [LastModifiedDate],
                 [LastModifiedByUserId],
                 [TimeStamp]
        FROM     [dbo].[Audio]
        ORDER BY [VCC] ASC, [ID] ASC, [Section] ASC, [Part] ASC;
    END

DROP TABLE [dbo].[Audio];

EXECUTE sp_rename N'[dbo].[tmp_ms_xx_Audio]', N'Audio';

EXECUTE sp_rename N'[dbo].[tmp_ms_xx_constraint_PK_Audio_11]', N'PK_Audio_1', N'OBJECT';

COMMIT TRANSACTION;

SET TRANSACTION ISOLATION LEVEL READ COMMITTED;


GO
PRINT N'Iniciando recompilación de la tabla [dbo].[NLU]...';


GO
BEGIN TRANSACTION;

SET TRANSACTION ISOLATION LEVEL SERIALIZABLE;

SET XACT_ABORT ON;

CREATE TABLE [dbo].[tmp_ms_xx_NLU] (
    [VCC]                  VARCHAR (50)  NOT NULL,
    [Name]                 VARCHAR (50)  NOT NULL,
    [Culture]              VARCHAR (50)  NULL,
    [Description]          VARCHAR (50)  NULL,
    [AppId]                VARCHAR (100) NULL,
    [SubscriptionKey]      VARCHAR (50)  NULL,
    [IsPublished]          BIT           NULL,
    [LastPublishedDate]    DATETIME      NULL,
    [IsTrained]            BIT           NULL,
    [LastTrainedDate]      DATETIME      NULL,
    [IsSystemApp]          BIT           CONSTRAINT [DF_NLU_IsSystemApp] DEFAULT ((0)) NULL,
    [CreatedDate]          DATETIME      NULL,
    [CreatedByUserId]      VARCHAR (50)  NULL,
    [LastModifiedDate]     DATETIME      NULL,
    [LastModifiedByUserId] VARCHAR (50)  NULL,
    [TimeStamp]            DATETIME      NULL,
    CONSTRAINT [tmp_ms_xx_constraint_PK_NLU1] PRIMARY KEY CLUSTERED ([VCC] ASC, [Name] ASC)
);

IF EXISTS (SELECT TOP 1 1 
           FROM   [dbo].[NLU])
    BEGIN
        INSERT INTO [dbo].[tmp_ms_xx_NLU] ([VCC], [Name], [Culture], [Description], [AppId], [SubscriptionKey], [IsPublished], [LastPublishedDate], [IsTrained], [LastTrainedDate], [CreatedDate], [CreatedByUserId], [LastModifiedDate], [LastModifiedByUserId], [TimeStamp])
        SELECT   [VCC],
                 [Name],
                 [Culture],
                 [Description],
                 [AppId],
                 [SubscriptionKey],
                 [IsPublished],
                 [LastPublishedDate],
                 [IsTrained],
                 [LastTrainedDate],
                 [CreatedDate],
                 [CreatedByUserId],
                 [LastModifiedDate],
                 [LastModifiedByUserId],
                 [TimeStamp]
        FROM     [dbo].[NLU]
        ORDER BY [VCC] ASC, [Name] ASC;
    END

DROP TABLE [dbo].[NLU];

EXECUTE sp_rename N'[dbo].[tmp_ms_xx_NLU]', N'NLU';

EXECUTE sp_rename N'[dbo].[tmp_ms_xx_constraint_PK_NLU1]', N'PK_NLU', N'OBJECT';

COMMIT TRANSACTION;

SET TRANSACTION ISOLATION LEVEL READ COMMITTED;


GO
PRINT N'Modificando [dbo].[BulkProcessInteraction]...';


GO

ALTER PROCEDURE [dbo].[BulkProcessInteraction]
AS
BEGIN
	-- ACTUALIZAMOS LOS AUDIOS CON EL RESULTADO EN LA TABLA
	UPDATE [dbo].[Audio] SET
		[dbo].[Audio].[Format] = [dbo].[#ProcessInteractionTemp].[Format],
		[dbo].[Audio].[MediaInfoTime] = [dbo].[#ProcessInteractionTemp].[MediaInfoTime],
		[dbo].[Audio].[DurationLinguisticTime] = [dbo].[#ProcessInteractionTemp].[DurationLinguisticTime],
		[dbo].[Audio].[IsDiariced] = [dbo].[#ProcessInteractionTemp].[IsDiariced],
		[dbo].[Audio].[ChannelsChanged] = [dbo].[#ProcessInteractionTemp].[ChannelsChanged],
		[dbo].[Audio].[ValidChar] = ISNULL([dbo].[#ProcessInteractionTemp].[ValidChar], [dbo].[Audio].[ValidChar]),
		[dbo].[Audio].[ValidWords] = ISNULL([dbo].[#ProcessInteractionTemp].[ValidWords], [dbo].[Audio].[ValidWords]),
		[dbo].[Audio].[TotalPhrases] = [dbo].[#ProcessInteractionTemp].[TotalPhrases],
		[dbo].[Audio].[CharsPerPhrase] = [dbo].[#ProcessInteractionTemp].[CharsPerPhrase],
		[dbo].[Audio].[IsTranscribed] = [dbo].[#ProcessInteractionTemp].[IsTranscribed],
		[dbo].[Audio].[IsCancel] = [dbo].[#ProcessInteractionTemp].[IsCancel],
		[dbo].[Audio].[FileName] = [dbo].[#ProcessInteractionTemp].[FileName],
		[dbo].[Audio].[ErrorMessage] = [dbo].[#ProcessInteractionTemp].[ErrorMessage],
		[dbo].[Audio].[LastModifiedDate] = GETUTCDATE()
	FROM [dbo].[#ProcessInteractionTemp]
	WHERE
		[dbo].[Audio].[VCC] = [dbo].[#ProcessInteractionTemp].[VCC]
		AND [dbo].[Audio].[ID] = [dbo].[#ProcessInteractionTemp].[ID]
		AND [dbo].[Audio].[Section] = [dbo].[#ProcessInteractionTemp].[Section]
		AND [dbo].[Audio].[Part] = [dbo].[#ProcessInteractionTemp].[Part]
		AND [dbo].[#ProcessInteractionTemp].[Channel] = 'CALL'

	-- ACTUALIZAMOS LOS TEXT CON EL RESULTADO DE LA TABLA
	UPDATE [dbo].[AsyncInteraction] 
		SET [dbo].[AsyncInteraction].[ValidChar] = ISNULL([dbo].[#ProcessInteractionTemp].[ValidChar], [dbo].[AsyncInteraction].[ValidChar]),
			[dbo].[AsyncInteraction].[ValidWords] = ISNULL([dbo].[#ProcessInteractionTemp].[ValidWords], [dbo].[AsyncInteraction].[ValidWords]),
			[dbo].[AsyncInteraction].[TotalPhrases] = [dbo].[#ProcessInteractionTemp].[TotalPhrases],
			[dbo].[AsyncInteraction].[CharsPerPhrase] = [dbo].[#ProcessInteractionTemp].[CharsPerPhrase],
			[dbo].[AsyncInteraction].[IsTranscribed] = [dbo].[#ProcessInteractionTemp].[IsTranscribed],
			[dbo].[AsyncInteraction].[IsCancel] = [dbo].[#ProcessInteractionTemp].[IsCancel],
			[dbo].[AsyncInteraction].[FileName] = [dbo].[#ProcessInteractionTemp].[FileName],
			[dbo].[AsyncInteraction].[ViewFileName] = [dbo].[#ProcessInteractionTemp].[ViewFileName],
			[dbo].[AsyncInteraction].[ErrorMessage] = [dbo].[#ProcessInteractionTemp].[ErrorMessage],
			[dbo].[AsyncInteraction].[LastModifiedDate] = GETUTCDATE()
	FROM [dbo].[#ProcessInteractionTemp]
	WHERE [dbo].[AsyncInteraction].[VCC] = [dbo].[#ProcessInteractionTemp].[VCC]
		AND [dbo].[AsyncInteraction].[Campaign] = [dbo].[#ProcessInteractionTemp].[Campaign]
		AND [dbo].[AsyncInteraction].[Channel] = [dbo].[#ProcessInteractionTemp].[Channel]
		AND [dbo].[AsyncInteraction].[ID] = [dbo].[#ProcessInteractionTemp].[ID]
		AND [dbo].[AsyncInteraction].[Folder] = [dbo].[#ProcessInteractionTemp].[Folder]

	DROP TABLE [dbo].[#ProcessInteractionTemp]
END
GO
PRINT N'Modificando [dbo].[GetAudio]...';


GO
ALTER PROCEDURE [dbo].[GetAudio] (
	@VCC Varchar(50) = NULL,
	@ProcessId Varchar(50) = NULL,
	@ID Varchar(100) = NULL,
	@Section NUMERIC(5, 0) NULL,
	@Part NUMERIC(5, 0) NULL
)
AS
BEGIN
	SET NOCOUNT ON

	SELECT TOP 1
		A.[ID]						'id',
		A.[Section]					'section',
		A.[Part]					'part',
		PA.[ProcessId]				'processId',
		A.[Number]					'number',
		A.[Gender]					'gender',
		A.[SilenceTime]				'silenceTime',
		A.[DurationTime]			'durationTime',
		A.[DurationLinguisticTime]	'durationLinguisticTime',
		A.[Category1]				'category1',
		A.[Category2]				'category2',
		A.[Category3]				'category3',
		A.[Description]				'description',
		A.[Campaign]				'campaign',
		A.[Agent]					'agent',
		A.[Type]					'type',
		A.[Init]					'init',
		A.[ChannelsChanged]			'channelsChanged',
		A.[IsTranscribed]			'isTranscribed',
		A.[FileName]				'fileName'
	FROM [Audio] A (NOLOCK)
	LEFT JOIN [ProcessAudio] PA (NOLOCK)
		ON A.ID = PA.AudioId 
			AND A.Section = PA.Section 
			AND A.Part = PA.Part
	LEFT JOIN [dbo].[Process] P (NOLOCK)
		ON PA.[ProcessId] = P.[Name]
	WHERE A.[VCC] = @VCC
		AND (
			(@ProcessId IS NOT NULL AND P.[Name] = @ProcessId)
			OR 
			(@ProcessId IS NULL)
		)
		AND A.[ID] = @ID
		AND A.[Section] = @Section
		AND A.[Part] = @Part
		AND A.[IsTranscribed] = 1
		AND A.[IsCancel] IS NULL
		AND P.[Name] IS NOT NULL
	ORDER BY A.CreatedDate DESC, PA.[CreatedDate] DESC

	SET NOCOUNT OFF
END
GO
PRINT N'Modificando [dbo].[GetNLUs]...';


GO
ALTER PROCEDURE [dbo].[GetNLUs] (
	@VCC Varchar(50) = NULL, 
	@SearchCriteria Varchar(50) = NULL, 
	@SearchExpression Varchar(50) = NULL,
	@Apps NVARCHAR(MAX),
	@IsSystemApp BIT = NULL
	)
AS
BEGIN
	-- EN CASO EL FLAG LLEGUE NULL LO SETTEAMOS COMO 0
	SET @IsSystemApp = 0

	DECLARE @SQL NVARCHAR(MAX)
	SET @SQL = '
	SET NOCOUNT ON
	SELECT
		[Name]						    ''name'',
		[Culture]						''culture'',
		[Description]					''description'',
		[AppId]							''appId'',
		[SubscriptionKey]				''subscriptionKey'',
		[IsPublished]					''isPublished'',
		[LastPublishedDate]				''lastPublishedDate'',
		[CreatedDate]					''createdDate'',
		[CreatedByUserId]				''createdByUserId'',
		[LastModifiedDate]				''lastModifiedDate'',
		[LastModifiedByUserId]			''lastModifiedByUserId''
	FROM [NLU] (NOLOCK)
	WHERE [VCC] = ''' + @VCC + '''
		AND [AppId] IN (''' + @Apps + ''')
		AND [IsSystemApp] = ' + CASE WHEN @IsSystemApp = 1 THEN '1' ELSE '0' END + '
		AND ISNULL([Name], '''') LIKE CASE WHEN ''' + @SearchCriteria + ''' = ''name'' THEN ''%' + @SearchExpression + '%'' ELSE ''%'' END
		AND ISNULL([Description], '''') LIKE CASE WHEN ''' + @SearchCriteria + ''' = ''description'' THEN ''%' + @SearchExpression + '%'' ELSE ''%'' END
	ORDER BY [LastModifiedDate] ASC, [Name] DESC
	'
	SET @SQL += ' SET NOCOUNT OFF'
	EXEC(@SQL)
END
GO
PRINT N'Creando [dbo].[LaunchAudioConverter]...';


GO
CREATE PROCEDURE [dbo].[LaunchAudioConverter] (
	@VCC VARCHAR(50) = NULL, 
	@APP_PATH VARCHAR(250) = NULL,
	@INPUT_FILE_PATH VARCHAR(250) = NULL, 
	@OUTPUT_FOLDER_PATH VARCHAR(250) = NULL
)
AS
BEGIN
	SET NOCOUNT ON

	-- CREAMOS UNA VARIABLE PARA ARMAR EL COMANDO
	DECLARE @COMMAND VARCHAR(1000) = NULL

	SET @COMMAND = @APP_PATH + '/inConcertDiarization.exe -i ' + @INPUT_FILE_PATH + ' -o ' + @OUTPUT_FOLDER_PATH + ' -d 1';
	--SET @COMMAND = 'C:/diarization/inConcertDiarization/inConcertDiarization.exe -i G:/Ftp_Volcado/Repositorio/diarization/inConcertDiarization/source/input/ENTRANTE.wav -o G:/Ftp_Volcado/Repositorio/diarization/inConcertDiarization/source/output -d 1'
	-- xp_cmdshell 'C:\diarization\inConcertDiarization\inConcertDiarization.exe -i C:\diarization\inConcertDiarization\source\input\ENTRANTE.wav -o C:\diarization\inConcertDiarization\source\output -d 1';
	
	-- EJECUTAMOS EL COMANDO
	EXEC('xp_cmdshell ''' +  @COMMAND + '''')
	
	SET NOCOUNT OFF
END
GO
PRINT N'Actualizando [dbo].[BulkAudio]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[BulkAudio]';


GO
PRINT N'Actualizando [dbo].[BulkInteractionProcess]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[BulkInteractionProcess]';


GO
PRINT N'Actualizando [dbo].[BulkInteractionQueryStudy]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[BulkInteractionQueryStudy]';


GO
PRINT N'Actualizando [dbo].[BulkProgress]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[BulkProgress]';


GO
PRINT N'Actualizando [dbo].[EvaluateProcessStatus]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[EvaluateProcessStatus]';


GO
PRINT N'Actualizando [dbo].[GetAllegroBillingInteractionsForEvaluationPlan]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[GetAllegroBillingInteractionsForEvaluationPlan]';


GO
PRINT N'Actualizando [dbo].[GetAudios]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[GetAudios]';


GO
PRINT N'Actualizando [dbo].[GetAudiosByProcessId]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[GetAudiosByProcessId]';


GO
PRINT N'Actualizando [dbo].[GetAudiosProcess]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[GetAudiosProcess]';


GO
PRINT N'Actualizando [dbo].[GetEvaluationPlanCognitiveInteractionTask]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[GetEvaluationPlanCognitiveInteractionTask]';


GO
PRINT N'Actualizando [dbo].[GetEvaluationPlanCognitiveTask]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[GetEvaluationPlanCognitiveTask]';


GO
PRINT N'Actualizando [dbo].[GetEvaluationPlanInteractionByTypeAndId]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[GetEvaluationPlanInteractionByTypeAndId]';


GO
PRINT N'Actualizando [dbo].[GetExecuteTemplateProcess]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[GetExecuteTemplateProcess]';


GO
PRINT N'Actualizando [dbo].[GetInteractionsCognitive]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[GetInteractionsCognitive]';


GO
PRINT N'Actualizando [dbo].[GetInteractionsResult]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[GetInteractionsResult]';


GO
PRINT N'Actualizando [dbo].[GetInteractionTranscription]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[GetInteractionTranscription]';


GO
PRINT N'Actualizando [dbo].[GetLinguisticProcessStatus]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[GetLinguisticProcessStatus]';


GO
PRINT N'Actualizando [dbo].[GetPendingAudios]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[GetPendingAudios]';


GO
PRINT N'Actualizando [dbo].[GetProcessInteractionsByProcessId]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[GetProcessInteractionsByProcessId]';


GO
PRINT N'Actualizando [dbo].[GetProcessInteractionsHistory]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[GetProcessInteractionsHistory]';


GO
PRINT N'Actualizando [dbo].[GetProcessInteractionsTask]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[GetProcessInteractionsTask]';


GO
PRINT N'Actualizando [dbo].[GetProcessSummary]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[GetProcessSummary]';


GO
PRINT N'Actualizando [dbo].[GetStudiesInProcess]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[GetStudiesInProcess]';


GO
PRINT N'Actualizando [dbo].[GetStudyCognitiveInteractionsTask]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[GetStudyCognitiveInteractionsTask]';


GO
PRINT N'Actualizando [dbo].[GetStudyResultSummary]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[GetStudyResultSummary]';


GO
PRINT N'Actualizando [dbo].[SaveAudio]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[SaveAudio]';


GO
PRINT N'Actualizando [dbo].[SaveAudioLinguisticProcess]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[SaveAudioLinguisticProcess]';


GO
PRINT N'Actualizando [dbo].[DeleteNLU]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[DeleteNLU]';


GO
PRINT N'Actualizando [dbo].[GetAbilitys]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[GetAbilitys]';


GO
PRINT N'Actualizando [dbo].[GetEvaluationFormats]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[GetEvaluationFormats]';


GO
PRINT N'Actualizando [dbo].[GetNLU]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[GetNLU]';


GO
PRINT N'Actualizando [dbo].[GetNLUByAppId]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[GetNLUByAppId]';


GO
PRINT N'Actualizando [dbo].[GetTemplates]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[GetTemplates]';


GO
PRINT N'Actualizando [dbo].[GetUniqueNLUByIntents]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[GetUniqueNLUByIntents]';


GO
PRINT N'Actualizando [dbo].[SaveNLU]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[SaveNLU]';


GO
PRINT N'Actualización completada.';


GO
